﻿//页面控件的值转为json字符串
function PageToJson(content) {
    var filedList = $(content).find("[fieldName]");
    var data = "{";
    for (var i = 0, i_Count = filedList.length; i < i_Count; i++) {
        var value;
        if ($(filedList[i]).attr("type") == "checkbox")
            value = $(filedList[i]).is(":checked") ? "true" : "false";
        else
            value = $(filedList[i]).val();
        data += "\"" + $(filedList[i]).attr("fieldName") + "\":\"" + value + "\",";
    }
    if (data[data.length - 1] == ",")
        data = data.substring(0, data.length - 1);
    data += "}";
    return data;
}

//页面控件的值转为json
function PageToJsonObj(content) {
    var filedList = $(content).find("[fieldName]");
    var data = {};
    for (var i = 0, i_Count = filedList.length; i < i_Count; i++) {
        var value;
        if ($(filedList[i]).attr("type") == "checkbox")
            value = $(filedList[i]).is(":checked") ? "true" : "false";
        else
            value = $(filedList[i]).val();
        data[$(filedList[i]).attr("fieldName")] = value;
    }
    return data;
}

//用json对象给页面控件赋值
function JsonToPage(content, data) {
    for (var key in data) {
        var filed = $(content).find("[fieldName='" + key + "']").first();
        if (filed) {
            filed.val(data[key]);
        }
    }
}

function JsonStrToJson(jsonStr) {
    return (new Function("return " + jsonStr))();
}

function JsonToJsonStr(jsonObj) {
    return JSON.stringify(jsonObj);
}


//启用按钮
function EnableBtn(btn) {
    $(btn).attr("disabled", false);
    //$(btn).attr("class", $(btn).attr("class").replace("_disable", "_enable"));
}

//禁用按钮
function DisableBtn(btn) {
    $(btn).attr("disabled", true);
    //$(btn).attr("class", $(btn).attr("class").replace("_enable", "_disable"));
}

function GetIcoClassByItemType(type, isEnable) {
    switch (type) {
        case "Channel":
            return "IcoChannel" + (isEnable ? "" : "_d");
            break;
        case "Area":
            return "IcoArea";
            break;
        case "Sensor":
            return "IcoSensorAlarm" + (isEnable ? "" : "_d");
            break;
    }
}

//选中文本框文字
function SetSelectText(el, start, end) {
    if (el.createTextRange) {
        var Range = el.createTextRange();
        Range.collapse();
        Range.moveEnd('character', end);
        Range.moveStart('character', start);
        Range.select();
    }
    else if (el.setSelectionRange) {
        el.focus();
        el.setSelectionRange(start, end);  //设光标 
    }
}

//获取选中的文字
function GetSelectText(id) {
    var word = '';
    if (document.selection) {
        o = document.selection.createRange();
        if (o.text.length > 0)
            word = o.text;
    }
    else {
        o = document.getElementById(id);
        p1 = o.selectionStart;
        p2 = o.selectionEnd;
        if (p1 || p1 == '0') {
            if (p1 != p2)
                word = o.value.substring(p1, p2);
        }
    }
    return word;
}

//ip输入公用js
function SetIPEvent(txt1, txt2, txt3, txt4) {
    //8 = BackSpace 
    //110 = KP_Decimal
    //190 = period colon
    ToNumOnlyTxt_NoReplace($("#" + txt1));
    ToNumOnlyTxt_NoReplace($("#" + txt2));
    ToNumOnlyTxt_NoReplace($("#" + txt3));
    ToNumOnlyTxt_NoReplace($("#" + txt4));
    IPEvent($("#" + txt1), $("#" + txt2));
    IPEvent($("#" + txt2), $("#" + txt3));
    IPEvent($("#" + txt3), $("#" + txt4));
    $("#" + txt4).keydown(function(event) {
        var keyCode = GetKeyCode(event);
        if (keyCode == 110 || keyCode == 190) {
            return false;
        }
    });
}

function SetIPValue(txt1, txt2, txt3, txt4, txt) {
    var arr = txt.split('.');
    $("#" + txt1).val(arr[0]);
    $("#" + txt2).val(arr[1]);
    $("#" + txt3).val(arr[2]);
    $("#" + txt4).val(arr[3]);
}

function IPEvent(input1, input2) {
    $(input1).keydown(function(event) {
        var keyCode = GetKeyCode(event);
        if ((keyCode == 110 || keyCode == 190) && $(input1).val().length < 3) {
            $(input2).focus();
            SetSelectText($(input2)[0], 0, $(input2).val().length);
            //$(input2).selected();
            return false;
        }
        else if ($(input1).val().length >= 3 && keyCode != 8) {
            if (GetSelectText($(input1).attr("id")).length == 0) {
                $(input2).focus();
                SetSelectText($(input2)[0], 0, $(input2).val().length);
            }
        }
    });

    $(input2).keydown(function(event) {
        var keyCode = GetKeyCode(event);
        if (keyCode == 8) {
            if ($(input2).val().length == 0) {
                SetCursorPosition($(input1), $(input1).val().length);
            }
        }
    });
}

//设置文本框光标位置
function SetCursorPosition(elem, caretPos) {
    elem = $(elem)[0];
    if (elem != null) {
        if (elem.createTextRange) {
            var range = elem.createTextRange();
            range.move('character', caretPos);
            range.select();
        }
        else {
            elem.focus();
            elem.setSelectionRange(caretPos, caretPos);
        }
    }
}

//检测IP是否未空，即“...”，或“0.0.0.0”
function CheckIPNull(strIP) {
    if (!(strIP))
        return true;
    else {
        var arr = strIP.split('.');
        for (var i = 0; i < arr.length; i++) {
            arr[i] = $.trim(arr[i]);
            if (!(arr[i].length == 0 || arr[i] * 1 == 0)) {
                return false;
            }
        }
        return true;
    }
}

function CheckIP(strIP) {
    if (!(strIP)) return false;
    var re = /^(\d+)\.(\d+)\.(\d+)\.(\d+)$/g; //匹配IP地址的正则表达式
    if (re.test(strIP)) {
        if (RegExp.$1 < 256 && RegExp.$2 < 256 && RegExp.$3 < 256 && RegExp.$4 < 256) return true;
    }
    return false;
}

function CheckEmail(strEmail) {
    var re = /^\w+([-+.]\w+)*@\w+([-.]\w+)*\.\w+([-.]\w+)*/g; //匹配IEmail的正则表达式
    if (re.test(strEmail))
        return true;
    else
        return false;
}

function CheckNum(str) {
    var re = /^\d+$/g; //匹配数字的正则表达式
    if (re.test(str))
        return true;
    return false;
}

function checkMAC(str) {
    var re = /^([a-fA-F0-9]{1,2}:){5}[a-fA-F0-9]{1,2}$/g; //匹配MAC地址的正则表达式
    if (re.test(str))
        return true;
    return false;
}

function GetKeyCode(e) {
    e = e ? e : window.event;
    var keyCode = e.which ? e.which : e.keyCode;
    return keyCode;
}

//只能输入数字的文本框（不包括小数点）
function ToNumOnlyTxt(txt) {
    //8 = BackSpace 
    //110 = KP_Decimal
    //190 = period colon
    $(txt).keydown(function(event) {
        var keyCode = GetKeyCode(event);
        return keyCode >= 48 && keyCode <= 57 || keyCode >= 96 && keyCode <= 105
        || keyCode == 46 || keyCode == 8 || keyCode == 9;
    });
    $(txt).keyup(function() {
        $(txt).val($(txt).val().replace(/[^\d]/g, ''));
    });
}

//只能输入数字的文本框（不在keyup时替换）
function ToNumOnlyTxt_NoReplace(txt) {
    //8 = BackSpace 
    //110 = KP_Decimal
    //190 = period colon
    $(txt).keydown(function(event) {
        var keyCode = GetKeyCode(event);
        return keyCode >= 48 && keyCode <= 57 || keyCode >= 96 && keyCode <= 105
      || keyCode == 46 || keyCode == 8 || keyCode == 9;
    });
}

function ValidateFloat(e, pnumber) {
    if (!/^\d+[.]?\d*$/.test(pnumber)) {
        var newValue = /^\d+[.]?\d*/.exec(e.value);
        if (newValue != null) {
            e.value = newValue;
        }
        else {
            e.value = "";
        }
    }
    return false;
}


function ValidateFloat2(e, pnumber) {
    if (!/^\d+[.]?[1-9]?$/.test(pnumber)) {
        var newValue = /\d+[.]?[1-9]?/.exec(e.value);
        if (newValue != null) {
            e.value = newValue;
        }
        else {
            e.value = "";
        }
    }

    return false;
}

//xml字符串转xml文档对象
function XMLStr2XMLDoc(txt) {
    var xmlDoc;
    if (window.DOMParser) {
        parser = new DOMParser();
        xmlDoc = parser.parseFromString(txt, "text/xml");
    }
    else {//IE
        xmlDoc = new ActiveXObject(getXmlDocID());
        xmlDoc.async = "false";
        xmlDoc.loadXML(txt);
    }
    return xmlDoc;
}

function getXmlDocID(){
    for(var t = ["MSXML2.DOMDocument", "MSXML2.DOMDocument.5.0", "MSXML2.DOMDocument.4.0", "MSXML2.DOMDocument.3.0", "Microsoft.XmlDom"], i=0; i< t.length; i++){
        try{
            var xmlDoc = new ActiveXObject(t[i]);
            return t[i];
        }catch (e){};
    }
    throw new Error("Could not find an installed XMLDoc object");
}

//xml文档对象转xml字符串
function XMLDoc2XMLStr(doc) {
	var xml;
    if (doc.xml) {
		xml = doc.xml;
    } else {
        xml = (new XMLSerializer()).serializeToString(doc);
    }
    // 防止自动添加空命名空间
    xml = xml.replace(/\s*xmlns=""/g, "");
    return xml;
}

//开始拖拽
function DragSetCapture(o) {
    if (o.setCapture) {
        o.setCapture();
    }
    else if (window.captureEvents) {
        window.captureEvents(Event.MOUSEMOVE | Event.MOUSEDOWN);
    }
}

//结束拖拽
function DragReleaseCapture(o) {
    if (o.releaseCapture) {
        o.releaseCapture();
    }
    else if (window.captureEvents) {
        window.captureEvents(Event.MOUSEMOVE | Event.MOUSEUP);
    }
}

function getArrMinus(arr1, arr2) {
    var a = $.grep(arr1, function(val, key) {
        return $.inArray(val, arr2) == -1;
    });
    return a;
}

Date.prototype.format = function(format) {
    var o =
    {
        "M+": this.getMonth() + 1, //month
        "d+": this.getDate(),    //day
        "h+": this.getHours(),   //hour
        "m+": this.getMinutes(), //minute
        "s+": this.getSeconds(), //second
        "q+": Math.floor((this.getMonth() + 3) / 3),  //quarter
        "S": this.getMilliseconds() //millisecond
    };
    if (/(y+)/.test(format))
        format = format.replace(RegExp.$1, (this.getFullYear() + "").substr(4 - RegExp.$1.length));
    for (var k in o)
        if (new RegExp("(" + k + ")").test(format))
        format = format.replace(RegExp.$1, RegExp.$1.length == 1 ? o[k] : ("00" + o[k]).substr(("" + o[k]).length));
    return format;
};

Date.parse = function(dateString, dateSpliter) {
    if (!dateSpliter) {
        dateSpliter = "-";
    }

    var dateParts = dateString.match(new RegExp("^(\\d{1,4})" + dateSpliter + "(\\d{1,2})" + dateSpliter + "(\\d{1,2}) (\\d{1,2}):(\\d{1,2}):(\\d{1,2})$"));
    return dateParts && dateParts.length == 7 ? new Date(dateParts[1]
		, parseInt(dateParts[2]) - 1, dateParts[3], dateParts[4], dateParts[5], dateParts[6]) : null;
};

//字符编码数值对应的存储长度：     
//UCS-2编码(16进制) UTF-8 字节流(二进制)    
//0000 - 007F       0xxxxxxx （1字节）     
//0080 - 07FF       110xxxxx 10xxxxxx （2字节）     
//0800 - FFFF       1110xxxx 10xxxxxx 10xxxxxx （3字节）
//var str="，";
//alert("字符数"+str.length+" ，字节数"+str.getBytesLength());
String.prototype.getBytesLength = function() {
    var totalLength = 0;
    var charCode;
    for (var i = 0; i < this.length; i++) {
        charCode = this.charCodeAt(i);
        if (charCode < 0x007f) {
            totalLength++;
        } else if ((0x0080 <= charCode) && (charCode <= 0x07ff)) {
            totalLength += 2;
        } else if ((0x0800 <= charCode) && (charCode <= 0xffff)) {
            totalLength += 3;
        } else {
            totalLength += 4;
        }
    }
    return totalLength;
};

//按字节数截取字符串，中英文混合时无乱码
//$sourcestr：源字符串
//$cutlength：字节长度
function cut_str_utf8_byte($sourcestr, $cutlength) {
    var $returnstr = $sourcestr;
    var $i = 0; //字节个数
    var $j = 0; //字符个数
    var $lastByte = 0;
    $str_length = $sourcestr.length; //字符长度
    while (($i <= $cutlength) && ($j < $str_length)) {
        charCode = $sourcestr.charCodeAt($j);
        if (charCode < 0x007f) {
            $i++;
            $j++;
            $lastByte = 1;
        } else if ((0x0080 <= charCode) && (charCode <= 0x07ff)) {
            $i += 2;
            $j++;
            $lastByte = 2;
        } else if ((0x0800 <= charCode) && (charCode <= 0xffff)) {
            $i += 3;
            $j++;
            $lastByte = 3;
        } else {
            $i += 4;
            $j++;
            $lastByte = 4;
        }
    }
    if ($i > $cutlength) {
        $returnstr = $sourcestr.substr(0, $j - 1);
    }
    return $returnstr;
}

function checkPwd(value) {
    var re = /^[A-Za-z0-9]*$/g; //匹配密码的正则表达式
    if (re.test(value)) {
        return true;
    }
    else {
        return false;
    }
}

function checkUserName(value) {
//    var re = /^[`~!@#$%^&*()_+<>?:"{},.\/;'[\]]*$/g; //匹配用户名的正则表达式
    var re = /(^\s+)|(\s+$)|(\[+)|(\]+)/g;
    if (re.test(value)) {
        return true;
    }
    else {
        return false;
    }
}

//检验非法字符
function chkSafeChar(a){
    var fibdn = new Array ("[","]");
    var i=fibdn.length;
    var j=a.length;
    var temp1,temp2;
    for (var n=0; n<i; n++) {
        for (var m=0; m<j; m++) {
            temp1 = a.charAt(m);
            temp2 = fibdn[n];
            if (temp1 === temp2){
                return false;
            }
        }
    }
    return true;
}
/*
* 调用方式
* var template1="apple is {0}，banana is {1}";
* var result1=template1.format("red","yellow"); 
*/
String.prototype.format = function(args) {
    var result = this;
    if (arguments.length > 0) {
        for (var i = 0; i < arguments.length; i++) {
            if (arguments[i] != undefined) {
                var reg = new RegExp("(\\{" + i + "\\})", "g");
                result = result.replace(reg, arguments[i]);
            }
        }
    }
    return result;
};

function isEnter(ev) {
    ev = ev || window.event;
    var code = (ev.keyCode || ev.which);
    return code == 13;
}

//名称编辑框，只能输入 数字、字母、宽字符、"_"、"-"、":"、")"、"("、" "、"."、"/"
function nameLimited(name) {
    if (!$.trim(name))
        return false;
    var re = /^[\x2d-\x3aA-Za-z_ \(\)\u0100-\uffff]+$/g;
    if (re.test(name))
        return true;
    return false;
}

/*
* 输入文本框的jquery对象
* 名称编辑框，只能输入 数字、字母、宽字符、"_"、"-"、":"、")"、"("、" "、"."、"/"
*/
function nameLimitEvent(txt) {
    txt.blur(function(ex) {
        var keyCode = GetKeyCode(event);
        if (keyCode >= 35 && keyCode <= 40)
            return true;
        $(this).val($(this).val().replace(/[^\x2d-\x3aA-Za-z_ \(\)\u0100-\uffff]+/g, ''));
    });
}


/*
AJAX请求封装
标准的XMLHttpRequest对象，不能跨域访问，为联调方便
优先初始化ActiveXObject
*/
function XmlHttpClient() { }

XmlHttpClient.CommBeforeSend = function (xhr) {
    var auInfo = $.cookie('auInfo');
    if (auInfo) {
        xhr.setRequestHeader("Authorization", "Basic " + auInfo);
        return true;
    }
    else {
        window.top.location.href = webBase + "Pages/login.htm";
        return false;
    }
}

XmlHttpClient.SendHttpRequest = function(options) {
    var settings = $.extend({
        url: "/",
        type: "POST",
        async: true,
        data: "",
        dataType: "xml",
        callback: null,
        timeout: null,
        running: false,
        beforeSend: function(xhr) {
        },
        error: function(msg) {
        }
    }, options);
    var xmlHttp = XmlHttpClient._getXmlHttp();
    var checkTimeOut = null;
    xmlHttp.open(settings.type, settings.url, settings.async);
    if (settings.async) {
        xmlHttp.onreadystatechange = function() {
            if (xmlHttp.readyState == 4 && settings.running) {
                if (checkTimeOut) clearTimeout(checkTimeOut);
                if (xmlHttp.status == 401) {
                    logout();
                }else if(xmlHttp.status == 200 || xmlHttp.status == 400){
                    if (settings.dataType == "xml")
                        settings.callback(xmlHttp.responseXML);
                    else
                        settings.callback(xmlHttp.responseText);
                }else{
                    settings.error(xmlHttp.status);
                }
                xmlHttp = null;
            }
        }
    }

    settings.running = true;
    xmlHttp.setRequestHeader("If-Modified-Since", "0");
    settings.beforeSend(xmlHttp);
    xmlHttp.send(settings.data);
    if (settings.timeout) {
        checkTimeOut = setTimeout(sendTimeOut, settings.timeout);
    }
    if (!settings.async) {
        if (checkTimeOut) clearTimeout(checkTimeOut);
        if (settings.dataType == "xml")
            return settings.callback(xmlHttp.responseXML);
        else
            return settings.callback(xmlHttp.responseText);
        xmlHttp = null;
    }

    function sendTimeOut() {
        if (!settings.running) return;
        settings.running = false;
        if (xmlHttp) xmlHttp.abort();
        settings.error("timeout");
        xmlHttp = null;
    }
}

// private: xmlhttp factory
XmlHttpClient._getXmlHttp = function() {
    try {
        if (window.ActiveXObject)
            return new ActiveXObject(XmlHttpClient._getXmlHttpProgID());
        if (window.XMLHttpRequest) {
            var req = new XMLHttpRequest();
            // some versions of Moz do not support the readyState property and the onreadystate event so we patch it!
            if (req.readyState == null) {
                req.readyState = 1;
                req.addEventListener("load",
									function() {
									    req.readyState = 4;
									    if (typeof req.onreadystatechange == "function")
									        req.onreadystatechange();
									},
									false);
            }
            return req;
        }
    }
    catch (ex) { }
    throw new Error("Your browser does not support XmlHttp objects");
}
XmlHttpClient._getXmlHttpProgID = function() {
    if (XmlHttpClient._getXmlHttpProgID.progid)
        return XmlHttpClient._getXmlHttpProgID.progid;
    var progids = ["Msxml2.XMLHTTP.5.0", "Msxml2.XMLHTTP.4.0", "MSXML2.XMLHTTP.3.0", "MSXML2.XMLHTTP", "Microsoft.XMLHTTP"];
    var o;
    for (var i = 0; i < progids.length; i++) {
        try {
            o = new ActiveXObject(progids[i]);
            return XmlHttpClient._getXmlHttpProgID.progid = progids[i];
        }
        catch (ex) { };
    }
    throw new Error("Could not find an installed XML parser");
}

XmlHttpClient.
    BindPageByXml = function(mapping, xmlDoc, formatters, context) {
	if (!context) {
		context = document;
	}

    for (var key in mapping) {
        var element = $("#" + key, context);
        var node = $(mapping[key], xmlDoc);
        var type = node.attr("type");
        if (!type) {
			type = $(mapping[key].replace(">item>", ">itemType>"), xmlDoc).attr("type");
        }
        var value = $.trim(node.text()) != "" ? node.text() : node.attr("default");
        var maxLen = node.attr("maxLen");
        if (!maxLen) {
			maxLen = $(mapping[key].replace(">item>", ">itemType>"), xmlDoc).attr("maxLen");
        }
        if (type && type.toLowerCase() == "string" && maxLen) {
            element.attr("maxlength", maxLen);
        }
        if (type && type.toLowerCase() == "uint16") {
            element.attr("maxlength", 5);
        }
        if (type && type.toLowerCase() == "uint32") {
            element.attr("maxlength", 10);
        }
        if (type && type.toLowerCase() == "boolean") {
            if (element.attr("type") == "checkbox") {
                element.attr("checked", value.toLowerCase() === "true");
            }
        } else {
            element.val(formatters && formatters[key] ? formatters[key](value) : value);
        }
    }
}

XmlHttpClient.GetXmlByPage = function(mapping, xmlDoc, parsers, context) {
	if (!context) {
		context = document;
	}

    for (var key in mapping) {
        var element = $("#" + key, context);
        var node = $(mapping[key], xmlDoc);
        var type = node.attr("type");
        if (!type) {
			type = $(mapping[key].replace(">item>", ">itemType>"), xmlDoc).attr("type");
        }
        if (type && type.toLowerCase() == "boolean") {
            if (element.attr("type") == "checkbox") {
                node.text(element.attr("checked") == "checked" ? "true" : "false");
            }
        }
        else if (type && type.toLowerCase() == "string") {
            cdataSection = xmlDoc.createCDATASection(parsers && parsers[key] ? parsers[key](element.val()) : element.val());
            node.empty();
            node.append(cdataSection);
        }
        else {
            node.text(parsers && parsers[key] ? parsers[key](element.val()) : element.val());
        }
    }
    return XMLDoc2XMLStr(xmlDoc);
}

XmlHttpClient.Verification = function(elementId, path, xmlDoc, message, context, offset) {
	if (!context) {
		context = document;
	}

    var element = $("#" + elementId, context);
    var node = $(path, xmlDoc);
    var type = node.attr("type").toLowerCase();
    ClearFloatError();

    var isError = false;
    switch (type) {
        case "uint16":
            var min = 0;
            var max = 65535;
            var value = element.val() * 1;
            if (isNaN(value) || value < min || value > max) {
                isError = true;
                ShowFloatError(element, message.format(min, max), offset);
            }
            break;
        case "uint32":
            var min = 0;
            var max = 4294967296;
            var value = element.val() * 1;
            if (isNaN(value) || value < min || value > max) {
                isError = true;
                ShowFloatError(element, message.format(min, max), offset);
            }
            break;
    }
    return isError;
}

function ShowError(elementId, message) {
    var element = $("#" + elementId);
    element.focus();
    if (element.select) {
        element.select();
    }
    var elementTip = $("#" + elementId + "_tip").html(message);
    elementTip.show();
    elementTip.click(function() {
        $(this).html("");
        $(this).hide();
    });
    setTimeout(function() {
        elementTip.html("");
        elementTip.hide();
    }, 5000);
}

function ClearError() {
    $("span.errorTip").html("").hide();
}

/*
* 浮动错误提示框
*/
function ShowFloatError($element, msg, offset,flag) {
    if ($element.is(":text") && $element.select) {
        $element.select();
    }
    var errorMsg = {};
    if(flag === "success"){
        errorMsg = $("<span class=\"floadSuccessTip\">" + msg + "</span>");
    }else if(flag === "failed"){
        errorMsg = $("<span class=\"floadFailedTip\">" + msg + "</span>");
    }else{
        errorMsg = $("<span class=\"floadErrorTip\">" + msg + "</span>");
    }

    var position = $element.position();
    errorMsg.css("top", position.top + (offset && !isNaN(offset.top) ? offset.top : 0) + "px");
    errorMsg.css("left", position.left + 10 + (offset && !isNaN(offset.left) ? offset.left : 0) + $element.width() + "px");
    errorMsg.appendTo($element.parent());
    errorMsg.click(function() {
        $(this).remove();
    });
    setTimeout(function() {
        if (errorMsg)
            errorMsg.remove();
    }, 5000);
}

function ClearFloatError(context) {
	if (!context) {
		context = document;
	}
    $("span.floadErrorTip", context).remove();
}

/*
获取文本匹配的节点
*/
function getTextMatchNodes($nodes, text) {
    var matchNodes = [];
    $nodes.each(function(e, elem) {
        if ($.trim($(elem).text()) == text) {
            matchNodes.push(elem);
        }
    });
    return matchNodes;
}

// 初始化密码输入框
function initPasswordInput($input, context) {
	if (!context) {
		context = document;
	}
	if (!$input || !($input instanceof jQuery) || $input.not(":password")) {
		$input = $(":password", context);
	}
	var placeholder = "      ";
	$input.each(function(index, element) {
		var $this = $(this);
		$this.focus(function(event) {
			if ($this.val() == placeholder) {
				$this.val("");
			}
		}).blur(function(event) {
			if ($.trim($this.val()) == "") {
				$this.val(placeholder);
			}
		}).keydown(function(event) {
			if (event.which == 32) {
				return false;
			}
		}).data("placeholder", placeholder).val(placeholder);
	});
}
// XML转换为JSON对象
function xml2json(xml, path) {
    var obj = {};
    if (typeof xml == "string") {
        xml = XMLStr2XMLDoc(xml);
    }

    var $xml = path ? $(path, xml).parent() : $(xml);
    var children = $xml.children();
    var attributes = xml.attributes;
    if (attributes && attributes.length > 0) {
        $.each(attributes, function(index, element) {
            obj["@" + element.nodeName] = element.nodeValue;
        });
    }

    if (children.size() > 0) {
        $xml.children().each(function(index, element) {
            var name = element.nodeName;
            var subObj = xml2json(element);
            if (obj[name]) {
                if (!(obj[name] instanceof Array)) {
                    var tmpObj = obj[name];
                    obj[name] = [];
                    obj[name].push(tmpObj);
                }
                obj[name].push(subObj);
            } else {
                obj[name] = subObj;
            }
        });
    } else if ($xml.size() > 0) {
        var text = $xml.text();
        if (attributes.length > 0) {
            obj["innerText"] = text;
        } else {
            obj = text;
        }
    }
    return obj;
}

//当地时间转UTC时间
function LocalTime2UTCTime(dateObj) {
    var t_offset = dateObj.getTimezoneOffset();
    var utcTime = dateObj.getTime() + t_offset * 60 * 1000;
    dateObj.setTime(utcTime);
    return dateObj;
}

/*
 初始化名称输入框：只能输入字母，数字，_，-
 */
function initNameInput($textInput, options) {
    var settings = $.extend({
        maxLeng: null, // 最大字节长度
        context: document// 上下文环境
    }, options);

    $textInput.data("initNameInput_settings", settings);
    $textInput.attr("maxlength", settings.maxLeng);
    $textInput.unbind("keydown", _initStringInput_keyup).keydown(_initNameInput_keydown)
        .unbind("keyup", _initNameInput_keyup).keydown(_initNameInput_keyup)
        .unbind("blur", _initNameInput_blur).blur(_initNameInput_blur);
}
function _initNameInput_keydown(event) {
    var keyCode = GetKeyCode(event);
    return keyCode >= 48 && keyCode <= 57 //数字0-9
        || keyCode >= 96 && keyCode <= 105  //小键盘数字0-9
        || keyCode == 46 //Delete
        || keyCode == 8 //BackSpace
        || keyCode == 9 //Tab
        || keyCode == 16 // Shift
        || keyCode == 17// Ctrl
        || keyCode == 18// Alt
        || keyCode == 35// End
        || keyCode == 36// Home
        || keyCode == 37// 向左
        || keyCode == 39// 向右
        || keyCode == 13// 回车
        || keyCode >= 65 && keyCode <= 90;//A-Z
}

function _initNameInput_keyup(event) {
    var $this = $(this);
    var text = $this.val();
    var settings = $this.data("initNameInput_settings");
    if (text.getBytesLength() > settings.maxLeng) {
        var newText = cut_str_utf8_byte(text, settings.maxLeng);
        $this.val(newText);
    }
}

function _initNameInput_blur(event) {
    var $this = $(this);
    $this.val($this.val().replace(/[^A-Za-z0-9_-]+/g, ''));
    var newText = cut_str_utf8_byte($this.val(), $this.data("initNameInput_settings").maxLeng);
    $this.val(newText);
}
function _initStringInput_keyup(event) {
    var $this = $(this);
    var text = $this.val();
    var settings = $this.data("initStringInput_settings");
    if (text.getBytesLength() > settings.maxLeng) {
        var newText = cut_str_utf8_byte(text, settings.maxLeng);
        $this.val(newText);
    }
}

function _initStringInput_blur(event) {
    var $this = $(this);
    var settings = $this.data("initStringInput_settings");
    var newText = cut_str_utf8_byte($this.val(), settings.maxLeng);
    $this.val(newText);
}

// 判断所有模块异步调用是否完毕
function callbackAllComplete(modules, key) {
    if (!key) {
        key = "callbackComplete";
    }
    var callbackComplete = true;
    $.each(modules, function(index, element) {
        callbackComplete = callbackComplete && element[key];
    });
    if (callbackComplete) {
        $.each(modules, function(index, element) {
            element[key] = false;
        });
    }
    return callbackComplete;
}



/**
 * 初始化数字输入框
 *
 * @param $textInput 文本框JQuery对象
 * @param options 选项
 */
function initNumberInput($textInput, options) {
    var settings = $.extend({
        maxValue: null,// 最大值
        minValue: null,// 最小值
        enableEmpty: false,// 是否允许空值
        context: document// 上下文环境
    }, options);

    $textInput.data("initNumberInput_settings", settings);

    $textInput.unbind("keydown", _initNumberInput_keydown).keydown(_initNumberInput_keydown)
        .unbind("blur", _initNumberInput_blur).blur(_initNumberInput_blur);
}

function _initNumberInput_keydown(event) {
    var settings = $(this).data("initNumberInput_settings");
    var keyCode = event.which;

    if (keyCode == 9// Tab
        || keyCode == 16// Shift
        || keyCode == 17// Ctrl
        || keyCode == 18// Alt
        || keyCode == 35// End
        || keyCode == 36// Home
        || keyCode == 37// 向左
        || keyCode == 39// 向右
        || keyCode == 13// 回车
        || keyCode == 8// 退格
        || keyCode == 46// 删除
        ) {
        return true;
    }

    if (keyCode == 32) {// 空格
        return false;
    }

    var range = getSelectRange(this, settings.context);
    var $this = $(this);
    var oldText = $this.val();
    var startIndex = range.start;
    var endIndex = range.end;
    var letter = String.fromCharCode(keyCode);
    var posIndex = endIndex + 1;

    if (keyCode >= 96 && keyCode <= 105) {// 数字小键盘
        letter = String.fromCharCode(keyCode - 48);
    }
    if (keyCode == 38) {// 向上
        if (!$.isNumeric(oldText)) {
            return false;
        }
        letter = oldText * 1 + 1 + "";
        posIndex = endIndex;
        startIndex = 0;
        endIndex = letter.length;
    }
    if (keyCode == 40) {// 向下
        if (!$.isNumeric(oldText)) {
            return false;
        }
        letter = oldText * 1 - 1 + "";
        posIndex = endIndex;
        startIndex = 0;
        endIndex = oldText.length;
    }
    //        if (keyCode == 8) {// 退格
    //            letter = "";
    //            if (startIndex == endIndex) {
    //                startIndex--;
    //            }
    //            posIndex = startIndex;
    //        }
    //        if (keyCode == 46) {// 删除
    //            letter = "";
    //            if (startIndex == endIndex) {
    //                endIndex++;
    //            }
    //            posIndex = startIndex;
    //        }
    var newText = oldText.substring(0, startIndex) + letter + oldText.substring(endIndex);

    if (newText == "") {
        if (settings.enableEmpty) {
            $this.val(newText);
            return false;
        }
        else {
            $this.val(settings.minValue);
        }
    }

    if ($.isNumeric(newText) && !/^0\d+$/.test(newText)) {
        if (((settings.minValue || settings.minValue === 0) && newText * 1 < settings.minValue && keyCode == 40) ||
            ((settings.maxValue || settings.maxValue === 0) && newText * 1 > settings.maxValue)) {
            return false;
        }
        $this.val(newText);
        setSelectRange(this, posIndex, posIndex, settings.context);
    }
    return false;
}

function _initNumberInput_blur(event) {
    var settings = $(this).data("initNumberInput_settings");
    var value = $(this).val();
    if (value == "") {
        if (settings.enableEmpty) {

        } else {
            $(this).val(settings.minValue);
        }
    } else if ($(this).val() * 1 < settings.minValue) {
        $(this).val(settings.minValue);
    }
}

/*
 获取选中区间
 */
function getSelectRange(textControl, context) {
    var range = {};
    if (!context) {
        context = document;
    }
    if (context.selection) {
        if (textControl.tagName != undefined && textControl.tagName == "INPUT") {
            var selectionRange = context.selection.createRange();
            var textControlRange = textControl.createTextRange();
            range.text = selectionRange.text;
            var oldLength = range.text.length;
            selectionRange.setEndPoint("EndToStart", textControlRange);
            var newLength = selectionRange.text.length;
            range.start = newLength;
            range.end = newLength + oldLength;
        }
    } else {
        range.start = textControl.selectionStart;
        range.end = textControl.selectionEnd;
        range.text = textControl.value.substring(range.start, range.end);
    }
    return range;
}

/*
 设置选中区间
 */
function setSelectRange(textControl, startIndex, endIndex, context) {
    if (!context) {
        context = document;
    }
    if (context.selection) {
        var range = textControl.createTextRange();
        range.collapse(true);
        range.moveStart("character", startIndex);
        range.moveEnd("character", endIndex - startIndex);
        range.select();
    } else {
        textControl.setSelectionRange(startIndex, endIndex);
        textControl.focus();
    }
}

//离开页面时，关闭流--IE8在页面注销时，不会注销OCX
function closeStream(){
    $(window).unload(function () {
        try {
            var sendXML = OCX_XML_Leave();
            NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
        }
        catch (ex) {
        }
    });
}

//数组中对象的属性比较函数
function by(name){
    return function (o, p) {
        var a, b;
        if (typeof o === 'object' && typeof p === 'object' && o && p) {
            a = o[name]*1;
            b = p[name]*1;
            if (a === b) {
                return 0;
            }
            if (typeof a === typeof b) {
                return a < b ? -1 : 1;
            }
            return typeof a < typeof b ? -1 : 1;
        } else {
            throw {
                name: 'Error',
                message: 'Expected an object when sorting by ' + name
        };
    }
};
}

//判断变量存储的数据属不属于Array:利用constructor、typeof结合判断
function is_array(value) {
    return value &&
        typeof value === 'object' &&
        value.constructor === Array;
}

//检测操作系统
function detectOS() {
    var sUserAgent = navigator.userAgent;
    var platForm = navigator.platform;
    var isWin = (platForm == "Win32") || (platForm == "Windows") || (platForm == "Win64") ;
    if (isWin) return "Windows";
    var isMac = (platForm == "Mac68K") || (platForm == "MacPPC") || (platForm == "Macintosh") || (platForm == "MacIntel");
    if (isMac) return "Mac";
    var isUnix = (platForm == "X11") && !isWin && !isMac;
    if (isUnix) return "Unix";
    var isLinux = (String(platForm).indexOf("Linux") > -1);
    if (isLinux) return "Linux";
    return "other";
}

//检测客户端浏览器类型
function detectBrowser() {
    var userAgent = navigator.userAgent;
    if(navigator.userAgent.indexOf("MSIE")>0 || (!!window.ActiveXObject || "ActiveXObject" in window) ) {
        return "IE";
    }
    if(navigator.userAgent.indexOf("Firefox")>0){
        return "Firefox";
    }
    if(navigator.userAgent.indexOf("Safari")>0) {
        return "Safari";
    }
    if(navigator.userAgent.indexOf("Chrome")>0){
        return "Firefox";
    }
    if(navigator.userAgent.indexOf("Opera")>0) {
        return "Safari";
    }
    return "unknown";
}



