/**
* Description: 弹出层
* Author: tengx
* Date: 2013-5-10
*/
function DisplayOCX(context, isShow) {
    /*ocx假隐藏*/
    var ocx = $("object", context);
    var loading = $(".loadingIndicator_bk",window.top.document).is(":visible") || $(".tvt_dialog_background",window.top.document).length > 0;
    if (isShow && !loading)
        ocx.width('100%');
    else
        ocx.width(0);

    var iframe = $("iframe", context);
    for (var i = 0; i < iframe.length; i++) {
        DisplayOCX($(iframe[i]).contents(), isShow);
    }
}

function DialogHelper(options) {
    /*ocx假隐藏*/
    DisplayOCX(window.top.document, false);

    var _self = this;
    var settings = $.extend({
        title: '',
        content: '',
        width: 0,
        height: 0,
        contentType: 'content', // 内容类型：content,url
        loadCallBack: null,
        zIndex: 300,
        beforCloseEvent: null
    }, options);

    settings.context = window.top.document;
    settings.topContainer = $("body", settings.context);
	settings.lastActive = document.activeElement;

    // 浏览器的宽，高
    var iWidth = settings.topContainer.width();
    var iHeight = window.top.document.body.scrollHeight;

    //初始偏移
    var initTop = (iHeight - settings.height) / 2;
    var initLeft = (iWidth - settings.width) / 2;

    // 弹出层遮盖层
    var $Background = $("<div class='tvt_dialog_background' style='z-index:"
			+ settings.zIndex + "; width:" + iWidth + "px; height:" + iHeight + "px;'></div>");
    $Background.appendTo(settings.topContainer);

    //弹出层Iframe(遮盖OCX)
//    var $TopIframe = $("<iframe class='tvt_dialog_backIframe' style=\"z-index:"
//			+ (settings.zIndex + 1) + "; width:" + settings.width + "px; height:" + settings.height + "px;top:" + initTop + "px; left:" + initLeft + "px;\" scrolling=\"no\" frameborder=\"0\" src=\"about:blank\"> </iframe>");
//    $TopIframe.appendTo(settings.topContainer);

    // 弹出层
    var dialogHtml = "<div class=\"tvt_dialog\">";
    dialogHtml += "	<div class=\"tvt_dialog_top\">";
    dialogHtml += "		<div class=\"tvt_dialog_top_left\"></div>";
    dialogHtml += "		<div class=\"tvt_dialog_top_middle\">";
    dialogHtml += "			<div class=\"tvt_dialog_title\">" + settings.title + "</div>";
    dialogHtml += "			<div class=\"tvt_dialog_close\"></div>";
    dialogHtml += "		</div>";
    dialogHtml += "		<div class=\"tvt_dialog_top_right\"></div>";
    dialogHtml += "	</div>";
    dialogHtml += "	<div class=\"tvt_dialog_content\"></div>";
    dialogHtml += "	<div class=\"tvt_dialog_bottom\">";
    dialogHtml += "		<div class=\"tvt_dialog_bottom_left\"></div>";
    dialogHtml += "		<div class=\"tvt_dialog_bottom_middle\"></div>";
    dialogHtml += "		<div class=\"tvt_dialog_bottom_right\"></div>";
    dialogHtml += "	</div>";
    dialogHtml += "</div>";

    var $Dialog = $(dialogHtml);
    $Dialog.css({
        top: initTop + "px",
        left: initLeft + "px",
        width: settings.width + "px",
        height: settings.height + "px",
        "z-index": settings.zIndex + 2
    });
    $Dialog.appendTo(settings.topContainer);
    this.dialog = $Dialog;
    var moveX = 0;
    var moveY = 0;
    var moveTop = 0;
    var moveLeft = 0;
    var moveable = false;

    // 检测浏览器类型
    function getBrowser() {
        var b;
        if ((navigator.userAgent.indexOf("MSIE") >= 0) && (navigator.userAgent.indexOf('Opera') < 0)) {
            b = "IE";
        } else if (navigator.userAgent.indexOf("Firefox") >= 0) {
            b = "Firefox";
        } else if (navigator.userAgent.indexOf("Opera") >= 0) {
            b = "Opera";
        } else {
            b = "Other";
        }
        return b;
    }

    // 获得事件Event对象，用于兼容IE和FireFox 
    function getEvent() {
        return window.event || arguments.callee.caller.arguments[0];
    }

    $(".tvt_dialog_title", $Dialog).bind({
        mousedown: function() {
            moveable = true;
            if (getBrowser() == "IE")
                $(this)[0].setCapture();
            var evt = getEvent();
            moveX = evt.clientX;
            moveY = evt.clientY;
            var offset = $Dialog.offset();
            moveTop = parseInt(offset.top);
            moveLeft = parseInt(offset.left);
        },
        mouseup: function() {
            if (moveable) {
                moveX = 0;
                moveY = 0;
                moveTop = 0;
                moveLeft = 0;
                moveable = false;
                if (getBrowser() == "IE")
                    $(this)[0].releaseCapture();
            }
        },
        selectstart: function() {
            return false;
        },
        mousemove: function() {
            if (moveable) {
                var evt = getEvent();
                var x = moveLeft + evt.clientX - moveX;
                var y = moveTop + evt.clientY - moveY;
                $Dialog.offset({ top: y, left: x });
//                $TopIframe.offset({ top: y, left: x });
            }
        }
    });

    this.CloseDialog = function () {
        $Background.remove();
        $Dialog.remove();

        /*ocx假隐藏*/
        DisplayOCX(window.top.document, true);

        //        $("input,a,select").removeAttr("tabindex");
        if (settings.beforCloseEvent)
            settings.beforCloseEvent(settings.context);

        try {
            settings.lastActive.focus();
        }
        catch (ex) { }
        enableTab(window);
        //        $TopIframe.remove();
    };

    $(".tvt_dialog_close", $Dialog).click(function() {
        _self.CloseDialog();
    });

    if (settings.contentType == "url") {
        //        $(".tvt_dialog_content", $Dialog).load(settings.content, settings.loadPara, settings.loadCallBack(settings.topContainer));

        $.ajax({
            type: "GET",
            dataType: "html",
            url: settings.content,
            success: function(result) {
                $(".tvt_dialog_content", $Dialog).html(result);
                try {
                    $("input,a,select", $Dialog).filter(":enabled").filter(":visible").filter(":first").focus();
                }
                catch (ex) { }
                if (settings.loadCallBack)
                    settings.loadCallBack(settings.context);
            }
        });
    } else {
        $(".tvt_dialog_content", $Dialog).html(settings.content);
        if (settings.loadCallBack)
            settings.loadCallBack(settings.context);
    }

    this.DialogContent = $Dialog;

	disableTab(window);
}

// 禁用被屏蔽控件的tab键获得焦点
function disableTab(win) {
	$("[tabindex], [tabindex=0]", win.document).each(function(event) {
		var $this = $(this);
		$this.attr("_tabindex", $this.attr("tabindex"));
		$this.attr("tabindex", -1);
	});
	if (win == win.top) {
		return;
	}
	disableTab(win.parent);
}

// 启用被屏蔽控件的tab键获得焦点
function enableTab(win) {
	$("[_tabindex]", win.document).each(function(event) {
		var $this = $(this);
		$this.attr("tabindex", $this.attr("_tabindex"));
		$this.removeAttr("_tabindex");
	});
	if (win == win.top) {
		return;
	}
	enableTab(win.parent);
}

$(window).resize(function() {
    $(".tvt_dialog_background").width($("body", window.top.document).width());
    $(".tvt_dialog_background").height(window.top.document.body.scrollHeight);
});