/**
* Description: 弹出窗口控制对象
* Author: tengx
* Date: 2013-5-13
*/

var MsgBoxHelper = {
    currentIndex: -1,
    boxes: [],
    /**
    弹出提示窗口
    type: (ok, error, info, alarm|单个按钮)(y/n|两个按钮)
    title: 标题
    msg: 消息,支持html格式
    callBack: 回调函数
    */
    Show: function(type, title, msg, callBack, width, height, zIndex) {
        this.currentIndex++;
        if (type == "y/n") {
            MsgBoxHelper.boxes[MsgBoxHelper.currentIndex] = new MsgBox_2Btn(title, msg, callBack, width, height, zIndex);
        }
        else {
            MsgBoxHelper.boxes[MsgBoxHelper.currentIndex] = new MsgBox_1Btn(type, title, msg, callBack, width, height, zIndex);
        }

        //单按钮提示框构造函数
        function MsgBox_1Btn(type, title, msg, callBack, width, height, zIndex) {
            var box = "<div class=\"Mgs_box\">";
            box += "	<div class=\"Msg_Icon " + getCSS(type) + "\"></div>";
            box += "	<div class=\"Msg_Content\"><span>" + msg + "</span></div>";
            box += "	<div class=\"Msg_btn\">";
            box += "		<input id=\"btnOk" + MsgBoxHelper.currentIndex + "\" curIndex=\"" + MsgBoxHelper.currentIndex + "\" type=\"button\" value=\"" + LangCtrl._L_("ok") + "\" />";
            box += "	</div>";
            box += "</div>";
            if (!width) width = 330;
            if (!height) height = 200;
            //ok, error, info, alarm
            function getCSS(type) {
                switch (type) {
                    case "ok":
                        return "Msg_ok";
                        break;
                    case "error":
                        return "Msg_error";
                        break;
                    case "info":
                        return "Msg_info";
                        break;
                    case "alarm":
                        return "Msg_alarm";
                        break;
                    case "query":
                        return "Msg_question";
                        break;
                }
            }

            this.dialog = new DialogHelper({
                title: title,
                content: box,
                width: width,
                height: height,
                contentType: 'content', // 内容类型：content,url
                zIndex: zIndex,
                beforCloseEvent: callBack
            });

            var _msgSpan = $(".Msg_Content>span", this.dialog.DialogContent);
            var _msgDiv = $(".Msg_Content", this.dialog.DialogContent);
            _msgDiv.css("padding-top", ((_msgDiv.height() - _msgSpan.height()) / 2) + "px");
            
            $("#btnOk" + MsgBoxHelper.currentIndex, this.dialog.dialog).click(function() {
                $("input,a,select").removeAttr("tabindex");
                MsgBoxHelper.boxes[$(this).attr("curIndex")].dialog.CloseDialog();
                MsgBoxHelper.boxes[$(this).attr("curIndex")] = null;
            });
            $("#btnOk" + MsgBoxHelper.currentIndex).focus();
        }

        //两个按钮提示框构造函数
        function MsgBox_2Btn() {
            var box = "<div class=\"Mgs_box\">";
            box += "<div class=\"Msg_Icon Msg_question\"></div>";
            box += "<div class=\"Msg_Content\"><span>" + msg + "</span></div>";
            box += "<div class=\"Msg_btn\">";
            box += "	<input id=\"btnY" + MsgBoxHelper.currentIndex + "\" curIndex=\"" + MsgBoxHelper.currentIndex + "\" type=\"button\" value=\"" + LangCtrl._L_("ok") + "\" />";
            box += "	<input id=\"btnN" + MsgBoxHelper.currentIndex + "\" curIndex=\"" + MsgBoxHelper.currentIndex + "\" type=\"button\" value=\"" + LangCtrl._L_("cancel") + "\" />";
            box += "</div>";
            box += "</div>";

            if (!width) width = 300;
            if (!height) height = 200;

            this.dialog = new DialogHelper({
                title: title,
                content: box,
                width: width,
                height: height,
                contentType: 'content', // 内容类型：content,url
                zIndex: zIndex,
                beforCloseEvent: null
            });

            var _msgSpan = $(".Msg_Content>span", this.dialog.DialogContent);
            var _msgDiv = $(".Msg_Content", this.dialog.DialogContent);
            _msgDiv.css("padding-top", ((_msgDiv.height() - _msgSpan.height()) / 2) + "px");

            $("#btnY" + MsgBoxHelper.currentIndex, this.dialog.dialog).click(function() {
                $("input,a,select").removeAttr("tabindex");
                MsgBoxHelper.boxes[$(this).attr("curIndex")].dialog.CloseDialog();
                MsgBoxHelper.boxes[$(this).attr("curIndex")] = null;
                if (callBack)
                    callBack(true);
            });
            $("#btnN" + MsgBoxHelper.currentIndex, this.dialog.dialog).click(function() {
                $("input,a,select").removeAttr("tabindex");
                MsgBoxHelper.boxes[$(this).attr("curIndex")].dialog.CloseDialog();
                MsgBoxHelper.boxes[$(this).attr("curIndex")] = null;
                if (callBack)
                    callBack(false);
            });
            $("#btnY" + MsgBoxHelper.currentIndex).focus();
        }
    }
};


