﻿(function($) {
    var methods = {
        //初始化方法
        init: function(options) {
            //设定属性--覆盖默认属性
            var settings = $.extend({
                data: [], //[{id:"",value:"",button:[]}]
                check: false,
                multiselect: false,
                alterRow: true,
                _alterStatus: true, //私有
                itemViewLen: 100,
                itemCustomMapping: {},
                mouse_over: null,
                mouse_out: null,
                mouse_enter:null,
                mouse_leave:null,
                selectItem: null, //function(item) { },
                unSelectItem: null, //function(item) { },
                clickItem: null, //function(item) { }
                dbClickItem: null
            }, options);

            //设定属性--缓存属性到data中
            return this.each(function() {
                var $this = $(this),
                data = $this.data('InteData');
                
                $(this).data('InteData', {
                    target: $this,
                    settings: settings
                });

                $(this).addClass("listbox");
                methods.reload.apply(this);
            });
        },

        reload: function() {
            var settings = $(this).data('InteData').settings;
            $(this).empty();
            settings._alterStatus = true;
            if (settings.data && settings.data.length > 0) {
                for (var i = 0; i < settings.data.length; i++) {
                    methods._addItem.apply(this, [settings.data[i]]);
                }
            }
        },

        addItem: function(itemData) {
            var setting = $(this).data('InteData').settings;
            setting.data.push(itemData);
            methods._addItem.apply(this, [itemData]);
        },

        delItem: function(id) {
            var setting = $(this).data('InteData').settings;
            var i = 0;

            for (; i < setting.data.length; i++) {
                if (id == setting.data[i].id) {
                    break;
                }
            }
            if (i == setting.data.length)
                return;

            setting.data.splice(i, 1);
            $(".listbox_row[uid='" + id + "']").remove();

            if (setting.alterRow) {
                setting._alterStatus = true;
                $(".listbox_row", this).each(function(i, elem) {
                    if (setting._alterStatus) {
                        $(elem).removeClass("alter");
                    }
                    else {
                        $(elem).addClass("alter");
                    }
                    setting._alterStatus = !setting._alterStatus;
                });
            }
        },

        //私有
        _addItem: function(itemData) {
            var _self = $(this);
            var setting = _self.data('InteData').settings;
            var tr;
            if (setting.alterRow) {
                if (setting._alterStatus) {
                    tr = $("<div class=\"listbox_row\" uid=\"" + itemData.id + "\"></div>");
                }
                else {
                    tr = $("<div class=\"listbox_row alter\" uid=\"" + itemData.id + "\"></div>");
                }
                setting._alterStatus = !setting._alterStatus;
            }
            else
                tr = $("<div class=\"listbox_row\" uid=\"" + itemData.id + "\"></div>");

            tr.data("itemData", itemData);
            if (setting.check) {
                $("<input type=\"checkbox\" />").appendTo(tr);
            }

            var valueTD = $("<span title=\"" + itemData.value + "\" class=\"valueTd\">" + (itemData.value.length > setting.itemViewLen ? itemData.value.sub(0, itemViewLen - 3) + "..." : itemData.value) + "</span>");
            for (var key in setting.itemCustomMapping) {
                if (itemData[key]) {
                    valueTD.addClass(setting.itemCustomMapping[key]);
                }
            }

            valueTD.appendTo(tr);
            var btnDiv = $("<div class=\"btnDiv\"></div>").appendTo(tr);
            if (itemData.btns && itemData.btns.length > 0) {
                for (var i = itemData.btns.length - 1; i >= 0; i--) {
                    itemData.btns[i].appendTo(btnDiv);
                }
            }

            if (setting.mouse_over) {
                tr.bind("mouseover", setting.mouse_over);
            }

            if (setting.mouse_out) {
                tr.bind("mouseout", setting.mouse_out);
            }

            if (setting.mouse_enter) {
                tr.bind("mouseenter", setting.mouse_enter);
            }

            if (setting.mouse_leave) {
                tr.bind("mouseleave", setting.mouse_leave);
            }

            tr.click(function() {
                var $this = $(this);
                if (setting.multiselect) {
                    if ($this.hasClass("selected")) {
                        $this.removeClass("selected");
                        if (setting.selectItem && !$this.hasClass("selected"))
                            setting.unSelectItem.apply(this);
                    }
                    else {
                        $this.addClass("selected");
                        if (setting.selectItem && $this.hasClass("selected"))
                            setting.selectItem.apply(this);
                    }
                }
                else {
                    _self.find('.listbox_row').each(function() {
                        if ($(this)[0] != $this[0] && $(this).hasClass("selected")) {
                            $(this).removeClass("selected");
                            if (setting.selectItem && !$this.hasClass("selected"))
                                setting.unSelectItem.apply(this);
                        }
                    });
                    if ($this.hasClass("selected")) {
                        //                        $this.removeClass("selected");
                        //                        if (setting.selectItem && !$this.hasClass("selected"))
                        //                            setting.unSelectItem.apply(this);
                    }
                    else {
                        $this.addClass("selected");
                        if (setting.selectItem && $this.hasClass("selected"))
                            setting.selectItem.apply(this);
                    }
                }

                if (setting.clickItem)
                    setting.clickItem.apply(this);
            });

            if (setting.dbClickItem) {
                tr.dblclick(function() {
                    if (setting.dbClickItem)
                        setting.dbClickItem.apply(this);
                    return false;
                });
            }

            tr.appendTo(this);
            return tr;
        },

        //注销方法
        clearData: function() {
            return $(this).each(function() {
                var $this = $(this);
                $this.data('InteData').settings.data.length = 0;
                $(this).empty();
            })
        },

        getSeletedItems: function() {
            var result = $("div.selected", this);
            return result;
        },

        isItemSelected: function(id) {
            if ($("div[uid='" + id + "']", this).hasClass("selected"))
                return true;
            else
                return false;
        },

        selectItem: function(id) {
            var $this = $(this);
            if (!$this.data('InteData').settings.multiselect) {
                $("div.listbox_row", this).each(function() {
                    $this.removeClass("selected");
                });
            }
            $("div[uid='" + id + "']", this).addClass("selected");
        },

        getItemByID: function(id) {
            return $("div[uid='" + id + "']", this);
        },

        getAllItems: function() {
            return $(this).find("div.listbox_row");
        },
        itemCustomValue: function(itemData){
            if (itemData.savedPosition == true)
            return true;
        }
    };

    $.fn.listbox = function(method) {
        if (methods[method]) {
            return methods[method].apply(this, Array.prototype.slice.call(arguments, 1));
        } else if (typeof method === 'object' || !method) {
            return methods.init.apply(this, arguments);
        } else {
            $.error('Method ' + method + ' does not exist on jQuery.listbox');
        }
    };

})(jQuery);