﻿/*
Tab页控件
*/

(function($) {
    var methods = {
        //初始化方法
        init: function(options) {
            //设定属性--覆盖默认属性
            var settings = $.extend({
                map: []
            }, options);

            //设定属性--缓存属性到data中
            return this.each(function() {
                var $this = $(this);
                $this.addClass("tab");
                $this.data('InteData', {
                    target: $this,
                    settings: settings
                });

                for (var i in settings.map) {
                    $("#" + settings.map[i]["tab"]).click(function() {
                        $this = $(this);
                        for (var j in settings.map) {
                            $("#" + settings.map[j]["content"]).hide();
                            $("#" + settings.map[j]["tab"] + ">a").removeClass('active');
                        }
                        $(">a", this).addClass('active');
                        var mapItem = $.grep(settings.map, function(elem, index) {
                            return elem["tab"] == $this.attr("id");
                        });
                        $("#" + mapItem[0]["content"]).show();
                        $.cookie('tab', $this.attr("id"));
                        if (mapItem[0]["init"])
                            mapItem[0]["init"](this);

                    });
                }
            });
        },
        /**
        * 选中指定tab页
        * @param time
        */
        selectTab: function(id) {
            $("#" + id).click();
        },

        /**
        * 选中最后访问的tab页
        */
        selectLastTab: function() {
            var loadDefault = true;
            var lastTab = $.cookie('tab');
            if (lastTab) {
                if ($("#" + lastTab).length > 0 && $("#" + lastTab + ">a").is(":visible")) {
                    this.tab("selectTab", lastTab);
                    loadDefault = false;
                }
                else {
                    $.cookie('tab', null);
                }
            }
            if (loadDefault) {
                var settings = $(this).data('InteData')["settings"];
                var index = 0;
                for(var i in settings.map){
                    if($("#"+settings.map[i]["tab"]+">a").is(":visible")){
                        index = i;
                        break;
                    }
                }
                this.tab("selectTab", settings.map[0]["tab"]);
            }
        }
    };

    $.fn.tab = function(method) {
        if (methods[method]) {
            return methods[method].apply(this, Array.prototype.slice.call(arguments, 1));
        } else if (typeof method === 'object' || !method) {
            return methods.init.apply(this, arguments);
        } else {
            $.error('Method ' + method + ' does not exist on jQuery.tab');
        }
    };

})(jQuery);