(function($) {
    var methods = {
        //初始化方法
        init: function(options) {
            //设定属性--覆盖默认属性
            var settings = $.extend({
                hour: 1,
                minute: 0,
                second: 0,
                type:24, //时间类型：24，12
                isShowSecond:true,
                lang:'en-us'//语言：zh-cn，en-us
            }, options);
            
            //设定属性--缓存属性到data中
            return this.each(function() {
                var $this = $(this),
                data = $this.data('TimeSpan');

                var langList = {
                	"AM":'AM',
                	'PM':'PM'
                };
                if(settings.lang == 'zh-cn'){
                	langList = {
                    	"AM":'上午',
                    	'PM':'下午'
                    };
                }

                settings.langList = langList;

                $(this).data('TimeSpan', {
                    target: $this,
                    settings: settings
                });
                
                //当前获得焦点的输入框
                var curForcus;
                //上午下午
                settings.daySpan = "AM";

                var content = "<div class=\"timeContent_ts\">";
                content += "	<input class=\"hour_ts\" type=\"text\" maxlength='2' />";
                content += "	<div class=\"timeSplit\">:</div>";
                content += "	<input class=\"minute_ts\" type=\"text\" maxlength='2' />";
                if(settings.isShowSecond){
	                content += "	<div class=\"timeSplit\">:</div>";
	                content += "	<input class=\"second_ts\" type=\"text\" maxlength='2' />";
                }

                if(settings.type == 12){
	                content += "	<input class=\"daySpan_ts\" type=\"text\" readonly='readonly' />";
                }
                else{
	                content += "	<input class=\"daySpan_ts\" type=\"text\" readonly='readonly' style='display:none;' />";                	
                }
                content += "</div>";
                content += "<div class=\"btnContent_ts\">";
                content += "	<input type=\"button\" class=\"up_ts\"/>";
                content += "	<input type=\"button\" class=\"down_ts\"/>";
                content += "</div>";

                $(content).appendTo($this);
                $this.addClass("timeSpan");

                var slHour = $this.find(".hour_ts");
                var slMinutes = $this.find(".minute_ts");
                var slSecond = $this.find(".second_ts");
                var slDaySpan = $this.find(".daySpan_ts");
                curForcus = slHour;
                if(settings.type == 12){
	                if(settings.hour > 12){
	                	settings.daySpan = "PM";
	                	slHour.val(settings.hour-12);
	                }
	                else if(settings.hour == 12){
	                	settings.daySpan = "PM";
	                	slHour.val(settings.hour);	                	
	                }
	                else{
	                	settings.daySpan = "AM";
	                	if(settings.hour==0){
	                		settings.hour=12;
	                	}
	                	slHour.val(settings.hour);
	                }
	                slDaySpan.val(langList[settings.daySpan]);
                }
                else{
                	/*24小时格式时，变长*/
                	$this.find(".timeContent_ts").css("width", settings.isShowSecond ? "100px" : "66px");
                	$this.css("width", settings.isShowSecond ? "125px" : "91px");
                    slHour.val(settings.hour);                	
                }
                slMinutes.val(settings.minute);
                if(settings.isShowSecond){
	                slSecond.val(settings.second);
                }

            	slHour.blur(function(){
            		hourTest(slHour,settings.type);
            	});

            	slMinutes.blur(function(){
            		timeTest(slMinutes,0,59);
            	});

                if(settings.isShowSecond){
	            	slSecond.blur(function(){
	            		timeTest(slSecond,0,59);
	            	});
                }
                
                function hourTest($this,type){
                	if(type == 24){
                		timeTest($this,0,23);
                	}
                	else if(type==12){
                		timeTest($this,1,12);
                	}
                }
                
                function timeTest($this,min,max){
            		var val = $this.val();
            		if(/^\d+$/g.test(val)){
            			val = val*1;
            			if(val > max)
            				$this.val(max);
            			else if(val < min)
            				$this.val(min);
            		}
            		else{
            			$this.val(min);
            		}
            	}               
                TimeLimitEvent(slHour);
                TimeLimitEvent(slMinutes);
                if(settings.isShowSecond){
                	TimeLimitEvent(slSecond);
                }
                slDaySpan.focus(function(){
                	curForcus = $(this);
                });
                
				function TimeLimitEvent(txt) {
					txt.keydown(function(event) {
						var keyCode = GetKeyCode(event);
						return keyCode >= 48 && keyCode <= 57
								|| keyCode >= 96 && keyCode <= 105
								|| keyCode == 46 || keyCode == 8
								|| keyCode == 9;
					});
					txt.focus(function(){
	                	curForcus = $(this);
	                });
				} 
				
				function GetKeyCode(e){
					e = e ? e : window.event; 
					var keyCode = e.which ? e.which : e.keyCode;
					return keyCode;
				}
                $this.find(".up_ts").click(function(){ 
                	if(!curForcus)
                		return;
                	if(curForcus.hasClass("daySpan_ts")
                			&& settings.type == 12){
                		if(settings.daySpan=="PM"){
                			settings.daySpan="AM";
                		}
    	                slDaySpan.val(langList[settings.daySpan]);                		
                	}
                	else{
                		var curVal = curForcus.val()*1;
                		//小时
                    	if(curForcus.hasClass("hour_ts")){
                    		//12小时制
                    		if(settings.type == 12){
                        		if(settings.daySpan=="AM"){
                        			if(curVal==12){
                        				curVal = 1;
                        			}
                        			else if(curVal==11){
                    					curVal = 12;
                    					settings.daySpan="PM";
                    				}
                    				else{
                    					curVal++;
                    				}
                        			curForcus.val(AddZero(curVal));
                	                slDaySpan.val(langList[settings.daySpan]);   
                        		}
                        		else {
                        			if(curVal==12){
                            			curForcus.val("01");
                            		}
                            		else if(curVal<11){
                            			curForcus.val(AddZero(curVal+1));
                            		}
                        		}
                    		}
                    		//24小时制
                    		else if(curVal<23)
                    			curForcus.val(AddZero(curVal+1));
                    	}
                    	//分秒
                    	else{
                    		if(curVal<59)
                    			curForcus.val(AddZero(curVal+1));                     		
                    	}               		
                	}                	
                });
                $this.find(".down_ts").click(function(){ 
                	if(!curForcus)
                		return;
                	if(curForcus.hasClass("daySpan_ts")
                			&& settings.type == 12){
                		if(settings.daySpan=="AM"){
                			settings.daySpan="PM";
                		}
    	                slDaySpan.val(langList[settings.daySpan]);                		
                	}
                	else{
	                	var curVal = curForcus.val()*1;
	                	//小时
                    	if(curForcus.hasClass("hour_ts")){
                    		//12小时制
                    		if(settings.type == 12){
                        		if(settings.daySpan=="PM"){
                    				if(curVal==1){
                    					curVal = 12;
                    				}
                    				else if(curVal==12){
                    					curVal = 11;
                    					settings.daySpan="AM";
                    				}
                    				else{
                    					curVal--;
                    				}
                        			curForcus.val(AddZero(curVal));
                	                slDaySpan.val(langList[settings.daySpan]);   
                        		}
                        		else {
                        			if(curVal == 12){
                        				
                        			}
                        			else if(curVal>1){
                        				curForcus.val(AddZero(curVal-1));
                        			}
                        			else{
                        				curForcus.val(12);                        				
                        			}
                        		}
                    		}
                    		//24小时制
                    		else if(curVal>0)
                    		    curForcus.val(AddZero(curVal - 1));
                    	}
                    	//分秒
                    	else{
                    		if(curVal>0)
                    			curForcus.val(AddZero(curVal-1));                    		
                    	}
                	}
                });
                
            });
        },
        /**
         * 设置时间
         * @param time
         */
        SetTime: function(time) {
            var $this = $(this);
            var slHour = $this.find(".hour_ts");
            var slMinutes = $this.find(".minute_ts");
            var slSecond = $this.find(".second_ts");
            var slDaySpan = $this.find(".daySpan_ts");
            var settings = $this.data('TimeSpan').settings;
            if(settings.type == 12){
            	slDaySpan.show();
                if(time.Hour > 11){
                	settings.daySpan = "PM";
                	if(time.Hour >12)
                		slHour.val(AddZero(time.Hour-12));
                	else
                		slHour.val(12);
                }
                else{
                	settings.daySpan = "AM";
                	if(time.Hour == 0){
                        slHour.val(12);  
                	}
                	else{
                        slHour.val(AddZero(time.Hour));                		
                	}
                }
            	$this.find(".timeContent_ts").css("width",'');
            	$this.css("width",'');
                slDaySpan.val(settings.langList[settings.daySpan]);
            }
            else{
            	slDaySpan.hide();
            	/*24小时格式时，变长*/
            	$this.find(".timeContent_ts").css("width",'100px');
            	$this.css("width",'125px');
                slHour.val(AddZero(time.Hour));                	
            }
            slMinutes.val(AddZero(time.Minute));
            if(settings.isShowSecond){
                slSecond.val(AddZero(time.Second));
            }
        },

        /**
         * 读取时间
         */
        GetTime: function() {
            var $this = $(this);
            var time =
            {
                Hour: $this.find(".hour_ts").val()*1,
                Minute: $this.find(".minute_ts").val()*1
            };
            if($this.data('TimeSpan').settings.isShowSecond)
            	time.Second=$this.find(".second_ts").val()*1;

            var settings = $this.data('TimeSpan').settings;
            if(settings.type == 12){
            	if(settings.daySpan == "PM"){
            		if(time.Hour<12)
            			time.Hour += 12;
            	}
            	else if(time.Hour==12){
            		time.Hour = 0;
            	}
            }
            return time;
        },
        
        /**
         * 设置可用状态
         * @param isEnable
         */
        Enable: function(isEnable){
        	var $this = $(this);
            var inputs = $this.find("input");
    		inputs.attr("disabled", !isEnable);
    		if(isEnable){
        		$this.find(".btnContent_ts").show();        			
    		}
    		else{
        		$this.find(".btnContent_ts").hide();    			
    		}
        },
        
        /**
         * 设置时间类型：12小时制，24小时制
         * @param type ： 12，24
         */
        ChangeType: function(type){
        	var $this = $(this);
        	var timeTmp = $this.TimeSpan("GetTime");
            var settings = $this.data('TimeSpan').settings;
            settings.type = type;
            $this.TimeSpan("SetTime",timeTmp);
        }
    };

    $.fn.TimeSpan = function(method) {
        if (methods[method]) {
            return methods[method].apply(this, Array.prototype.slice.call(arguments, 1));
        } else if (typeof method === 'object' || !method) {
            return methods.init.apply(this, arguments);
        } else {
            $.error('Method ' + method + ' does not exist on jQuery.listbox');
        }
    };

})(jQuery);

function CompareTime(time1, time2)
{
	t1 = time1.Hour*60*60 + time1.Minute*60 + time1.Second*1;
	t2 = time2.Hour*60*60 + time2.Minute*60 + time2.Second*1;
	if(t1 >t2)
		return 1;
	else if(t1==t2)
		return 0;
	else 
		return -1;
}

function AddZero(num) {
    num = num + "";
    if (num.length < 2) {
        num = "0" + num;
    }
    return num;
}