﻿var xmlDoc;
var alarmOutGrid;
var alarmOutSaveResult = [];
var successRequest = 0;
$(function() {
    AlarmOutModule.initCtrl();
    getDeviceInfo(function(result) {
        AlarmOutModule.alarmOutCount = $("config>deviceInfo>alarmOutCount", result).text() * 1;
        AlarmOutModule.getData();
    });
});

var AlarmOutModule = {
    initCtrl: function() {
        $("#btnSave").click(function() {
            AlarmOutModule.setData();
        });

        $("#alarmOutGrid").wbGrid({
            data: {
                colNames: ["id",LangCtrl._L_("alarmOut"),LangCtrl._L_("alarmHoldingTime"),LangCtrl._L_("manualOperate")],
                colModel: [
                    { name: "@id", index: "@id", key: true,width: 0, align:"center",hidden:true},
                    { name: "alarmOut", index: "alarmOut", width: 160, align: "center", sortable: false,formatter: 'textbox', formatterParam: {
                        mode: 'always',
                        events: [{ name: 'click', handler: function () {
                            //alert($(this).val());
                        }
                        }]
                    } },
                    { name: "alarmHoldingTime", index: "alarmHoldingTime", width: 140, align: "center",  formatter: 'select',
                        formatterParam: {
                            mode: 'always',
                            items:[{ text: LangCtrl._L_("seconds").format(5), value: 5 },
                                    { text: LangCtrl._L_("seconds").format(10), value: 10 },
                                    { text: LangCtrl._L_("seconds").format(20), value: 20 },
                                    { text: LangCtrl._L_("seconds").format(30), value: 30 },
                                    { text: LangCtrl._L_("seconds").format(60), value: 60 },
                                    { text: LangCtrl._L_("minutes").format(2), value: 120 },
                                    { text: LangCtrl._L_("always"), value: 0xFF }],
                            'default': 'type2',
                            events: [{ name: 'change', handler: function () {
                                var rowData = $("#alarmOutGrid").wbGrid("getRowDataByCellInput", this);
                            }
                            }]
                        }, sortable: false, colselSwitch: false,
                        colselParam: {
                            mode: "default",
                            param: [
                                { text: LangCtrl._L_("seconds").format(5), value: 5 },
                                { text: LangCtrl._L_("seconds").format(10), value: 10 },
                                { text: LangCtrl._L_("seconds").format(20), value: 20 },
                                { text: LangCtrl._L_("seconds").format(30), value: 30 },
                                { text: LangCtrl._L_("seconds").format(60), value: 60 },
                                { text: LangCtrl._L_("minutes").format(2), value: 120 },
                                { text: LangCtrl._L_("always"), value: 0xFF }
                            ],
                            clickItem: function(event, gridId, value) {
                                var ids = [];
                                var grid = $("#" + gridId);
                                $.each(grid.wbGrid("getRowDatas"), function(index, element) {
                                    if (!element["grid-row-disabled"]) {
                                        ids.push(element["@id"]);
                                    }
                                });
                                grid.wbGrid("setCellsValueByIds", ids, [ "alarmHoldingTime" ], [ value ]);
                            }
                        }

                    },
                    { name: "manual", index: "manual", width: 180, align: "center", sortable: false,formatter: "custom",
                        formatterParam: {
                            init: function ($cell, rowData) {
                                var btn1 = $("<button class=\"cfgBtn\" style=\"text-align:center;\">"+LangCtrl._L_("open")+"</button>")
                                var btn2 = $("<button class=\"cfgBtn\" style=\"margin-left:10px;text-align:center;\">"+LangCtrl._L_("close")+"</button>");
                                btn1.click(function(event) {
                                    AlarmOutModule.manulOption(rowData["@id"],true);
                                    event.stopPropagation();
                                }).appendTo($cell);
                                btn2.click(function(event) {
                                    AlarmOutModule.manulOption(rowData["@id"],false);
                                    event.stopPropagation();
                                }).appendTo($cell);
                                return $cell;
                            }
                        }
                    }
                ],
                rowList: []
            },
            view: {
                selectRow : true
            },
            callback: {
                cellValueChanged: function(gridId, rowIndex, rowData) {
                    $("#btnSave").attr("disabled", false).removeClass("disabled");
                }
            }
        });
        alarmOutGrid = $("#alarmOutGrid");
        AlarmOutModule.getData();
    },
    getData: function() {
        var rowData = [];
        for(var k = 1; k <= AlarmOutModule.alarmOutCount; k++){
            rowData.push({
                "@id":""+k,
                "alarmOut":"",
                "alarmHoldingTime":""
            });
        }
        if (!rowData) {
            rowData = [];
        }
        if (!(rowData instanceof Array)) {
            rowData = [ rowData ];
        }
        alarmOutGrid.wbGrid("load", rowData);

        for (var i = 1; i <= AlarmOutModule.alarmOutCount; i++) {
            try {
                XmlHttpClient.SendHttpRequest({
                    url: serverBase + "/GetAlarmOutConfig/" + i,
                    type: "POST",
                    async: true,
                    data: "",
                    beforeSend: XmlHttpClient.CommBeforeSend,
                    callback: function(result) {
                        xmlDoc = result;
                        var id = $("config>alarmOut>id", xmlDoc).text();
                        alarmOutGrid.wbGrid("setCellsValueByIds", [ id ], [ "alarmOut", "alarmHoldingTime" ], [
                            $("config>alarmOut>alarmOutName", xmlDoc).text(),
                            $("config>alarmOut>alarmHoldTime",xmlDoc).text()
                        ], true);

                        var $alarmOutName = alarmOutGrid.wbGrid("getStandardCellCtrl", id, "alarmOut");
                        $alarmOutName.attr("maxlength", $("config>alarmOut>alarmOutName", xmlDoc).attr("maxLen") * 1);
                        window.top.hideLoading();
                    }
                });
            }
            catch (ex) {
                alert(ex);
            }
        }
    },
    manulOption: function(id, isOpen) {
            var sendXml = xmlHeader + "<config version=\"" + apiVersion + "\" xmlns=\"" + defaultNS + "\"><action><status>" + isOpen + "</status></action></config>";
            try {
                XmlHttpClient.SendHttpRequest({
                    url: serverBase + "/ManualAlarmOut/" + id,
                    type: "POST",
                    async: true,
                    data: sendXml,
                    beforeSend: XmlHttpClient.CommBeforeSend,
                    callback: function(result) {
                        window.top.hideLoading();
                        if ($("config", result).attr("status") == "success") {
                            window.top.showLoading();
                            window.top.MsgBoxHelper.Show("success", LangCtrl._L_("successTip"), LangCtrl._L_("sendSuccess"), null);
                            window.top.hideLoading();
                        }
                        else {
                            window.top.MsgBoxHelper.Show("error", LangCtrl._L_("errorTip"), LangCtrl._L_("sendFailed"), null);
                        }
                    }
                });
            }
            catch (ex) {
                alert(ex);
            }
    },
    getSaveData: function(rowData) {
        return xmlHeader + "<config version=\"" + apiVersion + "\" xmlns=\"" + defaultNS + "\"><alarmOut>"
			+ "<id>" + rowData["@id"] + "</id>"
			+ "<alarmOutName><![CDATA[" + rowData["alarmOut"] + "]]></alarmOutName>"
			+ "<alarmHoldTime>" + rowData["alarmHoldingTime"] + "</alarmHoldTime>"
			+ "</alarmOut></config>";
    },
    setData: function() {
        window.top.showLoading();
        successRequest = 0;
        alarmOutSaveResult = [];

        var editRowDatas = alarmOutGrid.wbGrid("getEditedRows");
        for (var i = 1; i <= AlarmOutModule.alarmOutCount; i++) {
            try {
                XmlHttpClient.SendHttpRequest({
                    url: serverBase + "/SetAlarmOutConfig/" + i,
                    type: "POST",
                    async: true,
                    data: AlarmOutModule.getSaveData(editRowDatas[i-1]),
                    beforeSend: XmlHttpClient.CommBeforeSend,
                    callback: function(result) {
                        var id = this.url.substr(this.url.lastIndexOf("/") + 1);
                        successRequest++;
                        alarmOutSaveResult.push({ id: id, result: result });
                        if (successRequest == AlarmOutModule.alarmOutCount) {
                            window.top.hideLoading();
                            var successIds = [];
                            var failedIds = [];
                            for (var i = 0; i < alarmOutSaveResult.length; i++) {
                                if ($("config", alarmOutSaveResult[i].result).attr("status") == "success") {
                                    successIds.push(alarmOutSaveResult[i].id * 1);
                                } else {
                                    failedIds.push(alarmOutSaveResult[i].id * 1);
                                }
                            }
                            if (failedIds.length > 0) {
                                if (failedIds.length == AlarmOutModule.alarmOutCount) {
                                    window.top.MsgBoxHelper.Show("error", LangCtrl._L_("errorTip"), LangCtrl._L_("alarmOutSaveFailed").format(failedIds.sort().join(",")), null);
                                } else {
                                    window.top.MsgBoxHelper.Show("error", LangCtrl._L_("errorTip"), LangCtrl._L_("alarmOutSaveFailed").format(failedIds.sort().join(",")) + LangCtrl._L_("alarmOutSaveSuccess").format(successIds.sort().join(",")), null);
                                }
                            } else {
                                window.top.MsgBoxHelper.Show("success", LangCtrl._L_("successTip"), LangCtrl._L_("alarmOutSaveSuccess").format(successIds.sort().join(",")), null);
                            }
                        }
                    }
                });
            }
            catch (ex) {
                alert(ex);
            }
        }
    }
};