﻿var xmlDoc;
jQuery.fn.ForceNumericOnly =
    function()
    {
        return this.each(function()
        {
            $(this).keydown(function(e)
            {
                var key = e.charCode || e.keyCode || 0;
                // allow backspace, tab, delete, arrows, numbers and keypad numbers ONLY
                return (
                    key == 8 ||
                    key == 9 ||
                    key == 46 ||
                    (key >= 37 && key <= 40) ||
                    (key >= 48 && key <= 57) ||
                    (key >= 96 && key <= 105));
            });
        });
    };

$(function(){
    alarmServerModule.initCtrl();
});

var alarmServerModule = {
	initCtrl: function() {
        $("#serverPort").ForceNumericOnly();
		$("#btnOK").click(function() {
            if (!alarmServerModule.verification()) {
                window.top.hideLoading();
                return false;
            }
            alarmServerModule.addData();
		});
        alarmServerModule.getData();

	},
	verification: function() {
		ClearFloatError();
        var $txtServerAddress = $("#serverAddress");
        var $txtServerPort = $("#serverPort");
        if ($.trim($txtServerAddress.val()).length != 0 || $.trim($txtServerPort.val()).length != 0) {
            if($.trim($txtServerAddress.val()).length == 0){
                ShowFloatError($txtServerAddress, LangCtrl._L_("addressNotEmptyTip"));
                return false;
            }
            if(/^.*[\u4e00-\u9fa5]+.*$/i.test($txtServerAddress.val())){
                ShowFloatError($txtServerAddress, LangCtrl._L_("invalidChar"));
                return false;
            }
            if($.trim($txtServerPort.val()).length == 0){
                ShowFloatError($txtServerPort, LangCtrl._L_("portNotEmptyTip"));
                return false;
            }else if($txtServerPort.val()<0 || $txtServerPort.val() > 65535){
                ShowFloatError($txtServerPort, LangCtrl._L_("portNotInRange"));
                return false;
            }
        }
		return true;
	},
    getData: function() {
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/GetAlarmServerConfig",
                type: "POST",
                async: true,
                data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    xmlDoc = result;
                    $("#serverAddress").val($("config>alarmServer>serverAddr",xmlDoc).text());
                    $("#serverPort").val($("config>alarmServer>serverPort",xmlDoc).text());
                    window.top.hideLoading();
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    getSaveData: function() {
        $("config>alarmServer>serverAddr", xmlDoc).empty().append(xmlDoc.createCDATASection($("#serverAddress").val()));
        $("config>alarmServer>serverPort", xmlDoc).text($("#serverPort").val());
        return XMLDoc2XMLStr(xmlDoc);
    },
    addData : function(){
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/SetAlarmServerConfig",
                type: "POST",
                async: true,
                data: alarmServerModule.getSaveData(),
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    window.top.hideLoading();
                    if ($("config", result).attr("status") == "success") {
                        window.top.MsgBoxHelper.Show("success", LangCtrl._L_("successTip"), LangCtrl._L_("setSuccess"), null);
                    }
                    else {
                        window.top.MsgBoxHelper.Show("error", LangCtrl._L_("errorTip"), LangCtrl._L_("setFailed"), null);
                    }
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    }
};