﻿var holidaySchedules;
var NetLiveMonitor;
var xmlDoc;

$(function() {
	initControl();
    $("#Content", window.top.document).css("min-width", "1200px");
	$("#divParent").tab({
		map: [{ "tab": "liMotionDetectionTrigger", "content": "divMotionDetectionTrigger", init: initMotionDetectionTrigger },
			{ "tab": "liMotionDetectionArea", "content": "divMotionDetectionArea", init: initMotionDetectionArea },
			{ "tab": "liMotionDetectionSchedule", "content": "divMotionDetectionSchedule", init: initMotionDetectionSchedule}]
	});
	$("#divParent").tab("selectLastTab");
    closeStream();
    window.parent.setConfigMiniHeight(0);
    $(window.top).resize(function() {
        window.parent.setConfigMiniHeight(0);
    });
});

function initMotionDetectionTrigger() {
    $(".cfgfooter").css("width","20%").show();
	clearTab($("#divMotionDetectionTrigger"));
	getDeviceInfo(function(result) {
		TriggerModule.isSupportSDCard = $("config>deviceInfo>supportSDCard", result).text() === "true";
	});
    TriggerModule.getEmailListData();
}

function initMotionDetectionArea() {
//	$("#Content", window.top.document).css("min-height", cfgMinHeight);
    $(".cfgfooter").css("width","743px").hide();
	clearTab($("#divMotionDetectionArea"));
    if(!NetLiveMonitor){
        AreaModule.setOCX();
    }
    AreaModule.getData();
}

function initMotionDetectionSchedule() {
    ScheduleModule.ajustScheduleHeight();
    $(".cfgfooter").css("width","735px").show();
	ScheduleModule.getData();
}

var TriggerModule = {
    callbackComplete1: false,// ajax是否执行完毕
    callbackComplete2: false,// ajax是否执行完毕
	mapping: {
		chkEnableAlarm: "config>motion>switch",
		chkTriggerSnap: "config>motion>savePicSwitch",
        chkTriggerSDRec: "config>motion>sdRecSwitch",
		chkTriggerEmail: "config>motion>mail>switch", 
		chkTriggerFTP: "config>motion>ftp>switch"
	},
	toggle: function(enabled) {
		if (!enabled) {
			$(".triggle").hide();
		} else {
			$(".triggle:not(#trTriggerSnap,#trTriggerSDRec)").show();
			if (TriggerModule.isSupportSDCard) {
				$("#trTriggerSnap").show();
                $("#trTriggerSDRec").show();
			}
            TriggerModule.toggleFtpList($("#chkTriggerFTP").attr("checked") == "checked");
            TriggerModule.toggleEmailList($("#chkTriggerEmail").attr("checked") == "checked");
		}

	},
    toggleFtpList: function(enabled){
        if (!enabled) {
            $(".triggleFtp").hide();
        } else {
            TriggerModule.ajustHeight();
            $(".triggleFtp").show();
        }
    },
    toggleEmailList: function(enabled){
        if (!enabled) {
            $(".triggleEmail").hide();
        } else {
            TriggerModule.ajustHeight();
            $(".triggleEmail").show();
        }
    },
    ajustHeight: function() {
        var minHeight = $("#divMotionDetectionTrigger").height() + 160;
        window.parent.setConfigMiniHeight(minHeight);
    },
	initCtrl: function() {
		$(".trigger").hide();

		$("#chkEnableAlarm").click(function(e) {
			TriggerModule.toggle($(this).attr("checked") == "checked");
		});

		$("#cboAlarmHoldingTime").selectInput({
			list: [
				{ text: LangCtrl._L_("seconds").format(5), value: 5 },
				{ text: LangCtrl._L_("seconds").format(10), value: 10 },
				{ text: LangCtrl._L_("seconds").format(20), value: 20 },
				{ text: LangCtrl._L_("seconds").format(30), value: 30 },
				{ text: LangCtrl._L_("seconds").format(60), value: 60 },
				{ text: LangCtrl._L_("minutes").format(2), value: 120 }
			],
			mapping: function(text) {
				var validReg = /^[1-9]\d*$/;
				var execResults = validReg.exec(text);
				if (execResults) {
					return { text: execResults[0] % 60 == 0 ? LangCtrl._L_("minutes").format(execResults[0] / 60) : LangCtrl._L_("seconds").format(execResults[0]), value: execResults[0] };
				}

				validReg = new RegExp("^" + LangCtrl._L_("seconds").format("([1-9]\\d*)") + "$");
				execResults = validReg.exec(text);
				if (execResults) {
					return { text: text, value: execResults[1] };
				}

				validReg = new RegExp("^" + LangCtrl._L_("minutes").format("([1-9]\\d*)") + "$");
				execResults = validReg.exec(text);
				if (execResults) {
					return { text: text, value: execResults[1] * 60 };
				}
				return false;
			}
		});
	},
    getEmailListData: function(){
        window.top.showLoading();
        XmlHttpClient.SendHttpRequest({
            url: serverBase + "/GetMailConfig",
            type: "POST",
            async: true,
            data: "",
            beforeSend: XmlHttpClient.CommBeforeSend,
            callback: function(result) {

                var emailList = "";
                var d = document.getElementById('dvCompute');
                $("config>mail>recvMail>item",result).each(function(i,ele){
                    var emailName = $(ele).text();
                    d.innerHTML = emailName;
                    var  averageLen = d.offsetWidth / (emailName.length);
                    var indexStr = Math.floor(210 / averageLen);
                    var imageName =  d.offsetWidth > 210 ? (emailName.substr(0, indexStr) + "...") : emailName;
                    emailList = emailList +"<tr>" +
                        "<td style='word-break:keep-all;width: 260px;'>" + "<div title='"+ $(ele).text()+"'>"+"<input id='chkTriggerEmailAddr_"  + i + "' class='emailServer' type='checkbox' />"+imageName +"</div>"+ "</td>" +
                        "<td><input id='chkTriggerEmailPic_" + i + "' class='emailPic' type='checkbox' disabled/><label for='chkTriggerEmailPic_" + i +"' >" + LangCtrl._L_("pictureSend") + "</label></td>" +
                        "</tr>";
                });

                var alarmOutEmailList = $("#divEmailTable");
                var alarmOutEmailTitle = $("#divEmailTitle");
                var motionEmailTheme = $("#divEmailTheme");
                alarmOutEmailList.empty();
                alarmOutEmailTitle.empty();
                motionEmailTheme.empty();
                $("<table  class='contentTable' cellpadding='0' cellspacing='0' style='table-layout: fixed;'>" +
                    "<tbody>" +
                    "<tr>" +
                    "<td style='width: 260px;'>" + LangCtrl._L_("emailServer") + "</td>" +
                    "<td><input id='chkTriggerEmailPic'  type='checkbox' /><label for='chkTriggerEmailPic' >" + LangCtrl._L_("pictureSend") + "</label></td>" +
                    "</tr>" +
                    "</tbody>" +
                    "</table>").appendTo(alarmOutEmailTitle);
                $(emailList).appendTo(alarmOutEmailList);
                $("<table  class='contentTable' cellpadding='0' cellspacing='0' style='table-layout: fixed;'>" +
                    "<tbody>" +
                    "<tr>" +
                    "<td style='width: 100px;'>" + LangCtrl._L_("emailTheme") + "</td>" +
                    "<td><input id='emailTheme'  type='text' style='width: 300px;'/></td>" +
                    "</tr>" +
                    "<tr>" +
                    "<td style='width: 160px;'>" + LangCtrl._L_("emailContent") + "</td>" +
                    "<td><input id='emailContent'  type='text'  style='width: 300px;'/></td>" +
                    "</tr>" +
                    "</tbody>" +
                    "</table>").appendTo(motionEmailTheme);

                $("#chkTriggerEmailPic").click(function(){
                    var emialPicList = $(this).parent().parent().parent().parent().parent().next().find(".emailPic");
                    if($(this).attr("checked")){
                        for(var m=0;m<emialPicList.length;m++){
                            var chkEmailPic = $(emialPicList[m]);
                            if(chkEmailPic.attr("disabled")){
                                chkEmailPic.attr("checked",false);
                            }else{
                                chkEmailPic.attr("checked","checked");
                            }
                        }
                    }else{
                        $(emialPicList).attr("checked",false);
                    }
//                    if($(this).attr("checked") === "checked"){
//                        $(emialPicList).attr("checked","checked");
//                    }else{
//                        $(emialPicList).attr("checked",false);
//                    }
                });

                $(".emailServer").click(function(){
                    var emailPic = $(this).parent().parent().parent().find(".emailPic");
                    if( $(this).attr("checked")){
                        emailPic.removeAttr("disabled");
                    }else{
                        emailPic.attr("disabled","disabled");
                        emailPic.attr("checked",false);
                    }
                });
                TriggerModule.getFTPListData();
            }
        });
    },
    getFTPListData: function(){
        window.top.showLoading();
        XmlHttpClient.SendHttpRequest({
            url: serverBase + "/GetFtpConfig",
            type: "POST",
            async: true,
            data: "",
            beforeSend: XmlHttpClient.CommBeforeSend,
            callback: function(result) {

                var ftpList = "";
                var d = document.getElementById('dvCompute');
                $("config>ftp>item",result).each(function(i,ele){
                    var ftpName = $(">serverAddr",ele).text();
                    d.innerHTML = ftpName;
                    var  averageLen = d.offsetWidth / (ftpName.length);
                    var indexStr = Math.floor(210 / averageLen);
                    var imageName =  d.offsetWidth > 210 ? (ftpName.substr(0, indexStr) + "...") : ftpName;
                    ftpList = ftpList +"<tr>" +
                        "<td style='word-break:keep-all;width: 260px;'>" + "<div title='"+ ftpName+"'>"+"<input id='chkTriggerFTPAddr_"  + i + "' class='ftpServer' type='checkbox' />"+imageName +"</div>"+ "</td>" +
//                        "<td><input id='chkTriggerFTPRec_" + i + "' class='FTPRec' type='checkbox' /><label for='chkTriggerFTPRec_" + i +"' >" + LangCtrl._L_("recSend") + "</label></td>" +
                        "<td><input id='chkTriggerFTPPic_" + i + "' class='FTPPic' type='checkbox' disabled/><label for='chkTriggerFTPPic_" + i +"' >" + LangCtrl._L_("pictureSend") + "</label></td>" +
                        "</tr>";
                });

                var alarmOutFTPList = $("#divFTPTable");
                var alarmOutFTPTitle = $("#divFTPTitle");
                alarmOutFTPList.empty();
                alarmOutFTPTitle.empty();
                $("<table  class='contentTable' cellpadding='0' cellspacing='0' style='table-layout: fixed;' width='100%'>" +
                    "<tbody>" +
                    "<tr>" +
                    "<td style='width: 260px;'>" + LangCtrl._L_("FTPServer") + "</td>" +
                    "<td><input id='chkTriggerFTPPic'  type='checkbox' /><label for='chkTriggerFTPPic' >" + LangCtrl._L_("pictureSend") + "</label></td>" +
                    "</tr>" +
                    "</tbody>" +
                    "</table>").appendTo(alarmOutFTPTitle);
                $(ftpList).appendTo(alarmOutFTPList);

                $("#chkTriggerFTPPic").click(function(){
                    var ftpPicList = $(this).parent().parent().parent().parent().parent().next().find(".FTPPic");
                    if($(this).attr("checked")){
                        for(var m=0;m<ftpPicList.length;m++){
                            var chkFtpPic = $(ftpPicList[m]);
                            if(chkFtpPic.attr("disabled")){
                                chkFtpPic.attr("checked",false);
                            }else{
                                chkFtpPic.attr("checked","checked");
                            }
                        }
                    }else{
                        $(ftpPicList).attr("checked",false);
                    }

//                    if($(this).attr("checked") === "checked"  && $(ftpPicList).attr("disabled") == "undefined"){
//                        $(ftpPicList).attr("checked","checked");
//                    }else{
//                        $(ftpPicList).attr("checked",false);
//                    }
                });

                $(".ftpServer").click(function(){
                    var chkFTPPic = $(this).parent().parent().parent().find(".FTPPic");
                    if( $(this).attr("checked")){
                        chkFTPPic.removeAttr("disabled");
                    }else{
                        chkFTPPic.attr("disabled","disabled");
                        chkFTPPic.attr("checked",false);
                    }
                });

                //录像的只一个
                $(".FTPRec").click(function(){
                    var ftpRecList = $(this).parent().parent().parent().find(".FTPRec");
                    for(var m=0;m<ftpRecList.length;m++){
                        var chkFtpRec = $(ftpRecList[m]);
                        if(chkFtpRec.attr("id") == $(this).attr("id")){
                            chkFtpRec.attr("checked","checked");
                        }else{
                            chkFtpRec.attr("checked",false);
                        }
                    }
                });
                TriggerModule.getData();
            }
        });
    },
	getData: function() {
		window.top.showLoading();
		try {
			XmlHttpClient.SendHttpRequest({
				url: serverBase + "/GetMotionConfig",
				type: "POST",
				async: true,
				data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
				callback: function(result) {
					xmlDoc = result;
					var alarmEnabled = ($(TriggerModule.mapping.chkEnableAlarm, xmlDoc).text().toLowerCase() === "true");
					var divAlarmOut = $("#divAlarmOut");
					divAlarmOut.empty();

                    var alarmOutList = $("config>motion>triggerAlarmOut>item", xmlDoc);
                    if(alarmOutList.length <= 1){
                        $("config>motion>triggerAlarmOut>item", xmlDoc).each(function(index, element) {
                            var $this = $(this);
                            var id = $this.attr("id");
                            var isSwitch = $this.text().toLowerCase() === "true";
                            divAlarmOut.append($("<input id=\"chkAlarmOut" + id + "\" type=\"checkbox\" " + (isSwitch ? "checked=\"checked\"" : "") + " />"));
                            divAlarmOut.append($("<label for=\"chkAlarmOut" + id + "\">" + LangCtrl._L_("alarmOut") + "</label>"));
                        });
                    }else{
                        $("config>motion>triggerAlarmOut>item", xmlDoc).each(function(index, element) {
                            var $this = $(this);
                            var id = $this.attr("id");
                            var isSwitch = $this.text().toLowerCase() === "true";
                            divAlarmOut.append($("<input id=\"chkAlarmOut" + id + "\" type=\"checkbox\" " + (isSwitch ? "checked=\"checked\"" : "") + " />"));
                            divAlarmOut.append($("<label for=\"chkAlarmOut" + id + "\">" + LangCtrl._L_("alarmOut") + " " + id + "</label>"));
                        });
                    }

                    var chkTriggerEmail = $("#chkTriggerEmail");
                    chkTriggerEmail.attr("checked", $("config>motion>mail>switch", xmlDoc).text().toLowerCase() === "true");
                    chkTriggerEmail.click(function(e) {
                        TriggerModule.toggleEmailList($(this).attr("checked") == "checked");
                        TriggerModule.ajustHeight();
                    });
                    var emailChkList = $("#divEmail" ).find(".emailServer");
                    var emailChkPicList = $("#divEmail").find(".emailPic");
                    $("config>motion>mail>item", xmlDoc).each(function(i,element){
                        $(emailChkList[$(element).attr("id")-1]).attr("checked","checked");
                        $(emailChkPicList[$(element).attr("id")-1]).removeAttr("disabled");
                    });
                    $("config>motion>mail>item", xmlDoc).each(function(i,element){
                        if($(">sendPic",element).text() === "true"){
                            $(emailChkPicList[$(element).attr("id")-1]).attr("checked","checked");
                        }
                    });

                    var subject = $("config>motion>mail>subject", xmlDoc);
                    var content = $("config>motion>mail>content", xmlDoc);
//                    $("#emailTheme").attr("maxLength",subject.attr("maxLen"));
//                    $("#emailContent").attr("maxLength",content.attr("maxLen"));
                    $("#emailTheme").val(subject.text());
                    $("#emailContent").val(content.text());

                    var chkTriggerFTP = $("#chkTriggerFTP");
                    chkTriggerFTP.attr("checked", $("config>motion>ftp>switch", xmlDoc).text().toLowerCase() === "true");
                    chkTriggerFTP.click(function(e) {
                        TriggerModule.toggleFtpList($(this).attr("checked") == "checked");
                        TriggerModule.ajustHeight();
                    });
                    var ftpChkList = $("#divFTP" ).find(".ftpServer");
                    var ftpChkPicList = $("#divFTP").find(".FTPPic");
                    var ftpChkRecList = $("#divFTP").find(".FTPRec");
                    $("config>motion>ftp>item", xmlDoc).each(function(i,element){
                        $(ftpChkList[$(element).attr("id")-1]).attr("checked","checked");
                        $(ftpChkPicList[$(element).attr("id")-1]).removeAttr("disabled");
                    });

                    $("config>motion>ftp>item", xmlDoc).each(function(i,element){
                        if($(">sendPic",element).text() === "true"){
                            $(ftpChkPicList[$(element).attr("id")-1]).attr("checked","checked");
                        }
                        if($(">sendRec",element).text() === "true"){
                            $(ftpChkRecList[$(element).attr("id")-1]).attr("checked","checked");
                        }
                    });

					var holdTime = $("config>motion>alarmHoldTime", xmlDoc).text();
					$("#cboAlarmHoldingTime").selectInput("setData", { text: holdTime, value: holdTime });
					XmlHttpClient.BindPageByXml(TriggerModule.mapping, xmlDoc);
					TriggerModule.toggle(alarmEnabled);
                    TriggerModule.toggleFtpList(chkTriggerFTP.attr("checked") == "checked" && $("config>motion>switch", xmlDoc).text().toLowerCase() === "true");
                    TriggerModule.toggleEmailList(chkTriggerEmail.attr("checked") == "checked" && $("config>motion>switch", xmlDoc).text().toLowerCase() === "true");
                    if( $("config>motion>triggerAlarmOut", xmlDoc).attr("count") == "0"){
                        $("#trAlarmOutTitle").remove();
                        $("#trDivAlarmOut").remove();
                    }
                    if($("config>motion>sdRecSwitch", xmlDoc).size() < 1){
                        $("#trTriggerSDRec").hide();
                    }
					window.top.hideLoading();
				}
			});
		}
		catch (ex) {
			alert(ex);
		}
	},
    verification: function() {
        ClearFloatError();
        var emailTheme = $("#emailTheme");
        var emailContent = $("#emailContent");
        var subject = $("config>motion>mail>subject", xmlDoc);
        var content = $("config>motion>mail>content", xmlDoc);
        if((emailTheme.val()+"").getBytesLength() > subject.attr("maxLen")){
            ShowFloatError(emailTheme, LangCtrl._L_("nameTooLong"));
            return false;
        }
        if((emailContent.val()+"").getBytesLength() > content.attr("maxLen")){
            ShowFloatError(emailContent, LangCtrl._L_("nameTooLong"));
            return false;
        }
        return true;
    },
	getSaveData: function() {
		$("[id^=\"chkAlarmOut\"]").each(function(index, element) {
			$("config>motion>triggerAlarmOut>item[id=\"" + $(element).attr("id").substr(11) + "\"]", xmlDoc).text($(this).is(":checked") ? "true" : "false");
		});
		$("config>motion>alarmHoldTime", xmlDoc).text($("#cboAlarmHoldingTime").selectInput("getValue"));

        var divEmailList = $("#divEmail").find(".emailServer");
        $("config>motion>mail>item", xmlDoc).remove();
        $("config>motion>mail>switch",xmlDoc).text($("#chkTriggerEmail").is(":checked") ? "true" : "false");
        $("config>motion>mail>subject", xmlDoc).remove();
        $("config>motion>mail>content", xmlDoc).remove();
        $("config>motion>mail",xmlDoc).append(
            $(xmlDoc.createElement("subject")).attr("type","string").attr("maxLen","63").append(
                xmlDoc.createCDATASection($("#emailTheme").val())
            )
        );
        $("config>motion>mail",xmlDoc).append(
            $(xmlDoc.createElement("content")).attr("type","string").attr("maxLen","255").append(
                xmlDoc.createCDATASection($("#emailContent").val())
            )
        );
        var countEmail = 0;
        for(var i= 0,len = divEmailList.length;i<len;i++){
            if($(divEmailList[i]).attr("checked") === "checked"){
                countEmail++;
                $("config>motion>mail", xmlDoc).append(
                    $(xmlDoc.createElement("item")).attr("id",i+1).append(
                        $(xmlDoc.createElement("sendPic")).attr("type","boolean").append(
                                $(divEmailList[i]).parent().parent().next().find("input").attr("checked") === "checked" ? "true" : "false"
                        )
                    )
                );
            }
        }
        $("config>motion>mail", xmlDoc).attr("count",countEmail);

        var divFtpList = $("#divFTP").find(".ftpServer");
        $("config>motion>ftp>item", xmlDoc).remove();
        $("config>motion>ftp>switch",xmlDoc).text($("#chkTriggerFTP").is(":checked") ? "true" : "false");
        var count = 0;
        for(var i= 0,len = divFtpList.length;i<len;i++){
            if($(divFtpList[i]).attr("checked") === "checked"){
                count++;
                $("config>motion>ftp", xmlDoc).append(
                    $(xmlDoc.createElement("item")).attr("id",i+1).append(
                        $(xmlDoc.createElement("sendPic")).attr("type","boolean").append(
                                $(divFtpList[i]).parent().parent().next().find("input").attr("checked") === "checked" ? "true" : "false"
                        )
                    )
                        .append(
                       $(xmlDoc.createElement("sendRec")).attr("type","boolean").append(
                                $(divFtpList[i]).parent().parent().next().find("input").attr("checked") === "checked" ? "true" : "false"
                        )
                    )
                );
            }
        }

        $("config>motion>ftp", xmlDoc).attr("count",count);
        var result = XMLDoc2XMLStr(xmlDoc);
        return XmlHttpClient.GetXmlByPage(TriggerModule.mapping, xmlDoc)
	},
	setData: function() {
		window.top.showLoading();
        if (!TriggerModule.verification()) {
            window.top.hideLoading();
            return false;
        }
		try {
			XmlHttpClient.SendHttpRequest({
				url: serverBase + "/SetMotionConfig",
				type: "POST",
				async: true,
				data: TriggerModule.getSaveData(),
                beforeSend: XmlHttpClient.CommBeforeSend,
				callback: function(result) {
					window.top.hideLoading();
					commSaveResponseHadler(result);
				}
			});
		}
		catch (ex) {
			alert(ex);
		}
	}
};

var AreaModule = {
    action:"EDIT_ON",   //EDIT_ON,EDIT_OFF,NONE
    setAction:function(action){
        $("#btnDraw").removeAttr("class");
        this.action = action;
        switch (action) {
            case "disable":
                $("#btnDraw").addClass("disable").attr("value", LangCtrl._L_("drawArea"));
                break;
            case "on":
                var sendXML = OCX_XML_SetMotionAreaAction("EDIT_ON");
                NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
                $("#btnDraw").removeClass("off").addClass("on").attr("value", LangCtrl._L_("stopDraw"));
                break;
            case "off":
                var sendXML = OCX_XML_SetMotionAreaAction("EDIT_OFF");
                NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
                $("#btnDraw").removeClass("on").addClass("off").attr("value", LangCtrl._L_("drawArea"));
                break;
        }
    },
	initCtrl: function() {
		$("#sliderSensitivity").slider({
			minValue: 0,
			maxValue: 0,
			maxWidth: 124,
			thumbCss: "slider_thumb_1",
			valueChangeEvent: function(value) {
				$("#valueSensitivity").val(value);
			}
		});

		$("#rdoAreaOpTypeAdd").click(function() {
			var sendXML = OCX_XML_SetMotionAreaAction("ADD");
			NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
		});

		$("#rdoAreaOpTypeErase").click(function() {
			var sendXML = OCX_XML_SetMotionAreaAction("DEL");
			NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
		});

		$("#btnSelectAll").click(function() {
			var sendXML = OCX_XML_SetMotionAreaAction("ALL");
			NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
		});

		$("#btnClearAll").click(function() {
			var sendXML = OCX_XML_SetMotionAreaAction("NONE");
			NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
		});

		$("#btnInvertSelection").click(function() {
			var sendXML = OCX_XML_SetMotionAreaAction("INVERSE");
			NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
		});

        $("#btnDraw").click(function() {
            if (AreaModule.action == "disable")
                return;
            if (AreaModule.action == "on") {
                AreaModule.setAction("off");
            }
            else {
                AreaModule.setAction("on");
            }
        });
	},
	getData: function() {
		window.top.showLoading();
		try {
			XmlHttpClient.SendHttpRequest({
				url: serverBase + "/GetMotionConfig",
				type: "POST",
				async: true,
				data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
				callback: function(result) {
					xmlDoc = result;
					AreaModule.bindCtrlData();

					var sensitivityNode = $("config>motion>sensitivity", xmlDoc);
					$("#sliderSensitivity").slider("setValueWithEvent", sensitivityNode.text() ? sensitivityNode.text() : sensitivityNode.attr("default"));

					var motion = {};
					motion.column = $("config>motion>area>itemType", xmlDoc).attr("maxLen");
					motion.row = $("config>motion>area", xmlDoc).attr("count");
					motion.areaInfo = [];
					$("config>motion>area>item", xmlDoc).each(function(index, element) {
						motion.areaInfo.push($(this).text());
					});

					var sendXML = OCX_XML_SetMotionArea(motion);
					NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);

					window.top.hideLoading();
				}
			});
		}
		catch (ex) {
			alert(ex);
		}
	},
	bindCtrlData: function() {
		var sensitivityNode = $("config>motion>sensitivity", xmlDoc);
		var sliderSensitivity = $("#sliderSensitivity");
		sliderSensitivity.slider("setProperty", "minValue", sensitivityNode.attr("min") * 1);
		sliderSensitivity.slider("setProperty", "maxValue", sensitivityNode.attr("max") * 1);
	},
	getSaveData: function() {
		$("config>motion>sensitivity", xmlDoc).text($("#sliderSensitivity").slider("getValue"));

		var sendXML = OCX_XML_GetMotionArea();
		var result = NetLiveMonitor.QueryInfo(sendXML, sendXML.length);

		var $xmlDoc = $(XMLStr2XMLDoc(result));
		$("config>motion>area>item", xmlDoc).each(function(index, element) {
			$(this).empty().append(xmlDoc.createCDATASection($("response>areaInfo>item:eq(" + index + ")", $xmlDoc).text()));
		});

		return XMLDoc2XMLStr(xmlDoc);
	},
	setData: function() {
		window.top.showLoading();
		try {
			XmlHttpClient.SendHttpRequest({
				url: serverBase + "/SetMotionConfig",
				type: "POST",
				async: true,
				data: AreaModule.getSaveData(),
                beforeSend: XmlHttpClient.CommBeforeSend,
				callback: function(result) {
					window.top.hideLoading();
					commSaveResponseHadler(result);
				}
			});
		}
		catch (ex) {
			alert(ex);
		}
	},
	setOCX: function() {
//		window.top.showLoading();
		try {
			XmlHttpClient.SendHttpRequest({
				url: serverBase + "/GetPortConfig",
				type: "POST",
				async: true,
				data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
				callback: function(result) {
                    netPort = $("config>port>netPort", result).text() * 1;
                    $("#divOCX").empty();
                    NetLiveMonitor = LoadPlugin("divOCX","NetLiveMonitor");
                    // 设置模式
                    var sendXML = OCX_XML_SetPreViewModel("ReadOnly");
                    NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
				}
			});
		}
		catch (ex) {
			alert(ex);
		}
	}
};

//OCX调用js方法
function NotifyResultToJs(strXMLFormat, lStrLen) {
    var $xmlDoc = $(XMLStr2XMLDoc(strXMLFormat));

    // OCX已创建好窗口，通知可以登录了
    if ($("statenotify[type=\"Login\"]", $xmlDoc).length > 0) {
        var userInfo = Decryption($.cookie("auInfo"));
        var userInfoArr = userInfo.split(":");
        //设置登录信息
        var username = userInfoArr[0];
        var password = userInfoArr[1];
        var id = "";
        // 设置模式
        var sendXML = OCX_XML_SetPreViewModel("ReadOnly");
        NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);

        var sendXML = OCX_XML_SetLoginInfo(username, password, serverIp, netPort, id);
        NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);

        // 设置预览码流索引
        var sendXML = OCX_XML_SetStreamType(2);
        NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
    }

    if ($("statenotify[type=\"GetOriginalWH\"]", $xmlDoc).length > 0) {
        $("#divOCX").css({width:"400px",height:"300px"});
        AreaModule.getData();
    }

    var Connect  = $("statenotify[type='Connect']",$xmlDoc);
    if(Connect.length > 0){
        if($(">status", Connect).text() === "limit"){
            window.top.MsgBoxHelper.Show("info", LangCtrl._L_("infoTip"), LangCtrl._L_("limit"), AreaModule.getData);
        }
    }
}

var ScheduleModule = {
    ajustScheduleHeight: function() {
        var minHeight = $("#divMotionDetectionSchedule").height() + 140;
        window.parent.setConfigMiniHeight(minHeight);
    },
	initCtrl: function() {
//        $("#Content", window.top.document).css({"min-height":"770px"});
		$("#dpHoliday").dateInput({
			format: "MM-dd",
			defaultValue: new Date().format("MM-dd")
		});

		$("#divDate").listbox({
			data: [],
			selectItem: function() {
				var itemData = $(this).data("itemData");
				var times = holidaySchedules[itemData.value];
				var timelineObj = $("#divHolidayTimeline");
				timelineObj.timeline("clearTimes");
				$.each(times, function(index, element) {
					timelineObj.timeline("setTime", element);
				});
			},
			clickItem: function() {
				var itemData = $(this).data("itemData");
				var times = holidaySchedules[itemData.value];
				var timelineObj = $("#divHolidayTimeline");
				timelineObj.timeline("clearTimes");
				$.each(times, function(index, element) {
					timelineObj.timeline("setTime", element);
				});
			},
			unSelectItem: function() {
			}
		});

		$("#btnHolidayAdd").click(function(event) {
			var dateStr = $("#dpHoliday").val();
			ClearFloatError();
			for (var key in holidaySchedules) {
				if (key == dateStr) {
					ShowFloatError($("#divDate"), LangCtrl._L_("notUniqueDateTip"));
					return;
				}
			}
			$("#divHolidayTimeline").timeline("setEnable", true);
			holidaySchedules[dateStr] = ["00:00-23:59"];
			$("#divDate").listbox("addItem", { id: dateStr, value: dateStr });
			var lastItem = $("#divDate").listbox("getAllItems").last();
			lastItem.click();
			lastItem[0].scrollIntoView();
		});

		$("#btnHolidayDelete").click(function(event) {
			ClearFloatError();
			var id = $("#divDate").listbox("getSeletedItems").data("itemData").id;
			delete holidaySchedules[id];
			$("#divDate").listbox("delItem", id);
			var firstDate = $("#divDate").listbox("getAllItems").first();
			if (firstDate.length == 0) {
				$("#divHolidayTimeline").timeline("clearTimes");
				$("#divHolidayTimeline").timeline("setEnable", false);
			} else {
				firstDate.click();
				firstDate[0].scrollIntoView();
			}
		});

		$("[name=\"scheduleOpType\"]").click(function(event) {
			$("[controlType=\"timeline\"]").timeline("changeMode", event.target.value);
			$("#divHolidayTimeline").timeline("changeMode", event.target.value);
		});

		$("[controlType=\"timeline\"]").timeline({
			manualButtonText: LangCtrl._L_("manualInput"),
			okButtonText: LangCtrl._L_("ok"),
            paddingLeft: 0,
            paddingRight: 0,
            showSelectAllButton: false,
            showInverseButton: false,
            showClearButton: false,
            maxTimeShow: 4,
			oninvalidate: function(startTime, endTime, startInput, endInput) {
				ShowFloatError(startInput, LangCtrl._L_("startTimeGEEndTime"), { left: -startInput.outerWidth() - 6, top: startInput.outerHeight() + 5 });
			}
		});

		$("#divHolidayTimeline").timeline({
			enable: false,
            manualButtonText: LangCtrl._L_("manualInput"),
            okButtonText: LangCtrl._L_("ok"),
            paddingLeft: 0,
            paddingRight: 0,
            showSelectAllButton: false,
            showInverseButton: false,
            showClearButton: false,
            maxTimeShow: 4,
			onvaluechanged: function(control) {
				var itemData = $("#divDate").listbox("getSeletedItems").data("itemData");
				if (itemData && itemData.value) {
                    if(control.timeline("getTimes").length == 0){
                        holidaySchedules[itemData.value] = ["00:00-00:00"];
                    }else{
                        holidaySchedules[itemData.value] = control.timeline("getTimes");
                    }
				}
			},
			oninvalidate: function(startTime, endTime, startInput, endInput) {
				ShowFloatError(startInput, LangCtrl._L_("startTimeGEEndTime"), { left: -startInput.outerWidth() - 6, top: startInput.outerHeight() + 5 });
			}
		});
	},
	getData: function() {
		window.top.showLoading();
		try {
			XmlHttpClient.SendHttpRequest({
				url: serverBase + "/GetMotionScheduleConfig",
				type: "POST",
				async: true,
				data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
				callback: function(result) {
					xmlDoc = result;
					ScheduleModule.bindCtrlData();

					// 周排程
					$.each(["sunday", "monday", "tuesday", "wednesday", "thursday", "friday", "saturday"], function(index, element) {
						var timelineObj = $("[controlType=\"timeline\"]:eq(" + index + ")");
						timelineObj.timeline("clearTimes");
						$("config>schedule>period[mode=\"weekly\"][day=\"" + element + "\"]", xmlDoc).each(function(index, element) {
							timelineObj.timeline("setTime", $(this).attr("start") + "-" + $(this).attr("end"));
						});
					});

					// 年排程
					var firstDate = "";
					holidaySchedules = {};
					$("#divDate").listbox("clearData");
					$("#divHolidayTimeline").timeline("setTime","00:00-23:59");
					$("#divHolidayTimeline").timeline("setEnable", false);
					$("config>schedule>period[mode=\"yearly\"]", xmlDoc).each(function(index, element) {
						var dateStr = $(this).attr("date");
						if (index == 0) {
							$("#divHolidayTimeline").timeline("setEnable", true);
							firstDate = dateStr;
						}
						if (!holidaySchedules[dateStr]) {
							holidaySchedules[dateStr] = [];
							$("#divDate").listbox("addItem", { id: dateStr, value: dateStr });
						}
						holidaySchedules[dateStr].push($(this).attr("start") + "-" + $(this).attr("end"));
					});

					if (firstDate) {
						$("#divDate").listbox("getItemByID", firstDate).click();
					}
                    $("#divDate").keydown(function(e){
                        var tempDiv = $(this).children("div .selected");
                        var divPrev = tempDiv.prev();
                        var divNext = tempDiv.next();
                        if (event.keyCode==38){
                            if(divPrev.size() > 0){
                                tempDiv.removeClass("selected");
                                divPrev.addClass("selected");
                            }
                        }
                        if (event.keyCode==40){
                            if(divNext.size() > 0){
                                tempDiv.removeClass("selected");
                                divNext.addClass("selected");
                            }
                        }
                    });
					window.top.hideLoading();
				}
			});
		}
		catch (ex) {
			alert(ex);
		}
	},
	bindCtrlData: function() {
		ScheduleModule.timeSpanMaxCount = $("config>schedule", xmlDoc).attr("maxTimeSpan") * 1;
	},
	verification: function() {
		ClearFloatError();

		var count = 0;
		$("[controlType=\"timeline\"]").each(function(index, element) {
			var $this = $(this);
			count += $this.timeline("getTimes").length;
		});

		$.each($("#divDate").listbox("getAllItems"), function(index, element) {
			var dateStr = $(this).data("itemData").value;
			count += holidaySchedules[dateStr].length;
		});

		if (count > ScheduleModule.timeSpanMaxCount) {
			ShowFloatError($("#btnSave"), LangCtrl._L_("timeSpanMaxCount").format(ScheduleModule.timeSpanMaxCount), { left: -350, top: 1 });
			return false;
		}

        return true;
	},
	getSaveData: function() {
		var weeks = ["sunday", "monday", "tuesday", "wednesday", "thursday", "friday", "saturday"];
		var scheduleNode = $("config>schedule", xmlDoc);
		scheduleNode.empty();

		// 周排程
		$("[controlType=\"timeline\"]").each(function(weekIndex, element) {
			var timeSpans = $(this).timeline("getTimes", $.TIMELINE_DATA_MODE_STRING);
            if(timeSpans.length == 0){
                timeSpans = [["00:00","00:00"]];
            }
			$.each(timeSpans, function(index, element) {
				scheduleNode.append($(xmlDoc.createElement("period")).attr("mode", "weekly").attr("start", element[0]).attr("end", element[1]).attr("day", weeks[weekIndex]));
			});
		});

		// 年排程
		$.each($("#divDate").listbox("getAllItems"), function(index, element) {
			var dateStr = $(this).data("itemData").value;
			$.each(holidaySchedules[dateStr], function(index, element) {
				var timeParts = element.split("-");
				scheduleNode.append($(xmlDoc.createElement("period")).attr("mode", "yearly").attr("start", timeParts[0]).attr("end", timeParts[1]).attr("date", dateStr));
			});
		});

		return XMLDoc2XMLStr(xmlDoc);
	},
	setData: function() {
		window.top.showLoading();
		if (!ScheduleModule.verification()) {
			window.top.hideLoading();
			return false;
		}
		try {
			XmlHttpClient.SendHttpRequest({
				url: serverBase + "/SetMotionScheduleConfig",
				type: "POST",
				async: true,
				data: ScheduleModule.getSaveData(),
                beforeSend: XmlHttpClient.CommBeforeSend,
				callback: function(result) {
					window.top.hideLoading();
					commSaveResponseHadler(result);
				}
			});
		}
		catch (ex) {
			alert(ex);
		}
	}
};

function initControl() {
	TriggerModule.initCtrl();
	AreaModule.initCtrl();
	ScheduleModule.initCtrl();
	$("#btnSave").click(function() {
		ClearFloatError();
		var curTab = $.cookie("tab");
		if (!curTab) {
			curTab = "liMotionDetectionTrigger";
		}
		switch (curTab) {
			case "liMotionDetectionTrigger":
				TriggerModule.setData();
				break;
			case "liMotionDetectionArea":
				AreaModule.setData();
				break;
			case "liMotionDetectionSchedule":
				ScheduleModule.setData();
				break;
		}
	});

    $("#btnSave1").click(function() {
        ClearFloatError();
        AreaModule.setData();
    });
}

function clearTab(parent) {
	$("input[type=\"text\"]", parent).val("");
	$("input[type=\"checkbox\"]", parent).removeAttr("checked");
	$("select", parent).empty();
}