var xmlDoc;
$(function(){
    initControl();
    initTab();
});

function initControl(){

    DetectionCfgModule.initCtrl();
    senseModule.initCtrl();
    $("#btnSave").click(function() {
        ClearFloatError();
        var curTab = $.cookie("tab");
        if (!curTab) {
            curTab = "liDetectionCfg";
        }
        switch (curTab) {
            case "liDetectionCfg":
                DetectionCfgModule.setData();
                break;
            case "liSensitivity":
                senseModule.setData();
                break;
        }
    });
}

function initTab(){
    $("#divParent>ul").empty();

    $("<li id='liDetectionCfg'><a href='#' class='active'>" + LangCtrl._L_("DetectionCfg") + "</a></li>").appendTo("#divParent>ul");
    $("<li id='liSensitivity'><a href='#'>" + LangCtrl._L_("Sensitivity") + "</a></li>").appendTo("#divParent>ul");
    var arrMap = [{ "tab": "liDetectionCfg", "content": "divInputDetectionCfg", init: initDetectionCfg},
                  { "tab": "liSensitivity", "content": "divInputSensitivity", init: initSensitivity} ];


    $("#divParent").tab({
        map: arrMap
    });
    DetectionCfgModule.createAlarmInCfgItem();
    DetectionCfgModule.bindCtrlData();
    DetectionCfgModule.initCtrl();

    $("#divParent").tab("selectLastTab");

};

function initDetectionCfg(){
    DetectionCfgModule.getEmailListData();
    DetectionCfgModule.getFTPListData();
    DetectionCfgModule.getData();
};

function initSensitivity(){
    senseModule.getData();
};

var DetectionCfgModule ={
    initCtrl : function(){
//        DetectionCfgModule.getFTPListData();
    },
    toggleFtpList: function(enabled){
        if (!enabled) {
            $(".triggleFtp").hide();
        } else {
            DetectionCfgModule.ajustHeight();
            $(".triggleFtp").show();
        }
    },
    toggleEmailList: function(enabled){
        if (!enabled) {
            $(".triggleEmail").hide();
        } else {
            DetectionCfgModule.ajustHeight();
            $(".triggleEmail").show();
        }
    },
    ajustHeight: function() {
        var minHeight = $("#divInputDetectionCfg").height() + 160;
        window.parent.setConfigMiniHeight(minHeight);
    },
    getFTPListData: function(id){
        window.top.showLoading();
        XmlHttpClient.SendHttpRequest({
            url: serverBase + "/GetFtpConfig",
            type: "POST",
            async: true,
            data: "",
            beforeSend: XmlHttpClient.CommBeforeSend,
            callback: function(result) {
                var ftpList = "";
                var d = document.getElementById('dvCompute');
                $("config>ftp>item",result).each(function(i,ele){
                    var ftpName = $(">serverAddr",ele).text();
                    d.innerHTML = ftpName;
                    var  averageLen = d.offsetWidth / (ftpName.length);
                    var indexStr = Math.floor(210 / averageLen);
                    var imageName =  d.offsetWidth > 210 ? (ftpName.substr(0, indexStr) + "...") : ftpName;
                    ftpList = ftpList +"<tr>" +
                        "<td style='word-break:keep-all;width: 194px;'>" + "<div title='"+ ftpName+"'>"+"<input id='chkTriggerFTPAddr_"  + i + "' class='ftpServer' type='checkbox' />"+imageName +"</div>"+ "</td>" +
                        "<td><input id='chkTriggerFTPRec_" + i + "' class='FTPRec' type='checkbox' /><label for='chkTriggerFTPRec_" + i +"' >" + LangCtrl._L_("recSend") + "</label></td>" +
                        "<td><input id='chkTriggerFTPPic_" + i + "' class='FTPPic' type='checkbox' /><label for='chkTriggerFTPPic_"+ i +"' >" + LangCtrl._L_("pictureSend") + "</label></td>" +
                        "</tr>";
                });

                var alarmOutFTPList = $("#divFTP");
                var alarmOutFTPTitle = $("#divFTPTitle");
                for(var i= 0,len =alarmOutFTPList.length; i < len; i++ ){
                    $("<table  class='contentTable' cellpadding='0' cellspacing='0' style='table-layout: fixed;'>" +
                        "<tbody>" +
                        "<tr>" +
                        "<td style='width: 271px;'>" + LangCtrl._L_("FTPServer") + "</td>" +
                        "<td><input id='chkTriggerFTPPic'  type='checkbox' /><label for='chkTriggerFTPPic' >" + LangCtrl._L_("pictureSend") + "</label></td>" +
                        "</tr>" +
                        "</tbody>" +
                        "</table>").appendTo(alarmOutFTPTitle);
                    $(ftpList).appendTo(alarmOutFTPList);

                    $("#chkTriggerFTPPic").click(function(){
                        var ftpPicList = $(this).parent().parent().parent().parent().parent().next().find(".FTPPic");
                        if($(this).attr("checked") === "checked"){
                            $(ftpPicList).attr("checked","checked");
                        }else{
                            $(ftpPicList).attr("checked",false);
                        }
                    });

                    $(".FTPRec").click(function(){
                        var ftpRecList = $(this).parent().parent().parent().find(".FTPRec");
                        for(var m=0;m<ftpRecList.length;m++){
                            if($(ftpRecList[m]).attr("id") == $(this).attr("id")){
                                $(ftpRecList[m]).attr("checked","checked");
                            }else{
                                $(ftpRecList[m]).attr("checked",false);
                            }
                        }
                    });
                }
            }
        });
    },
    getEmailListData: function(){
        window.top.showLoading();
        XmlHttpClient.SendHttpRequest({
            url: serverBase + "/GetMailConfig",
            type: "POST",
            async: true,
            data: "",
            beforeSend: XmlHttpClient.CommBeforeSend,
            callback: function(result) {

                var emailList = "";
                var d = document.getElementById('dvCompute');
                $("config>mail>recvMail>item",result).each(function(i,ele){
                    var emailName = $(ele).text();
                    d.innerHTML = emailName;
                    var  averageLen = d.offsetWidth / (emailName.length);
                    var indexStr = Math.floor(210 / averageLen);
                    var imageName =  d.offsetWidth > 210 ? (emailName.substr(0, indexStr) + "...") : emailName;
                    emailList = emailList +"<tr>" +
                        "<td style='word-break:keep-all;width: 268px;'>" + "<div title='"+ $(ele).text()+"'>"+"<input id='chkTriggerEmailAddr_"  + i + "' class='emailServer' type='checkbox' />"+imageName +"</div>"+ "</td>" +
                        "<td><input id='chkTriggerEmailPic_" + i + "' class='emailPic' type='checkbox' /><label for='chkTriggerEmailPic_" + i +"' >" + LangCtrl._L_("pictureSend") + "</label></td>" +
                        "</tr>";
                });

                var alarmOutEmailList = $("#divEmailTable");
                var alarmOutEmailTitle = $("#divEmailTitle");
                var motionEmailTheme = $("#divEmailTheme");
                alarmOutEmailList.empty();
                alarmOutEmailTitle.empty();
                motionEmailTheme.empty();
                $("<table  class='contentTable' cellpadding='0' cellspacing='0' style='table-layout: fixed;'>" +
                    "<tbody>" +
                    "<tr>" +
                    "<td style='width: 271px;'>" + LangCtrl._L_("emailServer") + "</td>" +
                    "<td><input id='chkTriggerEmailPic'  type='checkbox' /><label for='chkTriggerEmailPic' >" + LangCtrl._L_("pictureSend") + "</label></td>" +
                    "</tr>" +
                    "</tbody>" +
                    "</table>").appendTo(alarmOutEmailTitle);
                $(emailList).appendTo(alarmOutEmailList);
                $("<table  class='contentTable' cellpadding='0' cellspacing='0' style='table-layout: fixed;'>" +
                    "<tbody>" +
                    "<tr>" +
                    "<td style='width: 100px;'>" + LangCtrl._L_("emailTheme") + "</td>" +
                    "<td><input id='emailTheme'  type='text' style='width: 300px;'/></td>" +
                    "</tr>" +
                    "<tr>" +
                    "<td style='width: 160px;'>" + LangCtrl._L_("emailContent") + "</td>" +
                    "<td><input id='emailContent'  type='text' style='width: 300px;'/></td>" +
                    "</tr>" +
                    "</tbody>" +
                    "</table>").appendTo(motionEmailTheme);

                $("#chkTriggerEmailPic").click(function(){
                    var emialPicList = $(this).parent().parent().parent().parent().parent().next().find(".emailPic");
                    if($(this).attr("checked") === "checked"){
                        $(emialPicList).attr("checked","checked");
                    }else{
                        $(emialPicList).attr("checked",false);
                    }
                });
            }
        });
    },
    getData: function(){
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/GetAvdConfig",
                type: "POST",
                async: true,
                data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    xmlDoc = result;
                    DetectionCfgModule.bindPageByXml(xmlDoc);
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    bindCtrlData: function() {
        $("#cboAlarmHoldingTime" ).selectInput({
            list: [
                { text: LangCtrl._L_("seconds").format(5), value: 5 },
                { text: LangCtrl._L_("seconds").format(10), value: 10 },
                { text: LangCtrl._L_("seconds").format(20), value: 20 },
                { text: LangCtrl._L_("seconds").format(30), value: 30 },
                { text: LangCtrl._L_("seconds").format(60), value: 60 },
                { text: LangCtrl._L_("minutes").format(2), value: 120 }
            ],
            mapping: function(text) {
                var validReg = /^[1-9]\d*$/;
                var execResults = validReg.exec(text);
                if (execResults) {
                    return { text: execResults[0] % 60 == 0 ? LangCtrl._L_("minutes").format(execResults[0] / 60) : LangCtrl._L_("seconds").format(execResults[0]), value: execResults[0] };
                }

                validReg = new RegExp("^" + LangCtrl._L_("seconds").format("([1-9]\\d*)") + "$");
                execResults = validReg.exec(text);
                if (execResults) {
                    return { text: text, value: execResults[1] };
                }

                validReg = new RegExp("^" + LangCtrl._L_("minutes").format("([1-9]\\d*)") + "$");
                execResults = validReg.exec(text);
                if (execResults) {
                    return { text: text, value: execResults[1] * 60 };
                }
                return false;
            }
        });
    },
    bindPageByXml: function(elem) {

        var sceneChgSwitch = $("config>avd>sceneChgSwitch", elem).text().toLowerCase() === "true";
        $("#sceneChgSwitch").attr("checked", sceneChgSwitch);
        var clarityAbnmlSwitch = $("config>avd>clarityAbnmlSwitch", elem).text().toLowerCase() === "true";
        $("#clarityAbnmlSwitch").attr("checked", clarityAbnmlSwitch);
        var colorAbnmlSwitch = $("config>avd>colorAbnmlSwitch", elem).text().toLowerCase() === "true";
        $("#colorAbnmlSwitch").attr("checked", colorAbnmlSwitch);

        var holdTime = $("config>avd>alarmHoldTime", elem).text();
        $("#cboAlarmHoldingTime" ).selectInput("setData", { text: holdTime, value: holdTime });

        var divAlarmOut = $("#divAlarmOut" );
        divAlarmOut.empty();
        var alarmOutList = $("config>avd>triggerAlarmOut>item", elem);
        if(alarmOutList.length <= 1){
            $("config>avd>triggerAlarmOut>item", elem).each(function(index, element) {
                var $this = $(this);
                var id = $this.attr("id");
                var isSwitch = $this.text().toLowerCase() === "true";
                divAlarmOut.append($("<input id=\"chkAlarmOut" + id + "\" type=\"checkbox\" " + (isSwitch ? "checked=\"checked\"" : "") + " />"));
                divAlarmOut.append($("<label for=\"chkAlarmOut" + id + "\">" + LangCtrl._L_("alarmOut") + "</label>"));
            });
        }else{
            $("config>avd>triggerAlarmOut>item", elem).each(function(index, element) {
                var $this = $(this);
                var id = $this.attr("id");
                var isSwitch = $this.text().toLowerCase() === "true";
                divAlarmOut.append($("<input id=\"chkAlarmOut" + id + "\" type=\"checkbox\" " + (isSwitch ? "checked=\"checked\"" : "") + " />"));
                divAlarmOut.append($("<label for=\"chkAlarmOut" + id + "\">" + LangCtrl._L_("alarmOut") + " " + id + "</label>"));
            });
        }

        var chkTriggerEmail = $("#chkTriggerEmail");
        chkTriggerEmail.attr("checked", $("config>avd>mail>switch", elem).text().toLowerCase() === "true");
        chkTriggerEmail.click(function(e) {
            DetectionCfgModule.toggleEmailList($(this).attr("checked") == "checked");
            DetectionCfgModule.ajustHeight();
        });
        var emailChkList = $("#divEmail" ).find(".emailServer");
        $("config>avd>mail>item", elem).each(function(i,element){
            $(emailChkList[$(element).attr("id")-1]).attr("checked","checked");

        });
        var emailChkPicList = $("#divEmail").find(".emailPic");
        $("config>avd>mail>item", elem).each(function(i,element){
            if($(">sendPic",element).text() === "true"){
                $(emailChkPicList[$(element).attr("id")-1]).attr("checked","checked");
            }
        });

        var subject = $("config>avd>mail>subject", elem);
        var content = $("config>avd>mail>content", elem);
        $("#emailTheme").attr("maxLength",subject.attr("maxLen"));
        $("#emailContent").attr("maxLength",content.attr("maxLen"));
        $("#emailTheme").val(subject.text());
        $("#emailContent").val(content.text());
        var chkTriggerFTP = $("#chkTriggerFTP");
        chkTriggerFTP.attr("checked", $("config>avd>ftp>switch", elem).text().toLowerCase() === "true");
        chkTriggerFTP.click(function(e) {
            DetectionCfgModule.toggleFtpList($(this).attr("checked") == "checked");
            DetectionCfgModule.ajustHeight();
        });

        var ftpChkList = $("#divFTP" ).find(".ftpServer");
        $("config>avd>ftp>item", elem).each(function(i,element){
            $(ftpChkList[$(element).attr("id")-1]).attr("checked","checked");

        });

        var ftpChkPicList = $("#divFTP").find(".FTPPic");
        var ftpChkRecList = $("#divFTP").find(".FTPRec");
        $("config>avd>ftp>item", xmlDoc).each(function(i,element){
            if($(">sendPic",element).text() === "true"){
                $(ftpChkPicList[$(element).attr("id")-1]).attr("checked","checked");
            }
            if($(">sendRec",element).text() === "true"){
                $(ftpChkRecList[$(element).attr("id")-1]).attr("checked","checked");
            }
        });

        DetectionCfgModule.toggleFtpList(chkTriggerFTP.attr("checked") == "checked");
        DetectionCfgModule.toggleEmailList(chkTriggerEmail.attr("checked") == "checked");
        $("#chkTriggerSnap" ).attr("checked", $("config>avd>savePicSwitch", elem).text().toLowerCase() === "true");
        $("#chkTriggerNetDisk").attr("checked", $("config>avd>netDiskSwitch", elem).text().toLowerCase() === "true");

        window.top.hideLoading();

    },
    createAlarmInCfgItem: function() {
        $(
            "<table id='tbTrigger' class='contentTable' cellpadding='0' cellspacing='0' style='table-layout: fixed;'>" +
            "<tbody>" +

            "<tr>" +
            "<td style='width: 250px;'>" +
            "<input id='sceneChgSwitch' type='checkbox' />" +
            "<label for='sceneChgSwitch'>" + LangCtrl._L_("sceneChgSwitch") + "</label>" +
            "</td>" +
            "<td>" +
            "</td>" +
            "</tr>" +

            "<tr>" +
            "<td colspan='2'>" +
            "<input id='clarityAbnmlSwitch' type='checkbox' />" +
            "<label for='clarityAbnmlSwitch'>" + LangCtrl._L_("clarityAbnmlSwitch") + "</label>" +
            "</td>" +
            "</tr>" +

            "<tr>" +
            "<td colspan='2'>" +
            "<input id='colorAbnmlSwitch' type='checkbox' />" +
            "<label for='colorAbnmlSwitch'>" + LangCtrl._L_("colorAbnmlSwitch") + "</label>" +
            "</td>" +
            "</tr>" +

            "<tr class='alter'>" +
            "<td>" + LangCtrl._L_("alarmHoldingTime") + "</td>" +
            "<td><div id='cboAlarmHoldingTime' style='width: 130px;margin-left: -100px'></div></td>" +
            "</tr>" +

            "<tr>" +
            "<td>" + LangCtrl._L_("triggerAlarmOut") + "</td>" +
            "<td></td>" +
            "</tr>" +

            "<tr class='alter'>" +
            "<td colspan='2'>" +
            "<div id='divAlarmOut' class='alarmOutList'></div>" +
            "</td>" +
            "</tr>" +

            "<tr id='trTriggerSnap'>" +
            "<td colspan='2'>" +
            "<input id='chkTriggerSnap' type='checkbox' />" +
            "<label for='chkTriggerSnap' >" + LangCtrl._L_("triggerSnap") + "</label>" +
            "</td>" +
            "</tr>" +

            "<tr>" +
            "<td colspan='2'>" +
            "<input id='chkTriggerEmail' type='checkbox' />" +
            "<label for='chkTriggerEmail'>" + LangCtrl._L_("triggerEmail") + "</label>" +
            "</td>" +
            "</tr>" +

            "<tr class='triggle triggleEmail'>" +
            "<td colspan='2'>" +
            "<div id='divEmailTitle' class='motionEmailTitle'></div>" +
            "<div id='divEmail' class='motionEmailList'><table id='divEmailTable'></table></div>" +
            "<div id='divEmailTheme' class='motionEmailTheme'></div>" +
            "</td>" +
            "</tr>" +

            "<tr>" +
            "<td colspan='2'>" +
            "<input id='chkTriggerFTP' type='checkbox' />" +
            "<label for='chkTriggerFTP' >" + LangCtrl._L_("triggerFTP") + "</label>" +
            "</td>" +
            "</tr>" +
            "<tr class='triggle triggleFtp'>" +
            "<td colspan='2'>" +
            "<div id='divFTPTitle' class='alarmOutFTPTitle'></div>" +
            "<div id='divFTP' class='alarmOutFTPList'>" +
//                            "<table id='divFTP_" + id + "' class='alarmOutFTPList'></table>" +
            "</div>" +
            "</td>" +
            "</tr>" +
//            "<tr>" +
//            "<td colspan='2'>" +
//            "<input id='chkTriggerNetDisk' type='checkbox' />" +
//            "<label for='chkTriggerNetDisk' >" + LangCtrl._L_("triggerNetDisk") + "</label>" +
//            "</td>" +
//            "</tr>" +

            "</tbody>" +
            "</table>").appendTo($("#divInputDetectionCfg"));
    },
    setData:function(){
        try{
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/SetAvdConfig",
                type: "POST",
                async: true,
                data: DetectionCfgModule.getSaveData(),
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    window.top.hideLoading();
                    commSaveResponseHadler(result);
                }
            });
        }catch (ex){
            alert(ex);
        }
    },
    getSaveData:function(){
        var elem = xmlDoc;

        $("config>avd>sceneChgSwitch", elem).text($("#sceneChgSwitch ").is(":checked") ? "true" : "false")
        $("config>avd>clarityAbnmlSwitch", elem).text($("#clarityAbnmlSwitch").is(":checked") ? "true" : "false")
        $("config>avd>colorAbnmlSwitch", elem).text($("#colorAbnmlSwitch").is(":checked") ? "true" : "false")

        $("config>avd>alarmHoldTime", elem).text($("#cboAlarmHoldingTime").selectInput("getValue"));

        var divAlarmOut = $("#divAlarmOut");
        $("config>avd>triggerAlarmOut>item", elem).each(function(j, j_elem) {
            if ($("#chkAlarmOut_" + $(j_elem).attr("id")).is(":checked")) {
                $(j_elem).text("true");
            }
            else {
                $(j_elem).text("false");
            }
        });

        $("config>avd>savePicSwitch", elem).text($("#chkTriggerSnap").is(":checked") ? "true" : "false");

        var divFtpList = $("#divFTP").find(".ftpServer");
        $("config>avd>ftp>item", xmlDoc).remove();
        $("config>avd>ftp>switch",xmlDoc).text($("#chkTriggerFTP").is(":checked") ? "true" : "false");
        var count = 0;
        for(var i= 0,len = divFtpList.length;i<len;i++){
            if($(divFtpList[i]).attr("checked") === "checked"){
                count++;
                $("config>avd>ftp", xmlDoc).append(
                    $(xmlDoc.createElement("item")).attr("id",i+1).append(
                        $(xmlDoc.createElement("sendPic")).attr("type","boolean").append(
                                $(divFtpList[i]).parent().parent().next().next().find("input").attr("checked") === "checked" ? "true" : "false"
                        )
                    ).append(
                        $(xmlDoc.createElement("sendRec")).attr("type","boolean").append(
                                $(divFtpList[i]).parent().parent().next().find("input").attr("checked") === "checked" ? "true" : "false"
                        )
                    )
                );
            }
        }
        $("config>avd>ftp", xmlDoc).attr("count",count);

        var divEmailList = $("#divEmail").find(".emailServer");
        $("config>avd>mail>item", xmlDoc).remove();
        $("config>avd>mail>switch",xmlDoc).text($("#chkTriggerEmail").is(":checked") ? "true" : "false");
        $("config>avd>mail>subject", xmlDoc).remove();
        $("config>avd>mail>content", xmlDoc).remove();
        $("config>avd>mail",xmlDoc).append(
            $(xmlDoc.createElement("subject")).attr("type","string").attr("maxLen","63").append(
                xmlDoc.createCDATASection($("#emailTheme").val())
            )
        );
        $("config>avd>mail",xmlDoc).append(
            $(xmlDoc.createElement("content")).attr("type","string").attr("maxLen","255").append(
                xmlDoc.createCDATASection($("#emailContent").val())
            )
        );
        var countEmail = 0;
        for(var i= 0,len = divEmailList.length;i<len;i++){
            if($(divEmailList[i]).attr("checked") === "checked"){
                countEmail++;
                $("config>avd>mail", xmlDoc).append(
                    $(xmlDoc.createElement("item")).attr("id",i+1).append(
                        $(xmlDoc.createElement("sendPic")).attr("type","boolean").append(
                                $(divEmailList[i]).parent().parent().next().find("input").attr("checked") === "checked" ? "true" : "false"
                        )
                    )
                );
            }
        }
        $("config>avd>mail", xmlDoc).attr("count",countEmail);

//        $("config>avd>netDiskSwitch", elem).text($("#chkTriggerNetDisk").is(":checked") ? "true" : "false");
        return XMLDoc2XMLStr(elem);
    }
};

var senseModule = {
    mapping: {
        cboAudioEncoding: "config>avd>sensitivity"
    },
    initCtrl : function(){
        $("#sliderDetectionCfg").slider({
            minValue: 0,
            maxValue: 0,
            maxWidth:100,
            thumbCss:"slider_thumb_1",
            valueChangeEvent: function(value) {
                $("#valueSaturation").val(value);
            }
        });
        $("#valueSaturation").bind("blur",function(){
            $("#sliderDetectionCfg").slider("setValueWithEvent",$("#valueSaturation").val())
        }).keydown(function(ev){
            ev = ev || event;
            if (isEnter(ev))
                $("#sliderDetectionCfg").slider("setValueWithEvent", $("#valueSaturation").val());
        });

    },
    getData : function(){
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/GetAvdConfig",
                type: "POST",
                async: true,
                data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    xmlDoc = result;
                    senseModule.bindCtrlData();
                    var sensitivityNode = $("config>avd>sensitivity", result);
                    $("#sliderDetectionCfg").slider("setValueWithEvent", sensitivityNode.text() ? sensitivityNode.text() : sensitivityNode.attr("default"));
                    window.top.hideLoading();
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    bindCtrlData: function() {
        var sensitivityNode = $("config>avd>sensitivity", xmlDoc);
        var sliderSensitivity = $("#sliderDetectionCfg");
        sliderSensitivity.slider("setProperty", "minValue", sensitivityNode.attr("min") * 1);
        sliderSensitivity.slider("setProperty", "maxValue", sensitivityNode.attr("max") * 1);
    },
    getSaveData:function(){
        $("config>avd>sensitivity", xmlDoc).text($("#sliderDetectionCfg").slider("getValue"));
        return XMLDoc2XMLStr(xmlDoc);
    },
    setData : function(){
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/SetAvdConfig",
                type: "POST",
                async: true,
                data: senseModule.getSaveData(),
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    window.top.hideLoading();
                    commSaveResponseHadler(result);
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    }
};
