var holidaySchedules;
var NetLiveMonitor;
var xmlDoc;

$(function() {
    initControl();
    $("#divParent").tab({
        map: [{ "tab": "liMotionDetectionTrigger", "content": "divMotionDetectionTrigger", init: initMotionDetectionTrigger },
            { "tab": "liMotionDetectionArea", "content": "divMotionDetectionArea", init: initMotionDetectionArea },
            { "tab": "liMotionDetectionSchedule", "content": "divMotionDetectionSchedule", init: initMotionDetectionSchedule}]
    });
    $("#divParent").tab("selectLastTab");
    closeStream();
    $("#Content",window.top.document).css({"min-width":"1200px"});
});

function initMotionDetectionTrigger() {
    $(".cfgfooter").css("width","20%");
    clearTab($("#divMotionDetectionTrigger"));
    getDeviceInfo(function(result) {
        TriggerModule.isSupportSDCard = $("config>deviceInfo>supportSDCard", result).text() === "true";
    });
    TriggerModule.getEmailListData();
    TriggerModule.getFTPListData();
    TriggerModule.getData();
}

function initMotionDetectionArea() {
    $(".cfgfooter").css("width","720px");
    clearTab($("#divMotionDetectionArea"));
    $("#btnClear").click(function(){
        var sendXML = OCX_XML_SetAreaAction("SetTripwireLineAction","NONE");
        NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
    });
    if(!NetLiveMonitor){
        AreaModule.setOCX();
    }

    AreaModule.getData();
}

function initMotionDetectionSchedule() {
    $(".cfgfooter").css("width","735px");
    ScheduleModule.getData();
}

var TriggerModule = {
    mapping: {
        chkEnableAlarm: "config>tripwire>switch",
        chkTriggerSnap: "config>tripwire>savePicSwitch",
        chkTriggerEmail: "config>tripwire>mailSwitch",
        chkTriggerFTP: "config>tripwire>ftpSwitch"
    },
    toggle: function(enabled) {
        if (!enabled) {
            $(".triggle").hide();
        } else {
            $(".triggle:not(#trTriggerSnap)").show();
            if (TriggerModule.isSupportSDCard) {
                $("#trTriggerSnap").show();
            }
            TriggerModule.toggleFtpList($("#chkTriggerFTP").attr("checked") == "checked");
            TriggerModule.toggleEmailList($("#chkTriggerEmail").attr("checked") == "checked");
        }
    },
    toggleFtpList: function(enabled){
        if (!enabled) {
            $(".triggleFtp").hide();
        } else {
            TriggerModule.ajustHeight();
            $(".triggleFtp").show();
        }
    },
    toggleEmailList: function(enabled){
        if (!enabled) {
            $(".triggleEmail").hide();
        } else {
            TriggerModule.ajustHeight();
            $(".triggleEmail").show();
        }
    },
    ajustHeight: function() {
        var minHeight = $("#divMotionDetectionTrigger").height() + 160;
        window.parent.setConfigMiniHeight(minHeight);
    },
    getEmailListData: function(){
        window.top.showLoading();
        XmlHttpClient.SendHttpRequest({
            url: serverBase + "/GetMailConfig",
            type: "POST",
            async: true,
            data: "",
            beforeSend: XmlHttpClient.CommBeforeSend,
            callback: function(result) {

                var emailList = "";
                var d = document.getElementById('dvCompute');
                $("config>mail>recvMail>item",result).each(function(i,ele){
                    var emailName = $(ele).text();
                    d.innerHTML = emailName;
                    var  averageLen = d.offsetWidth / (emailName.length);
                    var indexStr = Math.floor(210 / averageLen);
                    var imageName =  d.offsetWidth > 210 ? (emailName.substr(0, indexStr) + "...") : emailName;
                    emailList = emailList +"<tr>" +
                        "<td style='word-break:keep-all;width: 268px;'>" + "<div title='"+ $(ele).text()+"'>"+"<input id='chkTriggerEmailAddr_"  + i + "' class='emailServer' type='checkbox' />"+imageName +"</div>"+ "</td>" +
                        "<td><input id='chkTriggerEmailPic_" + i + "' class='emailPic' type='checkbox' /><label for='chkTriggerEmailPic_" + i +"' >" + LangCtrl._L_("pictureSend") + "</label></td>" +
                        "</tr>";
                });

                var alarmOutEmailList = $("#divEmailTable");
                var alarmOutEmailTitle = $("#divEmailTitle");
                var motionEmailTheme = $("#divEmailTheme");
                alarmOutEmailList.empty();
                alarmOutEmailTitle.empty();
                motionEmailTheme.empty();
                $("<table  class='contentTable' cellpadding='0' cellspacing='0' style='table-layout: fixed;' width='100%'>" +
                    "<tbody>" +
                    "<tr>" +
                    "<td style='width: 271px;'>" + LangCtrl._L_("emailServer") + "</td>" +
                    "<td><input id='chkTriggerEmailPic'  type='checkbox' /><label for='chkTriggerEmailPic' >" + LangCtrl._L_("pictureSend") + "</label></td>" +
                    "</tr>" +
                    "</tbody>" +
                    "</table>").appendTo(alarmOutEmailTitle);
                $(emailList).appendTo(alarmOutEmailList);
                $("<table  class='contentTable' cellpadding='0' cellspacing='0' style='table-layout: fixed;'>" +
                    "<tbody>" +
                    "<tr>" +
                    "<td style='width: 100px;'>" + LangCtrl._L_("emailTheme") + "</td>" +
                    "<td><input id='emailTheme'  type='text' style='width: 300px;'/></td>" +
                    "</tr>" +
                    "<tr>" +
                    "<td style='width: 160px;'>" + LangCtrl._L_("emailContent") + "</td>" +
                    "<td><input id='emailContent'  type='text' style='width: 300px;' /></td>" +
                    "</tr>" +
                    "</tbody>" +
                    "</table>").appendTo(motionEmailTheme);

                $("#chkTriggerEmailPic").click(function(){
                    var emialPicList = $(this).parent().parent().parent().parent().parent().next().find(".emailPic");
                    if($(this).attr("checked") === "checked"){
                        $(emialPicList).attr("checked","checked");
                    }else{
                        $(emialPicList).attr("checked",false);
                    }
                });
            }
        });
    },
    initCtrl: function() {
        $(".trigger").hide();

        $("#chkEnableAlarm").click(function(e) {
            TriggerModule.toggle($(this).attr("checked") == "checked");
        });

        $("#cboAlarmHoldingTime").selectInput({
            list: [
                { text: LangCtrl._L_("seconds").format(5), value: 5 },
                { text: LangCtrl._L_("seconds").format(10), value: 10 },
                { text: LangCtrl._L_("seconds").format(20), value: 20 },
                { text: LangCtrl._L_("seconds").format(30), value: 30 },
                { text: LangCtrl._L_("seconds").format(60), value: 60 },
                { text: LangCtrl._L_("minutes").format(2), value: 120 }
            ],
            mapping: function(text) {
                var validReg = /^[1-9]\d*$/;
                var execResults = validReg.exec(text);
                if (execResults) {
                    return { text: execResults[0] % 60 == 0 ? LangCtrl._L_("minutes").format(execResults[0] / 60) : LangCtrl._L_("seconds").format(execResults[0]), value: execResults[0] };
                }

                validReg = new RegExp("^" + LangCtrl._L_("seconds").format("([1-9]\\d*)") + "$");
                execResults = validReg.exec(text);
                if (execResults) {
                    return { text: text, value: execResults[1] };
                }

                validReg = new RegExp("^" + LangCtrl._L_("minutes").format("([1-9]\\d*)") + "$");
                execResults = validReg.exec(text);
                if (execResults) {
                    return { text: text, value: execResults[1] * 60 };
                }
                return false;
            }
        });
    },
    getFTPListData: function(){
        window.top.showLoading();
        XmlHttpClient.SendHttpRequest({
            url: serverBase + "/GetFtpConfig",
            type: "POST",
            async: true,
            data: "",
            beforeSend: XmlHttpClient.CommBeforeSend,
            callback: function(result) {

                var ftpList = "";
                var d = document.getElementById('dvCompute');
                $("config>ftp>item",result).each(function(i,ele){
                    var ftpName = $(">serverAddr",ele).text();
                    d.innerHTML = ftpName;
                    var  averageLen = d.offsetWidth / (ftpName.length);
                    var indexStr = Math.floor(210 / averageLen);
                    var imageName =  d.offsetWidth > 210 ? (ftpName.substr(0, indexStr) + "...") : ftpName;
                    ftpList = ftpList +"<tr>" +
                        "<td style='word-break:keep-all;width: 194px;'>" + "<div title='"+ ftpName+"'>"+"<input id='chkTriggerFTPAddr_"  + i + "' class='ftpServer' type='checkbox' />"+imageName +"</div>"+ "</td>" +
                        "<td><input id='chkTriggerFTPRec_" + i + "' class='FTPRec' type='checkbox' /><label for='chkTriggerFTPRec_" + i +"' >" + LangCtrl._L_("recSend") + "</label></td>" +
                        "<td><input id='chkTriggerFTPPic_" + i + "' class='FTPPic' type='checkbox' /><label for='chkTriggerFTPPic_" + i +"' >" + LangCtrl._L_("pictureSend") + "</label></td>" +
                        "</tr>";
                });

                var alarmOutFTPList = $("#divFTPTable");
                var alarmOutFTPTitle = $("#divFTPTitle");
                $("<table  class='contentTable' cellpadding='0' cellspacing='0' style='table-layout: fixed;'>" +
                    "<tbody>" +
                    "<tr>" +
                    "<td style='width: 273px;'>" + LangCtrl._L_("FTPServer") + "</td>" +
                    "<td><input id='chkTriggerFTPPic'  type='checkbox' /><label for='chkTriggerFTPPic' >" + LangCtrl._L_("pictureSend") + "</label></td>" +
                    "</tr>" +
                    "</tbody>" +
                    "</table>").appendTo(alarmOutFTPTitle);
                $(ftpList).appendTo(alarmOutFTPList);

                $("#chkTriggerFTPPic").click(function(){
                    var ftpPicList = $(this).parent().parent().parent().parent().parent().next().find(".FTPPic");
                    if($(this).attr("checked") === "checked"){
                        $(ftpPicList).attr("checked","checked");
                    }else{
                        $(ftpPicList).attr("checked",false);
                    }
                });

                $(".FTPRec").click(function(){
                    var ftpRecList = $(this).parent().parent().parent().find(".FTPRec");
                    for(var m=0;m<ftpRecList.length;m++){
                        if($(ftpRecList[m]).attr("id") == $(this).attr("id")){
                            $(ftpRecList[m]).attr("checked","checked");
                        }else{
                            $(ftpRecList[m]).attr("checked",false);
                        }
                    }
                });
            }
        });
    },
    getData: function() {
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/GetTripwireConfig",
                type: "POST",
                async: true,
                data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    xmlDoc = result;
                    var alarmEnabled = ($(TriggerModule.mapping.chkEnableAlarm, xmlDoc).text().toLowerCase() === "true");
                    var divAlarmOut = $("#divAlarmOut");
                    divAlarmOut.empty();
                    var alarmOutList = $("config>tripwire>triggerAlarmOut>item", xmlDoc);
                    if(alarmOutList.length <= 1){
                        $("config>tripwire>triggerAlarmOut>item", xmlDoc).each(function(index, element) {
                            var $this = $(this);
                            var id = $this.attr("id");
                            var isSwitch = $this.text().toLowerCase() === "true";
                            divAlarmOut.append($("<input id=\"chkAlarmOut" + id + "\" type=\"checkbox\" " + (isSwitch ? "checked=\"checked\"" : "") + " />"));
                            divAlarmOut.append($("<label for=\"chkAlarmOut" + id + "\">" + LangCtrl._L_("alarmOut") + "</label>"));
                        });
                    }else{
                        $("config>tripwire>triggerAlarmOut>item", xmlDoc).each(function(index, element) {
                            var $this = $(this);
                            var id = $this.attr("id");
                            var isSwitch = $this.text().toLowerCase() === "true";
                            divAlarmOut.append($("<input id=\"chkAlarmOut" + id + "\" type=\"checkbox\" " + (isSwitch ? "checked=\"checked\"" : "") + " />"));
                            divAlarmOut.append($("<label for=\"chkAlarmOut" + id + "\">" + LangCtrl._L_("alarmOut") + " " + id + "</label>"));
                        });
                    }

                    var chkTriggerEmail = $("#chkTriggerEmail");
                    chkTriggerEmail.attr("checked", $("config>tripwire>mail>switch", xmlDoc).text().toLowerCase() === "true");
                    chkTriggerEmail.click(function(e) {
                        TriggerModule.toggleEmailList($(this).attr("checked") == "checked");
                        TriggerModule.ajustHeight();
                    });
                    var emailChkList = $("#divEmail" ).find(".emailServer");
                    $("config>tripwire>mail>item", xmlDoc).each(function(i,element){
                        $(emailChkList[$(element).attr("id")-1]).attr("checked","checked");

                    });
                    var emailChkPicList = $("#divEmail").find(".emailPic");
                    $("config>tripwire>mail>item", xmlDoc).each(function(i,element){
                        if($(">sendPic",element).text() === "true"){
                            $(emailChkPicList[$(element).attr("id")-1]).attr("checked","checked");
                        }
                    });

                    var subject = $("config>tripwire>mail>subject", xmlDoc);
                    var content = $("config>tripwire>mail>content", xmlDoc);
                    $("#emailTheme").attr("maxLength",subject.attr("maxLen"));
                    $("#emailContent").attr("maxLength",content.attr("maxLen"));
                    $("#emailTheme").val(subject.text());
                    $("#emailContent").val(content.text());

                    var chkTriggerFTP = $("#chkTriggerFTP");
                    chkTriggerFTP.attr("checked", $("config>tripwire>ftp>switch", xmlDoc).text().toLowerCase() === "true");
                    chkTriggerFTP.click(function(e) {
                        TriggerModule.toggleFtpList($(this).attr("checked") == "checked");
                        TriggerModule.ajustHeight();
                    });
                    var ftpChkList = $("#divFTP" ).find(".ftpServer");
                    $("config>tripwire>ftp>item", xmlDoc).each(function(i,element){
                        $(ftpChkList[$(element).attr("id")-1]).attr("checked","checked");

                    });
                    var ftpChkPicList = $("#divFTP").find(".FTPPic");
                    var ftpChkRecList = $("#divFTP").find(".FTPRec");
                    $("config>tripwire>ftp>item", xmlDoc).each(function(i,element){
                        if($(">sendPic",element).text() === "true"){
                            $(ftpChkPicList[$(element).attr("id")-1]).attr("checked","checked");
                        }
                        if($(">sendRec",element).text() === "true"){
                            $(ftpChkRecList[$(element).attr("id")-1]).attr("checked","checked");
                        }
                    });

                    var holdTime = $("config>tripwire>alarmHoldTime", xmlDoc).text();
                    $("#cboAlarmHoldingTime").selectInput("setData", { text: holdTime, value: holdTime });
                    XmlHttpClient.BindPageByXml(TriggerModule.mapping, xmlDoc);
                    TriggerModule.toggle(alarmEnabled);
                    TriggerModule.toggleFtpList(chkTriggerFTP.attr("checked") == "checked" && $("config>tripwire>switch", xmlDoc).text().toLowerCase() === "true");
                    window.top.hideLoading();
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    getSaveData: function() {
        $("[id^=\"chkAlarmOut\"]").each(function(index, element) {
            $("config>tripwire>triggerAlarmOut>item[id=\"" + $(element).attr("id").substr(11) + "\"]", xmlDoc).text($(this).is(":checked") ? "true" : "false");
        });
        $("config>tripwire>alarmHoldTime", xmlDoc).text($("#cboAlarmHoldingTime").selectInput("getValue"));

        var divFtpList = $("#divFTP").find(".ftpServer");
        $("config>tripwire>ftp>item", xmlDoc).remove();
        $("config>tripwire>ftp>switch",xmlDoc).text($("#chkTriggerFTP").is(":checked") ? "true" : "false");
        var count = 0;
        for(var i= 0,len = divFtpList.length;i<len;i++){
            if($(divFtpList[i]).attr("checked") === "checked"){
                count++;
                $("config>tripwire>ftp", xmlDoc).append(
                    $(xmlDoc.createElement("item")).attr("id",i+1).append(
                        $(xmlDoc.createElement("sendPic")).attr("type","boolean").append(
                                $(divFtpList[i]).parent().parent().next().next().find("input").attr("checked") === "checked" ? "true" : "false"
                        )
                    ).append(
                        $(xmlDoc.createElement("sendRec")).attr("type","boolean").append(
                                $(divFtpList[i]).parent().parent().next().find("input").attr("checked") === "checked" ? "true" : "false"
                        )
                    )
                );
            }
        }
        $("config>tripwire>ftp", xmlDoc).attr("count",count);

        var divEmailList = $("#divEmail").find(".emailServer");
        $("config>tripwire>mail>item", xmlDoc).remove();
        $("config>tripwire>mail>switch",xmlDoc).text($("#chkTriggerEmail").is(":checked") ? "true" : "false");
        $("config>tripwire>mail>subject", xmlDoc).remove();
        $("config>tripwire>mail>content", xmlDoc).remove();
        $("config>tripwire>mail",xmlDoc).append(
            $(xmlDoc.createElement("subject")).attr("type","string").attr("maxLen","63").append(
                xmlDoc.createCDATASection($("#emailTheme").val())
            )
        );
        $("config>tripwire>mail",xmlDoc).append(
            $(xmlDoc.createElement("content")).attr("type","string").attr("maxLen","255").append(
                xmlDoc.createCDATASection($("#emailContent").val())
            )
        );
        var countEmail = 0;
        for(var i= 0,len = divEmailList.length;i<len;i++){
            if($(divEmailList[i]).attr("checked") === "checked"){
                countEmail++;
                $("config>tripwire>mail", xmlDoc).append(
                    $(xmlDoc.createElement("item")).attr("id",i+1).append(
                        $(xmlDoc.createElement("sendPic")).attr("type","boolean").append(
                                $(divEmailList[i]).parent().parent().next().find("input").attr("checked") === "checked" ? "true" : "false"
                        )
                    )
                );
            }
        }
        $("config>tripwire>mail", xmlDoc).attr("count",countEmail);

        var result = XMLDoc2XMLStr(xmlDoc);
        return XmlHttpClient.GetXmlByPage(TriggerModule.mapping, xmlDoc)
    },
    setData: function() {
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/SetTripwireConfig",
                type: "POST",
                async: true,
                data: TriggerModule.getSaveData(),
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    window.top.hideLoading();
                    commSaveResponseHadler(result);
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    }
};

var AreaModule = {
    action:"EDIT_ON",   //EDIT_ON,EDIT_OFF,NONE
    setAction:function(action){
        $("#btnDraw").removeAttr("class");
        this.action = action;
        switch (action) {
            case "disable":
                $("#btnDraw").addClass("disable").attr("value", LangCtrl._L_("drawArea"));
                break;
            case "on":
                var sendXML = OCX_XML_SetAreaAction("SetTripwireLineAction","EDIT_ON");
                NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
                $("#btnDraw").removeClass("off").addClass("on").attr("value", LangCtrl._L_("stopDraw"));
                break;
            case "off":
                var sendXML = OCX_XML_SetAreaAction("SetTripwireLineAction","EDIT_OFF");
                NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
                $("#btnDraw").removeClass("on").addClass("off").attr("value", LangCtrl._L_("drawArea"));
                break;
        }
    },
    initCtrl: function() {
        $("#sliderSensitivity").slider({
            minValue: 0,
            maxValue: 0,
            maxWidth: 124,
            thumbCss: "slider_thumb_1",
            valueChangeEvent: function(value) {
                $("#valueSensitivity").val(value);
            }
        });
        $("#valueSensitivity").bind("blur",function(){
            $("#sliderSensitivity").slider("setValueWithEvent",$("#valueSensitivity").val())
        }).keydown(function(ev){
            ev = ev || event;
            if (isEnter(ev))
                $("#sliderSensitivity").slider("setValueWithEvent", $("#valueSensitivity").val());
        });
        $("#btnDraw").click(function() {
            if (AreaModule.action == "disable")
                return;
            if (AreaModule.action == "on") {
                AreaModule.setAction("off");
            }
            else {
                AreaModule.setAction("on");
            }
        });
    },
    getData: function() {
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/GetTripwireConfig",
                type: "POST",
                async: true,
                data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    xmlDoc = result;
                    AreaModule.bindCtrlData();
                    window.top.hideLoading();
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    bindCtrlData: function() {

        var direction  = $("#direction");
        direction.empty();
        var symbolDirection = ["A<->B","A->B","A<-B"];
        $("config>types>direction>enum",xmlDoc).each(function(index,ele){
                var value = $(ele).text();
                switch (value){
                    case "none": $("<option value=" + value + ">" + symbolDirection[0] +"</option>").appendTo(direction);break;
                    case "rightortop": $("<option value=" + value + ">" + symbolDirection[1] +"</option>").appendTo(direction);break;
                    case "leftorbotton": $("<option value=" + value + ">" + symbolDirection[2] +"</option>").appendTo(direction);break;
                }
        });

        var alertSurface  = $("#alertSurface");
        alertSurface.empty();
        $("config>tripwire>line>item",xmlDoc).each(function(index,ele){
            $("<option>" + (index+1) +"</option>").appendTo(alertSurface);
        });


        alertSurface.on("focus",function(){

            var index = $(this).val() - 1;

            $("config>tripwire>line>item>direction:eq(" + index + ")", xmlDoc).text($("#direction").val());
            $("config>tripwire>line>item>sensitivity:eq(" + index + ")", xmlDoc).text( $("#sliderSensitivity").slider("getValue"));


            var sendXML = OCX_XML_GetTripwireLine();
            var result = NetLiveMonitor.QueryInfo(sendXML, sendXML.length);
            var $xmlDoc = $(XMLStr2XMLDoc(result));

            var startPoint = $("config>tripwire>line>item:eq(" + index + ")>startPoint", xmlDoc);
            var endPoint = $("config>tripwire>line>item:eq(" + index + ")>endPoint", xmlDoc);



            $(">X",startPoint).text( $("response>points>item:eq(" + 0 + ")", $xmlDoc).attr("X"));
            $(">Y",startPoint).text( $("response>points>item:eq(" + 0 + ")", $xmlDoc).attr("Y"));

            $(">X",endPoint).text( $("response>points>item:eq(" + 1 + ")", $xmlDoc).attr("X"));
            $(">Y",endPoint).text( $("response>points>item:eq(" + 1 + ")", $xmlDoc).attr("Y"));


        }).live("change",function(){
            var alertSurfaceNum = $(this).val() -1;
            changeByNum(alertSurfaceNum);
            $(this).blur();
        });

        function changeByNum(num){
            var item = $("config>tripwire>line>item",xmlDoc).eq(num);
            var itemDirection = $(">direction",item).text();
            $("#direction").val(itemDirection);

            var sensitivity = $(">sensitivity",item);
            var sliderSensitivity = $("#sliderSensitivity");
            sliderSensitivity.slider("setProperty", "minValue", sensitivity.attr("min") * 1);
            sliderSensitivity.slider("setProperty", "maxValue", sensitivity.attr("max") * 1);
            sliderSensitivity.slider("setValueWithEvent", sensitivity.text());

            var point= [];
            point.push( {X:$("config>tripwire>line>item:eq(" + (num) + ")>startPoint>X", xmlDoc).text(),Y:$("config>tripwire>line>item:eq(" + (num) + ")>startPoint>Y", xmlDoc).text()});
            point.push( {X:$("config>tripwire>line>item:eq(" + (num) + ")>endPoint>X", xmlDoc).text(),Y:$("config>tripwire>line>item:eq(" + (num) + ")>endPoint>Y", xmlDoc).text()});

            var sendXML = OCX_XML_SetTripwireArea(point);
            NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);


        }
        changeByNum(0);

    },
    getSaveData: function() {

        var alertSurfaceNum = $( "#alertSurface option:selected").text() - 1;
        var ele = $("config>tripwire>line>item", xmlDoc).eq(alertSurfaceNum);
        $(">sensitivity ",ele).text($("#sliderSensitivity").slider("getValue"));
        $(">direction",ele).text($( "#direction option:selected").val());

        var point= [];
        $("config>tripwire>line>item:eq(" + (alertSurfaceNum) + ")", xmlDoc).each(function(index, element) {
            $("point>item",element).each(function(i,ele){
                point.push({X:$("point>item>X",ele).text(),Y:$("point>item>Y",ele).text()});
            });
        });
        var sendXML = OCX_XML_GetTripwireLine(point);
        var result = NetLiveMonitor.QueryInfo(sendXML, sendXML.length);
        var $xmlDoc = $(XMLStr2XMLDoc(result));

        var startPoint = $("config>tripwire>line>item:eq(" + (alertSurfaceNum) + ")>startPoint", xmlDoc);
        var endPoint = $("config>tripwire>line>item:eq(" + (alertSurfaceNum) + ")>endPoint", xmlDoc);

        $(">X",startPoint).text( $("response>points>item:eq(" + 0 + ")", $xmlDoc).attr("X"));
        $(">Y",startPoint).text( $("response>points>item:eq(" + 0 + ")", $xmlDoc).attr("Y"));

        $(">X",endPoint).text( $("response>points>item:eq(" + 1 + ")", $xmlDoc).attr("X"));
        $(">Y",endPoint).text( $("response>points>item:eq(" + 1 + ")", $xmlDoc).attr("Y"));

        return XMLDoc2XMLStr(xmlDoc);
    },
    setData: function() {
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/SetTripwireConfig",
                type: "POST",
                async: true,
                data: AreaModule.getSaveData(),
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    window.top.hideLoading();
                    commSaveResponseHadler(result);
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    setOCX: function() {
//        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/GetPortConfig",
                type: "POST",
                async: true,
                data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    netPort = $("config>port>netPort", result).text() * 1;
                    $("#divOCX").empty();
                    NetLiveMonitor = LoadPlugin("divOCX","NetLiveMonitor");
                    // 设置模式
                    var sendXML = OCX_XML_SetPreViewModel("ReadOnly");
                    NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    }
};

//OCX调用js方法
function NotifyResultToJs(strXMLFormat, lStrLen) {
    var $xmlDoc = $(XMLStr2XMLDoc(strXMLFormat));

    // OCX已创建好窗口，通知可以登录了
    if ($("statenotify[type=\"Login\"]", $xmlDoc).length > 0) {
        var userInfo = Decryption($.cookie("auInfo"));
        var userInfoArr = userInfo.split(":");
        // 设置登录信息
        var username = userInfoArr[0];
        var password = userInfoArr[1];
        var ip = serverIp;
        var port = netPort;
        var id = "";
        // 设置模式
        var sendXML = OCX_XML_SetPreViewModel("ReadOnly");
        NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);

        var sendXML = OCX_XML_SetLoginInfo(username, password, ip, port, id);
        NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);

        // 设置预览码流索引
        var sendXML = OCX_XML_SetStreamType(2);
        NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
    }

    if ($("statenotify[type=\"GetOriginalWH\"]", $xmlDoc).length > 0) {
        $("#divOCX").css({width:"400px",height:"300px"});
        AreaModule.getData();
    }

    var connectstate = $("statenotify[type='connectstate']",$xmlDoc);
    if(connectstate.length > 0){
        if($(">status", connectstate).text() === "success"){
            window.top.hideLoading();
        }else{
            window.top.showLoading(window.top.LangCtrl._L_("connectError"));
        }
    }

    var Connect  = $("statenotify[type='Connect']",$xmlDoc);
    if(Connect.length > 0){
        if($(">status", Connect).text() === "limit"){
            window.top.MsgBoxHelper.Show("info", LangCtrl._L_("infoTip"), LangCtrl._L_("limit"), null);
        }
    }

};

var ScheduleModule = {
    initCtrl: function() {
        $("#dpHoliday").dateInput({
            format: "MM-dd",
            defaultValue: new Date().format("MM-dd")
        });

        $("#divDate").listbox({
            data: [],
            selectItem: function() {
                var itemData = $(this).data("itemData");
                var times = holidaySchedules[itemData.value];
                var timelineObj = $("#divHolidayTimeline");
                timelineObj.timeline("clearTimes");
                $.each(times, function(index, element) {
                    timelineObj.timeline("setTime", element);
                });
            },
            clickItem: function() {
                var itemData = $(this).data("itemData");
                var times = holidaySchedules[itemData.value];
                var timelineObj = $("#divHolidayTimeline");
                timelineObj.timeline("clearTimes");
                $.each(times, function(index, element) {
                    timelineObj.timeline("setTime", element);
                });
            },
            unSelectItem: function() {
            }
        });

        $("#btnHolidayAdd").click(function(event) {
            var dateStr = $("#dpHoliday").val();
            ClearFloatError();
            for (var key in holidaySchedules) {
                if (key == dateStr) {
                    ShowFloatError($("#divDate"), LangCtrl._L_("notUniqueDateTip"));
                    return;
                }
            }
            $("#divHolidayTimeline").timeline("setEnable", true);
            holidaySchedules[dateStr] = ["00:00-23:59"];
            $("#divDate").listbox("addItem", { id: dateStr, value: dateStr });
            var lastItem = $("#divDate").listbox("getAllItems").last();
            lastItem.click();
            lastItem[0].scrollIntoView();
        });

        $("#btnHolidayDelete").click(function(event) {
            ClearFloatError();
            var id = $("#divDate").listbox("getSeletedItems").data("itemData").id;
            delete holidaySchedules[id];
            $("#divDate").listbox("delItem", id);
            var firstDate = $("#divDate").listbox("getAllItems").first();
            if (firstDate.length == 0) {
                $("#divHolidayTimeline").timeline("clearTimes");
                $("#divHolidayTimeline").timeline("setEnable", false);
            } else {
                firstDate.click();
                firstDate[0].scrollIntoView();
            }
        });

        $("[name=\"scheduleOpType\"]").click(function(event) {
            $("[controlType=\"timeline\"]").timeline("changeMode", event.target.value);
            $("#divHolidayTimeline").timeline("changeMode", event.target.value);
        });

        $("[controlType=\"timeline\"]").timeline({
            manualButtonText: LangCtrl._L_("manualInput"),
            okButtonText: LangCtrl._L_("ok"),
            paddingLeft: 0,
            paddingRight: 0,
            showSelectAllButton: false,
            showInverseButton: false,
            showClearButton: false,
            maxTimeShow: 4,
            oninvalidate: function(startTime, endTime, startInput, endInput) {
                ShowFloatError(startInput, LangCtrl._L_("startTimeGEEndTime"), { left: -startInput.outerWidth() - 6, top: startInput.outerHeight() + 5 });
            }
        });

        $("#divHolidayTimeline").timeline({
            enable: false,
            manualButtonText: LangCtrl._L_("manualInput"),
            okButtonText: LangCtrl._L_("ok"),
            paddingLeft: 0,
            paddingRight: 0,
            showSelectAllButton: false,
            showInverseButton: false,
            showClearButton: false,
            maxTimeShow: 4,
            onvaluechanged: function(control) {
                var itemData = $("#divDate").listbox("getSeletedItems").data("itemData");
                if (itemData && itemData.value) {
                    if(control.timeline("getTimes").length == 0){
                        holidaySchedules[itemData.value] = ["00:00-00:00"];
                    }else{
                        holidaySchedules[itemData.value] = control.timeline("getTimes");
                    }
                }
            },
            oninvalidate: function(startTime, endTime, startInput, endInput) {
                ShowFloatError(startInput, LangCtrl._L_("startTimeGEEndTime"), { left: -startInput.outerWidth() - 6, top: startInput.outerHeight() + 5 });
            }
        });
    },
    getData: function() {
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/GetTripwireScheduleConfig",
                type: "POST",
                async: true,
                data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    xmlDoc = result;
                    ScheduleModule.bindCtrlData();

                    // 周排程
                    $.each(["sunday", "monday", "tuesday", "wednesday", "thursday", "friday", "saturday"], function(index, element) {
                        var timelineObj = $("[controlType=\"timeline\"]:eq(" + index + ")");
                        timelineObj.timeline("clearTimes");
                        $("config>schedule>period[mode=\"weekly\"][day=\"" + element + "\"]", xmlDoc).each(function(index, element) {
                            timelineObj.timeline("setTime", $(this).attr("start") + "-" + $(this).attr("end"));
                        });
                    });

                    // 年排程
                    var firstDate = "";
                    holidaySchedules = {};
                    $("#divDate").listbox("clearData");
                    $("#divHolidayTimeline").timeline("setTime","00:00-23:59");
                    $("#divHolidayTimeline").timeline("setEnable", false);
                    $("config>schedule>period[mode=\"yearly\"]", xmlDoc).each(function(index, element) {
                        var dateStr = $(this).attr("date");
                        if (index == 0) {
                            $("#divHolidayTimeline").timeline("setEnable", true);
                            firstDate = dateStr;
                        }
                        if (!holidaySchedules[dateStr]) {
                            holidaySchedules[dateStr] = [];
                            $("#divDate").listbox("addItem", { id: dateStr, value: dateStr });
                        }
                        holidaySchedules[dateStr].push($(this).attr("start") + "-" + $(this).attr("end"));
                    });

                    if (firstDate) {
                        $("#divDate").listbox("getItemByID", firstDate).click();
                    }

                    window.top.hideLoading();
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    bindCtrlData: function() {
        ScheduleModule.timeSpanMaxCount = $("config>schedule", xmlDoc).attr("maxTimeSpan") * 1;
    },
    verification: function() {
        ClearFloatError();

        var count = 0;
        $("[controlType=\"timeline\"]").each(function(index, element) {
            var $this = $(this);
            count += $this.timeline("getTimes").length;
        });

        $.each($("#divDate").listbox("getAllItems"), function(index, element) {
            var dateStr = $(this).data("itemData").value;
            count += holidaySchedules[dateStr].length;
        });

        if (count > ScheduleModule.timeSpanMaxCount) {
            ShowFloatError($("#btnSave"), LangCtrl._L_("timeSpanMaxCount").format(ScheduleModule.timeSpanMaxCount), { left: -350, top: 1 });
            return false;
        }

        return true;
    },
    getSaveData: function() {
        var weeks = ["sunday", "monday", "tuesday", "wednesday", "thursday", "friday", "saturday"];
        var scheduleNode = $("config>schedule", xmlDoc);
        scheduleNode.empty();

        // 周排程
        $("[controlType=\"timeline\"]").each(function(weekIndex, element) {
            var timeSpans = $(this).timeline("getTimes", $.TIMELINE_DATA_MODE_STRING);
            $.each(timeSpans, function(index, element) {
                scheduleNode.append($(xmlDoc.createElement("period")).attr("mode", "weekly").attr("start", element[0]).attr("end", element[1]).attr("day", weeks[weekIndex]));
            });
        });

        // 年排程
        $.each($("#divDate").listbox("getAllItems"), function(index, element) {
            var dateStr = $(this).data("itemData").value;
            $.each(holidaySchedules[dateStr], function(index, element) {
                var timeParts = element.split("-");
                scheduleNode.append($(xmlDoc.createElement("period")).attr("mode", "yearly").attr("start", timeParts[0]).attr("end", timeParts[1]).attr("date", dateStr));
            });
        });

        return XMLDoc2XMLStr(xmlDoc);
    },
    setData: function() {
        window.top.showLoading();
        if (!ScheduleModule.verification()) {
            window.top.hideLoading();
            return false;
        }
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/SetTripwireScheduleConfig",
                type: "POST",
                async: true,
                data: ScheduleModule.getSaveData(),
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    window.top.hideLoading();
                    commSaveResponseHadler(result);
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    }
};

function initControl() {
    TriggerModule.initCtrl();
    AreaModule.initCtrl();
    ScheduleModule.initCtrl();
    $("#btnSave").click(function() {
        ClearFloatError();
        var curTab = $.cookie("tab");
        if (!curTab) {
            curTab = "liMotionDetectionTrigger";
        }
        switch (curTab) {
            case "liMotionDetectionTrigger":
                TriggerModule.setData();
                break;
            case "liMotionDetectionArea":
                AreaModule.setData();
                break;
            case "liMotionDetectionSchedule":
                ScheduleModule.setData();
                break;
        }
    });
}

function clearTab(parent) {
    $("input[type=\"text\"]", parent).val("");
    $("input[type=\"checkbox\"]", parent).removeAttr("checked");
    $("select", parent).empty();
}