﻿var xmlDoc;
var rtspPort,netPort; // RTSP端口,数据端口
var NetLiveMonitor; // 视频控件


$(function() {
    FaceRegModel.initCtrl();

    closeStream();
});

var FaceRegModel ={

    action:"EDIT_ON",   //EDIT_ON,EDIT_OFF,NONE
    setAction:function(action){
        $("#btnDraw").removeAttr("class");
        this.action = action;
        switch (action) {
            case "disable":
                $("#btnDraw").addClass("disable").attr("value", LangCtrl._L_("drawArea"));
                break;
            case "on":
                var sendXML = OCX_XML_SetAreaAction("SetVfdAction","EDIT_ON");
                NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
                $("#btnDraw").removeClass("off").addClass("on").attr("value", LangCtrl._L_("stopDraw"));
                break;
            case "off":
                var sendXML = OCX_XML_SetAreaAction("SetVfdAction","EDIT_OFF");
                NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
                $("#btnDraw").removeClass("on").addClass("off").attr("value", LangCtrl._L_("drawArea"));
                break;
        }
    },
    initCtrl: function() {
        $("#btnClear").click(function(){
            var sendXML = OCX_XML_SetAreaAction("SetVfdAction","NONE");
            NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
        });
        if(!NetLiveMonitor){
            FaceRegModel.setOCX();
        }
    },
    bindFun:function(){
        $("#btnDraw").click(function() {
            if (FaceRegModel.action == "disable")
                return;
            if (FaceRegModel.action == "on") {
                FaceRegModel.setAction("off");
            }
            else {
                FaceRegModel.setAction("on");
            }
        });
        $("#btnSave").click(function(){
            FaceRegModel.saveData();
        });
    },
    getData: function() {
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/GetVfdConfig",
                type: "POST",
                async: true,
                data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    xmlDoc = result;
                    $("#faceCheck").attr("checked",($("config>vfd>switch", result).text().toLowerCase() === "true"));
                    var point= [];
                    $("config>vfd>point>item", xmlDoc).each(function(index, element) {
                        point.push({X:$(">X",element).text(),Y:$(">Y",element).text()});
                    });
                    var sendXML = OCX_XML_SetVfdArea(point);
                    NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
                    window.top.hideLoading();
                }
            });
        } catch (ex) {
            alert(ex);
        }
    },
    getSaveData: function() {

        var faceOpen = ($("#faceCheck").attr("checked") === "checked" ? "true" : "false");
        $("config>vfd>switch", xmlDoc).text(faceOpen);

        var sendXML = OCX_XML_GetVfd();
        var result = NetLiveMonitor.QueryInfo(sendXML, sendXML.length);
        var $xmlDoc = $(XMLStr2XMLDoc(result));

        var pointNode = $("config>vfd>point", xmlDoc).empty();

        var pointArr = [];
        var prvX;
        $("response>points>item", $xmlDoc).each(function(i,ele){

            if(prvX == $(ele).attr("X")){
                pointArr = [0,0,0,0];
            }
            if(!(i%2 == 1)){
                pointArr.push($(ele).attr("X"));
                pointArr.push($(ele).attr("Y"));
            }

        });
        pointNode.append(
            $(xmlDoc.createElement("item")).append(
                $(xmlDoc.createElement("X")).attr("type", "unit32").text( pointArr[0])
            ).append(
                $(xmlDoc.createElement("Y")).attr("type", "unit32").text( pointArr[1])
            )
        ).append(
            $(xmlDoc.createElement("item")).append(
                $(xmlDoc.createElement("X")).attr("type", "unit32").text( pointArr[2])
            ).append(
                $(xmlDoc.createElement("Y")).attr("type", "unit32").text( pointArr[1])
            )
        ).append(
            $(xmlDoc.createElement("item")).append(
                $(xmlDoc.createElement("X")).attr("type", "unit32").text( pointArr[2])
            ).append(
                $(xmlDoc.createElement("Y")).attr("type", "unit32").text( pointArr[3])
            )
        ).append(
            $(xmlDoc.createElement("item")).append(
                $(xmlDoc.createElement("X")).attr("type", "unit32").text( pointArr[0])
            ).append(
                $(xmlDoc.createElement("Y")).attr("type", "unit32").text( pointArr[3])
            )
        );

        return XMLDoc2XMLStr(xmlDoc);
    },
    saveData: function() {
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/SetVfdConfig",
                type: "POST",
                async: true,
                data: FaceRegModel.getSaveData(),
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    window.top.hideLoading();
                    if($("config",result).attr("status") === "success"){
                        ShowFloatError($("#btnSave"), LangCtrl._L_("saveSuccess"), { left: 15 });
                    }else{
                        ShowFloatError($("#btnSave"), LangCtrl._L_("saveFailed"), { left: 15 });
                    }
//                    FaceRegModel.getData();
                }
            });
        } catch (ex) {
            alert(ex);
        }
    },
    setOCX: function() {
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/GetPortConfig",
                type: "POST",
                async: true,
                data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    window.top.hideLoading();
                    netPort = $("config>port>netPort", result).text() * 1;
                    NetLiveMonitor = LoadPlugin("divOCX","NetLiveMonitor");

                    if(NetLiveMonitor){
                        // 设置模式
                        var sendXML = OCX_XML_SetPreViewModel("ReadOnly");
                        NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
                    }

                    FaceRegModel.bindFun();

                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    }

};

//OCX调用js方法
function NotifyResultToJs(strXMLFormat, lStrLen) {
    var $xmlDoc = $(XMLStr2XMLDoc(strXMLFormat));

    // OCX已创建好窗口，通知可以登录了
    if ($("statenotify[type=\"Login\"]", $xmlDoc).length > 0) {
        var userInfo = Decryption($.cookie("auInfo"));
        var userInfoArr = userInfo.split(":");
        // 设置登录信息
        var username = userInfoArr[0];
        var password = userInfoArr[1];
        var ip = serverIp;
        var port = netPort;
        var id = "";
        var sendXML = OCX_XML_SetLoginInfo(username, password, ip, port, id);
        NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);

        // 设置预览码流索引
        var sendXML = OCX_XML_SetStreamType(2);
        NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
    }

    if ($("statenotify[type=\"GetOriginalWH\"]", $xmlDoc).length > 0) {
        $("#divOCX").css({width:"640px",height:"480px"});
        FaceRegModel.getData();
    }

    var connectstate = $("statenotify[type='connectstate']",$xmlDoc);
    if(connectstate.length > 0){
        if($(">status", connectstate).text() === "success"){
            window.top.hideLoading();
        }else{
            window.top.showLoading(window.top.LangCtrl._L_("connectError"));
        }
    }

    var Connect  = $("statenotify[type='Connect']",$xmlDoc);
    if(Connect.length > 0){
        if($(">status", Connect).text() === "limit"){
            window.top.MsgBoxHelper.Show("info", LangCtrl._L_("infoTip"), LangCtrl._L_("limit"), null);
        }
    }

}

