﻿var holidaySchedules;
var NetLiveMonitor;
var xmlDoc;
var pointNum = 4;

$(function() {
	initControl();
	$("#divParent").tab({
		map: [{ tab: "liPerimeterTrigger", content: "divPerimeterTrigger", init: initPerimeterTrigger },
			{ tab: "liPerimeterArea", content: "divPerimeterArea", init: initPerimeterArea },
			{ tab: "liPerimeterSchedule", content: "divPerimeterSchedule", init: initPerimeterSchedule } ]
	});
	$("#divParent").tab("selectLastTab");
    closeStream();
    $("#Content",window.top.document).css({"min-width":"1200px"});
});

function initPerimeterTrigger() {
    $(".cfgfooter").css("width","20%");
	clearTab($("#divPerimeterTrigger"));
	getDeviceInfo(function(result) {
		TriggerModule.isSupportSDCard = $("config>deviceInfo>supportSDCard", result).text() === "true";
	});
    TriggerModule.getEmailListData();
	TriggerModule.getFTPListData();
}

function initPerimeterArea() {
    $(".cfgfooter").css("width","720px");
	clearTab($("#divPerimeterArea"));
    $("#btnClear").click(function(){
        var sendXML = OCX_XML_SetAreaAction("SetOscAreaAction","NONE");
        NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
    });
    if(!NetLiveMonitor){
        AreaModule.setOCX();
    }
    AreaModule.getData();

}

function initPerimeterSchedule() {
    $(".cfgfooter").css("width","735px");
	ScheduleModule.getData();
}

var TriggerModule = {
	mapping: {
		chkEnableAlarm: "config>osc>switch",
		chkTriggerSnap: "config>osc>savePicSwitch",
		chkTriggerEmail: "config>osc>mailSwitch",
        chkTriggerFTP: "config>osc>ftp>switch"
	},
	toggle: function(enabled) {
		if (!enabled) {
			$(".triggle").hide();
		} else {
			$(".triggle:not(#trTriggerSnap)").show();
			if (TriggerModule.isSupportSDCard) {
				$("#trTriggerSnap").show();
			}
            TriggerModule.toggleFtpList($("#chkTriggerFTP").attr("checked") == "checked");
            TriggerModule.toggleEmailList($("#chkTriggerEmail").attr("checked") == "checked");
		}
	},
    toggleFtpList: function(enabled){
        if (!enabled) {
            $(".triggleFtp").hide();
        } else {
            TriggerModule.ajustHeight();
            $(".triggleFtp").show();
        }
    },
    toggleEmailList: function(enabled){
        if (!enabled) {
            $(".triggleEmail").hide();
        } else {
            TriggerModule.ajustHeight();
            $(".triggleEmail").show();
        }
    },
    ajustHeight: function() {
        var minHeight = $("#divPerimeterTrigger").height() + 160;
        window.parent.setConfigMiniHeight(minHeight);
    },
	initCtrl: function() {
		$(".trigger").hide();

		$("#chkEnableAlarm").click(function(e) {
			TriggerModule.toggle($(this).attr("checked") == "checked");
		});

		$("#cboAlarmHoldingTime").selectInput({
			list: [
				{ text: LangCtrl._L_("seconds").format(5), value: 5 },
				{ text: LangCtrl._L_("seconds").format(10), value: 10 },
				{ text: LangCtrl._L_("seconds").format(20), value: 20 },
				{ text: LangCtrl._L_("seconds").format(30), value: 30 },
				{ text: LangCtrl._L_("seconds").format(60), value: 60 },
				{ text: LangCtrl._L_("minutes").format(2), value: 120 }
			],
			mapping: function(text) {
				var validReg = /^[1-9]\d*$/;
				var execResults = validReg.exec(text);
				if (execResults) {
					return { text: execResults[0] % 60 == 0 ? LangCtrl._L_("minutes").format(execResults[0] / 60) : LangCtrl._L_("seconds").format(execResults[0]), value: execResults[0] };
				}

				validReg = new RegExp("^" + LangCtrl._L_("seconds").format("([1-9]\\d*)") + "$");
				execResults = validReg.exec(text);
				if (execResults) {
					return { text: text, value: execResults[1] };
				}

				validReg = new RegExp("^" + LangCtrl._L_("minutes").format("([1-9]\\d*)") + "$");
				execResults = validReg.exec(text);
				if (execResults) {
					return { text: text, value: execResults[1] * 60 };
				}
				return false;
			}
		});
	},
    getEmailListData: function(){
        window.top.showLoading();
        XmlHttpClient.SendHttpRequest({
            url: serverBase + "/GetMailConfig",
            type: "POST",
            async: true,
            data: "",
            beforeSend: XmlHttpClient.CommBeforeSend,
            callback: function(result) {

                var emailList = "";
                var d = document.getElementById('dvCompute');
                $("config>mail>recvMail>item",result).each(function(i,ele){
                    var emailName = $(ele).text();
                    d.innerHTML = emailName;
                    var  averageLen = d.offsetWidth / (emailName.length);
                    var indexStr = Math.floor(210 / averageLen);
                    var imageName =  d.offsetWidth > 210 ? (emailName.substr(0, indexStr) + "...") : emailName;
                    emailList = emailList +"<tr>" +
                        "<td style='word-break:keep-all;width: 271px;'>" + "<div title='"+ $(ele).text()+"'>"+"<input id='chkTriggerEmailAddr_"  + i + "' class='emailServer' type='checkbox' />"+imageName +"</div>"+ "</td>" +
                        "<td><input id='chkTriggerEmailPic_" + i + "' class='emailPic' type='checkbox' /><label for='chkTriggerEmailPic_" + i +"' >" + LangCtrl._L_("pictureSend") + "</label></td>" +
                        "</tr>";
                });

                var alarmOutEmailList = $("#divEmailTable");
                var alarmOutEmailTitle = $("#divEmailTitle");
                var motionEmailTheme = $("#divEmailTheme");
                alarmOutEmailList.empty();
                alarmOutEmailTitle.empty();
                motionEmailTheme.empty();
                $("<table  class='contentTable' cellpadding='0' cellspacing='0' style='table-layout: fixed;'>" +
                    "<tbody>" +
                    "<tr>" +
                    "<td style='width: 273px;'>" + LangCtrl._L_("emailServer") + "</td>" +
                    "<td><input id='chkTriggerEmailPic'  type='checkbox' /><label for='chkTriggerEmailPic' >" + LangCtrl._L_("pictureSend") + "</label></td>" +
                    "</tr>" +
                    "</tbody>" +
                    "</table>").appendTo(alarmOutEmailTitle);
                $(emailList).appendTo(alarmOutEmailList);
                $("<table  class='contentTable' cellpadding='0' cellspacing='0' style='table-layout: fixed;'>" +
                    "<tbody>" +
                    "<tr>" +
                    "<td style='width: 100px;'>" + LangCtrl._L_("emailTheme") + "</td>" +
                    "<td><input id='emailTheme'  type='text' style='width: 300px;'/></td>" +
                    "</tr>" +
                    "<tr>" +
                    "<td style='width: 271px;'>" + LangCtrl._L_("emailContent") + "</td>" +
                    "<td><input id='emailContent'  type='text' style='width: 300px;'/></td>" +
                    "</tr>" +
                    "</tbody>" +
                    "</table>").appendTo(motionEmailTheme);

                $("#chkTriggerEmailPic").click(function(){
                    var emialPicList = $(this).parent().parent().parent().parent().parent().next().find(".emailPic");
                    if($(this).attr("checked") === "checked"){
                        $(emialPicList).attr("checked","checked");
                    }else{
                        $(emialPicList).attr("checked",false);
                    }
                });
            }
        });
    },
    getFTPListData: function(){
        window.top.showLoading();
        XmlHttpClient.SendHttpRequest({
            url: serverBase + "/GetFtpConfig",
            type: "POST",
            async: true,
            data: "",
            beforeSend: XmlHttpClient.CommBeforeSend,
            callback: function(result) {

                var ftpList = "";
                var d = document.getElementById('dvCompute');
                $("config>ftp>item",result).each(function(i,ele){
                    var ftpName = $(">serverAddr",ele).text();
                    d.innerHTML = ftpName;
                    var  averageLen = d.offsetWidth / (ftpName.length);
                    var indexStr = Math.floor(210 / averageLen);
                    var imageName =  d.offsetWidth > 210 ? (ftpName.substr(0, indexStr) + "...") : ftpName;
                    ftpList = ftpList +"<tr>" +
                        "<td style='word-break:keep-all;width: 184px;'>" + "<div title='"+ ftpName+"'>"+"<input id='chkTriggerFTPAddr_"  + i + "' class='ftpServer' type='checkbox' />"+imageName +"</div>"+ "</td>" +
                        "<td><input id='chkTriggerFTPRec_" + i + "' class='FTPRec' type='checkbox' /><label for='chkTriggerFTPRec_" + i +"' >" + LangCtrl._L_("recSend") + "</label></td>" +
                        "<td><input id='chkTriggerFTPPic_" + i + "' class='FTPPic' type='checkbox' /><label for='chkTriggerFTPPic_" + i +"' >" + LangCtrl._L_("pictureSend") + "</label></td>" +
                        "</tr>";
                });

                var alarmOutFTPList = $("#divFTPTable");
                var alarmOutFTPTitle = $("#divFTPTitle");
                $("<table  class='contentTable' cellpadding='0' cellspacing='0' style='table-layout: fixed;' width='100%'>" +
                    "<tbody>" +
                    "<tr>" +
                    "<td style='width: 271px;'>" + LangCtrl._L_("FTPServer") + "</td>" +
                    "<td><input id='chkTriggerFTPPic'  type='checkbox' /><label for='chkTriggerFTPPic' >" + LangCtrl._L_("pictureSend") + "</label></td>" +
                    "</tr>" +
                    "</tbody>" +
                    "</table>").appendTo(alarmOutFTPTitle);
                $(ftpList).appendTo(alarmOutFTPList);

                $("#chkTriggerFTPPic").click(function(){
                    var ftpPicList = $(this).parent().parent().parent().parent().parent().next().find(".FTPPic");
                    if($(this).attr("checked") === "checked"){
                        $(ftpPicList).attr("checked","checked");
                    }else{
                        $(ftpPicList).attr("checked",false);
                    }
                });

                $(".FTPRec").click(function(){
                    var ftpRecList = $(this).parent().parent().parent().find(".FTPRec");
                    for(var m=0;m<ftpRecList.length;m++){
                        if($(ftpRecList[m]).attr("id") == $(this).attr("id")){
                            $(ftpRecList[m]).attr("checked","checked");
                        }else{
                            $(ftpRecList[m]).attr("checked",false);
                        }
                    }
                });
                TriggerModule.getData();
            }
        });
    },
	getData: function() {
		window.top.showLoading();
		try {
			XmlHttpClient.SendHttpRequest({
				url: serverBase + "/GetOscConfig",
				type: "POST",
				async: true,
				data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
				callback: function(result) {
					xmlDoc = result;
					var alarmEnabled = ($(TriggerModule.mapping.chkEnableAlarm, xmlDoc).text().toLowerCase() === "true");
                    var typeOsc = $("config>osc>oscObject", xmlDoc).text();
                    switch (typeOsc){
                        case 'abandum':  $("input[id='leaveItems']").attr("checked",true);break;
                        case 'objstolen':  $("input[id='lostItems']").attr("checked",true);break;
                    }
					var divAlarmOut = $("#divAlarmOut");
					divAlarmOut.empty();
                    var alarmOutList = $("config>osc>triggerAlarmOut>item", xmlDoc);
                    if(alarmOutList.length <= 1){
                        $("config>osc>triggerAlarmOut>item", xmlDoc).each(function(index, element) {
                            var $this = $(this);
                            var id = $this.attr("id");
                            var isSwitch = $this.text().toLowerCase() === "true";
                            divAlarmOut.append($("<input id=\"chkAlarmOut" + id + "\" type=\"checkbox\" " + (isSwitch ? "checked=\"checked\"" : "") + " />"));
                            divAlarmOut.append($("<label for=\"chkAlarmOut" + id + "\">" + LangCtrl._L_("alarmOut") + "</label>"));
                        });
                    }else{
                        $("config>osc>triggerAlarmOut>item", xmlDoc).each(function(index, element) {
                            var $this = $(this);
                            var id = $this.attr("id");
                            var isSwitch = $this.text().toLowerCase() === "true";
                            divAlarmOut.append($("<input id=\"chkAlarmOut" + id + "\" type=\"checkbox\" " + (isSwitch ? "checked=\"checked\"" : "") + " />"));
                            divAlarmOut.append($("<label for=\"chkAlarmOut" + id + "\">" + LangCtrl._L_("alarmOut") + " " + id + "</label>"));
                        });
                    }

                    var chkTriggerEmail = $("#chkTriggerEmail");
                    chkTriggerEmail.attr("checked", $("config>osc>mail>switch", xmlDoc).text().toLowerCase() === "true");
                    chkTriggerEmail.click(function(e) {
                        TriggerModule.toggleEmailList($(this).attr("checked") == "checked");
                        TriggerModule.ajustHeight();
                    });
                    var emailChkList = $("#divEmail" ).find(".emailServer");
                    $("config>osc>mail>item", xmlDoc).each(function(i,element){
                        $(emailChkList[$(element).attr("id")-1]).attr("checked","checked");

                    });
                    var emailChkPicList = $("#divEmail").find(".emailPic");
                    $("config>osc>mail>item", xmlDoc).each(function(i,element){
                        if($(">sendPic",element).text() === "true"){
                            $(emailChkPicList[$(element).attr("id")-1]).attr("checked","checked");
                        }
                    });

                    var subject = $("config>osc>mail>subject", xmlDoc);
                    var content = $("config>osc>mail>content", xmlDoc);
                    $("#emailTheme").attr("maxLength",subject.attr("maxLen"));
                    $("#emailContent").attr("maxLength",content.attr("maxLen"));
                    $("#emailTheme").val(subject.text());
                    $("#emailContent").val(content.text());

                    var chkTriggerFTP = $("#chkTriggerFTP");
                    chkTriggerFTP.attr("checked", $("config>osc>ftp>switch", xmlDoc).text().toLowerCase() === "true");
                    chkTriggerFTP.click(function(e) {
                        TriggerModule.toggleFtpList($(this).attr("checked") == "checked");
                        TriggerModule.ajustHeight();
                    });
                    var ftpChkList = $("#divFTP" ).find(".ftpServer");
                    $("config>osc>ftp>item", xmlDoc).each(function(i,element){
                        $(ftpChkList[$(element).attr("id")-1]).attr("checked","checked");

                    });
                    var ftpChkPicList = $("#divFTP").find(".FTPPic");
                    var ftpChkRecList = $("#divFTP").find(".FTPRec");
                    $("config>osc>ftp>item", xmlDoc).each(function(i,element){
                        if($(">sendPic",element).text() === "true"){
                            $(ftpChkPicList[$(element).attr("id")-1]).attr("checked","checked");
                        }
                        if($(">sendRec",element).text() === "true"){
                            $(ftpChkRecList[$(element).attr("id")-1]).attr("checked","checked");
                        }
                    });

					var holdTime = $("config>osc>alarmHoldTime", xmlDoc).text();
					$("#cboAlarmHoldingTime").selectInput("setData", { text: holdTime, value: holdTime });
					XmlHttpClient.BindPageByXml(TriggerModule.mapping, xmlDoc);
					TriggerModule.toggle(alarmEnabled);
                    TriggerModule.toggleFtpList(chkTriggerFTP.attr("checked") == "checked" && $("config>osc>switch", xmlDoc).text().toLowerCase() === "true");
                    TriggerModule.toggleEmailList(chkTriggerEmail.attr("checked") == "checked" && $("config>osc>switch", xmlDoc).text().toLowerCase() === "true");
					window.top.hideLoading();
				}
			});
		}
		catch (ex) {
			alert(ex);
		}
	},
	getSaveData: function() {
        $("config>osc>oscObject", xmlDoc).text( $("input[name='oscObject']:checked").val());
		$("[id^=\"chkAlarmOut\"]").each(function(index, element) {
			$("config>osc>triggerAlarmOut>item[id=\"" + $(element).attr("id").substr(11) + "\"]", xmlDoc).text($(this).is(":checked") ? "true" : "false");
		});
		$("config>osc>alarmHoldTime", xmlDoc).text($("#cboAlarmHoldingTime").selectInput("getValue"));

        var divFtpList = $("#divFTP").find(".ftpServer");
        $("config>osc>ftp>item", xmlDoc).remove();
        $("config>osc>ftp>switch",xmlDoc).text($("#chkTriggerFTP").is(":checked") ? "true" : "false");

        var divFtpList = $("#divFTP").find(".ftpServer");
        $("config>osc>ftp>item", xmlDoc).remove();
        $("config>osc>ftp>switch",xmlDoc).text($("#chkTriggerFTP").is(":checked") ? "true" : "false");
        var count = 0;
        for(var i= 0,len = divFtpList.length;i<len;i++){
            if($(divFtpList[i]).attr("checked") === "checked"){
                count++;
                $("config>osc>ftp", xmlDoc).append(
                    $(xmlDoc.createElement("item")).attr("id",i+1).append(
                        $(xmlDoc.createElement("sendPic")).attr("type","boolean").append(
                                $(divFtpList[i]).parent().parent().next().next().find("input").attr("checked") === "checked" ? "true" : "false"
                        )
                    ).append(
                        $(xmlDoc.createElement("sendRec")).attr("type","boolean").append(
                                $(divFtpList[i]).parent().parent().next().find("input").attr("checked") === "checked" ? "true" : "false"
                        )
                    )
                );
            }
        }
        $("config>osc>ftp", xmlDoc).attr("count",count);

        var divEmailList = $("#divEmail").find(".emailServer");
        $("config>osc>mail>item", xmlDoc).remove();
        $("config>osc>mail>switch",xmlDoc).text($("#chkTriggerEmail").is(":checked") ? "true" : "false");
        $("config>osc>mail>subject", xmlDoc).remove();
        $("config>osc>mail>content", xmlDoc).remove();
        $("config>osc>mail",xmlDoc).append(
            $(xmlDoc.createElement("subject")).attr("type","string").attr("maxLen","63").append(
                xmlDoc.createCDATASection($("#emailTheme").val())
            )
        );
        $("config>osc>mail",xmlDoc).append(
            $(xmlDoc.createElement("content")).attr("type","string").attr("maxLen","255").append(
                xmlDoc.createCDATASection($("#emailContent").val())
            )
        );
        var countEmail = 0;
        for(var i= 0,len = divEmailList.length;i<len;i++){
            if($(divEmailList[i]).attr("checked") === "checked"){
                countEmail++;
                $("config>osc>mail", xmlDoc).append(
                    $(xmlDoc.createElement("item")).attr("id",i+1).append(
                        $(xmlDoc.createElement("sendPic")).attr("type","boolean").append(
                                $(divEmailList[i]).parent().parent().next().find("input").attr("checked") === "checked" ? "true" : "false"
                        )
                    )
                );
            }
        }
        $("config>osc>mail", xmlDoc).attr("count",countEmail);

		var result = XMLDoc2XMLStr(xmlDoc);
		return XmlHttpClient.GetXmlByPage(TriggerModule.mapping, xmlDoc)
	},
	setData: function() {
		window.top.showLoading();
		try {
			XmlHttpClient.SendHttpRequest({
				url: serverBase + "/SetOscConfig",
				type: "POST",
				async: true,
				data: TriggerModule.getSaveData(),
                beforeSend: XmlHttpClient.CommBeforeSend,
				callback: function(result) {
					window.top.hideLoading();
					commSaveResponseHadler(result);
				}
			});
		}
		catch (ex) {
			alert(ex);
		}
	}
};

var AreaModule = {
    areaIndex:0,
    action:"EDIT_ON",   //EDIT_ON,EDIT_OFF,NONE
    setAction:function(action){
        $("#btnDraw").removeAttr("class");
        this.action = action;
        switch (action) {
            case "disable":
                $("#btnDraw").addClass("disable").attr("value", LangCtrl._L_("drawArea"));
                break;
            case "on":
                var sendXML = OCX_XML_SetAreaAction("SetOscAreaAction","EDIT_ON");
                NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
                $("#btnDraw").removeClass("off").addClass("on").attr("value", LangCtrl._L_("stopDraw"));
                break;
            case "off":
                var sendXML = OCX_XML_SetAreaAction("SetOscAreaAction","EDIT_OFF");
                NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
                $("#btnDraw").removeClass("on").addClass("off").attr("value", LangCtrl._L_("drawArea"));
                break;
        }
    },
	initCtrl: function() {

        $("#sliderSensitivity").slider({
            minValue: 0,
            maxValue: 0,
            maxWidth: 124,
            thumbCss: "slider_thumb_1",
            valueChangeEvent: function(value) {
                $("#valueSensitivity").val(value);
            }
        });
        $("#valueSensitivity").bind("blur",function(){
            $("#sliderSensitivity").slider("setValueWithEvent",$("#valueSensitivity").val())
        }).keydown(function(ev){
            ev = ev || event;
            if (isEnter(ev))
                $("#sliderSensitivity").slider("setValueWithEvent", $("#valueSensitivity").val());
        });

        $("#btnDraw").click(function() {
            if (AreaModule.action == "disable")
                return;
            if (AreaModule.action == "on") {
                AreaModule.setAction("off");
            }
            else {
                AreaModule.setAction("on");
            }
        });

        $("#cboAlertArea").on('focus', function () {
            AreaModule.areaIndex = $(this).val();
            $("config>osc>speclRegions>item>name:eq(" + AreaModule.areaIndex + ")", xmlDoc).empty().append(xmlDoc.createCDATASection($("#nameArea").val()));
            $("config>osc>speclRegions>item>sensitivity:eq(" + AreaModule.areaIndex + ")", xmlDoc).text( $("#sliderSensitivity").slider("getValue"));
            $("config>osc>speclRegions>item>minTime:eq(" + AreaModule.areaIndex + ")", xmlDoc).text($("#minTime").val());

            var sendXML = OCX_XML_GetOscArea();
            var result = NetLiveMonitor.QueryInfo(sendXML, sendXML.length);
            var $xmlDoc = $(XMLStr2XMLDoc(result));
            $("config>osc>speclRegions>item:eq(" + AreaModule.areaIndex + ")>point", xmlDoc).attr("count",$("response>points>item", $xmlDoc).length);
            var pointNode = $("config>osc>speclRegions>item:eq(" + AreaModule.areaIndex + ")>point", xmlDoc).empty();
            var pointArr = [];
            var prvX;
            $("response>points>item", $xmlDoc).each(function(i,ele){

                if(prvX == $(ele).attr("X")){
                    pointArr = [0,0,0,0];
                }
                if(!(i%2 == 1)){
                    pointArr.push($(ele).attr("X"));
                    pointArr.push($(ele).attr("Y"));
                }

            });
            pointNode.append(
                $(xmlDoc.createElement("item")).append(
                    $(xmlDoc.createElement("X")).attr("type", "unit32").text( pointArr[0])
                ).append(
                    $(xmlDoc.createElement("Y")).attr("type", "unit32").text( pointArr[1])
                )
            ).append(
                $(xmlDoc.createElement("item")).append(
                    $(xmlDoc.createElement("X")).attr("type", "unit32").text( pointArr[2])
                ).append(
                    $(xmlDoc.createElement("Y")).attr("type", "unit32").text( pointArr[1])
                )
            ).append(
                $(xmlDoc.createElement("item")).append(
                    $(xmlDoc.createElement("X")).attr("type", "unit32").text( pointArr[2])
                ).append(
                    $(xmlDoc.createElement("Y")).attr("type", "unit32").text( pointArr[3])
                )
            ).append(
                $(xmlDoc.createElement("item")).append(
                    $(xmlDoc.createElement("X")).attr("type", "unit32").text( pointArr[0])
                ).append(
                    $(xmlDoc.createElement("Y")).attr("type", "unit32").text( pointArr[3])
                )
            );

//            $("config>osc>speclRegions>item:eq(" + AreaModule.areaIndex + ")>point", xmlDoc).attr("count",$("response>points>item", $xmlDoc).length);
//
//            var pointNode = $("config>osc>speclRegions>item:eq(" + AreaModule.areaIndex + ")>point", xmlDoc).empty();
//            $("response>points>item", $xmlDoc).each(function(i,ele){
//                pointNode.append(
//                    $(xmlDoc.createElement("item")).append(
//                        $(xmlDoc.createElement("X")).attr("type", "unit32").text( $(ele).attr("X"))
//                    ).append(
//                        $(xmlDoc.createElement("Y")).attr("type", "unit32").text( $(ele).attr("Y"))
//                    )
//                );
//            });

        }).live('change', function(event) {
            var selectIndex = $(this).val();
            var areaName = $("config>osc>speclRegions>item>name:eq(" + selectIndex + ")", xmlDoc);
            $("#nameArea").val(areaName.text());
            $("#nameArea").attr("maxlength", areaName.attr("maxLen") * 1);
            var sensitivityNode = $("config>osc>speclRegions>item>sensitivity:eq(" + selectIndex + ")", xmlDoc);
            $("#sliderSensitivity").slider("setValueWithEvent", sensitivityNode.text() ? sensitivityNode.text() : sensitivityNode.attr("default"));
            var minTime = $("config>osc>speclRegions>item>minTime:eq(" + selectIndex + ")", xmlDoc);
            $("#minTime").val(minTime.text());
            initNumberInput( $("#minTime"), { minValue: 1, maxValue: minTime.attr("max") * 1 });

            var point= [];
            $("config>osc>speclRegions>item:eq(" + selectIndex + ")>point>item", xmlDoc).each(function(index, element) {
                point.push({X:$(">X",element).text(),Y:$(">Y",element).text()});
                return index < pointNum;
            });
            var sendXML = OCX_XML_SetOscArea(point);
            NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);



            $(this).blur();
        });

	},
	getData: function() {
		window.top.showLoading();
		try {
			XmlHttpClient.SendHttpRequest({
				url: serverBase + "/GetOscConfig",
				type: "POST",
				async: true,
				data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
				callback: function(result) {
					xmlDoc = result;
					AreaModule.bindCtrlData();
                    var item = $("config>osc>speclRegions>item",xmlDoc).eq(0);
                    var areaName = $(">name",item);
                    $("#nameArea").val(areaName.text());
                    $("#nameArea").attr("maxlength", areaName.attr("maxLen") * 1);
					var sensitivityNode = $(">sensitivity", item);
					$("#sliderSensitivity").slider("setValueWithEvent", sensitivityNode.text() ? sensitivityNode.text() : sensitivityNode.attr("default"));
                    var minTime = $(">minTime", item);
                    $("#minTime").val(minTime.text());
                    initNumberInput( $("#minTime"), { minValue: 1, maxValue: minTime.attr("max") * 1 });
					window.top.hideLoading();
				}
			});
		}
		catch (ex) {
			alert(ex);
		}
	},
	bindCtrlData: function() {
		var cboAlertArea = $("#cboAlertArea");
		cboAlertArea.empty();
		$("config>osc>speclRegions>item", xmlDoc).each(function(index, element) {
			cboAlertArea.append("<option value=\"" + index + "\">" + (index + 1) + "</option>");
		});
		var sensitivityNode = $("config>osc>speclRegions>item>sensitivity:eq(0)", xmlDoc);
		var sliderSensitivity = $("#sliderSensitivity");
		sliderSensitivity.slider("setProperty", "minValue", sensitivityNode.attr("min") * 1);
		sliderSensitivity.slider("setProperty", "maxValue", sensitivityNode.attr("max") * 1);
        var point= [];
        $("config>osc>speclRegions>item:eq(0)", xmlDoc).each(function(index, element) {
            $("point>item",element).each(function(i,ele){
                point.push({X:$("point>item>X",ele).text(),Y:$("point>item>Y",ele).text()});
                return i < pointNum;
            });
        });
        var sendXML = OCX_XML_SetOscArea(point);
        NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
	},
	getSaveData: function() {
		var index = $("#cboAlertArea").val();
        $("config>osc>speclRegions>item>name:eq(" + index + ")", xmlDoc).empty().append(xmlDoc.createCDATASection($("#nameArea").val()));
		var sensitivityNode = $("config>osc>speclRegions>item>sensitivity:eq(" + index + ")", xmlDoc);
		sensitivityNode.text($("#sliderSensitivity").slider("getValue"));
        $("config>osc>speclRegions>item>minTime:eq(" + index + ")", xmlDoc).text($("#minTime").val());
        var sendXML = OCX_XML_GetOscArea();
        var result = NetLiveMonitor.QueryInfo(sendXML, sendXML.length);
        var $xmlDoc = $(XMLStr2XMLDoc(result));
        $("config>osc>speclRegions>item:eq(" + index + ")>point", xmlDoc).attr("count",$("response>points>item", $xmlDoc).length);
        var pointNode = $("config>osc>speclRegions>item:eq(" + index + ")>point", xmlDoc).empty();
        var pointArr = [];
        var prvX;
        $("response>points>item", $xmlDoc).each(function(i,ele){
            if(prvX == $(ele).attr("X")){
                pointArr = [0,0,0,0];
            }
            if(!(i%2 == 1)){
                pointArr.push($(ele).attr("X"));
                pointArr.push($(ele).attr("Y"));
            }
        });
        pointNode.append(
            $(xmlDoc.createElement("item")).append(
                $(xmlDoc.createElement("X")).attr("type", "unit32").text( pointArr[0])
            ).append(
                $(xmlDoc.createElement("Y")).attr("type", "unit32").text( pointArr[1])
            )
        ).append(
            $(xmlDoc.createElement("item")).append(
                $(xmlDoc.createElement("X")).attr("type", "unit32").text( pointArr[2])
            ).append(
                $(xmlDoc.createElement("Y")).attr("type", "unit32").text( pointArr[1])
            )
        ).append(
            $(xmlDoc.createElement("item")).append(
                $(xmlDoc.createElement("X")).attr("type", "unit32").text( pointArr[2])
            ).append(
                $(xmlDoc.createElement("Y")).attr("type", "unit32").text( pointArr[3])
            )
        ).append(
            $(xmlDoc.createElement("item")).append(
                $(xmlDoc.createElement("X")).attr("type", "unit32").text( pointArr[0])
            ).append(
                $(xmlDoc.createElement("Y")).attr("type", "unit32").text( pointArr[3])
            )
        );

//        $("config>osc>speclRegions>item:eq(" + index + ")>point", xmlDoc).attr("count",$("response>points>item", $xmlDoc).length);
//
//        var pointNode = $("config>osc>speclRegions>item:eq(" + index + ")>point", xmlDoc).empty();
//        $("response>points>item", $xmlDoc).each(function(i,ele){
//            pointNode.append(
//                $(xmlDoc.createElement("item")).append(
//                    $(xmlDoc.createElement("X")).attr("type", "unit32").text( $(ele).attr("X"))
//                ).append(
//                    $(xmlDoc.createElement("Y")).attr("type", "unit32").text( $(ele).attr("Y"))
//                )
//            );
//
//        });
		return XMLDoc2XMLStr(xmlDoc);
	},
	setData: function() {
		window.top.showLoading();
		try {
			XmlHttpClient.SendHttpRequest({
				url: serverBase + "/SetOscConfig",
				type: "POST",
				async: true,
				data: AreaModule.getSaveData(),
                beforeSend: XmlHttpClient.CommBeforeSend,
				callback: function(result) {
					window.top.hideLoading();
					commSaveResponseHadler(result);
				}
			});
		}
		catch (ex) {
			alert(ex);
		}
	},
	setOCX: function() {
//		window.top.showLoading();
		try {
			XmlHttpClient.SendHttpRequest({
				url: serverBase + "/GetPortConfig",
				type: "POST",
				async: true,
				data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
				callback: function(result) {
                    netPort = $("config>port>netPort", result).text() * 1;
                    $("#divOCX").empty();
                    NetLiveMonitor = LoadPlugin("divOCX","NetLiveMonitor");
                    // 设置模式
                    var sendXML = OCX_XML_SetPreViewModel("ReadOnly");
                    NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
				}
			});
		}
		catch (ex) {
			alert(ex);
		}
	}
};

//OCX调用js方法
function NotifyResultToJs(strXMLFormat, lStrLen) {
    var $xmlDoc = $(XMLStr2XMLDoc(strXMLFormat));

    // OCX已创建好窗口，通知可以登录了
    if ($("statenotify[type=\"Login\"]", $xmlDoc).length > 0) {
        var userInfo = Decryption($.cookie("auInfo"));
        var userInfoArr = userInfo.split(":");
        // 设置登录信息
        var username = userInfoArr[0];
        var password = userInfoArr[1];
        var ip = serverIp;
        var port = netPort;
        var id = "";
        // 设置模式
        var sendXML = OCX_XML_SetPreViewModel("ReadOnly");
        NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);

        var sendXML = OCX_XML_SetLoginInfo(username, password, ip, port, id);
        NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);

        // 设置预览码流索引
        var sendXML = OCX_XML_SetStreamType(2);
        NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
    }

    if ($("statenotify[type=\"GetOriginalWH\"]", $xmlDoc).length > 0) {
        $("#divOCX").css({width:"400px",height:"300px"});
        AreaModule.getData();
    }

//    if ($("statenotify[type=\"OscArea\"]", $xmlDoc).length > 0) {
//        var point = [];
//        $("statenotify>points>item", $xmlDoc).each(function (index, element) {
//            point.push({X:$(element).attr("X"),Y:$(element).attr("Y")});
//        });
//        var sendXML = OCX_XML_SetOscArea(point);
//        NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
//    }

    var connectstate = $("statenotify[type='connectstate']",$xmlDoc);
    if(connectstate.length > 0){
        if($(">status", connectstate).text() === "success"){
            window.top.hideLoading();
        }else{
            window.top.showLoading(window.top.LangCtrl._L_("connectError"));
        }
    }

    var Connect  = $("statenotify[type='Connect']",$xmlDoc);
    if(Connect.length > 0){
        if($(">status", Connect).text() === "limit"){
            window.top.MsgBoxHelper.Show("info", LangCtrl._L_("infoTip"), LangCtrl._L_("limit"), null);
        }
    }

};

var ScheduleModule = {
	initCtrl: function() {
		$("#dpHoliday").dateInput({
			format: "MM-dd",
			defaultValue: new Date().format("MM-dd")
		});

		$("#divDate").listbox({
			data: [],
			selectItem: function() {
				var itemData = $(this).data("itemData");
				var times = holidaySchedules[itemData.value];
				var timelineObj = $("#divHolidayTimeline");
				timelineObj.timeline("clearTimes");
				$.each(times, function(index, element) {
					timelineObj.timeline("setTime", element);
				});
			},
			clickItem: function() {
				var itemData = $(this).data("itemData");
				var times = holidaySchedules[itemData.value];
				var timelineObj = $("#divHolidayTimeline");
				timelineObj.timeline("clearTimes");
				$.each(times, function(index, element) {
					timelineObj.timeline("setTime", element);
				});
			},
			unSelectItem: function() {
			}
		});

		$("#btnHolidayAdd").click(function(event) {
			var dateStr = $("#dpHoliday").val();
			ClearFloatError();
			for (var key in holidaySchedules) {
				if (key == dateStr) {
					ShowFloatError($("#divDate"), LangCtrl._L_("notUniqueDateTip"));
					return;
				}
			}
			$("#divHolidayTimeline").timeline("setEnable", true);
            holidaySchedules[dateStr] = ["00:00-23:59"];
			$("#divDate").listbox("addItem", { id: dateStr, value: dateStr });
			var lastItem = $("#divDate").listbox("getAllItems").last();
			lastItem.click();
			lastItem[0].scrollIntoView();
		});

		$("#btnHolidayDelete").click(function(event) {
			ClearFloatError();
			var id = $("#divDate").listbox("getSeletedItems").data("itemData").id;
			delete holidaySchedules[id];
			$("#divDate").listbox("delItem", id);
			var firstDate = $("#divDate").listbox("getAllItems").first();
			if (firstDate.length == 0) {
				$("#divHolidayTimeline").timeline("clearTimes");
				$("#divHolidayTimeline").timeline("setEnable", false);
			} else {
				firstDate.click();
				firstDate[0].scrollIntoView();
			}
		});

		$("[name=\"scheduleOpType\"]").click(function(event) {
			$("[controlType=\"timeline\"]").timeline("changeMode", event.target.value);
			$("#divHolidayTimeline").timeline("changeMode", event.target.value);
		});

		$("[controlType=\"timeline\"]").timeline({
            manualButtonText: LangCtrl._L_("manualInput"),
            okButtonText: LangCtrl._L_("ok"),
            paddingLeft: 0,
            paddingRight: 0,
            showSelectAllButton: false,
            showInverseButton: false,
            showClearButton: false,
            maxTimeShow: 4,
			oninvalidate: function(startTime, endTime, startInput, endInput) {
				ShowFloatError(startInput, LangCtrl._L_("startTimeGEEndTime"), { left: -startInput.outerWidth() - 6, top: startInput.outerHeight() + 5 });
			}
		});

		$("#divHolidayTimeline").timeline({
			enable: false,
            manualButtonText: LangCtrl._L_("manualInput"),
            okButtonText: LangCtrl._L_("ok"),
            paddingLeft: 0,
            paddingRight: 0,
            showSelectAllButton: false,
            showInverseButton: false,
            showClearButton: false,
            maxTimeShow: 4,
			onvaluechanged: function(control) {
				var itemData = $("#divDate").listbox("getSeletedItems").data("itemData");
				if (itemData && itemData.value) {
                    if(control.timeline("getTimes").length == 0){
                        holidaySchedules[itemData.value] = ["00:00-00:00"];
                    }else{
                        holidaySchedules[itemData.value] = control.timeline("getTimes");
                    }

                }
			},
			oninvalidate: function(startTime, endTime, startInput, endInput) {
				ShowFloatError(startInput, LangCtrl._L_("startTimeGEEndTime"), { left: -startInput.outerWidth() - 6, top: startInput.outerHeight() + 5 });
			}
		});
	},
	getData: function() {
		window.top.showLoading();
		try {
			XmlHttpClient.SendHttpRequest({
				url: serverBase + "/GetOscScheduleConfig",
				type: "POST",
				async: true,
				data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
				callback: function(result) {
					xmlDoc = result;
					ScheduleModule.bindCtrlData();

					// 周排程
					$.each(["sunday", "monday", "tuesday", "wednesday", "thursday", "friday", "saturday"], function(index, element) {
						var timelineObj = $("[controlType=\"timeline\"]:eq(" + index + ")");
						timelineObj.timeline("clearTimes");
						$("config>schedule>period[mode=\"weekly\"][day=\"" + element + "\"]", xmlDoc).each(function(index, element) {
							timelineObj.timeline("setTime", $(this).attr("start") + "-" + $(this).attr("end"));
						});
					});

					// 年排程
					var firstDate = "";
					holidaySchedules = {};
					$("#divDate").listbox("clearData");
                    $("#divHolidayTimeline").timeline("setTime","00:00-23:59");
					$("#divHolidayTimeline").timeline("setEnable", false);
					$("config>schedule>period[mode=\"yearly\"]", xmlDoc).each(function(index, element) {
						var dateStr = $(this).attr("date");
						if (index == 0) {
							$("#divHolidayTimeline").timeline("setEnable", true);
							firstDate = dateStr;
						}
						if (!holidaySchedules[dateStr]) {
							holidaySchedules[dateStr] = [];
							$("#divDate").listbox("addItem", { id: dateStr, value: dateStr });
						}
						holidaySchedules[dateStr].push($(this).attr("start") + "-" + $(this).attr("end"));
					});

					if (firstDate) {
						$("#divDate").listbox("getItemByID", firstDate).click();
					}

					window.top.hideLoading();
				}
			});
		}
		catch (ex) {
			alert(ex);
		}
	},
	bindCtrlData: function() {
		ScheduleModule.timeSpanMaxCount = $("config>schedule", xmlDoc).attr("maxTimeSpan") * 1;
	},
	verification: function() {
		ClearFloatError();

		var count = 0;
		$("[controlType=\"timeline\"]").each(function(index, element) {
			var $this = $(this);
			count += $this.timeline("getTimes").length;
		});

		$.each($("#divDate").listbox("getAllItems"), function(index, element) {
			var dateStr = $(this).data("itemData").value;
			count += holidaySchedules[dateStr].length;
		});

		if (count > ScheduleModule.timeSpanMaxCount) {
			ShowFloatError($("#btnSave"), LangCtrl._L_("timeSpanMaxCount").format(ScheduleModule.timeSpanMaxCount), { left: -350, top: 1 });
			return false;
		}

        return true;
	},
	getSaveData: function() {
		var weeks = ["sunday", "monday", "tuesday", "wednesday", "thursday", "friday", "saturday"];
		var scheduleNode = $("config>schedule", xmlDoc);
		scheduleNode.empty();

		// 周排程
		$("[controlType=\"timeline\"]").each(function(weekIndex, element) {
			var timeSpans = $(this).timeline("getTimes", $.TIMELINE_DATA_MODE_STRING);
			$.each(timeSpans, function(index, element) {
				scheduleNode.append($(xmlDoc.createElement("period")).attr("mode", "weekly").attr("start", element[0]).attr("end", element[1]).attr("day", weeks[weekIndex]));
			});
		});

		// 年排程
		$.each($("#divDate").listbox("getAllItems"), function(index, element) {
			var dateStr = $(this).data("itemData").value;
			$.each(holidaySchedules[dateStr], function(index, element) {
				var timeParts = element.split("-");
				scheduleNode.append($(xmlDoc.createElement("period")).attr("mode", "yearly").attr("start", timeParts[0]).attr("end", timeParts[1]).attr("date", dateStr));
			});
		});

		return XMLDoc2XMLStr(xmlDoc);
	},
	setData: function() {
		window.top.showLoading();
		if (!ScheduleModule.verification()) {
			window.top.hideLoading();
			return false;
		}
		try {
			XmlHttpClient.SendHttpRequest({
				url: serverBase + "/SetOscScheduleConfig",
				type: "POST",
				async: true,
				data: ScheduleModule.getSaveData(),
                beforeSend: XmlHttpClient.CommBeforeSend,
				callback: function(result) {
					window.top.hideLoading();
					commSaveResponseHadler(result);
				}
			});
		}
		catch (ex) {
			alert(ex);
		}
	}
};

function initControl() {
	TriggerModule.initCtrl();
	AreaModule.initCtrl();
	ScheduleModule.initCtrl();
	$("#btnSave").click(function() {
		ClearFloatError();
		var curTab = $.cookie("tab");
		if (!curTab) {
			curTab = "liPerimeterTrigger";
		}
		
		switch (curTab) {
			case "liPerimeterTrigger":
				TriggerModule.setData();
				break;
			case "liPerimeterArea":
				AreaModule.setData();
				break;
			case "liPerimeterSchedule":
				ScheduleModule.setData();
				break;
		}
	});
}

function clearTab(parent) {
	$("input[type=\"text\"]", parent).val("");
	$("input[type=\"checkbox\"]", parent).removeAttr("checked");
	$("select", parent).empty();
}