﻿var context;

var AddFtpModule = {
    modifyFlag:false,
    initCtrl: function(c) {
        context = c;
        LangCtrl.translate($("#tbAddTask", context));

        $("#btnOK",context).unbind().click(function(){
            AddFtpModule.addNewFtp();
        });

        $("#btnCancel", context).unbind().click(function() {
            AddFtpModule.close();
        });

        $("#btnTest", context).unbind().click(function() {
            AddFtpModule.setTestData();
        });

        $("#chkAnonymous",context).unbind().click(function(){
            if($(this).attr("checked")){
                $("#txtUserName,#txtPassword",context).attr("disabled",true);
            }else{
                $("#txtUserName,#txtPassword",context).attr("disabled",false);
            }
        });

        initNumberInput($("#txtPort", context), { minValue: 0, maxValue: 65535 });
        $("#txtPort", context).val("21");


        $("#txtServerName", context).attr("maxLength",31);
        $("#txtServerAddress", context).attr("maxLength",131);
        $("#txtUploadPath", context).attr("maxLength",131);
        $("#txtUserName", context).attr("maxLength",67);
        $("#txtPassword", context).attr("maxLength",67);

        if (FTPModule.editIndex != -1) {

            $("#txtPassword",context).keydown(function(event){
                $(this).unbind();
                AddFtpModule.modifyFlag = true;
                $(this).val("");
                if(event.keyCode == 8){
                    return false;
                }
            });
//            $("#txtPassword",context).bind("propertychange input",function(){
//                $(this).unbind();
//                $(this).val("");
//                AddFtpModule.modifyFlag = true;
//            });

            var serverName = FTPModule.ftpList[FTPModule.editIndex]["serverName"];
            var serverAddress = FTPModule.ftpList[FTPModule.editIndex]["serverAddress"];
            var port = FTPModule.ftpList[FTPModule.editIndex]["port"];
            var userName =  FTPModule.ftpList[FTPModule.editIndex]["anonymousSwitch"] === "true" ? "" : FTPModule.ftpList[FTPModule.editIndex]["userName"];

            var uploadPath = FTPModule.ftpList[FTPModule.editIndex]["uploadPath"];
//            var password =  FTPModule.ftpList[FTPModule.editIndex]["anonymousSwitch"] === "true" ? "" : FTPModule.ftpList[FTPModule.editIndex]["password"];
            $("#txtServerName", context).val(serverName);
            $("#txtServerAddress", context).val(serverAddress);
            $("#txtUploadPath", context).val(uploadPath);
            $("#txtPort", context).val(port);
            $("#txtUserName", context).val(userName);
            if(FTPModule.ftpList[FTPModule.editIndex]["anonymousSwitch"] === "true"){
                $("#chkAnonymous",context).attr("checked","checked");
                $("#txtUserName,#txtPassword",context).attr("disabled",true);
            }

        }

    },
    verification: function() {
        ClearFloatError();
        var $ServerName =  $("#txtServerName",context);
        var $ServiceAddress = $("#txtServerAddress",context);
        var $UserName =  $("#txtUserName",context);
        var $Password =  $("#txtPassword",context);
        var $uploadPath =  $("#txtUploadPath",context);
        var anonymousFlag =  $("#chkAnonymous",context).attr("checked") === "checked";
        if ($.trim($ServerName.val()).length == 0) {
            ShowFloatError($ServerName, LangCtrl._L_("serverNameNotEmptyTip"));
            return false;
        }else{
            if($.trim($ServerName.val()).getBytesLength() >  31){
                ShowFloatError($ServerName, LangCtrl._L_("tooLong"));
                return false;
            }
        }

        if ($.trim($ServiceAddress.val()).length == 0) {
            ShowFloatError($ServiceAddress, LangCtrl._L_("serverAddressNotEmptyTip"));
            return false;
        }else{
            if($.trim($ServiceAddress.val()).getBytesLength() >  131){
                ShowFloatError($ServiceAddress, LangCtrl._L_("tooLong"));
                return false;
            }
        }

        if($.trim($uploadPath.val()).getBytesLength() >  131){
            ShowFloatError($uploadPath, LangCtrl._L_("tooLong"));
            return false;
        }

        if(!chkSafeChar($Password.val())){
            ShowFloatError($Password, LangCtrl._L_("invalidChar"));
            return false;
        }
        if(!anonymousFlag){
            if ($.trim($UserName.val()).length == 0) {
                ShowFloatError($UserName, LangCtrl._L_("userNameNotEmptyTip"));
                return false;
            }else{
                if($.trim($UserName.val()).getBytesLength() >  67){
                    ShowFloatError($UserName, LangCtrl._L_("tooLong"));
                    return false;
                }
            }
        }
        if(/^.*[\u4e00-\u9fa5]+.*$/i.test($Password.val())){
            ShowFloatError($Password, LangCtrl._L_("invalidChar"));
            return false;
        }
        return true;
    },
    addNewFtp:function(){
        var maxCount = $("config>ftp",ftpXmlDoc).attr("maxCount") * 1;

        if (!AddFtpModule.verification()) {
            return false;
        }
        var size = FTPModule.ftpList.length;
        var anonymousSwitch = $("#chkAnonymous", context).attr("checked") === "checked" ? "anonymous" : $("#txtUserName", context).val();
        if (FTPModule.editIndex == -1) {
            if (FTPGrid.wbGrid("getAllRows").length >= maxCount) {
                ShowFloatError($("#btnCancel", context), LangCtrl._L_("ftpMaxCount").format(maxCount), { left: 15 });
                return false;
            }
            var objFtpAdd = {
                "id":++FTPModule.maxAddValue,
                "serverName": $("#txtServerName", context).val(),
                "serverAddress": $("#txtServerAddress", context).val(),
                "port":  $("#txtPort", context).val(),
                "userName":  anonymousSwitch,
                "password": $("#txtPassword", context).val(),
                "changeFlag":"true",
                "anonymousSwitch": $("#chkAnonymous", context).attr("checked") === "checked",
                "uploadPath": $("#txtUploadPath", context).val()
            };
            for(var j= 0;j<size;j++){
                var sameFTPFlag = FTPModule.ftpList[j].serverAddress == objFtpAdd.serverAddress && FTPModule.ftpList[j].port == objFtpAdd.port && FTPModule.ftpList[j].uploadPath == objFtpAdd.uploadPath;
                if(sameFTPFlag){
                    ShowFloatError($("#btnCancel", context), LangCtrl._L_("ftpNotSame").format(maxCount), { left: 15 });
                    return false;
                }
            }
            FTPModule.ftpList.push(objFtpAdd);
        } else {
            var objFtpEdit = {
                "id":FTPModule.ftpList[FTPModule.editIndex].id,
                "serverName": $("#txtServerName", context).val(),
                "serverAddress": $("#txtServerAddress", context).val(),
                "port":  $("#txtPort", context).val(),
                "userName":  anonymousSwitch,
                "password": $("#txtPassword", context).val(),
                "changeFlag":AddFtpModule.modifyFlag ? "true" : "false",
                "anonymousSwitch": $("#chkAnonymous", context).attr("checked") === "checked",
                "uploadPath": $("#txtUploadPath", context).val()
            };
            for(var j= 0;j<size;j++){
                if(FTPModule.editIndex == j){
                    continue;
                }
                var sameFTPFlag = FTPModule.ftpList[j].serverAddress == objFtpEdit.serverAddress && FTPModule.ftpList[j].port == objFtpEdit.port && FTPModule.ftpList[j].uploadPath == objFtpEdit.uploadPath;
                if(sameFTPFlag){
                    ShowFloatError($("#btnCancel", context), LangCtrl._L_("ftpNotSame").format(maxCount), { left: 15 });
                    return false;
                }
            }
            FTPModule.ftpList[FTPModule.editIndex] = objFtpEdit;
        }

        FTPModule.setFtpList();
        AddFtpModule.close();
    },
    setFtpList: function() {
        var xmlDoc = XMLStr2XMLDoc(xmlHeader + "<config version=\"" + apiVersion + "\" xmlns=\"" + defaultNS + "\"><presetInfo></presetInfo></config>");
        var rowData = [];
        $.each( FTPModule.ftpList, function(index, element) {
            rowData.push({
                "id": element.id,
                "serverName": element.serverName,
                "serverAddress": element.serverAddress,
                "port":  element.port,
                "userName": element.userName,
                "password": element["password"],
                "changeFlag":element.changeFlag,
                "anonymousSwitch": element.anonymousSwitch,
                "uploadPath": element.uploadPath
            });
            $("config >ftp >item", ftpXmlDoc).remove();
            $.each(FTPModule.ftpList, function(index, element) {
                $("ftp", ftpXmlDoc).append(
                    $(ftpXmlDoc.createElement("item")).attr("id",element.id)
                        .append(
                        $(ftpXmlDoc.createElement("serverName")).attr("type","string").attr("maxLen","31").append(
                            $(ftpXmlDoc.createCDATASection(element.serverName))
                        )
                    ).append(
                        $(ftpXmlDoc.createElement("serverAddr")).attr("type","string").attr("maxLen","131").append(
                            $(ftpXmlDoc.createCDATASection(element.serverAddress))
                        )
                    ).append(
                        $(ftpXmlDoc.createElement("port")).attr("type","uint16").append(
                            element["port"]
                        )
                    ).append(
                        $(ftpXmlDoc.createElement("path")).attr("type","string").attr("maxLen","131").append(
                            $(ftpXmlDoc.createCDATASection(element.uploadPath))
                        )
                    ).append(
                        $(ftpXmlDoc.createElement("anonymousSwitch")).attr("type","boolean").append(
                                element.anonymousSwitch+""
                            )
                    ).append(
                        $(ftpXmlDoc.createElement("userName")).attr("type","string").attr("maxLen","67").append(
                            $(ftpXmlDoc.createCDATASection(element.userName))
                        )
                    ).append(
                        $(ftpXmlDoc.createElement("passwd")).attr("type","string").attr("maxLen","67").append(
                            $(ftpXmlDoc.createCDATASection(element["password"]))
                        )
                    )
                );
            });
        });
        FTPGrid.wbGrid("load", rowData);

        if (rowData.length != 0) {
            FTPGrid.wbGrid("selectRowByIndex",0);
            $("#btnAlterFTP,#btnDeleteFTP,#btnTestFTP",context).removeAttr("disabled").removeClass("disabled");
        }
        else {
            $("#btnAlterFTP,#btnDeleteFTP,#btnTestFTP",context).attr("disabled", "disabled").addClass("disabled");
        }
    },
    close: function() {
        dialogAddFtp.CloseDialog();
    }
};