﻿var netBasicXmlDoc;
var netPPPOEXmlDoc;
var ipNotifyXmlDoc;
var skipOut;

$(function() {

    $("#txtIP").ipInput();
    $("#txtSubnetMask").ipInput();
    $("#txtGateway").ipInput();
    $("#txtPreferredDNS").ipInput();
    $("#txtAlternateDNS").ipInput();

    $("#divParent").tab({
        map: [
            { "tab": "liTcpIP", "content": "divTcpIP", init: NetBasicModule.initCtrl },
            { "tab": "liPPPoE", "content": "divPPPoE", init: NetPPPOEModule.initCtrl },
            { "tab": "liIPNotify", "content": "divIPNotify", init: IPNotifyModule.initCtrl }
        ]
    });
    $("#divParent").tab("selectLastTab");

    $("#btnSave").unbind().click(function() {
        ClearFloatError();
        var curTab = $.cookie('tab');
        if (!curTab) {
            curTab = "liTcpIP";
        }
        switch (curTab) {
            case "liTcpIP":
                NetBasicModule.setData();
                break;
            case "liPPPoE":
                NetPPPOEModule.setData();
                break;
            case "liIPNotify":
                IPNotifyModule.setData();
                break;
        }
    });
	window.parent.setConfigMiniHeight(800);
});

var NetBasicModule = {
    httpPort:80,
    changeIP:"",
    staticIP:"",
    msg:"",
	mapping: {
		chkAutoDNS: "config>tcpIp>dnsFromDhcpSwitch"
	},
    verification:function(){

        if($("#autoIP_open").attr("checked") === "checked"){
            var wIp =  $("#txtIP").ipInput("getValue");
            var wSubnetMask =  $("#txtSubnetMask").ipInput("getValue");
            var wGateway =  $("#txtGateway").ipInput("getValue");
            var static_ip_arr = wIp.split(".");
            var static_mask_arr = wSubnetMask.split(".");
            var static_gw_arr = wGateway.split(".");

            var res0 = parseInt(static_ip_arr[0]) & parseInt(static_mask_arr[0]);
            var res1 = parseInt(static_ip_arr[1]) & parseInt(static_mask_arr[1]);
            var res2 = parseInt(static_ip_arr[2]) & parseInt(static_mask_arr[2]);
            var res3 = parseInt(static_ip_arr[3]) & parseInt(static_mask_arr[3]);

            var res0_gw = parseInt(static_gw_arr[0]) & parseInt(static_mask_arr[0]);
            var res1_gw = parseInt(static_gw_arr[1]) & parseInt(static_mask_arr[1]);
            var res2_gw = parseInt(static_gw_arr[2]) & parseInt(static_mask_arr[2]);
            var res3_gw = parseInt(static_gw_arr[3]) & parseInt(static_mask_arr[3]);

            if(res0==res0_gw && res1==res1_gw && res2==res2_gw  && res3==res3_gw)
            {

            }else{
                window.top.showLoading();
                window.top.MsgBoxHelper.Show("info", LangCtrl._L_("infoTip"), LangCtrl._L_("ipMaskGate"), null);
                window.top.hideLoading();
                return false;
            }
        }
        return true;
    },
	toggleIP: function(enabled) {
		$("#txtIP").ipInput("setEnable", enabled);
		$("#txtSubnetMask").ipInput("setEnable", enabled);
		$("#txtGateway").ipInput("setEnable", enabled);
		if (!enabled) {
			$("#txtIP").ipInput("setValue", $("config>tcpIp>staticIp", netBasicXmlDoc).text());
			$("#txtSubnetMask").ipInput("setValue", $("config>tcpIp>staticIpMask", netBasicXmlDoc).text());
			$("#txtGateway").ipInput("setValue", $("config>tcpIp>staticIpRoute", netBasicXmlDoc).text());
		}
	},
	toggleDNS: function(enabled) {
		$("#txtPreferredDNS").ipInput("setEnable", enabled);
		$("#txtAlternateDNS").ipInput("setEnable", enabled);
		if (!enabled) {
		    $("#txtPreferredDNS").ipInput("setValue", $("config>tcpIp>dnsServer1", netBasicXmlDoc).text());
		    $("#txtAlternateDNS").ipInput("setValue", $("config>tcpIp>dnsServer2", netBasicXmlDoc).text());
		}
	},
	initCtrl: function() {
        $(":radio[name=\"autoIP\"]").unbind().click(function() {
            NetBasicModule.toggleIP($(this).val()==="false");
        });
        $(":radio[name=\"autoDNS\"]").unbind().click(function() {
            NetBasicModule.toggleDNS($(this).val()==="false");
        });

        NetBasicModule.getData();
        NetBasicModule.getPortData();
	},
	getData: function() {
		window.top.showLoading();
		try {
			XmlHttpClient.SendHttpRequest({
				url: serverBase + "/GetNetBasicConfig",
				type: "POST",
				async: true,
				data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
				callback: function(result) {
					netBasicXmlDoc = result;
					var ipAutoEnable = ($("config>tcpIp>ipSettingMode", netBasicXmlDoc).text() === "dhcp");
					var dnsAutoEnable = ($("config>tcpIp>dnsFromDhcpSwitch", netBasicXmlDoc).text().toLowerCase() === "true");
					NetBasicModule.bindCtrlData();
					XmlHttpClient.BindPageByXml(NetBasicModule.mapping, netBasicXmlDoc);
                    NetBasicModule.staticIP = $("config>tcpIp>staticIp", netBasicXmlDoc).text();
					$("#txtIP").ipInput("setValue", $("config>tcpIp>staticIp", netBasicXmlDoc).text());
					$("#txtSubnetMask").ipInput("setValue", $("config>tcpIp>staticIpMask", netBasicXmlDoc).text());
					$("#txtGateway").ipInput("setValue", $("config>tcpIp>staticIpRoute", netBasicXmlDoc).text());
					$("#txtPreferredDNS").ipInput("setValue", $("config>tcpIp>dnsServer1", netBasicXmlDoc).text());
					$("#txtAlternateDNS").ipInput("setValue", $("config>tcpIp>dnsServer2", netBasicXmlDoc).text());
					NetBasicModule.toggleIP(!ipAutoEnable);
					NetBasicModule.toggleDNS(!dnsAutoEnable);
					window.top.hideLoading();
				}
			});
		}
		catch (ex) {
			alert(ex);
		}
	},
    getPortData: function() {
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/GetPortConfig",
                type: "POST",
                async: true,
                data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    NetBasicModule.httpPort = $("config>port>httpPort",result).text();
                    window.top.hideLoading();
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
	bindCtrlData: function() {

        var autoIPFlag = ($("config>tcpIp>ipSettingMode", netBasicXmlDoc).text() === "dhcp")+"";
        $(":radio[name=\"autoIP\"]").each(function(index, element) {
            if (autoIPFlag === $(this).val()) {
                $(this).attr("checked", true);
                return false;
            }
        });

        var autoDNSFlag = ($("config>tcpIp>dnsFromDhcpSwitch", netBasicXmlDoc).text().toLowerCase() === "true")+"";
        $(":radio[name=\"autoDNS\"]").each(function(index, element) {
            if (autoDNSFlag === $(this).val()) {
                $(this).attr("checked", true);
                return false;
            }
        });
	},
	getSaveData: function() {
		$("config>tcpIp>staticIp", netBasicXmlDoc).empty().append($(netBasicXmlDoc.createCDATASection($("#txtIP").ipInput("getValue"))));
		$("config>tcpIp>staticIpMask", netBasicXmlDoc).empty().append($(netBasicXmlDoc.createCDATASection($("#txtSubnetMask").ipInput("getValue"))));
		$("config>tcpIp>staticIpRoute", netBasicXmlDoc).empty().append($(netBasicXmlDoc.createCDATASection($("#txtGateway").ipInput("getValue"))));
		$("config>tcpIp>dnsServer1", netBasicXmlDoc).empty().append($(netBasicXmlDoc.createCDATASection($("#txtPreferredDNS").ipInput("getValue"))));
		$("config>tcpIp>dnsServer2", netBasicXmlDoc).empty().append($(netBasicXmlDoc.createCDATASection($("#txtAlternateDNS").ipInput("getValue"))));

        var autoIPFlag = ($("#autoIP_close").attr("checked") === "checked");
        if(autoIPFlag){
            $("config>tcpIp>ipSettingMode", netBasicXmlDoc).text("dhcp");
        }else{
            $("config>tcpIp>ipSettingMode", netBasicXmlDoc).text("staticIp");
        }

        var autoDNSFlag = ($("#autoDNS_close").attr("checked") === "checked");
        if(autoDNSFlag){
            $("config>tcpIp>dnsFromDhcpSwitch", netBasicXmlDoc).text("true");
        }else{
            $("config>tcpIp>dnsFromDhcpSwitch", netBasicXmlDoc).text("false");
        }
		return XmlHttpClient.GetXmlByPage(NetBasicModule.mapping, netBasicXmlDoc);
	},
	setData: function() {
        window.top.showLoading();
        if(!NetBasicModule.verification()){
            window.top.hideLoading();
            return false;
        }

        var autoIPFlag = ($("#autoIP_close").attr("checked") === "checked");
        var selectMode = autoIPFlag ? "dhcp" : "staticIp";
        if($("config>tcpIp>ipSettingMode", netBasicXmlDoc).text() === selectMode && selectMode !== "staticIp"){
//            window.top.showLoading();
        }else{
            if(autoIPFlag){
                NetBasicModule.msg = "changeAutoIPTip";
                window.top.showLoading(window.top.LangCtrl._L_(NetBasicModule.msg));
            }else{
                NetBasicModule.changeIP = $("#txtIP").ipInput("getValue");
                if(($("config>tcpIp>ipSettingMode", netBasicXmlDoc).text() === "dhcp")){
                    NetBasicModule.msg = "changeIPTip";
                    window.top.showLoading(window.top.LangCtrl._L_(NetBasicModule.msg));
                    skipOut = setTimeout(
                        function(){
                            window.top.location.href = "http://" + NetBasicModule.changeIP + ":" + NetBasicModule.httpPort + "/Pages/login.htm";
                        },5000
                    )
                }else{
                    if(NetBasicModule.staticIP === NetBasicModule.changeIP){
                        NetBasicModule.msg = "";
                        window.top.showLoading();
                    }else{
                        NetBasicModule.msg = "changeIPTip";
                        window.top.showLoading(window.top.LangCtrl._L_(NetBasicModule.msg));

                        skipOut = setTimeout(
                            function(){
                                window.top.location.href = "http://" + NetBasicModule.changeIP + ":" + NetBasicModule.httpPort + "/Pages/login.htm";
                            },5000
                        )

                    }
                }
            }
        }

		try {
			XmlHttpClient.SendHttpRequest({
				url: serverBase + "/SetNetBasicConfig",
				type: "POST",
//                timeout:10000,
				async: true,
				data: NetBasicModule.getSaveData(),
                beforeSend: XmlHttpClient.CommBeforeSend,
				callback: function(result) {
                    window.top.hideLoading();
                    commSaveResponseHadler(result);
				}
			});
		}
		catch (ex) {
			alert(ex);
		}
	}
};

var NetPPPOEModule = {
    modifyFlag:false,
	mapping: {
		chkUsePPPoE: "config>pppoe>switch",
		txtUserName: "config>pppoe>userName",
		txtPassword: "config>pppoe>password"
	},
    verification:function(){
        if(!chkSafeChar($("#txtPassword").val())){
            ShowFloatError($("#txtPassword"), LangCtrl._L_("invalidChar"));
            return false;
        }
        return true;
    },
	toggle: function(enabled) {
		$("#txtUserName").attr("disabled", !enabled);
		$("#txtPassword").attr("disabled", !enabled);
		if (!enabled) {
			XmlHttpClient.BindPageByXml({
				txtUserName: "config>pppoe>userName",
				txtPassword: "config>pppoe>password"
			}, netPPPOEXmlDoc);
		}else{
            $("#txtPassword").val("$#@$#@");
            $("#txtPassword").unbind().keydown(function(event){
                $(this).unbind();
                NetPPPOEModule.modifyFlag = true;
                $(this).val("");
                if(event.keyCode == 8){
                    return false;
                }
            });
        }
	},
	initCtrl: function() {
        NetPPPOEModule.getData();
		$("#chkUsePPPoE").unbind().click(function(event) {
			NetPPPOEModule.toggle($(this).attr("checked") == "checked");
		});
	},
	getData: function() {
		window.top.showLoading();
		try {
			XmlHttpClient.SendHttpRequest({
				url: serverBase + "/GetNetPppoeConfig",
				type: "POST",
				async: true,
				data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
				callback: function(result) {
					netPPPOEXmlDoc = result;
					var pppoeEnable = ($("config>pppoe>switch", netPPPOEXmlDoc).text().toLowerCase() === "true");
					XmlHttpClient.BindPageByXml(NetPPPOEModule.mapping, netPPPOEXmlDoc);
					NetPPPOEModule.toggle(pppoeEnable);

                    function _stopIt(e){
                        if(e.returnValue){
                            e.returnValue = false ;
                        }
                        if(e.preventDefault ){
                            e.preventDefault();
                        }

                        return false;
                    }
                    if(pppoeEnable){
                        $("#txtPassword").val("$#@$#@");
                        $("#txtPassword").keydown(function(event){
                            $(this).unbind();
                            NetPPPOEModule.modifyFlag = true;
                            $(this).val("");
                            if(event.keyCode == 8){
                                return false;
                            }
                        });
                    }
					window.top.hideLoading();
				}
			});
		}
		catch (ex) {
			alert(ex);
		}
	},
	getSaveData: function() {
		XmlHttpClient.GetXmlByPage(NetPPPOEModule.mapping, netPPPOEXmlDoc);
		var pwd = $("#txtPassword").val();
		var pwdNode = $(NetPPPOEModule.mapping.txtPassword, netPPPOEXmlDoc);
		if (pwd == "" || !NetPPPOEModule.modifyFlag) {
			pwdNode.remove();
		} else {
			if (pwdNode.size() == 0) {
                var selectorParts = /^((\w+>?)+)>(\w+)$/.exec(NetPPPOEModule.mapping.txtPassword);
				if (selectorParts) {
					pwdNode = $(netPPPOEXmlDoc.createElement(selectorParts[3]));
					$(selectorParts[1], netPPPOEXmlDoc).append(pwdNode);
				}
			}
			pwdNode.empty().append($(netPPPOEXmlDoc.createCDATASection(PrivEncrypt([pwd],23784501))));
		}
		return XMLDoc2XMLStr(netPPPOEXmlDoc);
	},
	setData: function() {
        window.top.showLoading();
        if (!NetPPPOEModule.verification()) {
            window.top.hideLoading();
            return false;
        }
		try {
			XmlHttpClient.SendHttpRequest({
				url: serverBase + "/SetNetPppoeConfig",
				type: "POST",
                timeout:5000,
				async: true,
				data: NetPPPOEModule.getSaveData(),
                beforeSend: XmlHttpClient.CommBeforeSend,
				callback: function(result) {
                    window.top.hideLoading();
                    commSaveResponseHadler(result);
				}
			});
		}
		catch (ex) {
			alert(ex);
		}
	}
};

var IPNotifyModule = {
	mapping: {
		chkTriggerEmail: "config>ipNotify>mailSwitch",
		chkTriggerFTP: "config>ipNotify>ftp>switch"
	},
    toggleFtpList: function(enabled){
        if (!enabled) {
            $(".triggleFtp").hide();
        } else {
            $(".triggleFtp").show();
        }
    },
    toggleEmailList: function(enabled){
        if (!enabled) {
            $(".triggleEmail").hide();
        } else {
            $(".triggleEmail").show();
        }
    },
    ajustHeight: function() {
        var minHeight = $("#tcpIPContent").height() + 190;
        window.parent.setConfigMiniHeight(minHeight);
    },
	initCtrl: function() {
        IPNotifyModule.getEmailListData();
	},
    getEmailListData: function(){
        window.top.showLoading();
        XmlHttpClient.SendHttpRequest({
            url: serverBase + "/GetMailConfig",
            type: "POST",
            async: true,
            data: "",
            beforeSend: XmlHttpClient.CommBeforeSend,
            callback: function(result) {

                var emailList = "";
                var d = document.getElementById('dvCompute');
                $("config>mail>recvMail>item",result).each(function(i,ele){
                    var emailName = $(ele).text();
                    d.innerHTML = emailName;
                    var  averageLen = d.offsetWidth / (emailName.length);
                    var indexStr = Math.floor(210 / averageLen);
                    var imageName =  d.offsetWidth > 210 ? (emailName.substr(0, indexStr) + "...") : emailName;
                    emailList = emailList +"<tr>" +
                        "<td style='word-break:keep-all;width: 260px;'>" + "<div title='"+ $(ele).text()+"'>"+"<input id='chkTriggerEmailAddr_"  + i + "' class='emailServer' type='checkbox' />"+imageName +"</div>"+ "</td>" +
                        "<td></td>" +
                        "</tr>";
                });

                var alarmOutEmailList = $("#divEmailTable");
                var alarmOutEmailTitle = $("#divEmailTitle");
                alarmOutEmailList.empty();
                alarmOutEmailTitle.empty();
                $("<table  class='contentTable' cellpadding='0' cellspacing='0' style='table-layout: fixed;'>" +
                    "<tbody>" +
                    "<tr>" +
                    "<td style='width: 160px;'>" + LangCtrl._L_("emailServer") + "</td>" +
                    "<td></td>" +
                    "</tr>" +
                    "</tbody>" +
                    "</table>").appendTo(alarmOutEmailTitle);
                $(emailList).appendTo(alarmOutEmailList);
                IPNotifyModule.getFTPListData();
            }
        });
    },
    getFTPListData: function(){
        window.top.showLoading();
        XmlHttpClient.SendHttpRequest({
            url: serverBase + "/GetFtpConfig",
            type: "POST",
            async: true,
            data: "",
            beforeSend: XmlHttpClient.CommBeforeSend,
            callback: function(result) {

                var ftpList = "";
                var d = document.getElementById('dvCompute');
                $("config>ftp>item",result).each(function(i,ele){
                    var ftpName = $(">serverAddr",ele).text();
                    d.innerHTML = ftpName;
                    var  averageLen = d.offsetWidth / (ftpName.length);
                    var indexStr = Math.floor(210 / averageLen);
                    var imageName =  d.offsetWidth > 210 ? (ftpName.substr(0, indexStr) + "...") : ftpName;
                    ftpList = ftpList +"<tr>" +
                        "<td style='word-break:keep-all;width: 260px;'>" + "<div title='"+ ftpName+"'>"+"<input id='chkTriggerFTPAddr_"  + i + "' class='ftpServer' type='checkbox' />"+imageName +"</div>"+ "</td>" +
                        "<td></td>" +
                        "</tr>";
                });

                var alarmOutFTPList = $("#divFTPTable");
                var alarmOutFTPTitle = $("#divFTPTitle");
                alarmOutFTPList.empty();
                alarmOutFTPTitle.empty();
                $("<table  class='contentTable' cellpadding='0' cellspacing='0' style='table-layout: fixed;' width='100%'>" +
                    "<tbody>" +
                    "<tr>" +
                    "<td style='width: 160px;'>" + LangCtrl._L_("FTPServer") + "</td>" +
                    "<td></td>" +
                    "</tr>" +
                    "</tbody>" +
                    "</table>").appendTo(alarmOutFTPTitle);
                $(ftpList).appendTo(alarmOutFTPList);

                IPNotifyModule.getData();
            }
        });
    },
	getData: function() {
		window.top.showLoading();
		try {
			XmlHttpClient.SendHttpRequest({
				url: serverBase + "/GetIpNotifyConfig",
				type: "POST",
                timeout:5000,
				async: true,
				data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
				callback: function(result) {
					ipNotifyXmlDoc = result;
					XmlHttpClient.BindPageByXml(IPNotifyModule.mapping, ipNotifyXmlDoc);

                    var chkTriggerFTP = $("#chkTriggerFTP");
                    chkTriggerFTP.attr("checked", $("config>ipNotify>ftp>switch", ipNotifyXmlDoc).text().toLowerCase() === "true");
                    chkTriggerFTP.click(function(e) {
                        IPNotifyModule.toggleFtpList($(this).attr("checked") == "checked");
                        IPNotifyModule.ajustHeight();
                    });

                    var ftpChkList = $("#divFTP" ).find(".ftpServer");
                    $("config>ipNotify>ftp>item", ipNotifyXmlDoc).each(function(i,element){
                        $(ftpChkList[$(element).attr("id")-1]).attr("checked","checked");

                    });

                    var chkTriggerEmail = $("#chkTriggerEmail");
                    chkTriggerEmail.attr("checked", $("config>ipNotify>mail>switch", ipNotifyXmlDoc).text().toLowerCase() === "true");
                    chkTriggerEmail.click(function(e) {
                        IPNotifyModule.toggleEmailList($(this).attr("checked") == "checked");
                        IPNotifyModule.ajustHeight();
                    });

                    var emailChkList = $("#divEmail" ).find(".emailServer");
                    $("config>ipNotify>mail>item", ipNotifyXmlDoc).each(function(i,element){
                        $(emailChkList[$(element).attr("id")-1]).attr("checked","checked");

                    });

                    IPNotifyModule.toggleFtpList(chkTriggerFTP.attr("checked") == "checked");
                    IPNotifyModule.toggleEmailList(chkTriggerEmail.attr("checked") == "checked");
                    IPNotifyModule.ajustHeight();
                    window.top.hideLoading();
				}
			});
		}
		catch (ex) {
			alert(ex);
		}
	},
    getSaveData: function() {
        XmlHttpClient.GetXmlByPage(IPNotifyModule.mapping, ipNotifyXmlDoc);

        var divFtpList = $("#divFTP").find(".ftpServer");
        $("config>ipNotify>ftp>item", ipNotifyXmlDoc).remove();
        $("config>ipNotify>ftp>switch",ipNotifyXmlDoc).text($("#chkTriggerFTP").is(":checked") ? "true" : "false");
        var count = 0;
        for(var i= 0,len = divFtpList.length;i<len;i++){
            if($(divFtpList[i]).attr("checked") === "checked"){
                count++;
                $("config>ipNotify>ftp", ipNotifyXmlDoc).append(
                    $(ipNotifyXmlDoc.createElement("item")).attr("id",i+1)
                );
            }
        }
        $("config>ipNotify>ftp", ipNotifyXmlDoc).attr("count",count);

        var divEmailList = $("#divEmail").find(".emailServer");
        $("config>ipNotify>mail>item", ipNotifyXmlDoc).remove();
        $("config>ipNotify>mail>switch",ipNotifyXmlDoc).text($("#chkTriggerEmail").is(":checked") ? "true" : "false");
        var countEmail = 0;
        for(var i= 0,len = divEmailList.length;i<len;i++){
            if($(divEmailList[i]).attr("checked") === "checked"){
                countEmail++;
                $("config>ipNotify>mail", ipNotifyXmlDoc).append(
                    $(ipNotifyXmlDoc.createElement("item")).attr("id",i+1)
                );
            }
        }
        $("config>ipNotify>mail", ipNotifyXmlDoc).attr("count",countEmail);
        return XMLDoc2XMLStr(ipNotifyXmlDoc);
    },
	setData: function() {
        window.top.showLoading();
		try {
			XmlHttpClient.SendHttpRequest({
				url: serverBase + "/SetIpNotifyConfig",
				type: "POST",
                timeout:5000,
				async: true,
				data: IPNotifyModule.getSaveData(),
                beforeSend: XmlHttpClient.CommBeforeSend,
				callback: function(result) {
                    window.top.hideLoading();
                    commSaveResponseHadler(result);
				}
			});
		}
		catch (ex) {
			alert(ex);
		}
	}
};
