﻿var dialogAddPreset;
var presetGrid;
var context;
var presetXmlDoc;
var cruiseXmlDoc;

var AddCruiseModule = {
    mapping: {
        txtCruiseName: "cruiseInfo>name"
    },
    initCtrl: function(c) {
        context = c;

        XmlHttpClient.BindPageByXml({ txtCruiseName: "config>cruiseInfo>itemType"}, autoCruiseXmlDoc, null, context);

        // 添加巡航线中的预置点
        $("#btnAddPreset", context).click(function() {
            AddCruiseModule.toAddPreset();
        });

        // 修改巡航线中的预置点
        $("#btnEditPreset", context).click(function() {
            AddCruiseModule.toEditPreset();
        });

        // 删除巡航线中的预置点
        $("#btnDelPreset", context).click(function() {
            AddCruiseModule.deletePreset();
        });

        // 新增巡航线
        $("#btnOK", context).click(function() {
            AddCruiseModule[ptzCruiseModule.editIndex == -1 ? "addData" : "setData"]();
        });

        // 取消
        $("#btnCancel", context).click(function() {
            AddCruiseModule.close();
        });

        $("#txtName", context).focus();

        AddCruiseModule.presets = [];

        $("#presetGrid",context).wbGrid({
            data: {
                colNames: ["ID",LangCtrl._L_("presetName"),LangCtrl._L_("time"),LangCtrl._L_("speed")],
                colModel: [
                    { name: "@id", index: "id",width: 20, key:true,align:"center"},
                    { name: "presetName", index: "presetName",width: 180, align:"center",sortable: false},
                    { name: "holdTime", index: "holdTime", width: 100, align: "center", sortable: false },
                    { name: "speed", index: "speed", width: 100, align: "center", sortable: false }
                ],
                rowList: []
            },
            view: {
                height: 200
            }
        });

        presetGrid = $("#presetGrid",context);
        presetGrid.wbGrid("setHeight",130);

        if (ptzCruiseModule.editIndex != -1) {
            AddCruiseModule.getData();
        } else {
            cruiseXmlDoc = XMLStr2XMLDoc(xmlHeader + "<cruiseInfo version=\"" + apiVersion + "\" xmlns=\"" + defaultNS + "\"><name></name><presetInfo type=\"array\"></presetInfo></cruiseInfo>");
            AddCruiseModule.setPresetList();
        }
        AddCruiseModule.getAllPresets();

        LangCtrl.translate($("#tbAddCruise", context));
    },
    getRequestData: function() {
        return xmlHeader + "<cruiseInfo><id>" + $("config>cruiseInfo>item:eq(" + ptzCruiseModule.editIndex + ")", autoCruiseXmlDoc).attr("id") + "</id></cruiseInfo>";
    },
    getData: function() {
//        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/PtzGetCruise",
                type: "POST",
                async: true,
                data: AddCruiseModule.getRequestData(),
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    cruiseXmlDoc = result;
                    XmlHttpClient.BindPageByXml(AddCruiseModule.mapping, cruiseXmlDoc, null, context);
                    AddCruiseModule.presets = [];
                    $("cruiseInfo>presetInfo>item", cruiseXmlDoc).each(function(index, element) {
                        var $this = $(this);
                        AddCruiseModule.presets.push({
                            id: $this.attr("id"),
                            name: $this.find("name").text(),
                            holdTime: $this.find("holdTime").text(),
                            speed: $this.find("speed").text()
                        });
                    });
                    AddCruiseModule.setPresetList();
//                    window.top.hideLoading();
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    verification: function() {
        ClearFloatError();
        if (presetGrid.wbGrid("getAllRows").length == 0) {
            ShowFloatError($("#presetGrid", context), LangCtrl._L_("emptyPresetListTip"), { left: -300, top: 90 });
            if (dialogAddCruise) {
                DisplayOCX(document, false);
            }
            return false;
        }
        return true;
    },
    setPresetList: function() {
        var xmlDoc = XMLStr2XMLDoc(xmlHeader + "<config version=\"" + apiVersion + "\" xmlns=\"" + defaultNS + "\"><presetInfo></presetInfo></config>");

        var rowData = [];

        $.each(AddCruiseModule.presets, function(index, element) {

            var ele = element;

            rowData.push({
                "@id":element.id,
                "presetName":element.name,
                "speed":element.speed,
                "holdTime":(element.holdTime % 60 == 0
                    ? LangCtrl._L_("minutes").format(element.holdTime / 60)
                    : LangCtrl._L_("seconds").format(element.holdTime))
            });

            $("config>presetInfo", xmlDoc).append(
				$(xmlDoc.createElement("item")).attr("id", element.id)
				.append(
					$(xmlDoc.createElement("name")).append(
						$(xmlDoc.createCDATASection(element.name))
					)
				).append(
					$(xmlDoc.createElement("speed")).append(
						$(xmlDoc.createTextNode(element.speed))
					)
				).append(
					$(xmlDoc.createElement("holdTime")).append(
						$(xmlDoc.createTextNode(element.holdTime % 60 == 0
							? LangCtrl._L_("minutes").format(element.holdTime / 60)
							: LangCtrl._L_("seconds").format(element.holdTime)))
					)
				)
			);
        });

        presetGrid.wbGrid("load", rowData);
        if (rowData.length != 0) {
            presetGrid.wbGrid("selectRowByIndex",0);
            $("#btnEditPreset,#btnDelPreset",context).removeAttr("disabled").removeClass("disabled");
        }
        else {
            $("#btnEditPreset,#btnDelPreset",context).attr("disabled", "disabled").addClass("disabled");
        }
//        $("#btnEditPreset, #btnDelPreset", context).attr("disabled",  presetGrid.wbGrid("getAllRows").length == 0);
    },
    getAllPresets: function() {
//        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/PtzGetPresets",
                type: "POST",
                async: true,
                data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    presetXmlDoc = result;
//                    window.top.hideLoading();
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    toAddPreset: function() {
        ClearFloatError();
        var maxLength = commonMethod.presetMaxCount*1 > commonMethod.cruisePresetMaxCount*1 ? commonMethod.cruisePresetMaxCount*1 : commonMethod.presetMaxCount*1;
        if (presetGrid.wbGrid("getAllRows").length >= maxLength) {
            ShowFloatError($("#btnAddPreset", context), LangCtrl._L_("presetMaxCount").format(maxLength), { left: 15 });
            return;
        }

        if ($("config>presetInfo>item", presetXmlDoc).size() == 0) {
            window.top.MsgBoxHelper.Show("y/n", LangCtrl._L_("infoTip"), LangCtrl._L_("noPresetTip"), function(flag) {
                if (flag) {
                    dialogAddCruise.CloseDialog();
                    $("#divParent", context).tab("selectTab","liPreset");
//                    $("#configRightFrame", window.parent.document).attr("src", MenuCtrl["menuList"]["preset"]["url"]);
                }
            });
        } else {
            AddCruiseModule.editIndex = -1;
            dialogAddPreset = new DialogHelper({
                title: LangCtrl._L_("selectPreset"),
                content: "addPresetForCruiseDialog.htm",
                width: 350,
                height: 170,
                zIndex: 302,
                contentType: "url",
                beforCloseEvent: function () {
                    if (dialogAddCruise) {
                        DisplayOCX(document, false);
                    }
                },
                loadCallBack: AddPresetForCruiseModule.initCtrl
            });
        }
    },
    toEditPreset: function() {
        AddCruiseModule.editIndex = presetGrid.wbGrid("getSelectRows").index;
        dialogAddPreset = new DialogHelper({
            title: LangCtrl._L_("selectPreset"),
            content: "addPresetForCruiseDialog.htm",
            width: 350,
            height: 170,
            zIndex: 302,
            contentType: "url",
            beforCloseEvent: function () {
                if (dialogAddCruise) {
                    DisplayOCX(document, false);
                }
            },
            loadCallBack: AddPresetForCruiseModule.initCtrl
        });
    },
    deletePreset: function() {
        AddCruiseModule.presets.splice(presetGrid.wbGrid("getSelectRows").index, 1);
        AddCruiseModule.setPresetList();
    },
    addData: function(c) {
        if (!AddCruiseModule.verification()) {
//            window.top.hideLoading();
            return false;
        }
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/PtzAddCruise",
                type: "POST",
                async: true,
                data: AddCruiseModule.getSaveData(),
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    window.top.hideLoading();
                    if ($("config",result).attr("status") === "success"){
                        AddCruiseModule.close();
                        ShowFloatError($("#tip",c), LangCtrl._L_("successAdd"),{},"success");
                    }else{
                        ShowFloatError($("#tip",c), LangCtrl._L_("failedAdd"),{},"failed");
                    }
                    ptzCruiseModule.getData();
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    getSaveData: function() {
        $("cruiseInfo>name", cruiseXmlDoc).empty().append(cruiseXmlDoc.createCDATASection($("#txtCruiseName", context).val()));

        $("cruiseInfo>presetInfo>item", cruiseXmlDoc).remove();

        $.each(AddCruiseModule.presets, function(index, element) {
            $("cruiseInfo>presetInfo", cruiseXmlDoc).append(
				$(cruiseXmlDoc.createElement("item")).attr("id", element.id)
				.append(
					$(cruiseXmlDoc.createElement("name")).append(
						$(cruiseXmlDoc.createCDATASection(element.name))
					)
				).append(
					$(cruiseXmlDoc.createElement("speed")).append(
						$(cruiseXmlDoc.createTextNode(element.speed))
					)
				).append(
					$(cruiseXmlDoc.createElement("holdTime")).append(
						$(cruiseXmlDoc.createTextNode(element.holdTime))
					)
				)
			);
        });

        return XMLDoc2XMLStr(cruiseXmlDoc);
    },
    setData: function(c) {
        window.top.showLoading();
        if (!AddCruiseModule.verification()) {
            window.top.hideLoading();
            return false;
        }
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/PtzModifyCruise",
                type: "POST",
                async: true,
                data: AddCruiseModule.getSaveData(),
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    window.top.hideLoading();
                    if ($("config",result).attr("status") === "success"){
                        AddCruiseModule.close();
                        ShowFloatError($("#tip",c), LangCtrl._L_("successEdit"),{},"success");
                    }else{
                        ShowFloatError($("#tip",c), LangCtrl._L_("failedEdit"),{},"failed");
                    }
                    ptzCruiseModule.getData();
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    close: function() {
        dialogAddCruise.CloseDialog();
    }
};