var context;

var AddPresetForCruiseModule = {
    initCtrl: function(c) {
        context = c;

        $("#btnPresetOK", context).click(function() {
            AddPresetForCruiseModule.setData();
            AddPresetForCruiseModule.close();
        });

        $("#btnPresetCancel", context).click(function() {
            AddPresetForCruiseModule.close();
        });

        $("#cboHoldTime", context).selectInput({
            context: $(context).context,
            list: [
				{ text: LangCtrl._L_("seconds").format(5), value: 5 },
				{ text: LangCtrl._L_("seconds").format(10), value: 10 },
				{ text: LangCtrl._L_("seconds").format(15), value: 15 },
				{ text: LangCtrl._L_("seconds").format(20), value: 20 },
				{ text: LangCtrl._L_("seconds").format(25), value: 25 },
				{ text: LangCtrl._L_("seconds").format(30), value: 30 },
				{ text: LangCtrl._L_("seconds").format(60), value: 60 },
				{ text: LangCtrl._L_("minutes").format(2), value: 120 },
				{ text: LangCtrl._L_("minutes").format(3), value: 180 },
                { text: LangCtrl._L_("minutes").format(4), value: 240 }
			],
            defaultData: { text: LangCtrl._L_("seconds").format(5), value: 5 },
            mapping: function(text) {
                function isOutOfBounds(value) {
                    return value * 1 < commonMethod.cruiseMinHoldTime || value * 1 > commonMethod.cruiseMaxHoldTime;
                }

                var validReg = /^[1-9]\d*$/;
                var value;
                var execResults = validReg.exec(text);
                if (execResults) {
                    if (isOutOfBounds(execResults[0])) {
                        return false;
                    }
                    return { text: execResults[0] % 60 == 0 ? LangCtrl._L_("minutes").format(execResults[0] / 60) : LangCtrl._L_("seconds").format(execResults[0]), value: execResults[0] };
                }

                validReg = new RegExp("^" + LangCtrl._L_("seconds").format("([1-9]\\d*)") + "$");
                execResults = validReg.exec(text);
                if (execResults) {
                    if (isOutOfBounds(execResults[1])) {
                        return false;
                    }
                    return { text: text, value: execResults[1] };
                }

                validReg = new RegExp("^" + LangCtrl._L_("minutes").format("([1-9]\\d*)") + "$");
                execResults = validReg.exec(text);
                if (execResults) {
                    if (isOutOfBounds(execResults[1] * 60)) {
                        return false;
                    }
                    return { text: text, value: execResults[1] * 60 };
                }
                return false;
            }
        });

        LangCtrl.translate($("#tbPreset", context));

        AddPresetForCruiseModule.bindCtrlData();

        if (AddCruiseModule.editIndex != -1) {
            $("#cboPresetName", context).val(AddCruiseModule.presets[AddCruiseModule.editIndex]["id"]);
            $("#cboSpeed", context).val(AddCruiseModule.presets[AddCruiseModule.editIndex]["speed"]);
            var holdTime = AddCruiseModule.presets[AddCruiseModule.editIndex]["holdTime"];
            $("#cboHoldTime", context).selectInput("setData", { text: holdTime, value: holdTime });
        }
    },
    bindCtrlData: function() {
        var cboPresetName = $("#cboPresetName", context);
        cboPresetName.empty();
        $("config>presetInfo>item", presetXmlDoc).each(function(index, element) {
            $("<option value=" + $(this).attr("id") + ">" + $(this).text() + "</option>").appendTo(cboPresetName);
        });

        var cboSpeed = $("#cboSpeed", context);
        cboSpeed.empty();
        for (var i = commonMethod.cruiseMinSpeed; i <= commonMethod.cruiseMaxSpeed; i++) {
            $("<option value=" + i + ">" + i + "</option>").appendTo(cboSpeed);
        }
    },
    setData: function() {
        var objPreset = {
            id: $("#cboPresetName", context).val(),
            name: $("#cboPresetName>option:selected", context).text(),
            speed: $("#cboSpeed", context).val(),
            holdTime: $("#cboHoldTime", context).selectInput("getValue")
        };

        if (AddCruiseModule.editIndex == -1) {
            AddCruiseModule.presets.push(objPreset);
        } else {
            AddCruiseModule.presets[AddCruiseModule.editIndex] = objPreset;
        }
        AddCruiseModule.setPresetList();
    },
    close: function() {
        dialogAddPreset.CloseDialog();
    }
};