﻿var taskGridForAdd;
var context;
var taskXmlDoc;

var AddTaskModule = {
    mapping: {
        txtCruiseName: "cruiseInfo>name"
    },
    initCtrl: function(c) {
        context = c;
        AddTaskModule.subTaskList = [];

        var format = "hh:mm";
        $("#txtStartTime,#txtEndTime",context).timeInput({ format: format,defaultValue:"00:00" });

        $("#taskGridForAdd",context).wbGrid({
            data: {
                colNames: [LangCtrl._L_("ID"),LangCtrl._L_("startTime"),LangCtrl._L_("endTime"),LangCtrl._L_("function"),LangCtrl._L_("number")],
                colModel: [
                    { name: "id", index: "id", key: true,width: 50, align:"center"},
                    { name: "startTime", index: "startTime",width: 100, align: "center",sortable: false},
                    { name: "endTime", index: "endTime", width: 100, align: "center", sortable: false },
                    { name: "function", index: "function", width: 80, align: "center", sortable: false },
                    { name: "number", index: "number", width: 80, align: "center", sortable: false }
                ],
                rowList: []
            },
            view: {
                height: 200
            }
        });
        taskGridForAdd = $("#taskGridForAdd",context);
        taskGridForAdd.wbGrid("setHeight",180);
        LangCtrl.translate($("#tbAddTask", context));
        AddTaskModule.setGridData();

        $("#saveSubTask",context).unbind().click(function(){
            AddTaskModule.addNewSubTask();
        });

        $("#btnTaskOK", context).unbind().click(function() {
            AddTaskModule.addData();
            AddTaskModule.close();
        });

        $("#btnTaskCancel",context).unbind().click(function(){
            AddTaskModule.close();
        });

        $("#btnEditTask", context).unbind().click(function() {
            AddTaskModule.toEditTask();
        });

        $("#btnDelTask", context).unbind().click(function() {
            AddTaskModule.deleteSubTask();
        });

    },
    setGridData: function(){

        var funcSelect = $("#functionMode",context);
        funcSelect.empty();
        $("config>types>function>enum",autoTaskXmlDoc).each(function(i,ele){
            $("<option value=\""+ $(ele).text() +"\">"+ LangCtrl._L_($(ele).text()) +"</option>").appendTo(funcSelect);
        });
        funcSelect.change(function(){
            var flag = $(this).val();
            var minValue,maxValue=0;
            var numberFunc = $("#number",context);
            switch(flag){
                case "RSC" : minValue = 0;maxValue=0; numberFunc.val(0);initNumberInput(numberFunc, { minValue: 0, maxValue: 0 });break;
                case "ASC" : minValue = 0;maxValue=0; numberFunc.val(0);initNumberInput(numberFunc, { minValue: 0, maxValue: 0 });break;
                case "NON" : minValue = 0;maxValue=0; numberFunc.val(0);initNumberInput(numberFunc, { minValue: 0, maxValue: 0 });break
                case "PRE" : minValue = $("config>types>pre",autoTaskXmlDoc).attr("min");maxValue=$("config>types>pre",autoTaskXmlDoc).attr("max");numberFunc.val(1);initNumberInput(numberFunc, { minValue: minValue, maxValue: maxValue });break;
                case "CRU" : minValue = $("config>types>cru",autoTaskXmlDoc).attr("min");maxValue=$("config>types>cru",autoTaskXmlDoc).attr("max");numberFunc.val(1);initNumberInput(numberFunc, { minValue: minValue, maxValue: maxValue });break;
                case "TRA" : minValue = $("config>types>tra",autoTaskXmlDoc).attr("min");maxValue=$("config>types>tra",autoTaskXmlDoc).attr("max");numberFunc.val(1);initNumberInput(numberFunc, { minValue: minValue, maxValue: maxValue });break;
            }
        });

        var numberFunc = $("#number",context);
        numberFunc.val(0);
        initNumberInput(numberFunc, { minValue: 0, maxValue: 0 });

        var rowData = [];
        var subTaskListData = [];
        $("config>taskInfo>item",autoTaskXmlDoc).each(function(i,ele){
            rowData.push({
                "id":($(ele).attr("id")),
                "startTime":$(">startTime",ele).text(),
                "endTime":$(">endTime",ele).text(),
                "function":LangCtrl._L_($(">function",ele).text()),
                "number":$(">number",ele).text()
            });
            subTaskListData.push({
                "id":($(ele).attr("id")),
                "startTime":$(">startTime",ele).text(),
                "endTime":$(">endTime",ele).text(),
                "function":$(">function",ele).text(),
                "number":$(">number",ele).text()
            });
        });
        taskGridForAdd.wbGrid("load", rowData);
        AddTaskModule.subTaskList = subTaskListData;

        if (rowData.length != 0) {
            taskGridForAdd.wbGrid("selectRowByIndex",0);
            $("#btnEditTask,#btnDelTask",context).removeAttr("disabled").removeClass("disabled");
        }
        else {
            $("#btnEditTask,#btnDelTask",context).attr("disabled", "disabled").addClass("disabled");
        }

    },
    verification: function() {
        ClearFloatError();
        if (taskGridForAdd.wbGrid("getAllRows").length == 0) {
            ShowFloatError(taskGridForAdd, LangCtrl._L_("emptyPresetListTip"), { left: -300, top: 90 });
            return false;
        }
        return true;
    },
    addNewSubTask:function(){
        var maxCount = $("config>taskInfo",autoTaskXmlDoc).attr("maxCount") * 1;
        if (taskGridForAdd.wbGrid("getAllRows").length >= maxCount) {
            ShowFloatError($("#saveSubTask", context), LangCtrl._L_("taskMaxCount").format(maxCount), { left: 15 });
            return;
        }
        var size = AddTaskModule.subTaskList.length;
        var objTask = {
            "id": size+1,
            "startTime": $("#txtStartTime", context).val(),
            "endTime": $("#txtEndTime", context).val(),
            "function":  $("#functionMode", context).val(),
            "number":  $("#number", context).val()
        };
        AddTaskModule.subTaskList.push(objTask);
        AddTaskModule.setTaskList();
    },
    setTaskList: function() {
        var xmlDoc = XMLStr2XMLDoc(xmlHeader + "<config version=\"" + apiVersion + "\" xmlns=\"" + defaultNS + "\"><presetInfo></presetInfo></config>");
        var rowData = [];
        $.each( AddTaskModule.subTaskList, function(index, element) {
            var ele = element;
            rowData.push({
                "id":element.id,
                "startTime":element.startTime,
                "endTime":element.endTime,
                "function":LangCtrl._L_(element["function"]),
                "number":element.number
            });
            $("config>taskInfo", xmlDoc).append(
				$(xmlDoc.createElement("item")).attr("id", element.id)
				.append(
					$(xmlDoc.createElement("startTime")).append(
						$(xmlDoc.createCDATASection(element.startTime))
					)
				).append(
					$(xmlDoc.createElement("endTime")).append(
                        $(xmlDoc.createCDATASection(element.endTime))
					)
				).append(
					$(xmlDoc.createElement("function")).append(
                        element["function"]
					)
				).append(
                    $(xmlDoc.createElement("number")).append(
                        element.number
                    )
                )
			);
        });
        taskGridForAdd.wbGrid("load", rowData);
        taskXmlDoc = xmlDoc;

        if (rowData.length != 0) {
            taskGridForAdd.wbGrid("selectRowByIndex",0);
            $("#btnEditTask,#btnDelTask",context).removeAttr("disabled").removeClass("disabled");
        }
        else {
            $("#btnEditTask,#btnDelTask",context).attr("disabled", "disabled").addClass("disabled");
        }
    },
    getSaveData: function() {
        $("taskInfo>item", autoTaskXmlDoc).remove();
        $.each(AddTaskModule.subTaskList, function(index, element) {
            $("taskInfo", autoTaskXmlDoc).append(
                $(autoTaskXmlDoc.createElement("item")).attr("id", element.id)
                    .append(
                    $(autoTaskXmlDoc.createElement("startTime")).append(
                        $(autoTaskXmlDoc.createCDATASection(element.startTime))
                    )
                ).append(
                    $(autoTaskXmlDoc.createElement("endTime")).append(
                        $(autoTaskXmlDoc.createCDATASection(element.endTime))
                    )
                ).append(
                    $(autoTaskXmlDoc.createElement("function")).append(
                        element["function"]
                    )
                ).append(
                    $(autoTaskXmlDoc.createElement("number")).append(
                        element.number
                    )
                )
            );
        });
        return XMLDoc2XMLStr(autoTaskXmlDoc);
    },
    addData: function(c) {
        window.top.showLoading();
        if (!AddTaskModule.verification()) {
            window.top.hideLoading();
            return false;
        }
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/SetPtzTask",
                type: "POST",
                async: true,
                data: AddTaskModule.getSaveData(),
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    window.top.hideLoading();
                    if ($("config",result).attr("status") === "success"){
                        AddTaskModule.close();
                        ShowFloatError($("#taskTip",c), LangCtrl._L_("successAdd"),{},"success");
                    }else{
                        ShowFloatError($("#taskTip",c), LangCtrl._L_("failedAdd"),{},"failed");
                    }
                    ptzTaskModule.getPtzTask();
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    toEditTask: function() {
        ptzTaskModule.editIndex = taskGridForAdd.wbGrid("getSelectRows").index;
        dialogEditTask = new DialogHelper({
            title: LangCtrl._L_("editTask"),
            content: "editSubTaskDialog.htm",
            width: 350,
            height: 230,
            zIndex: 302,
            contentType: "url",
            beforCloseEvent: function () {
                if (dialogEditTask) {
                    DisplayOCX(document, false);
                }
            },
            loadCallBack: AddSubTaskModule.initCtrl
        });
    },
    deleteSubTask: function() {
        AddTaskModule.subTaskList.splice(taskGridForAdd.wbGrid("getSelectRows").index, 1);
        AddTaskModule.setTaskList();
    },
    close: function() {
        dialogAddTask.CloseDialog();
    }
};