﻿var xmlDoc;
var cruiseGrid;
var dialogAddCruise;
var NetLiveMonitor; // 视频控件

$(function() {
    CruiseModule.initCtrl();
    CruiseModule.doResize();
    closeStream();
});

var CruiseModule = {
    doResize: function(){
        var height1 = $("#config_content", window.parent.document).height();
        var height2 = $("#navBar").height();

        $("#cruiseGrid").wbGrid("setHeight", height1 - height2 - 170);
        $(window.top).resize(function () {
            $("#cruiseGrid").wbGrid("setHeight", height1 - height2 - 170);
        });
    },
    initCtrl: function() {
        window.top.showLoading();

        // 创建巡航线
        $("#btnCreate").click(function() {
            CruiseModule.toAddData();
        });

        // 修改巡航线
        $("#btnEdit").click(function() {
            CruiseModule.toEditData();
        });

        // 删除巡航线
        $("#btnDel").click(function() {
            CruiseModule.deleteData();
        });

        // 停止巡航
        $("#btnStop").click(function() {
            CruiseModule.stopCruise();
        });

        $("#cruiseGrid").wbGrid({
            data: {
                colNames: [LangCtrl._L_("ID"),LangCtrl._L_("cruiseName"),LangCtrl._L_("action")],
                colModel: [
                    { name: "@id", index: "id", key: true,width: 50, align:"center"},
                    { name: "cruiseName", index: "cruiseName", width: 220, align: "center", sortable: false },
                    { name: "action", index: "action", width: 140, align: "center", sortable: false, formatter: "button",
                        formatterParam: {
                            text: LangCtrl._L_("startCruise"),
                            btnClass:'cfgBtn',
                            click: function (e, gridId, rowIndex, rowData) {
                                CruiseModule.startCruise(rowData["@id"]);
                                e.stopPropagation();
                            }
                        }

                    }
                ],
                rowList: []
            },
            view: {
                selectRow : true
            }
        });
        cruiseGrid = $("#cruiseGrid");


        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/PtzGetCaps",
                type: "POST",
                async: true,
                data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    CruiseModule.cruiseMaxCount = $("config>caps>cruiseMaxCount", result).text() * 1;
                    CruiseModule.presetMaxCount = $("config>caps>presetMaxCount", result).text() * 1;
                    CruiseModule.cruiseMinHoldTime = 5;
                    CruiseModule.cruiseMaxHoldTime = $("config>caps>cruisePresetMaxHoldTime", result).text() * 1;
                    CruiseModule.cruiseMinSpeed = $("config>caps>cruisePresetMinSpeed", result).text() * 1;
                    CruiseModule.cruiseMaxSpeed = $("config>caps>cruisePresetMaxSpeed", result).text() * 1;
                    window.top.hideLoading();
                }
            });
        }
        catch (ex) {
            alert(ex);
        }

        CruiseModule.setOCX();
    },
    getData: function() {
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/PtzGetCruises",
                type: "POST",
                async: true,
                data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    xmlDoc = result;

                    var $elem;
                    var rowData = [];
                    $("config>cruiseInfo>item",xmlDoc).each(function(i,ele){
                        rowData.push({
                            "@id":($(ele).attr("id")),
                            "cruiseName":$(ele).text()
                        })
                    });
                    cruiseGrid.wbGrid("load", rowData);
                    if (rowData.length >= 1) {
                        cruiseGrid.wbGrid("selectRowByIndex",0);
                        $("#btnEdit,#btnDel").removeAttr("disabled").removeClass("disabled");
                    }
                    else {
                        $("#btnEdit,#btnDel").attr("disabled", "disabled").addClass("disabled");
                    }
//                    $("#btnEdit, #btnDel").attr("disabled", cruiseGrid.wbGrid("getAllRows").length == 0);
                    window.top.hideLoading();
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    toAddData: function() {
        ClearFloatError();
        var count = cruiseGrid.wbGrid("getAllRows").length;
        if (count >= CruiseModule.cruiseMaxCount) {
            ShowFloatError($("#btnCreate"), LangCtrl._L_("cruiseMaxCount").format(CruiseModule.cruiseMaxCount), { left: 15 });
            return;
        }

        CruiseModule.editIndex = -1;
        dialogAddCruise = new DialogHelper({
            title: LangCtrl._L_("createCruise"),
            content: "addCruiseDialog.htm",
            width:  520,
            height: 420,
            contentType: "url",
            loadCallBack: AddCruiseModule.initCtrl
        });
    },
    toEditData: function() {
        CruiseModule.editIndex = cruiseGrid.wbGrid("getSelectRows").index;
        dialogAddCruise = new DialogHelper({
            title: LangCtrl._L_("modifyCruise"),
            content: "addCruiseDialog.htm",
            width: 520,
            height: 450,
            contentType: "url",
            loadCallBack: AddCruiseModule.initCtrl
        });
    },
    getDeleteData: function() {
        return xmlHeader + "<cruiseInfo><id>" + $("config>cruiseInfo>item:eq(" +  cruiseGrid.wbGrid("getSelectRows").index + ")", xmlDoc).attr("id") + "</id></cruiseInfo>";
    },
    deleteData: function() {
        window.top.MsgBoxHelper.Show("y/n", LangCtrl._L_("infoTip"), LangCtrl._L_("confirmDeleteCruise"), function(flag) {
            if (flag) {
                window.top.showLoading();
                try {
                    XmlHttpClient.SendHttpRequest({
                        url: serverBase + "/PtzDeleteCruise",
                        type: "POST",
                        async: true,
                        data: CruiseModule.getDeleteData(),
                        beforeSend: XmlHttpClient.CommBeforeSend,
                        callback: function(result) {
                            window.top.hideLoading();
                            if ($("config",result).attr("status") === "success"){
                                CruiseModule.getData();
                                ShowFloatError($("#tip"), LangCtrl._L_("successDelete"),{},"success");
                            }else{
                                ShowFloatError($("#tip"), LangCtrl._L_("failedDelete"),{},"failed");
                            }
                        }
                    });
                }
                catch (ex) {
                    alert(ex);
                }
            }
        });
    },
    startCruise: function(id) {
        startCruise(id,$("#tip"));
    },
    stopCruise: function() {
        stopCruise($("#tip"));
    },
    setOCX: function() {
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/GetPortConfig",
                type: "POST",
                async: true,
                data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    netPort = $("config>port>netPort", result).text() * 1;
                    NetLiveMonitor = LoadPlugin("divOCX","NetLiveMonitor");

                    // 设置模式
                    var sendXML = OCX_XML_SetPreViewModel("ReadOnly");
                    NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);

                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    }
};

//OCX调用js方法
function NotifyResultToJs(strXMLFormat, lStrLen) {
    var $xmlDoc = $(XMLStr2XMLDoc(strXMLFormat));

    // OCX已创建好窗口，通知可以登录了
    if ($("statenotify[type=\"Login\"]", $xmlDoc).length > 0) {
        var userInfo = Decryption($.cookie("auInfo"));
        var userInfoArr = userInfo.split(":");
        // 设置登录信息
        var username = userInfoArr[0];
        var password = userInfoArr[1];
        var ip = serverIp;
        var port = netPort;
        var id = "";
        var sendXML = OCX_XML_SetLoginInfo(username, password, ip, port, id);
        NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);

        // 设置预览码流索引
        var sendXML = OCX_XML_SetStreamType(2);
        NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
    }

    if ($("statenotify[type=\"GetOriginalWH\"]", $xmlDoc).length > 0) {
        $("#divOCX").css({width:"380px",height:"280px"});
        CruiseModule.getData();
    }

    var connectstate = $("statenotify[type='connectstate']",$xmlDoc);
    if(connectstate.length > 0){
        if($(">status", connectstate).text() === "success"){
            window.top.hideLoading();
        }else{
            window.top.showLoading(window.top.LangCtrl._L_("connectError"));
        }
    }

    var Connect  = $("statenotify[type='Connect']",$xmlDoc);
    if(Connect.length > 0){
        if($(">status", Connect).text() === "limit"){
            window.top.MsgBoxHelper.Show("info", LangCtrl._L_("infoTip"), LangCtrl._L_("limit"), null);
        }
    }
};