var context;

var EditAlarmModule = {
    initCtrl: function(c) {
        context = c;

        $("#btnAlarmOK", context).click(function() {
            EditAlarmModule.setData();
            EditAlarmModule.close();
        });

        $("#btnAlarmCancel", context).click(function() {
            EditAlarmModule.close();
        });

        LangCtrl.translate($("#tbSubTask", context));

        EditAlarmModule.bindCtrlData();

        initNumberInput($("#alarmCall1", context), { minValue: $("config>types>pre",alarmXmlDoc).attr("min"), maxValue: $("config>types>pre",alarmXmlDoc).attr("max") });

        if (ptzAlarmModule.editIndex != -1) {
            $("#alarmInCon1", context).val(ptzAlarmModule.alarmArr[ptzAlarmModule.editIndex]["alarmInCon"]);
            $("#alarmInMode1", context).val(ptzAlarmModule.alarmArr[ptzAlarmModule.editIndex]["alarmInMode"]);
            $("#alarmCall1", context).val(ptzAlarmModule.alarmArr[ptzAlarmModule.editIndex]["alarmCall"]);
            $("#outputEnable1", context).val(ptzAlarmModule.alarmArr[ptzAlarmModule.editIndex]["outputEnable"]);
        }
    },
    bindCtrlData: function() {
        function getConName(type){
            switch (type){
                case "open":
                    return LangCtrl._L_("normallyOpen");
                case "close":
                    return LangCtrl._L_("normallyClose");
                default :
                    return type;
            }
        }
        var alarmInCon1 = $("#alarmInCon1", context);
        alarmInCon1.empty();
        $("config>types>con>enum",alarmXmlDoc).each(function(i,ele){
            $("<option value=\""+ $(ele).text() +"\">"+ getConName($(ele).text()) +"</option>").appendTo(alarmInCon1);
        });
        var alarmInMode1 = $("#alarmInMode1", context);
        alarmInMode1.empty();
        $("config>types>mode>enum",alarmXmlDoc).each(function(i,ele){
            $("<option value=\""+ $(ele).text() +"\">"+ LangCtrl._L_($(ele).text()) +"</option>").appendTo(alarmInMode1);
        });
        var outputEnable1 = $("#outputEnable1", context);
        outputEnable1.empty();
        $("config>types>output>enum",alarmXmlDoc).each(function(i,ele){
            $("<option value=\""+ $(ele).text() +"\">"+ LangCtrl._L_($(ele).text()) +"</option>").appendTo(outputEnable1);
        });
    },
    getSavePtzAlarmInData: function(){
        var sendData = xmlHeader +  "<config version=\"1.0\" xmlns=\"http://www.ipc.com/ver10\"><alarmIn><item id=\"" + (ptzAlarmModule.editIndex+1) + "\"><alarmInCon>" + $("#alarmInCon1", context).val() +"</alarmInCon>" + "<alarmInMode>" + $("#alarmInMode1", context).val() +"</alarmInMode>" + "<alarmCall>" + $("#alarmCall1", context).val() +"</alarmCall>" + "<outputEnable>" + $("#outputEnable1", context).val() +"</outputEnable>" +"</item></alarmIn></config>";
        return sendData;
    },
    setData: function(c) {
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/SetPtzAlarmIn",
                type: "POST",
                async: true,
                data: EditAlarmModule.getSavePtzAlarmInData(),
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    if ($("config",result).attr("status") === "success"){
                        ptzAlarmModule.getPtzAlarmIn();
                        ShowFloatError($("#taskTip",c), LangCtrl._L_("deleteTaskSuccess"),{},"success");
                    }else{
                        ShowFloatError($("#taskTip",c), LangCtrl._L_("deleteTaskFailed"),{},"failed");
                    }
                    window.top.hideLoading();
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    close: function() {
        dialogEditAlarm.CloseDialog();
    }
};