﻿var xmlDoc;
var presetGrid;
var dialogAddPreset;
var NetLiveMonitor; // 视频控件

$(function() {
	window.top.showLoading();
	try {
		XmlHttpClient.SendHttpRequest({
			url: serverBase + "/PtzGetCaps",
			type: "POST",
			async: true,
			data: "",
            beforeSend: XmlHttpClient.CommBeforeSend,
			callback: function(result) {
				PresetModule.controlMinSpeed = $("config>caps>controlMinSpeed", result).text() * 1;
				PresetModule.controlMaxSpeed = $("config>caps>controlMaxSpeed", result).text() * 1;
				PresetModule.initCtrl();
                PresetModule.doResize();
				window.top.hideLoading();
			}
		});
	}
	catch (ex) {
		alert(ex);
	}
    closeStream();
});

var PresetModule = {
    doResize: function(){
        var height1 = $("#config_content", window.parent.document).height();
        var height2 = $("#navBar").height();

        $("#presetGrid").wbGrid("setHeight", height1 - height2 - 180);
        $(window.top).resize(function () {
            $("#presetGrid").wbGrid("setHeight", height1 - height2 - 180);
        });
    },
	initCtrl: function() {
		window.top.showLoading();

		$("#sliderSpeed").slider({
			minValue: PresetModule.controlMinSpeed,
			maxValue: PresetModule.controlMaxSpeed,
            maxWidth: 155,
            value: 4,
			buildTip: function(value) {
				return LangCtrl._L_("ptzSpeed") + value;
			}
		});

		$("#btnSlow").click(function(event) {
			var curSpeed = $("#sliderSpeed").slider("getValue");
			if (curSpeed <= 1) {
				return;
			}
			curSpeed = curSpeed - 1;
			$("#sliderSpeed").slider("setValue", curSpeed);
		});

		$("#btnQuick").click(function(event) {
			var curSpeed = $("#sliderSpeed").slider("getValue");
			if (curSpeed >= 8) {
				return;
			}
			curSpeed = curSpeed + 1;
			$("#sliderSpeed").slider("setValue", curSpeed);
		});

		// 创建预置点
		$("#btnCreate").click(function(event) {
			PresetModule.toAddData();
		});

		// 修改预置点名称
		$("#btnEditName").click(function(event) {
			PresetModule.toEditData();
		});

		// 删除预置点
		$("#btnDel").click(function(event) {
			PresetModule.deleteData();
		});

		bindPtzEvent();

        $("#presetGrid").wbGrid({
            data: {
                colNames: [LangCtrl._L_("ID"),LangCtrl._L_("presetName"),LangCtrl._L_("action")],
                colModel: [
                    { name: "@id", index: "id", key: true,width: 50, align:"center"},
                    { name: "presetName", index: "presetName", width: 170, align: "center", sortable: false },
                    { name: "action", index: "action", width: 190, align: "center", sortable: false, formatter: "custom",
                        formatterParam: {
                            init: function ($cell, rowData) {
                                var btn1 = $("<button class=\"cfgBtn\" style=\"text-align:center;\">"+LangCtrl._L_("call")+"</button>")
                                var btn2 = $("<button class=\"cfgBtn\" style=\"margin-left:10px;text-align:center;\">"+LangCtrl._L_("savePosition")+"</button>");
                                btn1.click(function(event) {
                                    PresetModule.callPreset(rowData["@id"]);
                                    event.stopPropagation();
                                }).appendTo($cell);
                                btn2.click(function(event) {
                                    PresetModule.savePosition(rowData["@id"]);
                                    event.stopPropagation();
                                }).appendTo($cell);
                                return $cell;
                            }
                        }
                    }
                ],
                rowList: []
            },
            view: {
                selectRow : true
            }
        });

        presetGrid = $("#presetGrid");

		try {
			XmlHttpClient.SendHttpRequest({
				url: serverBase + "/PtzGetCaps",
				type: "POST",
				async: true,
				data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
				callback: function(result) {
					PresetModule.presetMaxCount = $("config>caps>presetMaxCount", result).text() * 1;
					window.top.hideLoading();
				}
			});
		}
		catch (ex) {
			alert(ex);
		}

		PresetModule.setOCX();
	},
	getData: function() {
//		window.top.showLoading();
		try {
			XmlHttpClient.SendHttpRequest({
				url: serverBase + "/PtzGetPresets",
				type: "POST",
				async: true,
				data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
				callback: function(result) {
					xmlDoc = result;

                    var $elem;
                    var rowData = [];
                    $("config>presetInfo>item",xmlDoc).each(function(i,ele){
                        rowData.push({
                            "@id":($(ele).attr("id")),
                            "presetName":$(ele).text()
                        })
                    });
                    $("#presetGrid").wbGrid("load", rowData);

                    if (rowData.length >= 1) {
                        $('#presetGrid').wbGrid("selectRowByIndex",0);
                        $("#btnEditName,#btnDel").removeAttr("disabled").removeClass("disabled");
                    }
                    else {
                        $("#btnEditName,#btnDel").attr("disabled", "disabled").addClass("disabled");
                    }
//                    $("#btnEditName, #btnDel").attr("disabled", presetGrid.wbGrid("getAllRows").length == 0);
//					window.top.hideLoading();
				}
			});
		}
		catch (ex) {
			alert(ex);
		}
	},
	toAddData: function() {
		ClearFloatError();
        var count = presetGrid.wbGrid("getAllRows").length;
		if (count >= PresetModule.presetMaxCount) {
			ShowFloatError($("#btnCreate"), LangCtrl._L_("presetMaxCount").format(PresetModule.presetMaxCount), { left: 15 });
			return;
		}

		PresetModule.editIndex = -1;
		dialogAddPreset = new DialogHelper({
			title: LangCtrl._L_("createPreset"),
			content: "addPresetDialog.htm",
			width: 360,
			height: 150,
			contentType: "url",
			loadCallBack: AddPresetModule.initCtrl
		});
	},
	toEditData: function() {
		PresetModule.editIndex = presetGrid.wbGrid("getSelectRows").index;
		dialogAddPreset = new DialogHelper({
			title: LangCtrl._L_("modifyPreset"),
			content: "addPresetDialog.htm",
			width: 360,
			height: 150,
			contentType: "url",
			loadCallBack: AddPresetModule.initCtrl
		});
	},
	getDeleteData: function() {
		return xmlHeader + "<presetInfo><id>" + $("config>presetInfo>item[id='" + $("config>presetInfo>item:eq(" + presetGrid.wbGrid("getSelectRows").index + ")", xmlDoc).attr("id") + "']", xmlDoc).attr("id") + "</id></presetInfo>";
	},
	deleteData: function() {
		window.top.MsgBoxHelper.Show("y/n", LangCtrl._L_("infoTip"), LangCtrl._L_("confirmDeletePreset"), function(flag) {
			if (flag) {
				window.top.showLoading();
				try {
					XmlHttpClient.SendHttpRequest({
						url: serverBase + "/PtzDeletePreset",
						type: "POST",
						async: true,
						data: PresetModule.getDeleteData(),
                        beforeSend: XmlHttpClient.CommBeforeSend,
						callback: function(result) {
							window.top.hideLoading();
							PresetModule.getData();
						}
					});
				}
				catch (ex) {
					alert(ex);
				}
			}
		});
	},
	getSavePositionData: function(id) {
		return xmlHeader + "<presetInfo><id>" + $("config>presetInfo>item[id='" + id + "']", xmlDoc).attr("id") + "</id></presetInfo>";
	},
	savePosition: function(id) {
		window.top.showLoading();
		try {
			XmlHttpClient.SendHttpRequest({
				url: serverBase + "/PtzModifyPresetPosition",
				type: "POST",
				async: true,
				data: PresetModule.getSavePositionData(id),
                beforeSend: XmlHttpClient.CommBeforeSend,
				callback: function(result) {
					window.top.hideLoading();
					commSaveResponseHadler(result);
				}
			});
		}
		catch (ex) {
			alert(ex);
		}
	},
	callPreset: function(index) {
		callPreset($("config>presetInfo>item[id='" + index + "']", xmlDoc).attr("id"));
	},
	setOCX: function() {
		window.top.showLoading();
		try {
			XmlHttpClient.SendHttpRequest({
				url: serverBase + "/GetPortConfig",
				type: "POST",
				async: true,
				data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
				callback: function(result) {
                    netPort = $("config>port>netPort", result).text() * 1;
                    NetLiveMonitor = LoadPlugin("divOCX","NetLiveMonitor");
                    // 设置模式
                    var sendXML = OCX_XML_SetPreViewModel("ReadOnly");
                    NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
				}
			});
		}
		catch (ex) {
			alert(ex);
		}
	}
};

//OCX调用js方法
function NotifyResultToJs(strXMLFormat, lStrLen) {
    var $xmlDoc = $(XMLStr2XMLDoc(strXMLFormat));

    // OCX已创建好窗口，通知可以登录了
    if ($("statenotify[type=\"Login\"]", $xmlDoc).length > 0) {
        var userInfo = Decryption($.cookie("auInfo"));
        var userInfoArr = userInfo.split(":");
        // 设置登录信息
        var username = userInfoArr[0];
        var password = userInfoArr[1];
        var ip = serverIp;
        var port = netPort;
        var id = "";
        var sendXML = OCX_XML_SetLoginInfo(username, password, ip, port, id);
        NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);

        // 设置预览码流索引
        var sendXML = OCX_XML_SetStreamType(2);
        NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
    }

    if ($("statenotify[type=\"GetOriginalWH\"]", $xmlDoc).length > 0) {
        $("#divOCX").css({width:"380px",height:"280px"});
        PresetModule.getData();
    }

    var connectstate = $("statenotify[type='connectstate']",$xmlDoc);
    if(connectstate.length > 0){
        if($(">status", connectstate).text() === "success"){
            window.top.hideLoading();
        }else{
            window.top.showLoading(window.top.LangCtrl._L_("connectError"));
        }
    }

    var Connect  = $("statenotify[type='Connect']",$xmlDoc);
    if(Connect.length > 0){
        if($(">status", Connect).text() === "limit"){
            window.top.MsgBoxHelper.Show("info", LangCtrl._L_("infoTip"), LangCtrl._L_("limit"), null);
        }
    }
};