﻿var xmlDoc;
var rtspPort,netPort;
var NetLiveMonitor;
var presetGrid;
var cruiseGrid;
var groupGrid;
var traceGrid;
var taskGrid;
var alarmInGrid;
var privateGrid;
var dialogAddCruise;
var dialogAddCruiseForGroup;
var dialogAddTask;
var autoPresetXmlDoc;
var autoCruiseXmlDoc;
var autoTraceXmlDoc;
var autoTaskXmlDoc;
var statusXml;
var alarmXmlDoc;
var brushXmlDoc;
var guardXmlDoc;
var countTimer;
var traceId = null;
var saveZoneFlag = false;
$(function(){
    $("#divParent").tab({
        map: [
            { "tab": "liPreset", "content": "divPtzPresetTrigger", init: ptzPresetModule.initPtzPresetCtrl },
            { "tab": "liCruise", "content": "divPtzCruiseTrigger", init: ptzCruiseModule.initPtzCruiseCtrl },
            { "tab": "liGroup", "content": "divPtzGroupTrigger", init: ptzGroupModule.initPtzGroupCtrl },
            { "tab": "liTask", "content": "divPtzTaskTrigger", init: ptzTaskModule.initPtzTaskCtrl },
            { "tab": "liTrace", "content": "divPtzTraceTrigger", init: ptzTraceModule.initPtzTraceCtrl },
            { "tab": "liAlarm", "content": "divPtzAlarmTrigger", init: ptzAlarmModule.initPtzAlarmCtrl },
            { "tab": "liPrivacyZone", "content": "divPtzPrivacyZoneTrigger", init: ptzPrivacyZoneModule.initPtzPrivacyZoneCtrl },
            { "tab": "liMotion", "content": "divPtzMotionTrigger", init: ptzMotionModule.initPtzMotionCtrl },
            { "tab": "liGuard", "content": "divPtzGuardTrigger", init: ptzGuardModule.initPtzGuardCtrl },
            { "tab": "liBrush", "content": "divPtzBrushTrigger", init: ptzBrushModule.initPtzBrushCtrl }
        ]
    });
    commonMethod.setOCX();

    getDeviceInfo(function(result) {
        xmlDoc = result;
        if($("config > deviceInfo > supportWiper ",result).text() == "false"){
            $("#liBrush").hide();
        }
        //if($("config > deviceInfo > supportPrivateZone ",result).text() == "false"){
        //    $("#liPrivacyZone").hide();
        //}
        if($("config > deviceInfo > alarmInCount ",result).text() == 0){
            $("#liAlarm").hide();
        }
        $("#divParent").tab("selectLastTab");
    });

    $("#sliderSpeed").empty();
    $("#sliderSpeed").slider({
        minValue: commonMethod.controlMinSpeed,
        maxValue: commonMethod.controlMaxSpeed,
        maxWidth: 155,
        value: 4,
        buildTip: function(value) {
            return LangCtrl._L_("ptzSpeed") + value;
        }
    });

    $("#btnSlow").unbind().click(function(event) {
        var curSpeed = $("#sliderSpeed").slider("getValue");
        if (curSpeed <= 1) {
            return;
        }
        curSpeed = curSpeed - 1;
        $("#sliderSpeed").slider("setValue", curSpeed);
    });

    $("#btnQuick").unbind().click(function(event) {
        var curSpeed = $("#sliderSpeed").slider("getValue");
        if (curSpeed >= 8) {
            return;
        }
        curSpeed = curSpeed + 1;
        $("#sliderSpeed").slider("setValue", curSpeed);
    });

    $("#Content",window.top.document).css({"min-width":"1350px"});
    $(window).unload(function(){
        if(saveZoneFlag){
            ptzPrivacyZoneModule.cancelPrivateZone();
        }
        commonMethod.clearCountdown();
    });
    bindPtzEvent();
});

var commonMethod = {
    ptzGetCaps: function(){
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/PtzGetCaps",
                type: "POST",
                async: true,
                data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    commonMethod.cruiseMaxCount = $("config>caps>cruiseMaxCount", result).text() * 1;
                    commonMethod.presetMaxCount = $("config>caps>presetMaxCount", result).text() * 1;
                    commonMethod.cruiseMinHoldTime = 5;
                    commonMethod.cruiseMaxHoldTime = $("config>caps>cruisePresetMaxHoldTime", result).text() * 1;
                    commonMethod.cruiseMinSpeed = $("config>caps>cruisePresetMinSpeed", result).text() * 1;
                    commonMethod.cruiseMaxSpeed = $("config>caps>cruisePresetMaxSpeed", result).text() * 1;
                    commonMethod.controlMinSpeed = 1;
                    commonMethod.controlMaxSpeed = $("config>caps>controlMaxSpeed", result).text() * 1;
                    commonMethod.cruisePresetMaxCount = $("config>caps>cruisePresetMaxCount", result).text() * 1;
                    window.top.hideLoading();
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    setOCX: function() {
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/GetPortConfig",
                type: "POST",
                async: true,
                data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    netPort = $("config>port>netPort", result).text() * 1;
                    NetLiveMonitor = LoadPlugin("divOCX","NetLiveMonitor");
                    // 设置模式
                    var sendXML = OCX_XML_SetPreViewModel("ReadOnly");
                    NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
                    window.top.hideLoading();
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    clearCountdown: function(){
        if(traceId !== null){
            ptzTraceModule.ptzCancelTrace(null,traceId);
        }
    }
 };

var ptzPresetModule = {
    doResize: function(){
        var height = $("#config_content", window.parent.document).height();
        $("#presetGrid").wbGrid("setHeight", height - 183);
        $(window.top).resize(function () {
            $("#presetGrid").wbGrid("setHeight", height - 183);
        });
    },
    initPtzPresetCtrl: function(){
        if(saveZoneFlag){
            ptzPrivacyZoneModule.cancelPrivateZone();
        }
        $("#divPresetRight").css({left:"600px"});
        $("#resizeButton").hide();
        commonMethod.clearCountdown();
        commonMethod.ptzGetCaps();
        closeStream();

        $("#presetGrid").wbGrid({
            data: {
                colNames: [LangCtrl._L_("ID"),LangCtrl._L_("presetName"),LangCtrl._L_("action")],
                colModel: [
                    { name: "@id", index: "@id", key: true,width: 50, align:"center"},
                    { name: "presetName", index: "presetName", width: 80, align: "center", sortable: false },
                    { name: "action", index: "action", width: 230, align: "center", sortable: false, formatter: "custom",
                        formatterParam: {
                            init: function ($cell, rowData) {
                                var btn1 = $("<button class=\"cfgBtn\" style=\"text-align:center;\">"+LangCtrl._L_("call")+"</button>")
                                var btn2 = $("<button class=\"cfgBtn\" style=\"margin-left:10px;text-align:center;\">"+LangCtrl._L_("savePosition")+"</button>");
                                var btn3 = $("<button class=\"cfgBtn\" style=\"margin-left:10px;text-align:center;\">"+LangCtrl._L_("delete")+"</button>");
                                btn1.click(function(event) {
                                    ptzPresetModule.callPreset(rowData["@id"]);
                                    event.stopPropagation();
                                }).appendTo($cell);
                                btn2.click(function(event) {
                                    ptzPresetModule.savePosition(rowData["@id"]);
                                    event.stopPropagation();
                                }).appendTo($cell);
                                btn3.click(function(event) {
                                    ptzPresetModule.deleteData(rowData["@id"]);
                                    event.stopPropagation();
                                }).appendTo($cell);
                                return $cell;
                            }
                        }
                    }
                ],
                rowList: []
            },
            view: {
                selectRow : true
            }
        });

        presetGrid = $("#presetGrid");

        // 创建预置点
        $("#btnCreate").unbind().click(function(event) {
            ptzPresetModule.toAddData();
        });

        // 修改预置点名称
        $("#btnEditName").unbind().click(function(event) {
            ptzPresetModule.toEditData();
        });
        ptzPresetModule.doResize();
        ptzPresetModule.getData();
    },
    getData: function() {
//		window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/PtzGetPresets",
                type: "POST",
                async: true,
                data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    autoPresetXmlDoc = result;

                    var $elem;
                    var rowData = [];
                    $("config>presetInfo>item",autoPresetXmlDoc).each(function(i,ele){
                        rowData.push({
                            "@id":($(ele).attr("id")),
                            "presetName":$(ele).text()
                        })
                    });
//                    rowData.sort(by("@id"));
                    ptzPresetModule.presetData = rowData;
                    $("#presetGrid").wbGrid("load", rowData);

                    if (rowData.length >= 1) {
                        $('#presetGrid').wbGrid("selectRowByIndex",0);
                        $("#btnEditName,#btnDel").removeAttr("disabled").removeClass("disabled");
                    }
                    else {
                        $("#btnEditName,#btnDel").attr("disabled", "disabled").addClass("disabled");
                    }
//                    $("#btnEditName, #btnDel").attr("disabled", presetGrid.wbGrid("getAllRows").length == 0);
//					window.top.hideLoading();
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    toAddData: function() {
        ClearFloatError();
        var count = presetGrid.wbGrid("getAllRows").length;
        if (count >= commonMethod.presetMaxCount) {
            ShowFloatError($("#btnCreate"), LangCtrl._L_("presetMaxCount").format(commonMethod.presetMaxCount), { left: 15 });
            return;
        }

        ptzPresetModule.editIndex = -1;
        dialogAddPreset = new DialogHelper({
            title: LangCtrl._L_("createPreset"),
            content: "addPresetDialog.htm",
            width: 360,
            height: 170,
            contentType: "url",
            loadCallBack: AddPresetModule.initCtrl
        });
    },
    toEditData: function() {
        ptzPresetModule.editIndex = presetGrid.wbGrid("getSelectRows").index;
        dialogAddPreset = new DialogHelper({
            title: LangCtrl._L_("modifyPreset"),
            content: "addPresetDialog.htm",
            width: 360,
            height: 200,
            contentType: "url",
            loadCallBack: AddPresetModule.initCtrl
        });
    },
    getDeleteData: function(id) {
        return xmlHeader + "<presetInfo><id>"+ id + "</id></presetInfo>";
    },
    deleteData: function(id) {
        window.top.MsgBoxHelper.Show("y/n", LangCtrl._L_("infoTip"), LangCtrl._L_("confirmDeletePreset"), function(flag) {
            if (flag) {
                window.top.showLoading();
                try {
                    XmlHttpClient.SendHttpRequest({
                        url: serverBase + "/PtzDeletePreset",
                        type: "POST",
                        async: true,
                        data: ptzPresetModule.getDeleteData(id),
                        beforeSend: XmlHttpClient.CommBeforeSend,
                        callback: function(result) {
                            window.top.hideLoading();
                            if ($("config",result).attr("status") === "success"){
                                ptzPresetModule.getData();
                                ShowFloatError($("#presetTip"), LangCtrl._L_("successDeletePreset"),{},"success");
                            }else{
                                ShowFloatError($("#presetTip"), LangCtrl._L_("failedDeletePreset"),{},"failed");
                            }

                        }
                    });
                }
                catch (ex) {
                    alert(ex);
                }
            }
        });
    },
    getSavePositionData: function(id) {
        return xmlHeader + "<presetInfo><id>" + $("config>presetInfo>item[id='" + id + "']", autoPresetXmlDoc).attr("id") + "</id></presetInfo>";
    },
    savePosition: function(id) {
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/PtzModifyPresetPosition",
                type: "POST",
                async: true,
                data: ptzPresetModule.getSavePositionData(id),
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    window.top.hideLoading();
                    commSaveResponseHadler(result);
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    callPreset: function(index) {
        callPreset($("config>presetInfo>item[id='" + index + "']", autoPresetXmlDoc).attr("id"),$("#presetTip"));
    }
};

var ptzCruiseModule = {
    initPtzCruiseCtrl: function(){
        if(saveZoneFlag){
            ptzPrivacyZoneModule.cancelPrivateZone();
        }
        $("#divPresetRight").css({left:"490px"});
        $("#resizeButton").hide();
        commonMethod.clearCountdown();
        commonMethod.ptzGetCaps();
        // 创建巡航线
        $("#btnCruiseCreate").unbind().click(function() {
            ptzCruiseModule.toAddData();
        });

        // 修改巡航线
        $("#btnCruiseEdit").unbind().click(function() {
            ptzCruiseModule.toEditData();
        });

        // 删除巡航线
        $("#btnCruiseDel").unbind().click(function() {
            ptzCruiseModule.deleteData();
        });

        $("#cruiseGrid").wbGrid({
            data: {
                colNames: [LangCtrl._L_("ID"),LangCtrl._L_("cruiseName"),LangCtrl._L_("action")],
                colModel: [
                    { name: "@id", index: "id", key: true,width: 50, align:"center"},
                    { name: "cruiseName", index: "cruiseName", width: 180, align: "center", sortable: false },
                    { name: "action", index: "action", width: 230, align: "center", sortable: false, formatter: "custom",
                        formatterParam: {
                            init: function ($cell, rowData) {
                                var btn1 = $("<button class=\"cfgBtn\" style=\"text-align:center;\">"+LangCtrl._L_("startCruise")+"</button>")
                                var btn2 = $("<button class=\"cfgBtn\" style=\"margin-left:10px;text-align:center;\">"+LangCtrl._L_("stopCruise")+"</button>");
                                btn1.click(function(event) {
                                    ptzCruiseModule.startCruise(rowData["@id"]);
                                    event.stopPropagation();
                                }).appendTo($cell);
                                btn2.click(function(event) {
                                    ptzCruiseModule.stopCruise();
                                    event.stopPropagation();
                                }).appendTo($cell);
                                return $cell;
                            }
                        }
                    }
                ],
                rowList: []
            },
            view: {
                selectRow : true
            }
        });
        cruiseGrid = $("#cruiseGrid");
        ptzCruiseModule.getData();

    },
    getData: function() {
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/PtzGetCruises",
                type: "POST",
                async: true,
                data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    autoCruiseXmlDoc = result;

                    var $elem;
                    var rowData = [];
                    $("config>cruiseInfo>item",result).each(function(i,ele){
                        rowData.push({
                            "@id":($(ele).attr("id")),
                            "cruiseName":$(ele).text()
                        })
                    });
//                    rowData.sort(by("@id"));
                    cruiseGrid.wbGrid("load", rowData);
                    if (rowData.length >= 1) {
                        cruiseGrid.wbGrid("selectRowByIndex",0);
                        $("#btnCruiseEdit,#btnCruiseDel").removeAttr("disabled").removeClass("disabled");
                    }
                    else {
                        $("#btnCruiseEdit,#btnCruiseDel").attr("disabled", "disabled").addClass("disabled");
                    }
//                    $("#btnEdit, #btnDel").attr("disabled", cruiseGrid.wbGrid("getAllRows").length == 0);
                    window.top.hideLoading();
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    toAddData: function() {
        ClearFloatError();
        var count = cruiseGrid.wbGrid("getAllRows").length;
        if (count >= commonMethod.cruiseMaxCount) {
            ShowFloatError($("#btnCruiseCreate"), LangCtrl._L_("cruiseMaxCount").format(commonMethod.cruiseMaxCount), { left: 15 });
            return;
        }

        ptzCruiseModule.editIndex = -1;
        dialogAddCruise = new DialogHelper({
            title: LangCtrl._L_("createCruise"),
            content: "addCruiseDialog.htm",
            width:  520,
            height: 420,
            contentType: "url",
            loadCallBack: AddCruiseModule.initCtrl
        });
    },
    toEditData: function() {
        ptzCruiseModule.editIndex = cruiseGrid.wbGrid("getSelectRows").index;
        dialogAddCruise = new DialogHelper({
            title: LangCtrl._L_("modifyCruise"),
            content: "addCruiseDialog.htm",
            width: 520,
            height: 450,
            contentType: "url",
            loadCallBack: AddCruiseModule.initCtrl
        });
    },
    getDeleteData: function() {
        return xmlHeader + "<cruiseInfo><id>" + cruiseGrid.wbGrid("getSelectRows")["data"]["@id"]  + "</id></cruiseInfo>";
    },
    deleteData: function() {
        window.top.MsgBoxHelper.Show("y/n", LangCtrl._L_("infoTip"), LangCtrl._L_("confirmDeleteCruiseTip"), function(flag) {
            if (flag) {
                window.top.showLoading();
                try {
                    XmlHttpClient.SendHttpRequest({
                        url: serverBase + "/PtzDeleteCruise",
                        type: "POST",
                        async: true,
                        data: ptzCruiseModule.getDeleteData(),
                        beforeSend: XmlHttpClient.CommBeforeSend,
                        callback: function(result) {
                            window.top.hideLoading();
                            if ($("config",result).attr("status") === "success"){
                                ptzCruiseModule.getData();
                                ShowFloatError($("#tip"), LangCtrl._L_("successDelete"),{},"success");
                            }else{
                                ShowFloatError($("#tip"), LangCtrl._L_("failedDelete"),{},"failed");
                            }
                        }
                    });
                }
                catch (ex) {
                    alert(ex);
                }
            }
        });
    },
    startCruise: function(id) {
        startCruise(id,$("#tip"));
    },
    stopCruise: function() {
        stopCruise($("#tip"));
    }
};

var ptzGroupModule = {
    getCruiseData: function(){
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/PtzGetCruises",
                type: "POST",
                async: true,
                data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    autoCruiseXmlDoc = result;
                    window.top.hideLoading();
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    initPtzGroupCtrl: function(){
        if(saveZoneFlag){
            ptzPrivacyZoneModule.cancelPrivateZone();
        }
        $("#divPresetRight").css({left:"450px"});
        $("#resizeButton").hide();
        commonMethod.clearCountdown();
        ptzGroupModule.getCruiseData();
        $("#groupGrid").wbGrid({
            data: {
                colNames: [LangCtrl._L_("ID"),"cruiseId",LangCtrl._L_("cruise"),LangCtrl._L_("action")],
                colModel: [
                    { name: "@id", index: "id", key: true,width: 50, align:"center"},
                    { name: "cruiseId", index: "cruiseId", hidden: true,width: 50, align:"center"},
                    { name: "cruiseName", index: "cruiseName", width: 150, align: "center", sortable: false },
                    { name: "action", index: "action", width: 170, align: "center", sortable: false, formatter: "custom",
                        formatterParam: {
                            init: function ($cell, rowData) {
                                var strLang = rowData["cruiseId"]*1 !== 0 ? LangCtrl._L_("editCruise") : LangCtrl._L_("addCruise");
                                var btn = $("<button class=\"cfgBtn\" style=\"text-align:center;\">"+strLang+"</button>")
                                btn.unbind().click(function(event) {
                                    ptzGroupModule.addCruise(rowData["@id"]);
                                    event.stopPropagation();
                                }).appendTo($cell);
                                return $cell;
                            }
                        }
                    }
                ],
                rowList: []
            },
            view: {
                selectRow : true
            }
        });

        groupGrid = $("#groupGrid");

        $("#btnGroupRun").unbind().click(function(event) {
            ptzGroupModule.runGroup();
        });

        $("#btnGroupDel").unbind().click(function(event) {
            ptzGroupModule.delGroup();
        });

        $("#btnGroupStop").unbind().click(function(){
            ptzGroupModule.stopGroup();
        });

        ptzGroupModule.getGroupData();
    },
    getGroupData: function(){
        window.top.showLoading();
        try {
                XmlHttpClient.SendHttpRequest({
                url: serverBase + "/PtzGetGroup",
                type: "POST",
                async: true,
                data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    xmlDoc = result;
                    var rowData = [];
                    var cruiseSize = $("config>groupInfo>item",xmlDoc).size();
                    var cruiseMax = $("config>groupInfo",xmlDoc).attr("maxCount") * 1;
                    if(cruiseSize >  0){
                        for(var i = 1,len=cruiseMax;i<=len;i++){
                            var flag = false;
                            $("config>groupInfo>item",xmlDoc).each(function(n,ele){
                                if(i === $(ele).attr("id")*1){
                                    var cruiseId = $(">cruise",ele).attr("id");
                                    var cruiseName = $(">cruise",ele).text();
                                    rowData.push({
                                        "@id":($(ele).attr("id")),
                                        "cruiseId":cruiseId,
                                        "cruiseName":cruiseName
                                    });
                                    flag = true;
                                    return false;
                                }
                            });
                            if(!flag){
                                rowData.push({
                                    "@id":i,
                                    "cruiseId":"0",
                                    "cruiseName":LangCtrl._L_("no")
                                })
                            }
                        }
                    }else{
                        for(var i = 1,len=cruiseMax;i<=len;i++){
                            rowData.push({
                                "@id":i,
                                "cruiseId":"0",
                                "cruiseName":LangCtrl._L_("no")
                            })
                        }
                    }
                    groupGrid.wbGrid("load", rowData);
                    window.top.hideLoading();
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    addCruise: function(id){
        AddCruiseForGroupModule.itemId = id;
        dialogAddCruiseForGroup = new DialogHelper({
            title: LangCtrl._L_("selectCruise"),
            content: "addCruiseForGroupDialog.htm",
            width: 350,
            height: 200,
            zIndex: 302,
            contentType: "url",
            beforCloseEvent: function () {
                if (dialogAddCruise) {
                    DisplayOCX(document, false);
                }
            },
            loadCallBack: AddCruiseForGroupModule.initCtrl
        });
    },
    runGroup: function(){
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/PtzRunGroup",
                type: "POST",
                async: true,
                data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    if ($("config",result).attr("status") === "success"){
                        ShowFloatError($("#tip1"), LangCtrl._L_("successRunGroup"),{},"success");
                    }else{
                        ShowFloatError($("#tip1"), LangCtrl._L_("failedRunGroup"),{},"failed");
                    }
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    delGroup: function(){
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/PtzDeleteGroup",
                type: "POST",
                async: true,
                data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    window.top.hideLoading();
                    if ($("config",result).attr("status") === "success"){
                        ptzGroupModule.getGroupData();
                        ShowFloatError($("#tip1"), LangCtrl._L_("successDeleteGroup"),{},"success");
                    }else{
                        ShowFloatError($("#tip1"), LangCtrl._L_("failedDeleteGroup"),{},"failed");
                    }
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    stopGroup: function(){
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/PtzStopGroup",
                type: "POST",
                async: true,
                data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    window.top.hideLoading();
                    if ($("config",result).attr("status") === "success"){
                        ptzGroupModule.getGroupData();
                        ShowFloatError($("#tip1"), LangCtrl._L_("successStopGroup"),{},"success");
                    }else{
                        ShowFloatError($("#tip1"), LangCtrl._L_("failedStopGroup"),{},"failed");
                    }
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    showTip: function(result){
        if ($("config",result).attr("status") === "success"){
            AddCruiseForGroupModule.close();
            ShowFloatError($("#tip1"), LangCtrl._L_("successAddCruise"),{},"success");
        }else{
            ShowFloatError($("#tip1"), LangCtrl._L_("failedAddCruise"),{},"failed");
        }
        ptzGroupModule.getGroupData();
    }
};


var ptzTraceModule = {
    initPtzTraceCtrl: function(){
        if(saveZoneFlag){
            ptzPrivacyZoneModule.cancelPrivateZone();
        }
        $("#divPresetRight").css({left:"450px"});
        $("#resizeButton").hide();
        commonMethod.clearCountdown();
        $("#traceGrid").wbGrid({
            data: {
                colNames: [LangCtrl._L_("ID"),"traceState",LangCtrl._L_("trace"),LangCtrl._L_("action")],
                colModel: [
                    { name: "@id", index: "id", key: true,width: 50, align:"center"},
                    { name: "traceState", index: "traceState", hidden: true,width: 50, align:"center"},
                    { name: "traceName", index: "traceName", width: 110, align: "center", sortable: false },
                    { name: "action", index: "action", width: 280, align: "center", sortable: false, formatter: "custom",
                        formatterParam: {
                            init: function ($cell, rowData) {
                                var strLang = rowData["traceState"]*1 !== 0 ? LangCtrl._L_("editTrace") : LangCtrl._L_("addTrace");
                                var btnStart = $("<button class=\"cfgBtn\" style=\"text-align:center;\">"+strLang+"</button>");
                                btnStart.unbind().click(function(event) {
                                    var nextAll = $(this).nextAll();
                                    ptzTraceModule.ptzStartTrace(this,rowData["@id"],nextAll);
                                    event.stopPropagation();
                                }).appendTo($cell);

                                var btnSave = $("<button class=\"cfgBtn\" style=\"display:none;text-align:center;margin-left:10px\">"+ LangCtrl._L_("saveTrace")+"</button>");
                                btnSave.unbind().click(function(event) {
                                    var next = $(this).nextAll();
                                    ptzTraceModule.ptzSaveTrace(this,rowData["@id"],next);
                                    event.stopPropagation();
                                }).appendTo($cell);
                                var btnCancel = $("<button class=\"cfgBtn\" style=\"display:none;text-align:center;margin-left:10px\">"+ LangCtrl._L_("cancelTrace")+"</button>");
                                btnCancel.unbind().click(function(event) {
                                    var next = $(this).next();
                                    ptzTraceModule.ptzCancelTrace(this,rowData["@id"],next);
                                    event.stopPropagation();
                                }).appendTo($cell);

                                return $cell;
                            }
                        }
                    }
                ],
                rowList: []
            },
            view: {
                selectRow : true
            }
        });
        traceGrid = $("#traceGrid");
        $("#btnTraceRun").unbind().click(function(event) {
            ptzTraceModule.ptzRunTrace();
        });

        $("#btnTraceDelete").unbind().click(function(event) {
            ptzTraceModule.ptzDeleteTrace();
        });

        $("#btnTraceStop").unbind().click(function(){
            ptzTraceModule.ptzStopTrace();
        });

        ptzTraceModule.getTraceData();
    },
    getTraceData: function(){
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/PtzGetTraces",
                type: "POST",
                async: true,
                data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    autoTraceXmlDoc = result;
                    var rowData = [];
                    var traceSize = $("config>traceInfo>item",autoTraceXmlDoc).size();
                    var traceMax = $("config>traceInfo",autoTraceXmlDoc).attr("maxCount") * 1;

                    for(var a = 1;a<=traceMax;a++){
                        var traceState = false;
                        $("config>traceInfo>item",autoTraceXmlDoc).each(function(n,ele){
                            if(a === $(ele).attr("id")*1){
                                rowData.push({
                                    "@id":($(ele).attr("id")),
                                    "traceState":"1",
                                    "traceName":$(ele).text()
                                });
                                traceState = true;
                                return false;
                            }
                        });
                        if(!traceState){
                            rowData.push({
                                "@id":a,
                                "traceState":"0",
                                "traceName":LangCtrl._L_("no")
                            })
                        }
                    }
                    traceGrid.wbGrid("load", rowData);
                    if (rowData.length >= 1) {
                        traceGrid.wbGrid("selectRowByIndex",0);
                        $("#btnTraceRun,#btnTraceDelete").removeAttr("disabled").removeClass("disabled");
                    }
                    else {
                        $("#btnTraceRun,#btnTraceDelete").attr("disabled", "disabled").addClass("disabled");
                    }
                    window.top.hideLoading();
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    ptzStartTrace: function(self,id,$object){
        window.top.showLoading();
        var sendData = xmlHeader + "<traceInfo><id>" + id + "</id></traceInfo>";
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/PtzStartTrace",
                type: "POST",
                async: true,
                data: sendData,
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    if ($("config",result).attr("status") === "success"){
                        ClearFloatError();
                        ShowFloatError($("#traceTip"), LangCtrl._L_("startSetSuccess"),{},"success");
                        $(self).hide();
                        for(var i= 0,len=$object.length;i<len;i++){
                            $($object[i]).show();
                        }
                        clearInterval(countTimer);
                        ptzTraceModule.setCountdown( $(self).next(),id,180);

                    }else{
                        ShowFloatError($("#traceTip"), LangCtrl._L_("startSetFailed"),{},"failed");
                    }
                    window.top.hideLoading();
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    ptzStopTrace: function(){
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/PtzStopTrace",
                type: "POST",
                async: true,
                data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    if ($("config",result).attr("status") === "success"){
                        ShowFloatError($("#traceTip"), LangCtrl._L_("stopTraceSuccess"),{},"success");
                    }else{
                        ShowFloatError($("#traceTip"), LangCtrl._L_("stopTraceFailed"),{},"failed");
                    }
                    window.top.hideLoading();
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    setCountdown: function(self,id,startNum){
        var counter = startNum*1;
        $("<div id='countTime'></div>").appendTo($("#divPresetRight"));
        $("#countTime").html(counter);
        traceId = id;
        countTimer = setInterval(function () {
            counter--;
            $("#countTime").html(counter);
            if (counter == 0) {
                clearInterval(countTimer);
                ptzTraceModule.ptzSaveTrace(self,id);
            }
        }, 1000);
    },
    ptzSaveTrace: function(self,id,$object){
        window.top.showLoading();
        var sendData = xmlHeader + "<traceInfo><id>" + id + "</id></traceInfo>";
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/PtzSaveTrace",
                type: "POST",
                async: true,
                data: sendData,
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    if ($("config",result).attr("status") === "success"){
                        ptzTraceModule.getTraceData();
                        ShowFloatError($("#traceTip"), LangCtrl._L_("saveTraceSuccess"),{},"success");
                        $(self).prev().show();
                        $(self).hide();
                        $(self).next().hide();
                        clearInterval(countTimer);
                        $("#countTime").remove();
                        traceId = null;
                    }else{
                        ShowFloatError($("#traceTip"), LangCtrl._L_("saveTraceFailed"),{},"failed");
                    }
                    window.top.hideLoading();
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    ptzCancelTrace: function(self,id,$object){
        window.top.showLoading();
        var sendData = xmlHeader + "<traceInfo><id>" + id + "</id></traceInfo>";
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/PtzCancelTrace",
                type: "POST",
                async: true,
                data: sendData,
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    if ($("config",result).attr("status") === "success"){
                        if(self){
                            ShowFloatError($("#traceTip"), LangCtrl._L_("saveTraceSuccess"),{},"success");
                            $(self).hide();
                            $(self).prev().hide();
                            $(self).prev().prev().show();
                        }
                        clearInterval(countTimer);
                        $("#countTime").remove();
                        traceId = null;
                    }else if(self){
                        ShowFloatError($("#traceTip"), LangCtrl._L_("saveTraceFailed"),{},"failed");
                    }
                    window.top.hideLoading();
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    ptzRunTrace: function(){
        var traceId = traceGrid.wbGrid("getSelectRows").data['@id'];
        var sendData = xmlHeader + "<traceInfo><id>" + traceId + "</id></traceInfo>";
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/PtzRunTrace",
                type: "POST",
                async: true,
                data: sendData,
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    if ($("config",result).attr("status") === "success"){
                        ShowFloatError($("#traceTip"), LangCtrl._L_("runTraceSuccess"),{},"success");
                    }else{
                        ShowFloatError($("#traceTip"), LangCtrl._L_("runTraceFailed"),{},"failed");
                    }
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    ptzDeleteTrace: function(){
        window.top.showLoading();
        var traceId = traceGrid.wbGrid("getSelectRows").data['@id'];
        var sendData = xmlHeader + "<traceInfo><id>" + traceId + "</id></traceInfo>";
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/PtzDeleteTrace",
                type: "POST",
                async: true,
                data: sendData,
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    if ($("config",result).attr("status") === "success"){
                        ptzTraceModule.getTraceData();
                        ShowFloatError($("#traceTip"), LangCtrl._L_("deleteTraceSuccess"),{},"success");
                    }else{
                        ShowFloatError($("#traceTip"), LangCtrl._L_("deleteTraceFailed"),{},"failed");
                    }
                    window.top.hideLoading();
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    }
};

var ptzTaskModule = {
    initPtzTaskCtrl: function(){
        if(saveZoneFlag){
            ptzPrivacyZoneModule.cancelPrivateZone();
        }
        $("#divPresetRight").css({left:"450px"});
        $("#resizeButton").hide();
        commonMethod.clearCountdown();
        $("#taskGrid").wbGrid({
            data: {
                colNames: [LangCtrl._L_("ID"),LangCtrl._L_("startTime"),LangCtrl._L_("endTime"),LangCtrl._L_("function"),LangCtrl._L_("number")],
                colModel: [
                    { name: "@id", index: "id", key: true,width: 40, align:"center"},
                    { name: "startTime", index: "startTime",width: 70, align: "center",sortable: false},
                    { name: "endTime", index: "endTime", width: 70, align: "center", sortable: false },
                    { name: "function", index: "function", width: 50, align: "center", sortable: false },
                    { name: "number", index: "number", width: 50, align: "center", sortable: false }
                ],
                rowList: []
            },
            view: {
                selectRow : true
            }
        });
        taskGrid = $("#taskGrid");

        $("#btnTaskCreate").unbind().click(function(){
            ptzTaskModule.addTask();
        });

        $("#btnTaskDelete").unbind().click(function(){
            ptzTaskModule.deletePtzTask();
        });

        $("#taskCheck").click(function(){
            if($(this).attr("checked")){
                ptzTaskModule.setPtzTaskStatus("true");
            }else{
                ptzTaskModule.setPtzTaskStatus("false");
            }
        });

        ptzTaskModule.getPtzTaskStatus();
        ptzTaskModule.getPtzTask();

    },
    getPtzTaskStatus: function(){
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/GetPtzTaskStatus",
                type: "POST",
                async: true,
                data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    statusXml = result;
                    $("#taskCheck").attr("checked", $("config>status", result).text().toLowerCase() === "true");
                    window.top.hideLoading();
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    setPtzTaskStatus: function(status){
        window.top.showLoading();
        $("config > status",statusXml).text(status);
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/SetPtzTaskStatus",
                type: "POST",
                async: true,
                data: statusXml,
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    if ($("config",result).attr("status") === "success"){
                        ShowFloatError($("#tipTopTask"), LangCtrl._L_("seStatusSuccess"),{},"success");
                    }else{
                        ShowFloatError($("#tipTopTask"), LangCtrl._L_("seStatusFailed"),{},"failed");
                    }
                    window.top.hideLoading();
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    addTask: function(){
        dialogAddTask = new DialogHelper({
            title: LangCtrl._L_("taskCreate"),
            content: "addTaskDialog.htm",
            width:  600,
            height: 470,
            contentType: "url",
            loadCallBack: AddTaskModule.initCtrl
        });
    },
    getPtzTask: function(){
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/GetPtzTask",
                type: "POST",
                async: true,
                data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    autoTaskXmlDoc = result;
                    var rowData = [];
                    var taskSize = $("config>taskInfo>item",autoTaskXmlDoc).size();
                    var taskMax = $("config>taskInfo",autoTaskXmlDoc).attr("maxCount") * 1;

                    $("config>taskInfo>item",autoTaskXmlDoc).each(function(i,ele){
                        rowData.push({
                            "@id":($(ele).attr("id")),
                            "startTime":$(">startTime",ele).text(),
                            "endTime":$(">endTime",ele).text(),
                            "function":LangCtrl._L_($(">function",ele).text()),
                            "number":$(">number",ele).text()
                        });
                    });

                    taskGrid.wbGrid("load", rowData);
                    window.top.hideLoading();
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    deletePtzTask: function(){
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/DeletePtzTask",
                type: "POST",
                async: true,
                data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    if ($("config",result).attr("status") === "success"){
                        ptzTaskModule.getPtzTask();
                        $("#taskCheck").attr("checked",false);
                        ShowFloatError($("#taskTip"), LangCtrl._L_("deleteTaskSuccess"),{},"success");
                    }else{
                        ShowFloatError($("#taskTip"), LangCtrl._L_("deleteTaskFailed"),{},"failed");
                    }
                    window.top.hideLoading();
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    }
};

var ptzAlarmModule = {
    initPtzAlarmCtrl: function(){
        if(saveZoneFlag){
            ptzPrivacyZoneModule.cancelPrivateZone();
        }
        $("#divPresetRight").css({left:"450px"});
        $("#resizeButton").hide();
        commonMethod.clearCountdown();
        $("#alarmInGrid").wbGrid({
            data: {
                colNames: [LangCtrl._L_("ID"),LangCtrl._L_("alarmInCon"),LangCtrl._L_("alarmInMode"),LangCtrl._L_("alarmCall"),LangCtrl._L_("outputEnable")],
                colModel: [
                    { name: "@id", index: "id", key: true,width: 40, align:"center"},
                    { name: "alarmInCon", index: "alarmInCon",width: 80, align: "center",sortable: false},
                    { name: "alarmInMode", index: "alarmInMode", width: 60, align: "center", sortable: false },
                    { name: "alarmCall", index: "alarmCall", width: 70, align: "center", sortable: false },
                    { name: "outputEnable", index: "outputEnable", width: 50, align: "center", sortable: false }
                ],
                rowList: []
            },
            view: {
                selectRow : true
            }
        });
        alarmInGrid = $("#alarmInGrid");

        ptzAlarmModule.alarmArr = [];
        ptzAlarmModule.getPtzAlarmIn();

        $("#btnAlarmInEdit").unbind().click(function(){
            ptzAlarmModule.setPtzAlarmIn();
        });
    },
    getPtzAlarmIn: function(){
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/GetPtzAlarmIn",
                type: "POST",
                async: true,
                data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    function getConName(type){
                        switch (type){
                            case "open":
                                return LangCtrl._L_("normallyOpen");
                            case "close":
                                return LangCtrl._L_("normallyClose");
                            default :
                                return type;
                        }
                    }
                    alarmXmlDoc = result;
                    var rowData = [];
                    var count = $("config>alarmIn",result).attr("count") * 1;

                    $("config>alarmIn>item",result).each(function(i,ele){
                        rowData.push({
                            "@id":($(ele).attr("id")),
                            "alarmInCon":getConName($(">alarmInCon",ele).text()),
                            "alarmInMode":LangCtrl._L_($(">alarmInMode",ele).text()),
                            "alarmCall":LangCtrl._L_("prePoint")+$(">alarmCall",ele).text(),
                            "outputEnable":LangCtrl._L_($(">outputEnable",ele).text())
                        });

                        ptzAlarmModule.alarmArr.push({
                            "@id":($(ele).attr("id")),
                            "alarmInCon":$(">alarmInCon",ele).text(),
                            "alarmInMode":$(">alarmInMode",ele).text(),
                            "alarmCall":$(">alarmCall",ele).text(),
                            "outputEnable":$(">outputEnable",ele).text()
                        })
                    });

                    alarmInGrid.wbGrid("load", rowData);
                    if (rowData.length >= 1) {
                        alarmInGrid.wbGrid("selectRowByIndex",0);
                    }
                    window.top.hideLoading();
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    setPtzAlarmIn: function(){
        ptzAlarmModule.editIndex = alarmInGrid.wbGrid("getSelectRows").index;
        dialogEditAlarm = new DialogHelper({
            title: LangCtrl._L_("alarmInEdit"),
            content: "editAlarmDialog.htm",
            width: 350,
            height: 240,
            zIndex: 302,
            contentType: "url",
            beforCloseEvent: function () {
//                if (dialogAddCruise) {
//                    DisplayOCX(document, false);
//                }
            },
            loadCallBack: EditAlarmModule.initCtrl
        });
    }
};

var ptzPrivacyZoneModule = {
    initPtzPrivacyZoneCtrl: function(){
        $("#divPresetRight").css({left:"450px"});
        $("#resizeButton").show();
        $("#privateGrid").wbGrid({
            data: {
                colNames: [LangCtrl._L_("ID"),LangCtrl._L_("color"),LangCtrl._L_("show"),LangCtrl._L_("action")],
                colModel: [
                    { name: "@id", index: "id", key: true,width: 50, align:"center"},
                    { name: "color", index: "color",width: 90, align: "center",sortable: false,  formatter: "select",formatterParam: {
                        mode: "always",
                        getItems: function(rowData) {
                            return $.map(rowData["colorArr"], function(element) {
                                var value = null;
                                var key =null;
                                for(var v in element){
                                    key = v;
                                    value = getColorName(key);
                                }
                                return { value: key, text: value };
                            });
                        },
                        events: [
                            {
                                name: "change",
                                handler: function (event) {
                                    event.stopPropagation();

                                    var ids = [];
                                    $.each($("#privateGrid").wbGrid("getRowDatas"), function(index, element) {
                                        if (!element["grid-row-disabled"]) {
                                            ids.push(element["@id"]);
                                        }
                                    });
                                    $("#privateGrid").wbGrid("setCellsValueByIds", ids, [ "color" ], [ $(this).val() ]);

                                    var rowData = $("#privateGrid").wbGrid("getRowDataByCellInput", this)["data"];
                                    var sendData = xmlHeader +  "<config version=\"1.0\" xmlns=\"http://www.ipc.com/ver10\"><item id=\"" + (rowData["@id"])+"\"><color>"+(rowData["color"])+"</color></item></config>";
                                    window.top.showLoading();
                                    try {
                                        XmlHttpClient.SendHttpRequest({
                                            url: serverBase + "/SetPtzPrivateInfo",
                                            type: "POST",
                                            async: true,
                                            data: sendData,
                                            beforeSend: XmlHttpClient.CommBeforeSend,
                                            callback: function(result) {
                                                if ($("config",result).attr("status") === "success"){
                                                    ShowFloatError($("#privateTip"), LangCtrl._L_("deleteTaskSuccess"),{},"success");
                                                }else{
                                                    ShowFloatError($("#privateTip"), LangCtrl._L_("deleteTaskFailed"),{},"failed");
                                                }
                                                window.top.hideLoading();
                                            }
                                        });
                                    }
                                    catch (ex) {
                                        alert(ex);
                                    }

                                }
                            }
                        ]
                    }},
                    { name: "show", index: "show", width: 90, align: "center", sortable: false,  formatter: "select",formatterParam: {
                        mode: "always",
                        getItems: function(rowData) {
                            return $.map(rowData["showArr"], function(element) {
                                var value = null;
                                var key =null;
                                for(var v in element){
                                    key = v;
                                    value = getOnOffName(key);
                                }
                                return { value: key, text: value };
                            });
                        },
                        events: [
                            {
                                name: "change",
                                handler: function (event) {
                                    var rowData = $("#privateGrid").wbGrid("getRowDataByCellInput", this)["data"];
                                    var sendData = xmlHeader +  "<config version=\"1.0\" xmlns=\"http://www.ipc.com/ver10\"><item id=\"" + (rowData["@id"])+"\"><show>"+(rowData["show"])+"</show></item></config>";
                                    window.top.showLoading();
                                    try {
                                        XmlHttpClient.SendHttpRequest({
                                            url: serverBase + "/SetPtzPrivateInfo",
                                            type: "POST",
                                            async: true,
                                            data: sendData,
                                            beforeSend: XmlHttpClient.CommBeforeSend,
                                            callback: function(result) {
                                                if ($("config",result).attr("status") === "success"){
                                                    ShowFloatError($("#privateTip"), LangCtrl._L_("deleteTaskSuccess"),{},"success");
                                                }else{
                                                    ShowFloatError($("#privateTip"), LangCtrl._L_("deleteTaskFailed"),{},"failed");
                                                }
                                                window.top.hideLoading();
                                            }
                                        });
                                    }
                                    catch (ex) {
                                        alert(ex);
                                    }
                                }
                            }
                        ]
                    } },
                    { name: "action", index: "action", width: 170, align: "center", sortable: false, formatter: "custom",
                        formatterParam: {
                            init: function ($cell, rowData) {
                                var btnDeleteCurrent = $("<button class=\"cfgBtn\" style=\"text-align:center;\">"+ LangCtrl._L_("deleteCurrent")+"</button>");
                                btnDeleteCurrent.unbind().click(function(event) {
                                    ptzPrivacyZoneModule.deletePtzCurPrivate(rowData["@id"]);
                                    event.stopPropagation();
                                }).appendTo($cell);

                                return $cell;
                            }
                        }
                    }
                ],
                rowList: []
            },
            view: {
                selectRow : true
            },
            callback:{
                onDblClickCell: function (e, gridId, rowIndex, rowData) {
                    ptzPrivacyZoneModule.showCurrentPrivate(rowData["@id"]);
                }
            }
        });
        privateGrid = $("#privateGrid");

        ptzPrivacyZoneModule.getPtzPrivateInfo();

        $("#btnDeleteAll").unbind().click(function(){
            ptzPrivacyZoneModule.deleteAllPtzPrivateInfo();
        });

        $("#resize").unbind().click(function(){
            ptzPrivacyZoneModule.resizePrivateZone();
        });

        $("#savePrivate").unbind().click(function(){
            ptzPrivacyZoneModule.savePrivateSize();
        });

        $("#cancelPrivate").unbind().click(function(){
            ptzPrivacyZoneModule.cancelPrivateSize();
        });
    },
    showCurrentPrivate: function(id){
        var sendData = xmlHeader +  "<config version=\"1.0\" xmlns=\"http://www.ipc.com/ver10\"><item id=\"" + (id)+"\"></item></config>";
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/ShowCurrentPrivate",
                type: "POST",
                async: true,
                data: sendData,
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    if ($("config",result).attr("status") === "success"){
                        ShowFloatError($("#privateTip"), LangCtrl._L_("deleteTaskSuccess"),{},"success");
                    }else{
                        ShowFloatError($("#privateTip"), LangCtrl._L_("deleteTaskFailed"),{},"failed");
                    }
                    window.top.hideLoading();
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    getPtzPrivateInfo: function(){
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/GetPtzPrivateInfo",
                type: "POST",
                async: true,
                data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    var colorArr = [];
                    $("config>types>color>enum", result).each(function(i, item) {
                        var typeModeKey = $(item).text();
                        var typeModeValue = getColorName(typeModeKey);
                        var object ={};
                        switch (typeModeKey){
                            case 'black':
                                object = {black:typeModeValue};
                                break;
                            case 'white':
                                object = {white:typeModeValue};
                                break;
                            case 'red':
                                object = {red:typeModeValue};
                                break;
                            case 'green':
                                object = {green:typeModeValue};
                                break;
                            case 'blue':
                                object = {blue:typeModeValue};
                                break;
                            case 'cyan':
                                object = {cyan:typeModeValue};
                                break;
                            case 'yellow':
                                object = {yellow:typeModeValue};
                                break;
                            case 'magen':
                                object = {magen:typeModeValue};
                                break;
                        }
                        colorArr.push(object);
                    });

                    var showArr = [];
                    $("config>types>show>enum", result).each(function(i, item) {
                        var typeModeKey = $(item).text();
                        var typeModeValue = getOnOffName(typeModeKey);
                        var object ={};
                        switch (typeModeKey){
                            case 'on':
                                object = {on:typeModeValue};
                                break;
                            case 'off':
                                object = {off:typeModeValue};
                                break;
                        }
                        showArr.push(object);
                    });

                    var rowData = [];
                    $("config>privateInfo>item",result).each(function(i,ele){
                        rowData.push({
                            "@id":($(ele).attr("id")),
                            "color":$(">color",ele).text(),
                            "colorArr":colorArr,
                            "show":$(">show",ele).text(),
                            "showArr":showArr
                        });
                    });

                    privateGrid.wbGrid("load", rowData);
                    if (rowData.length >= 1) {
                        privateGrid.wbGrid("selectRowByIndex",0);
                    }
                    window.top.hideLoading();
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    setPtzPrivateInfo: function(id,value){
        var sendData = xmlHeader +  "<config version=\"1.0\" xmlns=\"http://www.ipc.com/ver10\"><item id=\"" + (id)+"\"></item></config>";
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/ShowCurrentPrivate",
                type: "POST",
                async: true,
                data: sendData,
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    if ($("config",result).attr("status") === "success"){
                        ShowFloatError($("#privateTip"), LangCtrl._L_("deleteTaskSuccess"),{},"success");
                    }else{
                        ShowFloatError($("#privateTip"), LangCtrl._L_("deleteTaskFailed"),{},"failed");
                    }
                    window.top.hideLoading();
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    deletePtzCurPrivate: function(id){
        var sendData = xmlHeader +  "<config version=\"1.0\" xmlns=\"http://www.ipc.com/ver10\"><item id=\"" + id+"\"></item></config>";
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/DeleteCurPtzPrivate",
                type: "POST",
                async: true,
                data: sendData,
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    if ($("config",result).attr("status") === "success"){
                        ShowFloatError($("#privateTip"), LangCtrl._L_("deleteTaskSuccess"),{},"success");
                    }else{
                        ShowFloatError($("#privateTip"), LangCtrl._L_("deleteTaskFailed"),{},"failed");
                    }
                    window.top.hideLoading();
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    deleteAllPtzPrivateInfo: function(){
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/DeleteAllPtzPrivate",
                type: "POST",
                async: true,
                data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    if ($("config",result).attr("status") === "success"){
                        ShowFloatError($("#privateTip"), LangCtrl._L_("deleteTaskSuccess"),{},"success");
                    }else{
                        ShowFloatError($("#privateTip"), LangCtrl._L_("deleteTaskFailed"),{},"failed");
                    }
                    window.top.hideLoading();
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    resizePrivateZone: function(){
        var id = privateGrid.wbGrid("getSelectRows")["data"]["@id"];
        var sendData = xmlHeader +  "<config version=\"1.0\" xmlns=\"http://www.ipc.com/ver10\"><item id=\"" + id+"\"></item></config>";
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/ResizePrivateZone",
                type: "POST",
                async: true,
                data: sendData,
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    if ($("config",result).attr("status") === "success"){
                        saveZoneFlag = true;
                        ShowFloatError($("#privateTip"), LangCtrl._L_("deleteTaskSuccess"),{},"success");
                    }else{
                        ShowFloatError($("#privateTip"), LangCtrl._L_("deleteTaskFailed"),{},"failed");
                    }
                    window.top.hideLoading();
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    savePrivateSize: function(){
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/SavePrivateSize",
                type: "POST",
                async: true,
                data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    if ($("config",result).attr("status") === "success"){
                        saveZoneFlag = false;
                        ShowFloatError($("#privateTip"), LangCtrl._L_("deleteTaskSuccess"),{},"success");
                    }else{
                        ShowFloatError($("#privateTip"), LangCtrl._L_("deleteTaskFailed"),{},"failed");
                    }
                    window.top.hideLoading();
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    cancelPrivateSize: function(){
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/CancelPrivateSize",
                type: "POST",
                async: true,
                data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    if ($("config",result).attr("status") === "success"){
                        ShowFloatError($("#privateTip"), LangCtrl._L_("deleteTaskSuccess"),{},"success");
                    }else{
                        ShowFloatError($("#privateTip"), LangCtrl._L_("deleteTaskFailed"),{},"failed");
                    }
                    window.top.hideLoading();
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    cancelPrivateZone: function(){
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/CancelPrivateSize",
                type: "POST",
                async: true,
                data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    if($("config",result).attr("status") === "success"){
                        saveZoneFlag =false;
                    }
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    }
};

function getColorName(value) {
    switch (value) {
        case "black":
            return LangCtrl._L_("black");
        case "white":
            return LangCtrl._L_("white");
        case "red":
            return LangCtrl._L_("red");
        case "green":
            return LangCtrl._L_("green");
        case "blue":
            return LangCtrl._L_("blue");
        case "cyan":
            return LangCtrl._L_("cyan");
        case "yellow":
            return LangCtrl._L_("yellow");
        case "magen":
            return LangCtrl._L_("magen");
    }
}

function getOnOffName(value) {
    switch (value) {
        case "on":
            return LangCtrl._L_("on");
        case "off":
            return LangCtrl._L_("off");
    }
}

var ptzMotionModule = {
    initPtzMotionCtrl: function(){

    }
};

var ptzGuardModule = {
    initPtzGuardCtrl: function(){
        if(saveZoneFlag){
            ptzPrivacyZoneModule.cancelPrivateZone();
        }
        $("#divPresetRight").css({left:"400px"});
        $("#resizeButton").hide();
        commonMethod.clearCountdown();
        $("#btnBrushRun").unbind().click(function(){
            ptzBrushModule.runBrush();
        });
        $("#btnGuardSave").unbind().click(function(){
            ptzGuardModule.setPtzGuardInfo();
        });

        ptzGuardModule.getPtzGuardInfo();
    },
    getPtzGuardInfo: function(){
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/GetPtzGuardInfo",
                type: "POST",
                async: true,
                data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    guardXmlDoc = result;

                    var guardSwitch = $("config >guardInfo>switch",guardXmlDoc).text();
                    $("#guardCheck").attr("checked",$("config>guardInfo>switch", result).text().toLowerCase() === "true");

                    var guardLocation =  $("#guardLocation");
                    guardLocation.empty();
                    $("config>types>location>enum",result).each(function(i,ele){
                        $("<option value=\""+ $(ele).text() +"\" title=\"" + LangCtrl._L_($(ele).text()) + "\">"+ LangCtrl._L_($(ele).text()) +"</option>").appendTo(guardLocation);
                    });
                    guardLocation.val( LangCtrl._L_($("config>guardInfo>location",result)).text());
                    guardLocation.change(function(){
                        var flag = $(this).val();
                        var minValue,maxValue=0;
                        var numberFunc = $("#guardNumber");
                        switch(flag){
                            case "RSC" : minValue = 0;maxValue=0; numberFunc.val(0);initNumberInput(numberFunc, { minValue: 0, maxValue: 0 });break;
                            case "ASC" : minValue = 0;maxValue=0; numberFunc.val(0);initNumberInput(numberFunc, { minValue: 0, maxValue: 0 });break;
                            case "PRE" : minValue = $("config>types>pre",guardXmlDoc).attr("min");maxValue=$("config>types>pre",guardXmlDoc).attr("max");numberFunc.val(minValue);initNumberInput(numberFunc, { minValue: minValue, maxValue: maxValue });break;
                            case "CRU" : minValue = $("config>types>cru",guardXmlDoc).attr("min");maxValue=$("config>types>cru",guardXmlDoc).attr("max");numberFunc.val(1);initNumberInput(numberFunc, { minValue: minValue, maxValue: maxValue });break;
                            case "TRA" : minValue = $("config>types>tra",guardXmlDoc).attr("min");maxValue=$("config>types>tra",guardXmlDoc).attr("max");numberFunc.val(1);initNumberInput(numberFunc, { minValue: minValue, maxValue: maxValue });break;
                        }
                    });

                    var numberG = $("#guardNumber");
                    var minValueG,maxValueG=0;
                    var flagG = $("config>guardInfo>location",result).text();
                    switch(flagG){
                        case "RSC" : minValueG = 0;maxValueG=0; numberG.val(0);initNumberInput(numberG, { minValue: 0, maxValue: 0 });break;
                        case "ASC" : minValueG = 0;maxValueG=0; numberG.val(0);initNumberInput(numberG, { minValue: 0, maxValue: 0 });break;
                        case "PRE" : minValueG = $("config>types>pre",guardXmlDoc).attr("min");maxValueG=$("config>types>pre",guardXmlDoc).attr("max");numberG.val(minValueG);initNumberInput(numberG, { minValue: minValueG, maxValue: maxValueG });break;
                        case "CRU" : minValueG = $("config>types>cru",guardXmlDoc).attr("min");maxValueG=$("config>types>cru",guardXmlDoc).attr("max");numberG.val(1);initNumberInput(numberG, { minValue: minValueG, maxValue: maxValueG });break;
                        case "TRA" : minValueG = $("config>types>tra",guardXmlDoc).attr("min");maxValueG=$("config>types>tra",guardXmlDoc).attr("max");numberG.val(1);initNumberInput(numberG, { minValue: minValueG, maxValue: maxValueG });break;
                    }
                    numberG.val($("config>guardInfo>number",result).text());

                   var waitDuration = $("#waitDuration");
                   initNumberInput(waitDuration, { minValue: $("config>types>waitTime",guardXmlDoc).attr("min"), maxValue: $("config>types>waitTime",guardXmlDoc).attr("max") });
                   waitDuration.val($("config>guardInfo>waitTime",result).text());

                    window.top.hideLoading();
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    getSaveData: function(){
        $("config>guardInfo>location",guardXmlDoc).text($("#guardLocation").val());
        $("config>guardInfo>number",guardXmlDoc).text($("#guardNumber").val());

        $("config>guardInfo>waitTime",guardXmlDoc).text($("#waitDuration").val());

        if($("#guardCheck").attr("checked")){
            $("config >guardInfo>switch",guardXmlDoc).text("true");
        }else{
            $("config >guardInfo>switch",guardXmlDoc).text("false");
        }
        return XMLDoc2XMLStr(guardXmlDoc);
    },
    setPtzGuardInfo: function(){
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/SetPtzGuardInfo",
                type: "POST",
                async: true,
                data: ptzGuardModule.getSaveData(),
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    if ($("config",result).attr("status") === "success"){
                        ShowFloatError($("#guardTip"), LangCtrl._L_("saveSuccess"),{},"success");
                    }else{
                        ShowFloatError($("#guardTip"), LangCtrl._L_("saveFailed"),{},"failed");
                    }
                    window.top.hideLoading();
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    }
};

var ptzBrushModule = {
    initPtzBrushCtrl: function(){
        if(saveZoneFlag){
            ptzPrivacyZoneModule.cancelPrivateZone();
        }
        $("#divPresetRight").css({left:"340px"});
        $("#btnBrushRun").unbind().click(function(){
            ptzBrushModule.runBrush();
        });
        $("#btnBrushStop").unbind().click(function(){
            ptzBrushModule.stopBrush();
        });
        $("#btnBrushSave").unbind().click(function(){
            ptzBrushModule.ptzSetBrushInfo();
        });
        ptzBrushModule.getBrushInfo();
    },
    getBrushInfo: function(){
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/PtzGetBrushInfo",
                type: "POST",
                async: true,
                data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    brushXmlDoc = result;

                    var brushSpeed =  $("#brushSpeed");
                    brushSpeed.empty();
                    $("config>types>speed>enum",result).each(function(i,ele){
                        $("<option value=\""+ $(ele).text() +"\">"+ LangCtrl._L_($(ele).text()) +"</option>").appendTo(brushSpeed);
                    });
                    brushSpeed.val( LangCtrl._L_($("config>brush>speed",result)).text());

                    var brushDuration = $("#brushDuration");
                    brushDuration.empty();
                    $("config>types>runtime>enum",result).each(function(i,ele){
                        $("<option value=\""+ $(ele).text() +"\">"+ LangCtrl._L_($(ele).text()) +"</option>").appendTo(brushDuration);
                    });
                    brushDuration.val($("config>brush>duration",result).text());

                    window.top.hideLoading();
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    getPtzSetBrushInfoData: function(){
        var brushSpeed =  $("#brushSpeed").val();
        var duration =  $("#brushDuration").val();
        $("config>brush>speed",brushXmlDoc).text(brushSpeed);
        $("config>brush>duration",brushXmlDoc).text(duration);
        return XMLDoc2XMLStr(brushXmlDoc);
    },
    ptzSetBrushInfo: function(){
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/PtzSetBrushInfo",
                type: "POST",
                async: true,
                data: ptzBrushModule.getPtzSetBrushInfoData(),
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    if ($("config",result).attr("status") === "success"){
                        ShowFloatError($("#brushTip"), LangCtrl._L_("saveSuccess"),{},"success");
                    }else{
                        ShowFloatError($("#brushTip"), LangCtrl._L_("saveFailed"),{},"failed");
                    }
                    window.top.hideLoading();
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    runBrush:function(){
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/RunBrush",
                type: "POST",
                async: true,
                data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    if ($("config",result).attr("status") === "success"){
                        ShowFloatError($("#brushTip"), LangCtrl._L_("runBrushSuccess"),{},"success");
                    }else{
                        ShowFloatError($("#brushTip"), LangCtrl._L_("runBrushFailed"),{},"failed");
                    }
                    window.top.hideLoading();
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    stopBrush: function(){
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/StopBrush",
                type: "POST",
                async: true,
                data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    if ($("config",result).attr("status") === "success"){
                        ShowFloatError($("#brushTip"), LangCtrl._L_("runBrushSuccess"),{},"success");
                    }else{
                        ShowFloatError($("#brushTip"), LangCtrl._L_("runBrushFailed"),{},"failed");
                    }
                    window.top.hideLoading();
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    }
};


//OCX调用js方法
function NotifyResultToJs(strXMLFormat, lStrLen) {
    var $xmlDoc = $(XMLStr2XMLDoc(strXMLFormat));

    // OCX已创建好窗口，通知可以登录了
    if ($("statenotify[type=\"Login\"]", $xmlDoc).length > 0) {
        var userInfo = Decryption($.cookie("auInfo"));
        var userInfoArr = userInfo.split(":");
        // 设置登录信息
        var username = userInfoArr[0];
        var password = userInfoArr[1];
        var ip = serverIp;
        var port = netPort;
        var id = "";
        var sendXML = OCX_XML_SetLoginInfo(username, password, ip, port, id);
        NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);

        // 设置预览码流索引
        var sendXML = OCX_XML_SetStreamType(2);
        NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
    }

    if ($("statenotify[type=\"GetOriginalWH\"]", $xmlDoc).length > 0) {
        $("#divOCX").css({width:"380px",height:"280px"});
    }

    var connectstate = $("statenotify[type='connectstate']",$xmlDoc);
    if(connectstate.length > 0){
        if($(">status", connectstate).text() === "success"){
            window.top.hideLoading();
        }else{
            window.top.showLoading(window.top.LangCtrl._L_("connectError"));
        }
    }

    var Connect  = $("statenotify[type='Connect']",$xmlDoc);
    if(Connect.length > 0){
        if($(">status", Connect).text() === "limit"){
            window.top.MsgBoxHelper.Show("info", LangCtrl._L_("infoTip"), LangCtrl._L_("limit"), null);
        }
    }
}