﻿var xmlDoc;

$(function() {
	ProtocolModule.initCtrl();
	ProtocolModule.getData();
});

var ProtocolModule = {
	mapping: {
		cboProtocol: "config>ptzInfo>protocol",
		txtAddress: "config>ptzInfo>address",
		cboBaudRate: "config>ptzInfo>baudRate"
	},
	initCtrl: function() {
		$("#btnSave").click(function(event) {
			ProtocolModule.setData();
		});
	},
	getData: function() {
		window.top.showLoading();
		try {
			XmlHttpClient.SendHttpRequest({
				url: serverBase + "/PtzGetProtocolConfig",
				type: "POST",
				async: true,
				data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
				callback: function(result) {
					xmlDoc = result;
					ProtocolModule.bindCtrlData();
					XmlHttpClient.BindPageByXml(ProtocolModule.mapping, xmlDoc);
					window.top.hideLoading();
				}
			});
		}
		catch (ex) {
			alert(ex);
		}
	},
	bindCtrlData: function() {
		function getProtocolType(value) {
			switch (value) {
				default:
					return value;
			}
		}

		function getBaudRate(value) {
			switch (value) {
				default:
					return value;
			}
		}

		var cboProtocol = $("#cboProtocol");
		cboProtocol.empty();
		$("config>types>ptzProtocol>enum", xmlDoc).each(function(index, element) {
			$("<option value=" + $(element).text() + ">" + getProtocolType($(element).text()) + "</option>").appendTo(cboProtocol);
		});

		var cboBaudRate = $("#cboBaudRate");
		cboBaudRate.empty();
		$("config>types>baudRate>enum", xmlDoc).each(function(index, element) {
			$("<option value=" + $(element).text() + ">" + getBaudRate($(element).text()) + "</option>").appendTo(cboBaudRate);
		});
	},
	setData: function() {
		window.top.showLoading();
		try {
			XmlHttpClient.SendHttpRequest({
				url: serverBase + "/PtzSetProtocolConfig",
				type: "POST",
				async: true,
				data: XmlHttpClient.GetXmlByPage(ProtocolModule.mapping, xmlDoc),
                beforeSend: XmlHttpClient.CommBeforeSend,
				callback: function(result) {
					window.top.hideLoading();
					commSaveResponseHadler(result);
				}
			});
		}
		catch (ex) {
			alert(ex);
		}
	}
};