﻿var xmlDoc;
$(function(){
    $("#divParent").tab({
        map: [{ "tab": "liPtzSettings", "content": "divPtzInfoTrigger", init: ptzSettingsModule.initPtzSettingsCtrl },
            { "tab": "liPtzOthers", "content": "divPtzOtherTrigger", init: ptzSettingsModule.initPtzOthersCtrl }]
    });
    $("#divParent").tab("selectLastTab");
});

var ptzSettingsModule = {
    initPtzSettingsCtrl: function(){
        $("#btnSave").unbind().click(function(){
            ptzSettingsModule.setPtzSettingsData();
        });

        getDeviceInfo(function(result){
            if ($("config>deviceInfo>supportKeyBoardControl", result).text() == "true") {
                $("#communicationTr").show();
            }
        });
        ptzSettingsModule.getPtzSettingsData();
    },
    initPtzOthersCtrl:function(){
        $("#createPwdBtn").unbind().click(function(){
            ptzSettingsModule.addPtzPassword();
        });
        window.top.hideLoading();
    },
    getPtzPubInfo: function(){
        window.top.showLoading();
        var xml = xmlHeader + "<config version=\"1.0\" xmlns=\"http://www.ipc.com/ver10\">" +
        "<idType>" + $("#IDType").val() + "</idType>" +
        "</config>";

        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/GetPtzPubInfo" ,
                type: "POST",
                async: true,
                data: xml,
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    var nodeDemo = $("config>rs485>demoId", result);
                    var min =  nodeDemo.attr("min");
                    var max =  nodeDemo.attr("max");
                    $("#DomeId").val( nodeDemo.text() == ""? "1" : nodeDemo.text());

                    initNumberInput($("#DomeId"), { minValue: min, maxValue: max });

                    $("#protocol").val($("config>rs485>protocol", result).text());
                    $("#baudRate").val($("config>rs485>baudRate", result).text());

                    window.top.hideLoading();
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    getPtzSettingsData: function(){
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/GetPtzConfig" ,
                type: "POST",
                async: true,
                data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    xmlDoc = result;

                    var autoExitTime = $("#autoExitTime");
                    autoExitTime.empty();
                    $("config>types>autoExitTime>enum", result).each(function(i, ele) {
                        $("<option value=" + $(ele).text() + ">" +  LangCtrl._L_($(ele).text()) + "</option>").appendTo(autoExitTime);
                    });
                    autoExitTime.val($("config>ptzSettings>autoExitTime", result).text());

                    var languageSetup = $("#languageSetup");
                    languageSetup.empty();
                    $("config>types>language>enum", result).each(function(i, ele) {
                        $("<option value=" + $(ele).text() + ">" + LangCtrl._L_($(ele).text()) + "</option>").appendTo(languageSetup);
                    });
                    languageSetup.val($("config>ptzSettings>language", result).text());

                    var autoPtzFlip = $("#autoPtzFlip");
                    autoPtzFlip.empty();
                    var autoPtzFlipFlag =["true","false"];
                    for(var i= 0,len = autoPtzFlipFlag.length;i<len;i++){
                        $("<option value=" + autoPtzFlipFlag[i] + ">" + LangCtrl._L_(autoPtzFlipFlag[i]) + "</option>").appendTo(autoPtzFlip);
                    }
                    autoPtzFlip.val($("config>ptzSettings>autoPtzFlip", result).text());

                    var idType = $("#IDType");
                    idType.empty();
                    $("config>types>idType>enum", result).each(function(i, ele) {
                        $("<option value=" + $(ele).text() + ">" +  LangCtrl._L_($(ele).text()) + "</option>").appendTo(idType);
                    });
                    idType.val($("config>ptzSettings>rs485>idType", result).text());
                    if(idType.val() == "HW"){
                        $("#DomeId,#protocol,#baudRate").attr("disabled", true);
                    }
                    idType.change(function(){
                        if($(this).val() == "SW"){
                            $("#DomeId,#protocol,#baudRate").attr("disabled", false);
                        }else if($(this).val() == "HW"){
                            $("#DomeId,#protocol,#baudRate").attr("disabled", true);
                        }
                        ptzSettingsModule.getPtzPubInfo();
                    });

                    var nodeDemo = $("config>ptzSettings>rs485>demoId", result);
                    var min =  nodeDemo.attr("min");
                    var max =  nodeDemo.attr("max");
                    $("#DomeId").val( nodeDemo.text() == ""? "1" : nodeDemo.text());

                    initNumberInput($("#DomeId"), { minValue: min, maxValue: max });

                    var protocol = $("#protocol");
                    protocol.empty();
                    $("config>types>protocol>enum", result).each(function(i, ele) {
                        $("<option value=" + $(ele).text() + ">" +  $(ele).text() + "</option>").appendTo(protocol);
                    });
                    protocol.val($("config>ptzSettings>rs485>protocol", result).text());

                    var baudRate = $("#baudRate");
                    baudRate.empty();
                    $("config>types>baudRate>enum", result).each(function(i, ele) {
                        $("<option value=" + $(ele).text() + ">" +  $(ele).text() + "</option>").appendTo(baudRate);
                    });
                    baudRate.val($("config>ptzSettings>rs485>baudRate", result).text());
                    window.top.hideLoading();
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    getSavePtzSettings:function(){
        $("config> ptzSettings>autoPtzFlip",xmlDoc).text($("#autoPtzFlip").val());
        $("config> ptzSettings>language",xmlDoc).text($("#languageSetup").val());
        $("config> ptzSettings>autoExitTime ",xmlDoc).text($("#autoExitTime").val());
        $("config> ptzSettings>rs485>idType",xmlDoc).text($("#IDType").val());
        $("config> ptzSettings>rs485>demoId",xmlDoc).text($("#DomeId").val());
        $("config> ptzSettings>rs485>protocol ",xmlDoc).empty().append(xmlDoc.createCDATASection($("#protocol").val()));
        $("config> ptzSettings>rs485>baudRate ",xmlDoc).text($("#baudRate").val());
        return XMLDoc2XMLStr(xmlDoc);
    },
    setPtzSettingsData:function(){
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/SetPtzConfig",
                type: "POST",
                async: true,
                data: ptzSettingsModule.getSavePtzSettings(),
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    window.top.hideLoading();
                    commSaveResponseHadler(result);
                }
            });
        } catch (ex) {
            alert(ex);
        }
    },
    verifyPassWord: function(){
        ClearFloatError();
        if (!/^[0-9]*$/.test($("#txtPassword").val())) {
            ShowFloatError($("#txtPassword"), LangCtrl._L_("onlyNum"));
            return false;
        }
        if ($("#txtPassword").val() != $("#txtConfirmPassword").val()) {
            ShowFloatError($("#txtConfirmPassword"), LangCtrl._L_("passwordNotEqualTip"));
            return false;
        }
        return true;
    },
    getPtzPwdData: function(){
        var ptzXml = xmlHeader +"<config version=\"1.0\" xmlns=\"http://www.ipc.com/ver10\">" + "<ptzPassword><password type=\"string\"><![CDATA[";
        ptzXml += PrivEncrypt([$("#txtPassword").val()],23784501) + "]]></password></ptzPassword></config>";
        return ptzXml;
    },
    addPtzPassword: function(){
        window.top.showLoading();
        if (!ptzSettingsModule.verifyPassWord()) {
            window.top.hideLoading();
            return false;
        }
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/CreatePtzPwd",
                type: "POST",
                async: true,
                data: ptzSettingsModule.getPtzPwdData(),
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    window.top.hideLoading();
                    if ($("config", result).attr("status") == "success") {
                        $("#txtPassword,#txtConfirmPassword").val("");
                        window.top.MsgBoxHelper.Show("ok", LangCtrl._L_("infoTip"), LangCtrl._L_("saveSuccess"), null);
                    } else {
                        window.top.MsgBoxHelper.Show("error", LangCtrl._L_("errorTip"), LangCtrl._L_("saveFailed"), null);
                    }
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    }
};
