﻿var context;

var AddUserModule = {
	toggle: function(enabled) {
		$("#txtBindingMac", context).attr("disabled", !enabled);
	},
	initCtrl: function(c) {
		context = c;

		$("#txtBindingMac", context).macInput({ enable: false });

		$("#chkBindingMac", context).click(function() {
			AddUserModule.toggle($(this).attr("checked") == "checked");
		});

		$("#btnOK", context).click(function() {
			AddUserModule.addData();
		});

		$("#btnCancel", context).click(function() {
			AddUserModule.close();
		});

		$("#txtUserName", context).focus();

		AddUserModule.bindCtrlData();

		LangCtrl.translate($("#tbContent_addUser", context));
	},
	bindCtrlData: function() {
		function getUserType(value) {
			switch (value) {
				case "advance":
					return LangCtrl._L_("advanceUser");
				case "normal":
					return LangCtrl._L_("normalUser");
				default:
					return LangCtrl._L_(value);
			}
		}
		$("#cboUserType", context).empty();
		$("config>types>userType>enum", xmlDoc).each(function(i, ele) {
			$("<option value=" + $(ele).text() + ">" + getUserType($(ele).text()) + "</option>").appendTo($("#cboUserType", context));
		});

//		$("#txtUserName", context).attr("maxlength", $("config>user>itemType>userName", xmlDoc).attr("maxLen") * 1);
//		$("#txtPassword,#txtConfirmPassword", context).attr("maxlength", $("config>user>itemType>password", xmlDoc).attr("maxLen") * 1);
	},
	verification: function() {
		ClearFloatError();
        var nameMaxLen = $("config>user>itemType>userName", xmlDoc).attr("maxLen");
        var passwordMaxLen = $("config>user>itemType>password", xmlDoc).attr("maxLen");
        var $txtUserName = $("#txtUserName",context);

        if ($.trim($txtUserName.val()).length == 0) {
            if (checkUserName($txtUserName.val())) {
                ShowFloatError($txtUserName, LangCtrl._L_("invalidChar"));
                return false;
            }else{
                ShowFloatError($txtUserName, LangCtrl._L_("userNameNotEmptyTip"));
                return false;
            }
        }
        else {

            var flag = false;
            $("config>user>item",xmlDoc).each(function(i,ele){
                if($(">userName",ele).text() == $txtUserName.val()){
                    flag = true;
                    return false;
                }
            });

            if(flag){
                ShowFloatError($txtUserName, LangCtrl._L_("userNameExist"));
                return false;
            }

            if(($txtUserName.val()+"").getBytesLength() > nameMaxLen){
                ShowFloatError($txtUserName, LangCtrl._L_("nameTooLong"));
                return false;
            }

            if (checkUserName($txtUserName.val())) {
                ShowFloatError($txtUserName, LangCtrl._L_("invalidChar"));
                return false;
            }

            if(/^.*[\u4e00-\u9fa5]+.*$/i.test($txtUserName.val())){
                ShowFloatError($txtUserName, LangCtrl._L_("invalidChar"));
                return false;
            }
        }

        var $txtPassword = $("#txtPassword", context);
        if (!checkPwd($txtPassword.val())) {
            ShowFloatError($txtPassword, LangCtrl._L_("TipPWDChar"));
            return false;
        }
        if ($txtPassword.val() != $("#txtConfirmPassword", context).val()) {
            ShowFloatError($("#txtConfirmPassword", context), LangCtrl._L_("passwordNotEqualTip"));
            return false;
        }
        if(($txtPassword.val()+"").getBytesLength() > passwordMaxLen){
            ShowFloatError($txtPassword, LangCtrl._L_("passwordTooLong"));
            return false;
        }
		return true;
	},
	getAddData: function() {
		var addXmlDoc = XMLStr2XMLDoc(XMLDoc2XMLStr(xmlDoc));
		$("config>user>item", addXmlDoc).remove();
		$("config>user", addXmlDoc).append(
			$(addXmlDoc.createElement("item")).append(
				$(addXmlDoc.createElement("userType")).attr("type","userType").append(
					$(addXmlDoc.createTextNode($("#cboUserType", context).val()))
				)
			).append(
				$(addXmlDoc.createElement("userName")).attr("type","string").attr("maxLen","19").append(
					$(addXmlDoc.createCDATASection($("#txtUserName", context).val()))
				)
			).append(
				$(addXmlDoc.createElement("password")).attr("type","string").attr("maxLen","19").append(
					$(addXmlDoc.createCDATASection(PrivEncrypt([$("#txtPassword", context).val()],23784501)))
				)
			).append(
				$(addXmlDoc.createElement("macBindSwitch")).attr("type","boolean").append(
					$(addXmlDoc.createTextNode($("#chkBindingMac", context).attr("checked") == "checked" ? "true" : "false"))
				)
			).append(
				$(addXmlDoc.createElement("clientMacAddr")).attr("type","string").attr("minLen","17").attr("maxLen","17").append(
					$(addXmlDoc.createCDATASection($("#txtBindingMac", context).val()))
				)
			)
		);
		return XMLDoc2XMLStr(addXmlDoc);
	},
	addData: function() {
		window.top.showLoading();
		if (!AddUserModule.verification()) {
			window.top.hideLoading();
			return false;
		}
		try {
			XmlHttpClient.SendHttpRequest({
				url: serverBase + "/AddUser",
				type: "POST",
				async: true,
				data: AddUserModule.getAddData(),
                beforeSend: XmlHttpClient.CommBeforeSend,
				callback: function(result) {
					window.top.hideLoading();
                    if ($("config", result).attr("status") == "success") {
                        window.top.MsgBoxHelper.Show("ok", LangCtrl._L_("infoTip"), LangCtrl._L_("saveSuccess"), null);
                        UserModule.getData();
                        AddUserModule.close();
                    } else {
                        window.top.MsgBoxHelper.Show("error", LangCtrl._L_("errorTip"), LangCtrl._L_("saveFailed"), null);
                        AddUserModule.close();
                    }
				}
			});
		}
		catch (ex) {
			alert(ex);
		}
	},
	close: function() {
		dialog_addUser.CloseDialog();
	}
};