﻿var context;
var EditUserModule = {
    selfFlag:true,
    mapping: {
        txtUserName: "config>user>item>userName",
        chkBindingMac: "config>user>item>macBindSwitch",
        txtBindingMac: "config>user>item>clientMacAddr"
    },
    togglePassword: function (enabled) {
        $("#txtOldPassword", context).attr("disabled", !enabled);
        $("#txtNewPassword", context).attr("disabled", !enabled);
        $("#txtConfirmPassword", context).attr("disabled", !enabled);
    },
    toggleMac: function (enabled) {
        $("#txtBindingMac", context).attr("disabled", !enabled);
    },
    initCtrl: function (c) {
        context = c;

        if(Decryption($.cookie("auInfo")).split(":")[0] != $("config>user>item>userName:eq(" + UserModule.editIndex + ")", xmlDoc).text()){
            EditUserModule.selfFlag = true;
           $("#oldPwd",context).hide();
        }else{
            EditUserModule.selfFlag = false;
           $("#oldPwd",context).show();
        }

        $("#txtBindingMac", context).macInput();

        $("#chkEditPassword", context).click(function () {
            EditUserModule.togglePassword($(this).attr("checked") == "checked");
        });

        $("#chkBindingMac", context).click(function () {
            EditUserModule.toggleMac($(this).attr("checked") == "checked");
        });

        $("#btnOK", context).click(function () {
            EditUserModule.setData();
        });

        $("#btnCancel", context).click(function () {
            EditUserModule.close();
        });

        EditUserModule.bindCtrlData();

        LangCtrl.translate($("#divEditUser", context));

        EditUserModule.getData();
    },
    getData: function () {
        var bindMacEnabled = ($("config>user>item>macBindSwitch:eq(" + UserModule.editIndex + ")", xmlDoc).text() === "true");
        $("#txtUserName", context).val($("config>user>item>userName:eq(" + UserModule.editIndex + ")", xmlDoc).text());
        $("#chkBindingMac", context).attr("checked", bindMacEnabled);
        $("#txtBindingMac", context).val(bindMacEnabled ? $("config>user>item>clientMacAddr:eq(" + UserModule.editIndex + ")", xmlDoc).text() : "00:00:00:00:00:00");

        EditUserModule.toggleMac(bindMacEnabled);
    },
    bindCtrlData: function () {
        $("#txtUserName", context).attr("maxlength", $("config>user>itemType>userName", xmlDoc).attr("maxLen") * 1);
        $("#txtPassword,#txtConfirmPassword,#txtOldPassword,#txtNewPassword", context).attr("maxlength", $("config>user>itemType>password", xmlDoc).attr("maxLen") * 1);
    },
    verification: function () {
        ClearFloatError();
        if ($("#chkEditPassword", context).attr("checked") == "checked") {
            if (!checkPwd($("#txtOldPassword",context).val())) {
                ShowFloatError($("#txtOldPassword", context), LangCtrl._L_("TipPWDChar"));
                return false;
            }
            if (!checkPwd($("#txtNewPassword",context).val())) {
                ShowFloatError($("#txtNewPassword", context), LangCtrl._L_("TipPWDChar"));
                return false;
            }
            if ($("#txtNewPassword", context).val() != $("#txtConfirmPassword", context).val()) {
                ShowFloatError($("#txtConfirmPassword", context), LangCtrl._L_("passwordNotEqualTip"));
                return false;
            }
        }
        return true;
    },
    getSaveData: function () {
        var xDoc = XMLStr2XMLDoc(XMLDoc2XMLStr(xmlDoc));
        $("config>user>itemType", xDoc).remove();
        $("config>user>item", xDoc).remove();
        var userCfg = $("config>user", xDoc);

        var itemType = $(xDoc.createElement("itemType"));
        itemType.append(
            $(xDoc.createElement("userType")).attr("type","userType")
        );
        itemType.append(
            $(xDoc.createElement("userName")).attr("type","string").attr("maxLen","19")
        );

        if(Decryption($.cookie("auInfo")).split(":")[0] == $("config>user>item>userName:eq(" + UserModule.editIndex + ")", xmlDoc).text()){
            itemType.append(
                $(xDoc.createElement("oldPassword")).attr("type","string").attr("maxLen","19")
            );
        }

        itemType.append(
            $(xDoc.createElement("password")).attr("type","string").attr("maxLen","19")
        );
        itemType.append(
            $(xDoc.createElement("macBindSwitch")).attr("type","boolean")
        );
        itemType.append(
            $(xDoc.createElement("clientMacAddr")).attr("type","string").attr("maxLen","19")
        );
        userCfg.append(itemType);



        var item = $(xDoc.createElement("item"));
        item.append(
			$(xDoc.createElement("userName")).attr("type","string").attr("maxLen","19").append(
				$(xDoc.createCDATASection($("#txtUserName", context).val()))
			)
		);
        if ($("#chkEditPassword", context).attr("checked") == "checked") {
            if(Decryption($.cookie("auInfo")).split(":")[0] == $("config>user>item>userName:eq(" + UserModule.editIndex + ")", xmlDoc).text()){
                item.append(
                    $(xDoc.createElement("oldPassword")).attr("type","string").attr("maxLen","19").append(
                        $(xDoc.createCDATASection(PrivEncrypt([$("#txtOldPassword", context).val()],23784501)))
                    )
                ).append(
                    $(xDoc.createElement("password")).attr("type","string").attr("maxLen","19").append(
                        $(xDoc.createCDATASection(PrivEncrypt([$("#txtNewPassword", context).val()],23784501)))
                    )
                );
            }else{
                item.append(
                    $(xDoc.createElement("password")).attr("type","string").attr("maxLen","19").append(
                        $(xDoc.createCDATASection(PrivEncrypt([$("#txtNewPassword", context).val()],23784501)))
                    )
                );
            }
        }
        item.append(
			$(xDoc.createElement("macBindSwitch")).attr("type","boolean").append(
				$(xDoc.createTextNode($("#chkBindingMac", context).attr("checked") == "checked" ? "true" : "false"))
			)
		).append(
			$(xDoc.createElement("clientMacAddr")).attr("type","string").attr("minLen","17").attr("maxLen","17").append(
				$(xDoc.createCDATASection($("#txtBindingMac", context).val()))
			)
		);
        userCfg.append(item);
        return XMLDoc2XMLStr(xDoc);
    },
    setData: function () {
        window.top.showLoading();
        if (!EditUserModule.verification()) {
            window.top.hideLoading();
            return false;
        }
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/ModifyUser", /// <reference path="../SysMaintenance/" />

                type: "POST",
                async: true,
                data: EditUserModule.getSaveData(),
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function (result) {
                    window.top.hideLoading();
                    if ($("config", result).attr("status") == "success") {
                        window.top.MsgBoxHelper.Show("ok", LangCtrl._L_("infoTip"), LangCtrl._L_("saveSuccess"), null);
                        if ($("#chkBindingMac", context).is(":checked")) {
                            $("config>user>item>macBindSwitch:eq(" + UserModule.editIndex + ")", xmlDoc).text("true");
                            $('#divUser').wbGrid("setCellsValueByIndexes", [UserModule.editIndex], ["clientMacAddr"], [$("#txtBindingMac", context).val()], false)
                        }
                        else {
                            $("config>user>item>macBindSwitch:eq(" + UserModule.editIndex + ")", xmlDoc).text("false");
                            $('#divUser').wbGrid("setCellsValueByIndexes", [UserModule.editIndex], ["clientMacAddr"], [""], false);
                        }
                        $("config>user>item>clientMacAddr:eq(" + UserModule.editIndex + ")", xmlDoc).text($("#txtBindingMac", context).val());

                        if($("#chkEditPassword", context).is(":checked") && !EditUserModule.selfFlag){
                            var userInfo = Decryption($.cookie('auInfo'));
                            var userInfoArr = userInfo.split(':');
                            var username = userInfoArr[0];
                            var password = $("#txtNewPassword", context).val();
                            var auInfo = zhBase64Encode($.trim(username + ":" + password));
                            $.cookie('auInfo', auInfo);
                            $.cookie("pwd",zhBase64Encode(password),{expires:45});
//                            $.cookie("pwd",PrivEncrypt([password],23784501),{expires:45});
                        }

                        EditUserModule.close();
                    } else {
                        window.top.MsgBoxHelper.Show("error", LangCtrl._L_("errorTip"), LangCtrl._L_("oldPasswordTip"), null);
                    }

                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    close: function () {
        dialog_editUser.CloseDialog();
    }
};