﻿var xmlDoc;

$(function() {
	FilterModule.initCtrl();
	FilterModule.getData();
    $(window).unload(function(){
        $.cookie("inputMac",$("#txtMAC").val());
    });
    if($.cookie("inputMac")){
        $("#txtMAC").val($.cookie("inputMac"));
    }
});

var FilterModule = {
	mapping: {
		chkEnableIPFilter: "config>filterClient>ipList>switch",
		chkEnableMACFilter: "config>filterClient>macList>switch"
	},
	toggleIP: function(enabled) {
		$(".ipFilter")[enabled ? "show" : "hide"]();
	},
	toggleMAC: function(enabled) {
		$(".macFilter")[enabled ? "show" : "hide"]();
	},
	initCtrl: function() {
		function addIP() {
			var txtIP = $("#txtIP");
			var ip = txtIP.ipInput("getValue");
			var cboIPList = $("#cboIPList");
			ClearFloatError();
			if (FilterModule.ipMaxCount && cboIPList.find("option").size() >= FilterModule.ipMaxCount) {
				ShowFloatError(txtIP, LangCtrl._L_("ipMaxCount").format(FilterModule.ipMaxCount));
				return;
			}
			if (ip == "" || !CheckIP(ip) || ip == "0.0.0.0") {
				ShowFloatError(txtIP, LangCtrl._L_("invalidIPTip"));
				return;
			}
			if (cboIPList.find("option[value=\"" + ip + "\"]").size() > 0) {
				ShowFloatError(txtIP, LangCtrl._L_("notUniqueIPTip"));
				return;
			}
			cboIPList.append("<option value=\"" + ip + "\">" + ip + "</option>");
			cboIPList.find("option:not(:last)").attr("selected", false);
			cboIPList.find("option:last").attr("selected", true);
			txtIP.ipInput("setValue", "0.0.0.0")
		}

		function addMAC() {
			var txtMAC = $("#txtMAC");
			var mac = txtMAC.val();
			var cboMACList = $("#cboMACList");
			ClearFloatError();
			if (FilterModule.macMaxCount && cboMACList.find("option").size() >= FilterModule.macMaxCount) {
				ShowFloatError(txtMAC, LangCtrl._L_("macMaxCount").format(FilterModule.macMaxCount));
				return;
			}
			if (mac == "" || !checkMAC(mac)) {
				ShowFloatError(txtMAC, LangCtrl._L_("invalidMACTip"));
				return;
			}
			if (cboMACList.find("option[value=\"" + mac + "\"]").size() > 0) {
				ShowFloatError(txtMAC, LangCtrl._L_("notUniqueMACTip"));
				return;
			}
			cboMACList.append("<option value=\"" + mac + "\">" + mac + "</option>");
			cboMACList.find("option:not(:last)").attr("selected", false);
			cboMACList.find("option:last").attr("selected", true);
			txtMAC.val("00:00:00:00:00:00");
		}

		$("#chkEnableIPFilter").click(function(event) {
			FilterModule.toggleIP($(this).attr("checked") == "checked");
		});

		$("#txtIP").ipInput({
			defaultValue: "0.0.0.0"
		});

		$("#btnIPAdd").click(function(event) {
			addIP();
		});

		$("#btnIPDel").click(function(event) {
			var cboIPList = $("#cboIPList");
			var selectedIP = cboIPList.find("option:selected");
			ClearFloatError();
			if (selectedIP.size() == 0) {
				ShowFloatError($("#txtIP"), LangCtrl._L_("noIPSelectedTip"));
				return;
			}
			selectedIP.remove();
			cboIPList.find("option:last").attr("selected", true);
		});

		$("#chkEnableMACFilter").click(function(event) {
			FilterModule.toggleMAC($(this).attr("checked") == "checked");
		});

		$("#txtMAC").keydown(function(event) {
			if (isEnter(event)) {
				addMAC();
			}
		}).macInput();

		$("#btnMACAdd").click(function(event) {
			addMAC();
		});

		$("#btnMACDel").click(function(event) {
			var cboMACList = $("#cboMACList");
			var selectedMAC = cboMACList.find("option:selected");
			ClearFloatError();
			if (selectedMAC.size() == 0) {
				ShowFloatError($("#txtMAC"), LangCtrl._L_("noMACSelectedTip"));
				return;
			}
			selectedMAC.remove();
			cboMACList.find("option:last").attr("selected", true);
		});
		
		$("#btnSave").click(function(event) {
            var cboIPListSize = $("#cboIPList").children().size() * 1;
            var checkIPFilter = $("#chkEnableIPFilter").attr("checked") === "checked";

            var cboMACListSize = $("#cboMACList").children().size() * 1;
            var checkMACFilter = $("#chkEnableMACFilter").attr("checked") === "checked";

            if(checkIPFilter && cboIPListSize === 0){
                ShowFloatError($("#IPFilterTip"), LangCtrl._L_("IPFilterTip"));
                return false;
            }
            if(checkMACFilter && cboMACListSize === 0){
                ShowFloatError($("#IPFilterTip"), LangCtrl._L_("MACFilterTip"));
                return false;
            }
            FilterModule.setData();

		});
	},
	getData: function() {
		window.top.showLoading();
		try {
			XmlHttpClient.SendHttpRequest({
				url: serverBase + "/GetSecurityConfig",
				type: "POST",
				async: true,
				data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
				callback: function(result) {
					xmlDoc = result;
					var ipFilterEnabled = ($(FilterModule.mapping.chkEnableIPFilter, xmlDoc).text().toLowerCase() === "true");
					var macFilterEnabled = ($(FilterModule.mapping.chkEnableMACFilter, xmlDoc).text().toLowerCase() === "true");
					FilterModule.bindCtrlData();
					XmlHttpClient.BindPageByXml(FilterModule.mapping, xmlDoc);
                    FilterModule.toggleIP(ipFilterEnabled);
                    FilterModule.toggleMAC(macFilterEnabled);
					window.top.hideLoading();
				}
			});
		}
		catch (ex) {
			alert(ex);
		}
	},
	bindCtrlData: function() {
		var cboIPList = $("#cboIPList");
		var cboMACList = $("#cboMACList");
		var ipFilterType = $("config>filterClient>ipList>type", xmlDoc).text();
		var macFilterType = $("config>filterClient>macList>type", xmlDoc).text();
		
		cboIPList.empty();
		$("config>filterClient>ipList>filters>item", xmlDoc).each(function(index, element) {
			$("<option value=" + $(this).text() + ">" + $(this).text() + "</option>").appendTo(cboIPList);
		});
		cboIPList.find("option:last").attr("selected", true);
		$("#txtIP").attr("maxlength", $("config>filterClient>ipList>filters>itemType", xmlDoc).attr("maxLen"));

		FilterModule.ipMaxCount = $("config>filterClient>ipList>filters", xmlDoc).attr("maxCount") * 1;
		$(":radio[name=\"rdoIPFilterRule\"]").each(function(index, element) {
			if ($(this).val() == ipFilterType) {
				$(this).attr("checked", true);
			}
		});

		cboMACList.empty();
		$("config>filterClient>macList>filters>item", xmlDoc).each(function(index, element) {
			$("<option value=" + $(this).text() + ">" + $(this).text() + "</option>").appendTo(cboMACList);
		});
		cboMACList.find("option:last").attr("selected", true);
		$("#txtMAC").attr("maxlength", $("config>filterClient>macList>filters>itemType", xmlDoc).attr("maxLen"));

		FilterModule.macMaxCount = $("config>filterClient>macList>filters", xmlDoc).attr("maxCount") * 1;

		$(":radio[name=\"rdoMACFilterRule\"]").each(function(index, element) {
			if ($(this).val() == macFilterType) {
				$(this).attr("checked", true);
			}
		});
	},
	getSaveData: function() {
		var ipList = $("config>filterClient>ipList>filters", xmlDoc);
		var macList = $("config>filterClient>macList>filters", xmlDoc);

		$("config>filterClient>ipList>filters>item", xmlDoc).remove();

		if ($("#chkEnableIPFilter").attr("checked") == "checked") {
			$(":radio[name=\"rdoIPFilterRule\"]").each(function(index, element) {
				if ($(this).attr("checked") == "checked") {
					$("config>filterClient>ipList>type", xmlDoc).text($(this).val());
				}
			});

			
			$("#cboIPList>option").each(function(index, element) {
				ipList.append($(xmlDoc.createElement("item")).append(xmlDoc.createCDATASection($(this).val())));
			});
		}

		$("config>filterClient>macList>filters>item", xmlDoc).remove();

		if ($("#chkEnableMACFilter").attr("checked") == "checked") {
			$(":radio[name=\"rdoMACFilterRule\"]").each(function(index, element) {
				if ($(this).attr("checked") == "checked") {
					$("config>filterClient>macList>type", xmlDoc).text($(this).val());
				}
			});
			$("#cboMACList>option").each(function(index, element) {
				macList.append($(xmlDoc.createElement("item")).append(xmlDoc.createCDATASection($(this).val())));
			});
		}
		return XmlHttpClient.GetXmlByPage(FilterModule.mapping, xmlDoc);
	},
	setData: function() {
		window.top.showLoading();
		try {
			XmlHttpClient.SendHttpRequest({
				url: serverBase + "/SetSecurityConfig",
				type: "POST",
				async: true,
				data: FilterModule.getSaveData(),
                beforeSend: XmlHttpClient.CommBeforeSend,
				callback: function(result) {
					window.top.hideLoading();
					commSaveResponseHadler(result);
				}
			});
		}
		catch (ex) {
			alert(ex);
		}
	}
};