var xmlDoc;

$(function() {
    UserModule.initCtrl();
    UserModule.doResize();
    UserModule.getData();
});

var gridIndex;
var UserModule = {
    doResize: function(){
        var height1 = $("#config_content", window.parent.document).height();
        var height2 = $("#topButtonPL").height();

        $("#divUser").wbGrid("setHeight", height1 - height2 - 135);
        $(window.top).resize(function () {
            $("#divUser").wbGrid("setHeight", height1 - height2 - 135);
        });
    },
    initCtrl: function() {
        $("#btnAdd").unbind().click(function(event) {
            var maxCount = $("config>user",xmlDoc).attr("maxCount");
            if($("config>user>item",xmlDoc).size() == maxCount){
                window.top.MsgBoxHelper.Show("info", LangCtrl._L_("infoTip"), LangCtrl._L_("NumIsLimit"), function() {
                });
            }else{
                UserModule.toAddData();
            }
        });

        $("#btnModify").click(function(event) {
            var userName = $('#divUser').wbGrid("getSelectRows").data['userName'];
            if(Decryption($.cookie("auInfo")).split(":")[0] !== "admin" && userName === "admin"){
                window.top.MsgBoxHelper.Show("info", LangCtrl._L_("infoTip"), LangCtrl._L_("defaultNotModify"), function() {
                });
            }else{
                gridIndex =  $('#divUser').wbGrid("getSelectRows").index;
                UserModule.toEditData(gridIndex);
            }
        });

        $("#btnDelete").click(function(event) {
             gridIndex =  $('#divUser').wbGrid("getSelectRows").index;

            if(gridIndex == 0){
                window.top.showLoading();
                window.top.MsgBoxHelper.Show("info", LangCtrl._L_("infoTip"), LangCtrl._L_("selectInf"), function() {
                });
                window.top.hideLoading();
            }else{
                UserModule.deleteData($("config>user>item>userName:eq(" + gridIndex + ")", xmlDoc).text());
            }
        });

        $('#divUser').wbGrid({
            data: {
                colNames: [LangCtrl._L_("userName"), LangCtrl._L_("userType"), LangCtrl._L_("bindingMac")],
                colModel: [
                    { name: 'userName', index: 'userName',width: 80, align: "center", sortable: false },
                    { name: 'userType', index: 'userType',width: 80, align: "center", sortable: false },
                    { name: 'clientMacAddr', index: 'clientMacAddr',width: 80, align: "center", sortable: false }
                ],
                rowList: []
            },
            view: {
                selectRow : true,
                rownumbers: true,
                lang: LangCtrl.getLang()
            },
            callback: {
                onClickRow: function (e, gridId, rowIndex, rowData) {
                    var userInfo = Decryption($.cookie("userInfo"));
                    var userName = userInfo.split(":")[0];
                    if(rowIndex == 0 || userName===rowData["userName"]){
                        $("#btnDelete").attr({disabled:true});
                    }else{
                        $("#btnDelete").attr("disabled", false);
                    }
                }
            }
        });
    },
    getData: function() {
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/GetUsers",
                type: "POST",
                async: true,
                data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    xmlDoc = result;

                    var rowData = [];
                    var userType = "",clientMacAddr;

                    $("config>user>item",xmlDoc).each(function(i,ele){
                        var userTypeEle = $(">userType",ele).text();
                        userType = (userTypeEle == "administrator" ?  LangCtrl._L_("administrator") : userTypeEle == "advance" ?  LangCtrl._L_("advanceUser") :  LangCtrl._L_("normalUser"));
                        clientMacAddr = $(">macBindSwitch",ele).text() == "false" ? "" :$(">clientMacAddr",ele).text();
                        rowData.push({
                            "userName":$(">userName",ele).text(),
                            "userType":userType,
                            "clientMacAddr":clientMacAddr
                        })

                    });


//                    var rowData = xml2json(xmlDoc, "config>user>item")["item"];
//                    if (!rowData)
//                        rowData = [];
//                    if (!(rowData instanceof Array)) {
//                        rowData = [rowData];
//                    }
//                    $.each( rowData, function(i, n){
//
//                        switch (n["userType"]){
//                            case 'administrator':
//                                n["userType"] = LangCtrl._L_("administrator");
//                                break;
//                            case 'advance':
//                                n["userType"] = LangCtrl._L_("advanceUser");
//                                break;
//                            default :
//                                n["userType"] = LangCtrl._L_("normalUser");
//                        }
//                        if(n["macBindSwitch"] == "false"){
//                            (n["clientMacAddr"])= "";
//                        }
//
//                    });
                    $("#divUser").wbGrid("load", rowData);

                    if (rowData.length >= 1) {
                        $('#divUser').wbGrid("selectRowByIndex",0);
                        $("#btnModify,#btnDelete").removeAttr("disabled").removeClass("disabled");
                    }
                    else {
                        $("#btnModify,#btnDelete").attr("disabled", "disabled").addClass("disabled");
                    }
//                    $('#divUser').wbGrid("selectRowByIndex",0);
                    window.top.hideLoading();
                }
            });

        }
        catch (ex) {
            alert(ex);
        }
    },
    bindCtrlData: function() {
        UserModule.userMaxCount = $("config>userCfg", xmlDoc).attr("maxCount") * 1;
    },
    toAddData: function() {
        dialog_addUser = new DialogHelper({
            title: LangCtrl._L_("addUser"),
            content: "addUser.htm",
            width: 430,
            height: 350,
            contentType: "url",
            loadCallBack: AddUserModule.initCtrl
        });
//        $('#divUser').wbGrid("selectRowByIndex",0);
    },
    toEditData: function(index) {
        UserModule.editIndex = $('#divUser').wbGrid("getSelectRows").index;
        dialog_editUser = new DialogHelper({
            title: LangCtrl._L_("editUser"),
            content: "editUser.htm",
            width: 430,
            height: 370,
            contentType: "url",
            loadCallBack: EditUserModule.initCtrl
        });
    },
    getDeleteData: function() {
//        return xmlHeader + "<user><name>" + $("config>user>item>userName:eq(" + $('#divUser').wbGrid("getSelectRows").index + ")", xmlDoc).text() + "</name></user>";
        return xmlHeader + "<user><name>" + $('#divUser').wbGrid("getSelectRows").data['userName']  + "</name></user>";
    },
    deleteData: function() {
        window.top.MsgBoxHelper.Show("y/n", LangCtrl._L_("infoTip"), LangCtrl._L_("confirmDeleteUser"), function(flag) {
            if (flag) {
                window.top.showLoading();
                try {
                    XmlHttpClient.SendHttpRequest({
                        url: serverBase + "/DeleteUser",
                        type: "POST",
                        async: true,
                        data: UserModule.getDeleteData(),
                        beforeSend: XmlHttpClient.CommBeforeSend,
                        callback: function(result) {
                            window.top.hideLoading();
                            UserModule.getData();
                        }
                    });
                }
                catch (ex) {
                    alert(ex);
                }
            }
        });
    }
};
