﻿var xmlDoc;
var sdXmlDoc;
var recordDoc;

$(function() {
    $("#divParent").tab({
        map: [{"tab": "liSdCfg", "content": "divSdCfg", init: SdCfgModule.initCtrl},
            {"tab": "liRecord", "content": "divRecord", init: initRecord}
        ]
    });
    $("#divParent").tab("selectLastTab");
    $("#Content",window.top.document).css({"min-width":"980px"});
});

function initRecord(){
    PreRecordModule.initCtrl();
}

var SdCfgModule = {
    initCtrl: function() {
        $("#format").unbind().click(function(){
            if($("config>sdCardInfo>status", sdXmlDoc).length > 0  && $("config>sdCardInfo>status", sdXmlDoc).text() === "formatting"){
                SdCfgModule.formatSD();
            }else{
                window.top.MsgBoxHelper.Show("y/n", LangCtrl._L_("infoTip"), LangCtrl._L_("formatSDTip"), function(flag) {
                    if (flag) {
                        SdCfgModule.formatSD();
                    }
                },400);
            }
        });
        $("#popUp").unbind().click(function(){
            SdCfgModule.popUpSD();
        });

        initNumberInput($("#txtPicPercent"), { minValue: 10, maxValue: 50 });
        initNumberInput($("#txtRecPercent"), { minValue: 50, maxValue: 90 });

        $("#txtPicPercent").blur(function(){
            $("#txtRecPercent").val(100 - $(this).val());
        });

        $("#txtRecPercent").blur(function(){
            $("#txtPicPercent").val(100 - $(this).val());
        });
        SdCfgModule.getData();
    },
    getData: function() {
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/GetSdCardStatus",
                type: "POST",
                async: true,
                data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    xmlDoc = result;
                    var size = $("config>sdCardInfo>totalSize", xmlDoc).text();
                    var status = $("config>sdCardInfo>status", xmlDoc).text();
                    var usedCapacity = $("config>sdCardInfo>usedSize", xmlDoc).text();
                    var remainCapacity = $("config>sdCardInfo>spareSize", xmlDoc).text();
                    if(status === "no card"){
                        $("#trCapacity,#trUsedCapacity,#trRemainCapacity,#trSdBtn,#trPicPercent,#trRecPercent,#trTip").hide();
                        $("#trSdState").removeClass("alter");
                    }else{
                        $("#txtCapacity").val(size + " MB");
                        $("#txtUsedCapacity").val(usedCapacity  + " MB");
                        $("#txtRemainCapacity").val(remainCapacity  + " MB");
                        $("#trCapacity,#trUsedCapacity,#trRemainCapacity,#trSdBtn,#trPicPercent,#trRecPercent").show();
                        $("#trSdState").addClass("alter");
                    }
                    $("#txtSdState").val(status === "no card" ? LangCtrl._L_("noCard") : status === "unformat" ? LangCtrl._L_("noFormatted") : status === "formatting" ? LangCtrl._L_("formatting") : status === "popup" ? LangCtrl._L_("popup") : status === "invalid card" ? LangCtrl._L_("invalid") : status === "uninit" ? LangCtrl._L_("uninit") : LangCtrl._L_("normal"));
                    window.top.hideLoading();

                    $("#txtPicPercent").val($("config>sdCardInfo>picPercent",xmlDoc).text());
                    $("#txtRecPercent").val(100 - $("#txtPicPercent").val());

                    if(status === "formatting" || status === "formated"){
                        setTimeout(SdCfgModule.getData, 10000);
                    }
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    getPercent: function(){
        return xmlHeader + "<config version=\"1.0\" xmlns=\"http://www.ipc.com/ver10\"><sdCardInfo>"
            + "<picPercent>" + $("#txtPicPercent").val() + "</picPercent></sdCardInfo></config>";
    },
    formatSD: function(){
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/FormatSdCard",
                type: "POST",
                async: true,
                data: SdCfgModule.getPercent(),
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    window.top.hideLoading();
                    if ($("config", result).attr("status") === "success") {
                        SdCfgModule.getData();
                        /*window.top.MsgBoxHelper.Show("ok", LangCtrl._L_("infoTip"), LangCtrl._L_("success"), null);*/
                    } else {
                        window.top.MsgBoxHelper.Show("error", LangCtrl._L_("infoTip"), LangCtrl._L_("failed"), null);
                    }
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    popUpSD: function(){
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/PopUpSdCard",
                type: "POST",
                async: true,
                data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    window.top.hideLoading();
                    if ($("config", result).attr("status") === "success") {
                        window.top.MsgBoxHelper.Show("ok", LangCtrl._L_("infoTip"), LangCtrl._L_("popSuccess"), null);
                        SdCfgModule.getData();
                    } else {
                        window.top.MsgBoxHelper.Show("error", LangCtrl._L_("infoTip"), LangCtrl._L_("popFailed"), null);
                    }
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    }
};

var PreRecordModule = {
    initCtrl: function() {
        PreRecordModule.getStreamInfo();
        PreRecordModule.getData();
        $("#btnSave").unbind().click(function(event) {
            PreRecordModule.setData();
        });

        $("#selectCycle").empty();
        $("<option value=\"true\">" + LangCtrl._L_("yes") + "</option>").appendTo($("#selectCycle"));
        $("<option value=\"false\">" + LangCtrl._L_("no2") + "</option>").appendTo($("#selectCycle"));
    },
    setPreTime:function(){
        var option = "<option value=\"0\">" + LangCtrl._L_("noPreRecord") + "</option>";
        $("config>type>preTime>enum",recordDoc).each(function(index,element){
            option += "<option value="+ $(element).text()+">" + LangCtrl._L_("seconds").format($(element).text()) + "</option>";
        });

        $("#selectPreTime").empty().append(option);
    },
    getStreamInfo:function(){
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/GetLoadInfo",
                type: "POST",
                async: false,
                data: "",
                callback: function(result) {
                    var option = "";
                    $("config>loadInfo>streamInfo>item",result).each(function(index,ele){
                        option += "<option value="+$(ele).attr("id")+">" + LangCtrl._L_("stream"+$(ele).attr("id"))+ "</option>";
                    });
                    $("#selectStream").empty().append(option);
                    window.top.hideLoading();
                }
            });
        }
        catch (ex) {
            alert(ex);
            window.top.hideLoading();
        }
    },
    getData: function() {
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/GetRecordCfg",
                type: "POST",
                async: true,
                data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    recordDoc = result;
                    PreRecordModule.setPreTime();
                    $("#selectStream").val( $("config>record>streamId",recordDoc).text());

                    if($("config>record>switch",recordDoc).text() == "true"){
                        $("#selectPreTime").val($("config>record>preTime",recordDoc).text());
                    }else{
                        $("#selectPreTime").val("0");
                    }

                    $("#selectCycle").val($("config>record>coverMode",recordDoc).text());
                    window.top.hideLoading();
                }
            });
        }
        catch (ex) {
            alert(ex);
            window.top.hideLoading();
        }
    },
    getSaveData: function() {
        $("config>record>streamId", recordDoc).text($("#selectStream").val());
        if($("#selectPreTime").val() !== "0"){
            $("config>record>preTime", recordDoc).text($("#selectPreTime").val());
        }
        $("config>record>switch", recordDoc).text($("#selectPreTime").val() === "0" ? "false" : "true");
        $("config>record>coverMode", recordDoc).text($("#selectCycle").val());
        return XMLDoc2XMLStr(recordDoc);
    },
    setData: function() {
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/SetRecordCfg",
                type: "POST",
                async: true,
                data: PreRecordModule.getSaveData(),
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    window.top.hideLoading();
                    if ($("config", result).attr("status") == "success") {
                        window.top.MsgBoxHelper.Show("success", LangCtrl._L_("successTip"), LangCtrl._L_("saveSuccess"), null);
                    }else{
                        window.top.MsgBoxHelper.Show("error", LangCtrl._L_("errorTip"), LangCtrl._L_("recordParamFailed"), null);
                    }
                }
            });
        }
        catch (ex) {
            alert(ex);
            window.top.hideLoading();
        }
    }
};

