﻿var refreshTimeId; // 刷新时间线程ID
var xmlDoc;

$(function() {

    var now = new Date();
    now.setHours(0, 0, 0, 0);
    $("#dpManualDate").wbDatePicker({
        lang: LangCtrl.getLang(),
        showTime: false,
        defaultDate: now,
        dateFormat: "yyyy-MM-dd"
    });
    $("#txtManualTime").timeInput();

    $("#divParent").tab({
        map: [
            { "tab": "liZone", "content": "divZoneTrigger", init: TimeZoneModule.initControl },
            { "tab": "liDateTime", "content": "divDateTimeTrigger", init: TimeSetModule.initControl }
        ]
    });
    $("#divParent").tab("selectLastTab");
    $("#Content",window.top.document).css({"min-width":"980px"});
});

var TimeZoneModule = {
    mapping: {
        cboTimeZone: "config>time>timezoneInfo>timeZone",
        chkIsUseDST: "config>time>timezoneInfo>daylightSwitch "
    },
    initControl: function(id) {
        $(".cfgfooter").css({"left":"-90px","top":"150px"});
        $("#btnSave").unbind().click(function(e) {
            TimeZoneModule.setData();
        });
        TimeZoneModule.getData();
    },
    getData: function() {
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/GetDateAndTime",
                type: "POST",
                async: true,
                data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    xmlDoc = result;
                    TimeZoneModule.bindPageByXml();
                    window.top.hideLoading();
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    bindPageByXml: function() {
        var timezones = [ "GMT+12", "GMT+11", "HAST10HADT,M3.2.0,M11.1.0", "AKST9AKDT,M3.2.0,M11.1.0", "PST8PDT,M3.2.0,M11.1.0", "MST7MDT,M3.2.0,M11.1.0",
            "CST6CDT,M3.2.0,M11.1.0", "CST6CDT,M4.1.0,M10.5.0", "CST5CDT,M3.2.0/0,M11.1.0/1", "EST5EDT,M3.2.0,M11.1.0", "VET4:30",
            "CST4CDT,M3.2.0,M11.1.0", "AMT4AMST,M10.3.0/0,M2.3.0/0", "AST4", "PYT4PYST,M10.1.0/0,M4.2.0/0", "CLT4CLST,M10.2.0/0,M3.2.0/0",
            "NST3:30NDT,M3.2.0,M11.1.0", "BRT3BRST,M10.3.0/0,M2.3.0/0", "ART3", "WGT3WGST,M3.5.6/22,M10.5.6/23", "UYT3UYST,M10.1.0,M3.2.0",
            "FNT2", "AZOT1AZOST,M3.5.0/0,M10.5.0/1", "GMT0BST,M3.5.0/1,M10.5.0", "CET-1CEST,M3.5.0,M10.5.0/3", "WAT-1WAST,M9.1.0,M4.1.0",
            "EET-2EEST,M3.5.0/3,M10.5.0/4", "EET-2", "IST-2IDT,M3.5.5/2,M10.5.0/2", "SAST-2", "EET-2EEST,M3.5.0/0,M10.5.0/0",
            "EET-2EEST,M3.5.5/0,M10.5.5/0", "AST-3","MSK-3", "IRST-3:30IRDT-4:30,J80/0,J264/0", "AZT-4AZST,M3.5.0/4,M10.5.0/5", "GST-4",
            "AFT-4:30", "PKT-5", "IST-5:30", "NPT-5:45", "ALMT-6", "MMT-6:30", "WIT-7", "CST-8", "WST-8", "JST-9", "CST-9:30",
            "CST-9:30CST,M10.1.0,M4.1.0/3", "YAKT-10", "EST-10EST,M10.1.0,M4.1.0/3", "SBT-11", "NFT-11:30", "NZST-12NZDT,M9.5.0,M4.1.0/3",
            "FJT-12FJST,M10.5.0,M1.3.0/3", "PETT-12PETST,M3.5.0,M10.5.0/3", "MHT-12", "CHAST-12:45CHADT,M9.5.0/2:45,M4.1.0/3:45", "TOT-13", "SST-13SDT,M9.5.0/3,M4.1.0/4"];
        var timezone = $(TimeZoneModule.mapping.cboTimeZone, xmlDoc).text();
        var cboTimeZone = $("#cboTimeZone");
        cboTimeZone.empty();
        $.each(timezones, function(index, element) {
            $("<option value=" + element + " title=\"" + LangCtrl._L_("timezone" + (index + 1)) + "\">" + LangCtrl._L_("timezone" + (index + 1)) + "</option>").appendTo(cboTimeZone);
        });
        if ($.inArray(timezone, timezones) == -1) {
            var str = "";
            if (/(\+\d+[:\d+]*)/.test(timezone)){
                str = "GMT" + RegExp.$1.replace("+","-");
            }else if(/(\-\d+[:\d+]*)/.test(timezone)){
                str = "GMT" + RegExp.$1.replace("-","+");
            }else if(/(\d+[:\d+]*)/.test(timezone)){
                str = "GMT-" + RegExp.$1;
            }
            $("<option value=\"" + timezone + "\">" + str + "</option>").appendTo(cboTimeZone);
        }
        XmlHttpClient.BindPageByXml(TimeZoneModule.mapping, xmlDoc);
    },
    setData: function() {
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/SetDateAndTime",
                type: "POST",
                async: true,
                data: TimeZoneModule.getSaveData(),
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    window.top.hideLoading();
                    commSaveResponseHadler(result);
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    getSaveData: function() {
        $("config>time>synchronizeInfo",xmlDoc).remove();
        return XmlHttpClient.GetXmlByPage(TimeZoneModule.mapping, xmlDoc);
    }
};

var TimeSetModule = {
    mapping: {
        cboTimeZone: "config>time>timezoneInfo>timeZone",
        txtNTPAddress: "config>time>synchronizeInfo>ntpServer",
        chkIsUseDST: "config>time>timezoneInfo>daylightSwitch "
    },
    initControl: function(id) {
        $("#rdoComputerTime").unbind().click(function(e) {
            TimeSetModule.setSyncTimeMode(0);
        });
        $("#rdoManual").unbind().click(function(e) {
            TimeSetModule.setSyncTimeMode(2);
        });
        $("#rdoSyncNTP").unbind().click(function(e) {
            TimeSetModule.setSyncTimeMode(1);
        });

        $(".cfgfooter").css({"left":"-280px","top":"300px"});
        $("#btnSave").unbind().click(function(e) {
            TimeSetModule.setData();
        });
        TimeSetModule.getData();
        refreshTimeId = setInterval(refreshTime, 1000);
    },
    setSyncTimeMode: function(type) {
        switch (type) {
            case 0://和电脑时间同步
                $("#txtCtDate,#txtCtTime,#trComputerTime").attr("disabled", false);
                $("#txtNTPAddress,#trManual,#txtManualTime,#trNtp").attr("disabled", true);
                $("#rdoComputerTime").attr("checked", "checked");
                $("#dpManualDate").wbDatePicker("setProperty", { enable: false });
                break;
            case 1://NTP服务器同步
                $("#txtCtDate,#txtCtTime,#trComputerTime,#trManual,#txtManualTime").attr("disabled", true);
                $("#txtNTPAddress,#trNtp").attr("disabled", false);
                $("#rdoSyncNTP").attr("checked", "checked");
                $("#dpManualDate").wbDatePicker("setProperty", { enable: false });
                break;
            case 2://手动设置时间
                $("#txtCtDate,#txtCtTime,#txtNTPAddress,#trComputerTime,#trNtp").attr("disabled", true);
                $("#rdoManual").attr("checked", "checked");
                $("#trManual,#txtManualTime").attr("disabled", false);
                $("#dpManualDate").wbDatePicker("setProperty", { enable:true });
                break;
        }

    },
    getData: function() {
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/GetDateAndTime",
                type: "POST",
                async: true,
                data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    xmlDoc = result;
                    TimeSetModule.bindPageByXml();
                    window.top.hideLoading();
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    bindPageByXml: function() {

        XmlHttpClient.BindPageByXml(TimeSetModule.mapping, xmlDoc);
        var synchronizeTimeMode = $("config>time>synchronizeInfo>type", xmlDoc).text();
        switch (synchronizeTimeMode) {
            case "manually":
                TimeSetModule.setSyncTimeMode(2);
                break;
            case "NTP":
                TimeSetModule.setSyncTimeMode(1);
                break;
            case "PC":
                TimeSetModule.setSyncTimeMode(0);
                break;
        }

        var time = $("config>time>synchronizeInfo>currentTime", xmlDoc).text();
        time =  time.replace(/-/g,"/");
        var curTime = new Date(time);
//            Date.parse($("config>time>synchronizeInfo>currentTime", xmlDoc).text());

        $("#dpManualDate").val(curTime.format("yyyy-MM-dd"));
        $("#txtManualTime").val(curTime.format("hh:mm:ss"));
    },
    verification:function(){
        ClearFloatError();
        var $txtNTPAddress = $("#txtNTPAddress");
        if(($txtNTPAddress.val()+"").getBytesLength() > $("config>time>synchronizeInfo>ntpServer",xmlDoc).attr("maxLen")){
            ShowFloatError($txtNTPAddress, LangCtrl._L_("charsTooLong"));
            return false;
        }
        return true;
    },
    setData: function() {
        window.top.showLoading();
        if (!TimeSetModule.verification()) {
            window.top.hideLoading();
            return false;
        }
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/SetDateAndTime",
                type: "POST",
                async: true,
                data: TimeSetModule.getSaveData(),
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    window.top.hideLoading();
                    commSaveResponseHadler(result);
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    getSaveData: function() {

        $("config>time>timezoneInfo",xmlDoc).remove();

        var curTime = "";
        var type = "NTP";
        if ($("#rdoComputerTime").is(":checked")) {
            curTime = $("#txtCtDate").val() + " " + $("#txtCtTime").val();
            type = "PC";
        }
        else if($("#rdoManual").is(":checked")){
            curTime = $("#dpManualDate").val() + " " + $("#txtManualTime").val();
            type = "manually";
        }else{
//            curTime = $("#dpManualDate").val() + " " + $("#txtManualTime").val();
        }

        $("config>time>synchronizeInfo>currentTime", xmlDoc).empty().append(xmlDoc.createCDATASection(curTime));
        $("config>time>synchronizeInfo>type", xmlDoc).text(type);
        return XmlHttpClient.GetXmlByPage(TimeSetModule.mapping, xmlDoc);
    }
};


// 刷新时间显示
function refreshTime() {
    var now = new Date();
    $("#txtCtDate").val(now.format("yyyy-MM-dd"));
    $("#txtCtTime").val(now.format("hh:mm:ss"));
}