﻿var xmlDoc;
var rtspPort,netPort; // RTSP端口
var NetLiveMonitor; // 视频控件

$(function() {
    AZConfigModel.initCtrl();
    mainZoomCtrl.init();
    closeStream();
});

//设置主位置
var mainZoomCtrl = {
    status: "off", //"on","off"
    setStatus: function (status) {
        switch (status) {
            case "on":
                mainZoomCtrl.setData("true");
                mainZoomCtrl.status = status;
                $("#mainAZP").removeClass("on").addClass("off").attr("value", LangCtrl._L_("mainZoomFalse"));
                break;
            case "off":
                mainZoomCtrl.status = status;
                mainZoomCtrl.setData("false");
                $("#mainAZP").removeClass("off").addClass("on").attr("value", LangCtrl._L_("mainZoomTrue"));
                break;
        }
    },
    init: function (status) {
        if (status == "on"){
            $("#mainAZP").removeClass().addClass("on");
        }else if(status == "off"){
            $("#mainAZP").removeClass().addClass("off");
        }
        $("#mainAZP").click(function () {
            if (mainZoomCtrl.status == "on") {
                mainZoomCtrl.setStatus("off");
            }
            else {
                mainZoomCtrl.setStatus("on");
            }
        });
    },
    setData: function(value) {
        window.top.showLoading();
        var sendXml = xmlHeader + "<config version=\"" + apiVersion + "\" xmlns=\"" + defaultNS + "\"><setMainZoom><switch type=\"boolean\">" + value + "</switch></setMainZoom></config>";
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/SetMainZoomPst",
                type: "POST",
                async: true,
                data: sendXml,
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    window.top.hideLoading();
                    commSaveResponseHadler(result);
                }
            });
        }
        catch (ex) {
            alert(ex);
        }

    }
};

var AZConfigModel ={
    initCtrl: function() {
        AZConfigModel.getData();
        bindPtzEvent();
        AZConfigModel.setOCX();

    },
    toggle: function(enabled){
        if(enabled){
            $("#trFocus,#trOneKeyFocus").hide();
            $("#trLensTime").show();
        }else{
            $("#trFocus,#trOneKeyFocus").show();
            $("#trLensTime").hide();
        }
    },
    bindFun:function(){
        $("#combLensMode").change(function(){
            if($(this).val() === "auto"){
                $("#trFocus,#trOneKeyFocus").hide();
                $("#trLensTime").show();
            }else{
                $("#trFocus,#trOneKeyFocus").show();
                $("#trLensTime").hide();
            }
        });

        $("#btnSave").click(function(){
            AZConfigModel.saveData();
        });
    },
    getData: function() {
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/GetAZConfig",
                type: "POST",
                async: true,
                data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    xmlDoc = result;
                    var combLensMode = $("#combLensMode");
                    combLensMode.empty();
                    $("config>types>lensMode>enum", result).each(function(i, ele) {
                        $("<option value=" + $(ele).text() + ">" + LangCtrl._L_($(ele).text()) + "</option>").appendTo(combLensMode);
                    });
                    combLensMode.val( $("config>lensCon>lensMode", result).text());
                    AZConfigModel.toggle($("config>lensCon>lensMode", result).text() === "auto");

                    var combLensTime = $("#combLensTime");
                    combLensTime.empty();
                    var option;
                    $("config>types>lensTime>enum", result).each(function(i, ele) {
                        option =  $(ele).text() === "all" ? $("<option value=" + $(ele).text() + ">" + LangCtrl._L_("all") + "</option>") : $("<option value=" + $(ele).text() + ">" + $(ele).text() + LangCtrl._L_("minute") + "</option>");
                        option.appendTo(combLensTime);
                    });
                    combLensTime.val($("config>lensCon>lensTime", result).text());

                    $("#autoFocusSwitch").attr("checked",$("config>lensCon>autoFocusSwitch", result).text() === "true");

                }
            });
        } catch (ex) {
            alert(ex);
        }
    },
    getSaveData: function() {

       $("config>lensCon>lensMode",xmlDoc).text($("#combLensMode").val());
       $("config>lensCon>lensTime",xmlDoc).text($("#combLensTime").val());
       $("config>lensCon>autoFocusSwitch",xmlDoc).text($("#autoFocusSwitch").attr("checked") === "checked"?"true":"false");

        return XMLDoc2XMLStr(xmlDoc);
    },
    saveData: function() {
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/SetAZConfig",
                type: "POST",
                async: true,
                data: AZConfigModel.getSaveData(),
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    window.top.hideLoading();
                    commSaveResponseHadler(result);
//                    AZConfigModel.getData();
                }
            });
        } catch (ex) {
            alert(ex);
        }
    },
    setOCX: function() {
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/GetPortConfig",
                type: "POST",
                async: true,
                data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    window.top.hideLoading();
                    netPort = $("config>port>netPort", result).text() * 1;
                    NetLiveMonitor = LoadPlugin("divOCX","NetLiveMonitor");

                    if(NetLiveMonitor){
                        // 设置模式
                        var sendXML = OCX_XML_SetPreViewModel("ReadOnly");
                        NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
                    }

                    AZConfigModel.bindFun();

                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    }

};

//OCX调用js方法
function NotifyResultToJs(strXMLFormat, lStrLen) {
    var $xmlDoc = $(XMLStr2XMLDoc(strXMLFormat));

    // OCX已创建好窗口，通知可以登录了
    if ($("statenotify[type=\"Login\"]", $xmlDoc).length > 0) {
        var userInfo = Decryption($.cookie("auInfo"));
        var userInfoArr = userInfo.split(":");
        // 设置登录信息
        var username = userInfoArr[0];
        var password = userInfoArr[1];
        var ip = serverIp;
        var port = netPort;
        var id = "";
        var sendXML = OCX_XML_SetLoginInfo(username, password, ip, port, id);
        NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);

        // 设置预览码流索引
        var sendXML = OCX_XML_SetStreamType(2);
        NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
    }

    if ($("statenotify[type=\"GetOriginalWH\"]", $xmlDoc).length > 0) {
        $("#divOCX").css({width:"640px",height:"480px"});
//        AZConfigModel.getData();
    }

    var connectstate = $("statenotify[type='connectstate']",$xmlDoc);
    if(connectstate.length > 0){
        if($(">status", connectstate).text() === "success"){
            window.top.hideLoading();
        }else{
            window.top.showLoading(window.top.LangCtrl._L_("connectError"));
        }
    }

    var Connect  = $("statenotify[type='Connect']",$xmlDoc);
    if(Connect.length > 0){
        if($(">status", Connect).text() === "limit"){
            window.top.MsgBoxHelper.Show("info", LangCtrl._L_("infoTip"), LangCtrl._L_("limit"), null);
        }
    }

}

