﻿var xmlDoc;
var rtspPort,netPort; // RTSP端口
var NetLiveMonitor; // 视频控件


$(function() {
    ROIConfigModel.initCtrl();
    closeStream();
});

var ROIConfigModel ={

    action:"EDIT_ON",   //EDIT_ON,EDIT_OFF,NONE
    setAction:function(action){
        $("#btnDraw").removeAttr("class");
        this.action = action;
        switch (action) {
            case "disable":
                $("#btnDraw").addClass("disable").attr("value", LangCtrl._L_("drawArea"));
                break;
            case "on":
                var sendXML = OCX_XML_SetROIAreaAction("EDIT_ON");
                NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
                $("#btnDraw").removeClass("off").addClass("on").attr("value", LangCtrl._L_("stopDraw"));
                break;
            case "off":
                var sendXML = OCX_XML_SetROIAreaAction("EDIT_OFF");
                NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
                $("#btnDraw").removeClass("on").addClass("off").attr("value", LangCtrl._L_("drawArea"));
                break;
        }
    },
    initCtrl: function() {
        ROIConfigModel.setOCX();

        $("#sliderLevel").slider({
            minValue: 0,
            maxValue: 10,
            maxWidth: 124,
            thumbCss: "slider_thumb_1",
            valueChangeEvent: function(value) {
                $("#valueLevel").val(value);
            }
        });
        $("#valueLevel").bind("blur", function() {
            $("#sliderLevel").slider("setValueWithEvent", $("#valueLevel").val());
        }).keydown(function(ev) {
            ev = ev || event;
            if (isEnter(ev))
                $("#sliderLevel").slider("setValueWithEvent", $("#valueLevel").val());
        });

    },
    bindFun:function(){
        $("#btnDraw").click(function() {
            if (ROIConfigModel.action == "disable")
                return;
            if (ROIConfigModel.action == "on") {
                ROIConfigModel.setAction("off");
            }
            else {
                ROIConfigModel.setAction("on");
            }
        });
        $("#btnClear").click(function(){
            var sendXML = OCX_XML_SetROIAreaAction("NONE");
            NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
        });
        $("#btnSave").click(function(){
            ROIConfigModel.saveData();
        });
    },
    getData: function() {
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/GetROIConfig",
                type: "POST",
                async: true,
                data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    xmlDoc = result;
                    var firstItem = $("config>ROIConfig>item", result)[0];
                    $("#maskCheck").attr("checked",($(">switch", firstItem).text().toLowerCase() === "true"));
                    $("#sliderLevel").slider("setValue",$(">level", firstItem).text());
                    var rowData = xml2json(xmlDoc, "config>ROIConfig>item")["item"];
                    if (!rowData)
                        rowData = [];
                    if (!(rowData instanceof Array)) {
                        rowData = [rowData];
                    }
                    var masks = [];
                    $.each( rowData, function(i, n){
                        var mask = {};
                        mask.id = i;
                        mask.rectangle = {};
                        mask.rectangle.X1 = n["rectangle"].X;
                        mask.rectangle.Y1 = n["rectangle"].Y;
                        mask.rectangle.X2 = (n["rectangle"].width) * 1  + (n["rectangle"].X) * 1 ;
                        mask.rectangle.Y2 = (n["rectangle"].height) * 1 + (n["rectangle"].Y) * 1;
                        masks.push(mask);
                    });
                    var sendXML = OCX_XML_SetROIArea(masks);
                    NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
                    window.top.hideLoading();
                }
            });
        } catch (ex) {
            alert(ex);
        }
    },
    getSaveData: function() {

        var sliderValue = $("#sliderLevel").slider("getValue");
        var sendXML = OCX_XML_GetROIArea();
        var result = NetLiveMonitor.QueryInfo(sendXML, sendXML.length);
        var $xmlDoc = $(XMLStr2XMLDoc(result));

        $("response>item", $xmlDoc).each(function(index,element){
            var id = $(element).attr("id");
            var maskOpen = ($("#maskCheck").attr("checked") === "checked" ? "true" : "false");
            $("config>ROIConfig>item>switch", xmlDoc).text(maskOpen);
            $("config>ROIConfig>item>level", xmlDoc).text(sliderValue);
            $("config>ROIConfig>item>rectangle>X:eq(" + id + ")", xmlDoc).text($(element).attr("X1"));
            $("config>ROIConfig>item>rectangle>Y:eq(" + id + ")", xmlDoc).text($(element).attr("Y1"));
            $("config>ROIConfig>item>rectangle>width:eq(" + id + ")", xmlDoc).text(($(element).attr("X2") * 1) - ($(element).attr("X1") * 1));
            $("config>ROIConfig>item>rectangle>height:eq(" + id + ")", xmlDoc).text(($(element).attr("Y2") * 1) - ($(element).attr("Y1") * 1));
        });

        return XMLDoc2XMLStr(xmlDoc);
    },
    saveData: function() {
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/SetROIConfig",
                type: "POST",
                async: true,
                data: ROIConfigModel.getSaveData(),
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    window.top.hideLoading();
                    if($("config",result).attr("status") === "success"){
                        ShowFloatError($("#btnSave"), LangCtrl._L_("saveSuccess"), { left: 15 });
                    }else{
                        ShowFloatError($("#btnSave"), LangCtrl._L_("saveFailed"), { left: 15 });
                    }
//                    commSaveResponseHadler(result);
//                    ROIConfigModel.getData();
                }
            });
        } catch (ex) {
            alert(ex);
        }
    },
    setOCX: function() {
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/GetPortConfig",
                type: "POST",
                async: true,
                data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    window.top.hideLoading();
                    netPort = $("config>port>netPort", result).text() * 1;
                    NetLiveMonitor =  LoadPlugin("divOCX","NetLiveMonitor");

                    if(NetLiveMonitor){
                        // 设置模式
                        var sendXML = OCX_XML_SetPreViewModel("ReadOnly");
                        NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
                    }

                    ROIConfigModel.bindFun();

                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    }

};

//OCX调用js方法
function NotifyResultToJs(strXMLFormat, lStrLen) {
    var $xmlDoc = $(XMLStr2XMLDoc(strXMLFormat));

    // OCX已创建好窗口，通知可以登录了
    if ($("statenotify[type=\"Login\"]", $xmlDoc).length > 0) {
        var userInfo = Decryption($.cookie("auInfo"));
        var userInfoArr = userInfo.split(":");
        // 设置登录信息
        var username = userInfoArr[0];
        var password = userInfoArr[1];
        var ip = serverIp;
        var port = netPort;
        var id = "";
        var sendXML = OCX_XML_SetLoginInfo(username, password, ip, port, id);
        NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);

        // 设置预览码流索引
        var sendXML = OCX_XML_SetStreamType(2);
        NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
    }

    if ($("statenotify[type=\"GetOriginalWH\"]", $xmlDoc).length > 0) {
        $("#divOCX").css({width:"640px",height:"480px"});
        ROIConfigModel.getData();
    }

    var connectstate = $("statenotify[type='connectstate']",$xmlDoc);
    if(connectstate.length > 0){
        if($(">status", connectstate).text() === "success"){
            window.top.hideLoading();
        }else{
            window.top.showLoading(window.top.LangCtrl._L_("connectError"));
        }
    }

    var Connect  = $("statenotify[type='Connect']",$xmlDoc);
    if(Connect.length > 0){
        if($(">status", Connect).text() === "limit"){
            window.top.MsgBoxHelper.Show("info", LangCtrl._L_("infoTip"), LangCtrl._L_("limit"), ROIConfigModel.getData);
        }
    }

}

