﻿var xmlDoc;
var rtspPort,netPort; //RTSP端口
var NetLiveMonitor; //视频控件
var xmlDocReset;

$(function() {
	CameraModule.initCtrl();
    closeStream();
});

var CameraModule = {
    frequency:"",
	mapping: {
		chkWideDynamic: "config>image>WDR>switch",
		chkSharpen: "config>image>sharpen>switch",
		chkDenoise: "config>image>denoise>switch",
		chkAutoIris: "config>image>irisSwitch",
		cboWhiteBalance: "config>image>whiteBalance>mode",
		cboFrequency: "config>image>frequency",
		cboDayNight: "config>image>IRCutMode",
        sensitivity: "config>image>IRCutConvSen",
        autoExposureMode: "config>image>autoExposureMode>mode",
        chkLightInhibit: "config>image>HLC>switch"
    },
	toggleWideDynamic: function(enabled) {
		$("#valueWideDynamic").attr("disabled", !enabled);
		$("#sliderWideDynamic").slider("setProperty", "enable", enabled);
//		if (!enabled) {
//			var wideDynamicNode = $("config>image>WDR>value", xmlDoc);
//			$("#sliderWideDynamic").slider("setValue", wideDynamicNode.text() ? wideDynamicNode.text() : wideDynamicNode.attr("default"));
//		}
	},
	toggleSharpen: function(enabled) {
		$("#valueSharpen").attr("disabled", !enabled);
		$("#sliderSharpen").slider("setProperty", "enable", enabled);
//		if (!enabled) {
//			var sharpenNode = $("config>image>sharpen>value", xmlDoc);
//			$("#sliderSharpen").slider("setValue", sharpenNode.text() ? sharpenNode.text() : sharpenNode.attr("default"));
//		}
	},
	toggleDenoise: function(enabled) {
		$("#valueDenoise").attr("disabled", !enabled);
		$("#sliderDenoise").slider("setProperty", "enable", enabled);
//		if (!enabled) {
//			var denoiseNode = $("config>image>denoise>value", xmlDoc);
//			$("#sliderDenoise").slider("setValue", denoiseNode.text() ? denoiseNode.text() : denoiseNode.attr("default"));
//		}
	},
	toggleWhiteBalance: function(enabled) {
		$("#trBalanceRed")[enabled ? "show" : "hide"]();
		$("#trBalanceBlue")[enabled ? "show" : "hide"]();
	},
	toggleDayNight: function(enabled) {
		$("#trDayToNight")[enabled ? "show" : "hide"]();
		$("#trNightToDay")[enabled ? "show" : "hide"]();
	},
    toggleSensitivity: function(enabled) {
        $("#trSensitivity")[enabled ? "show" : "hide"]();
    },
    toggleAutoExposure: function(enabled) {
        $("#trAutoExposureModeValue")[enabled ? "show" : "hide"]();
    },
    toggleLightInhibit: function(enabled) {
        $("#valueLightInhibit").attr("disabled", !enabled);
        $("#sliderLightInhibit").slider("setProperty", "enable", enabled);
        if (!enabled) {
            var lightInhibiNtode = $("config>image>HLC>value", xmlDoc);
            $("#sliderLightInhibit").slider("setValue", lightInhibiNtode.text() ? lightInhibiNtode.text() : lightInhibiNtode.attr("default"));
        }
    },
	initCtrl: function() {
		$("#Content", window.top.document).css({ "min-width": "1260px" });
		$("#sliderBrightness").slider({
			minValue: 0,
			maxValue: 0,
			maxWidth:124,
			thumbCss:"slider_thumb_1",
			valueChangeEvent: function(value) {
				$("#valueBrightness").val(value);
			},
			setValueCompleteEvent: function(value) {
				CameraModule.setData({ bright: value });
			}
		});

		$("#valueBrightness").bind("blur", function() {
			$("#sliderBrightness").slider("setValueWithEvent", $("#valueBrightness").val());
		}).keydown(function(ev) {
			ev = ev || event;
			if (isEnter(ev))
				$("#sliderBrightness").slider("setValueWithEvent", $("#valueBrightness").val());
		});

		$("#sliderContrast").slider({
			minValue: 0,
			maxValue: 0,
			maxWidth: 124,
			thumbCss: "slider_thumb_1",
			valueChangeEvent: function(value) {
				$("#valueContrast").val(value);
			},
			setValueCompleteEvent: function(value) {
				CameraModule.setData({ contrast: value });
			}
		});
		$("#valueContrast").bind("blur", function() {
			$("#sliderContrast").slider("setValueWithEvent", $("#valueContrast").val());
		}).keydown(function(ev) {
			ev = ev || event;
			if (isEnter(ev))
				$("#sliderContrast").slider("setValueWithEvent", $("#valueContrast").val());
		});

		$("#sliderChroma").slider({
			minValue: 0,
			maxValue: 0,
			maxWidth: 124,
			thumbCss: "slider_thumb_1",
			valueChangeEvent: function(value) {
				$("#valueChroma").val(value);
			},
			setValueCompleteEvent: function(value) {
				CameraModule.setData({ hue: value });
			}
		});

		$("#valueChroma").bind("blur", function() {
			$("#sliderChroma").slider("setValueWithEvent", $("#valueChroma").val());
		}).keydown(function(ev) {
			ev = ev || event;
			if (isEnter(ev))
				$("#sliderChroma").slider("setValueWithEvent", $("#valueChroma").val());
		});

		$("#sliderSaturation").slider({
			minValue: 0,
			maxValue: 0,
			maxWidth: 124,
			thumbCss: "slider_thumb_1",
			valueChangeEvent: function(value) {
				$("#valueSaturation").val(value);
			},
			setValueCompleteEvent: function(value) {
				CameraModule.setData({ saturation: value });
			}
		});

		$("#valueSaturation").bind("blur", function() {
			$("#sliderSaturation").slider("setValueWithEvent", $("#valueSaturation").val());
		}).keydown(function(ev) {
			ev = ev || event;
			if (isEnter(ev))
				$("#sliderSaturation").slider("setValueWithEvent", $("#valueSaturation").val());
		});

		$("#sliderWideDynamic").slider({
			enable: false,
			minValue: 0,
			maxValue: 0,
			maxWidth: 124,
			thumbCss: "slider_thumb_1",
			valueChangeEvent: function(value) {
				$("#valueWideDynamic").val(value);
			},
			setValueCompleteEvent: function(value) {
				CameraModule.setData({ WDR: { "switch": $("#chkWideDynamic").attr("checked") ? "true" : "false", value: value } });
			}
		});

		$("#valueWideDynamic").bind("blur", function() {
			$("#sliderWideDynamic").slider("setValueWithEvent", $("#valueWideDynamic").val());
		}).keydown(function(ev) {
			ev = ev || event;
			if (isEnter(ev))
				$("#sliderWideDynamic").slider("setValueWithEvent", $("#valueWideDynamic").val());
		});

		$("#sliderSharpen").slider({
			enable: false,
			minValue: 0,
			maxValue: 0,
			maxWidth: 124,
			thumbCss: "slider_thumb_1",
			valueChangeEvent: function(value) {
				$("#valueSharpen").val(value);
			},
			setValueCompleteEvent: function(value) {
				CameraModule.setData({ sharpen: { "switch": $("#chkSharpen").attr("checked") ? "true" : "false", value: value } });
			}
		});

		$("#valueSharpen").bind("blur", function() {
			$("#sliderSharpen").slider("setValueWithEvent", $("#valueSharpen").val());
		}).keydown(function(ev) {
			ev = ev || event;
			if (isEnter(ev))
				$("#sliderSharpen").slider("setValueWithEvent", $("#valueSharpen").val());
		});

		$("#sliderDenoise").slider({
			enable: false,
			minValue: 0,
			maxValue: 0,
			maxWidth: 124,
			thumbCss: "slider_thumb_1",
			valueChangeEvent: function(value) {
				$("#valueDenoise").val(value);
			},
			setValueCompleteEvent: function(value) {
				CameraModule.setData({ denoise: { "switch": $("#chkDenoise").attr("checked") ? "true" : "false", value: value } });
			}
		});

		$("#valueDenoise").bind("blur", function() {
			$("#sliderDenoise").slider("setValueWithEvent", $("#valueDenoise").val());
		}).keydown(function(ev) {
			ev = ev || event;
			if (isEnter(ev))
				$("#sliderDenoise").slider("setValueWithEvent", $("#valueDenoise").val());
		});
		
		$("#cboWhiteBalance").change(function(event) {
			CameraModule.toggleWhiteBalance($(this).val() == "manual");
			CameraModule.setData({ whiteBalance: { mode: $(this).val(), red: $("#sliderWhiteBalanceRed").slider("getValue"), blue: $("#sliderWhiteBalanceBlue").slider("getValue") } });
		});

		$("#sliderWhiteBalanceRed").slider({
			minValue: 0,
			maxValue: 0,
			maxWidth: 124,
			thumbCss: "slider_thumb_1",
			valueChangeEvent: function(value) {
				$("#valueWhiteBalanceRed").val(value);
			},
			setValueCompleteEvent: function(value) {
				CameraModule.setData({ whiteBalance: { mode: $("#cboWhiteBalance").val(), red: value, blue: $("#sliderWhiteBalanceBlue").slider("getValue") } });
			}
		});

		$("#valueWhiteBalanceRed").bind("blur", function() {
			$("#sliderWhiteBalanceRed").slider("setValueWithEvent", $("#valueWhiteBalanceRed").val());
		}).keydown(function(ev) {
			ev = ev || event;
			if (isEnter(ev))
				$("#sliderWhiteBalanceRed").slider("setValueWithEvent", $("#valueWhiteBalanceRed").val());
		});

		$("#sliderWhiteBalanceBlue").slider({
			minValue: 0,
			maxValue: 0,
			maxWidth: 124,
			thumbCss: "slider_thumb_1",
			valueChangeEvent: function(value) {
				$("#valueWhiteBalanceBlue").val(value);
			},
			setValueCompleteEvent: function(value) {
				CameraModule.setData({ whiteBalance: { mode: $("#cboWhiteBalance").val(), red: $("#sliderWhiteBalanceRed").slider("getValue"), blue: value } });
			}
		});

        $("#AutoExposureModeValue").slider({
            minValue: 0,
            maxValue: 0,
            maxWidth: 124,
            thumbCss: "slider_thumb_1",
            valueChangeEvent: function(value) {
                $("#valueExposureMode").val(value);
            },
            setValueCompleteEvent: function(value) {
                CameraModule.setData({ autoExposureMode: { mode: $("#autoExposureMode").val(),  value: $("#AutoExposureModeValue").slider("getValue") } });
            }
        });

		$("#valueWhiteBalanceBlue").bind("blur", function() {
			$("#sliderWhiteBalanceBlue").slider("setValueWithEvent", $("#valueWhiteBalanceBlue").val());
		}).keydown(function(ev) {
			ev = ev || event;
			if (isEnter(ev))
				$("#sliderWhiteBalanceBlue").slider("setValueWithEvent", $("#valueWhiteBalanceBlue").val());
		});

        $("#sliderLightInhibit").slider({
            enable: false,
            minValue: 0,
            maxValue: 20,
            maxWidth: 124,
            thumbCss: "slider_thumb_1",
            valueChangeEvent: function(value) {
                $("#valueLightInhibit").val(value);
            },
            setValueCompleteEvent: function(value) {
                CameraModule.setData({ HLC: { "switch": $("#chkLightInhibit").attr("checked") ? "true" : "false", value: value } });
            }
        });
        $("#valueLightInhibit").bind("blur", function() {
            $("#sliderLightInhibit").slider("setValueWithEvent", $("#valueLightInhibit").val());
        }).keydown(function(ev) {
            ev = ev || event;
            if (isEnter(ev))
                $("#sliderLightInhibit").slider("setValueWithEvent", $("#valueLightInhibit").val());
        });

        $("#valueDayToNight,#valueNightToDay").timeInput();

        $("#chkLightInhibit").click(function() {
            CameraModule.toggleLightInhibit($(this).attr("checked"));
            CameraModule.setData({ HLC: { "switch": $(this).attr("checked") ? "true" : "false", value: $("#sliderLightInhibit").slider("getValue") } });
        });

		$("#chkWideDynamic").click(function() {
			CameraModule.toggleWideDynamic($(this).attr("checked"));
			CameraModule.setData({ WDR: { "switch": $(this).attr("checked") ? "true" : "false", value: $("#sliderWideDynamic").slider("getValue") } });
		});

		$("#chkSharpen").click(function() {
			CameraModule.toggleSharpen($(this).attr("checked"));
			CameraModule.setData({ sharpen: { "switch": $(this).attr("checked") ? "true" : "false", value: $("#sliderSharpen").slider("getValue") } });
		});

		$("#chkDenoise").click(function() {
			CameraModule.toggleDenoise($(this).attr("checked"));
			CameraModule.setData({ denoise: { "switch": $(this).attr("checked") ? "true" : "false", value: $("#sliderDenoise").slider("getValue") } });
		});

		$("#chkAutoIris").click(function() {
			CameraModule.setData({ irisSwitch: $(this).attr("checked") ? "true" : "false" });
		});

		$("#cboFrequency").on("focus",function(){
            CameraModule.frequency = $(this).val();
        }).change(function() {
            var $this = $(this);
            window.top.MsgBoxHelper.Show("y/n", LangCtrl._L_("infoTip"), LangCtrl._L_("confirmRestartCamera"), function(flag) {
                if (flag) {
                    CameraModule.setData({ frequency: $this.val() });
                    window.top.showLoading(LangCtrl._L_("loadingTip"));
                    $(".loadingIndicator_tip",window.top.document).css({background:"#5A626B"});
                    $(".msg_border>.msg",window.top.document).css({color:"white"});
                    setTimeout("reconnect()", 10000);
                }else{
                    $this.val(CameraModule.frequency);
                }
            },400);
		});

		$("#cboDayNight").change(function() {
			CameraModule.setData({ IRCutMode: $(this).val() });
			CameraModule.toggleDayNight($(this).val() == "time");
            CameraModule.toggleSensitivity($(this).val() == "auto");
		});

        $("#sensitivity").change(function() {
            CameraModule.setData({ IRCutConvSen: $(this).val() });
        });

        $("#autoExposureMode").change(function() {
            CameraModule.setData({ autoExposureMode: { mode: $("#autoExposureMode").val(),  value: $("#AutoExposureModeValue").slider("getValue") } });
            CameraModule.toggleAutoExposure($(this).val() == "manual");
        });

		$("#valueDayToNight").bind("blur", function() {
			CameraModule.setData({ IRCutDayTime: $(this).val() });
		}).keydown(function(ev) {
			ev = ev || event;
			if (isEnter(ev))
				CameraModule.setData({ IRCutDayTime: $(this).val() });
		});
		$("#valueNightToDay").bind("blur", function() {
			CameraModule.setData({ IRCutNightTime: $(this).val() });
		}).keydown(function(ev) {
			ev = ev || event;
			if (isEnter(ev))
				CameraModule.setData({ IRCutNightTime: $(this).val() });
		});

		$(":radio[name=\"rdoImgMirror\"]").click(function() {
			CameraModule.setData({ mirrorSwitch: $(this).val() });
		});

		$(":radio[name=\"rdoOverTurn\"]").click(function() {
			CameraModule.setData({ flipSwitch: $(this).val() });
		});

        $(":radio[name=\"Smartir\"]").click(function() {
            CameraModule.setData({ SMARTIR: $(this).val() });
        });

		$("#btnRepairBadPixel").click(function() {
			CameraModule.repairBadPixel();
		});

        $("#infraredMode").change(function() {
            CameraModule.setData({ InfraredMode: $(this).val() });
        });

		$("#btnToDefault").click(function() {
			CameraModule.toDefault();
		});

        $("#btnReset").click(function(){
            CameraModule.reset();
        });

        if(!NetLiveMonitor){
            CameraModule.setOCX();
        }

	},
    setModuleValue: function(xmlDoc){
        if (CameraModule.isSupportBright) {
            var brightNode = $("config>image>bright", xmlDoc);
            $("#sliderBrightness").slider("setValue", brightNode.text() ? brightNode.text() : brightNode.attr("default"));
        }

        if (CameraModule.isSupportContrast) {
            var contrastNode = $("config>image>contrast", xmlDoc);
            $("#sliderContrast").slider("setValue", contrastNode.text() ? contrastNode.text() : contrastNode.attr("default"));
        }

        if (CameraModule.isSupportHue) {
            var hueNode = $("config>image>hue", xmlDoc);
            $("#sliderChroma").slider("setValue", hueNode.text() ? hueNode.text() : hueNode.attr("default"));
        }

        if (CameraModule.isSupportSaturation) {
            var saturationNode = $("config>image>saturation", xmlDoc);
            $("#sliderSaturation").slider("setValue", saturationNode.text() ? saturationNode.text() : saturationNode.attr("default"));
        }

        if (CameraModule.isSupportWideDynamic) {
            var wideDynamicNode = $("config>image>WDR>value", xmlDoc);
            $("#sliderWideDynamic").slider("setValue", wideDynamicNode.text() ? wideDynamicNode.text() : wideDynamicNode.attr("default"));
        }

        if (CameraModule.isSupportSharpen) {
            var sharpenNode = $("config>image>sharpen>value", xmlDoc);
            $("#sliderSharpen").slider("setValue", sharpenNode.text() ? sharpenNode.text() : sharpenNode.attr("default"));
            CameraModule.toggleSharpen($(CameraModule.mapping.chkSharpen, xmlDoc).text() === "true");
        }

        if (CameraModule.isSupportDenoise) {
            var denoiseNode = $("config>image>denoise>value", xmlDoc);
            $("#sliderDenoise").slider("setValue", denoiseNode.text() ? denoiseNode.text() : denoiseNode.attr("default"));
            CameraModule.toggleDenoise($(CameraModule.mapping.chkDenoise, xmlDoc).text() === "true");
        }

        if (CameraModule.isSupportWhiteBalance) {
            var whiteBalanceRedNode = $("config>image>whiteBalance>red", xmlDoc);
            $("#sliderWhiteBalanceRed").slider("setValue", whiteBalanceRedNode.text() ? whiteBalanceRedNode.text() : whiteBalanceRedNode.attr("default"));
            var whiteBalanceBlueNode = $("config>image>whiteBalance>blue", xmlDoc);
            $("#sliderWhiteBalanceBlue").slider("setValue", whiteBalanceBlueNode.text() ? whiteBalanceBlueNode.text() : whiteBalanceBlueNode.attr("default"));
            CameraModule.toggleWhiteBalance($(CameraModule.mapping.cboWhiteBalance, xmlDoc).text() === "manual");
        }

        if (CameraModule.isSupportIRCutMode) {
            var IRCutDayTime = $("config>image>IRCutDayTime", xmlDoc).text();
            var IRCutNightTime = $("config>image>IRCutNightTime", xmlDoc).text();
//            var format = IRCutDayTime.split(":").length == 2 ? "hh:mm" : "hh:mm:ss";
//            $("#valueDayToNight,#valueNightToDay").timeInput("setFormat",format);
            $("#valueDayToNight").val(IRCutDayTime);
            $("#valueNightToDay").val(IRCutNightTime);

            var cboSensitivity = $("#sensitivity");
            cboSensitivity.empty();
            $("config>types>IRCutConvSen>enum", xmlDoc).each(function(i, ele) {
                $("<option value=" + $(ele).text() + ">" + LangCtrl._L_($(ele).text()) + "</option>").appendTo(cboSensitivity);
            });
            cboSensitivity.val($("config>image>IRCutConvSen",xmlDoc).text());

            CameraModule.toggleDayNight($(CameraModule.mapping.cboDayNight, xmlDoc).text() === "time");
            CameraModule.toggleSensitivity($(CameraModule.mapping.cboDayNight, xmlDoc).text() === "auto");
        }

        if (CameraModule.isSupportWideDynamic) {
            CameraModule.toggleWideDynamic($(CameraModule.mapping.chkWideDynamic, xmlDoc).text() === "true");
        }

        if (CameraModule.isSupportMirror) {
            var imageMirror = $("config>image>mirrorSwitch", xmlDoc).text();
            $(":radio[name=\"rdoImgMirror\"]").each(function(index, element) {
                if (imageMirror == $(this).val()) {
                    $(this).attr("checked", true);
                    return false;
                }
            });
        }

        if (CameraModule.isSupportFlip) {
            var imageFlip = $("config>image>flipSwitch", xmlDoc).text();
            $(":radio[name=\"rdoOverTurn\"]").each(function(index, element) {
                if (imageFlip == $(this).val()) {
                    $(this).attr("checked", true);
                    return false;
                }
            });
        }

        if (CameraModule.isSupportSmartir) {
            var imageSmartir = $("config>image>SMARTIR", xmlDoc).text();
            $(":radio[name=\"Smartir\"]").each(function(index, element) {
                if (imageSmartir == $(this).val()) {
                    $(this).attr("checked", true);
                    return false;
                }
            });
        }

        if (CameraModule.isSupportInfrared) {
            var InfraredMode = $("config>image>InfraredMode", xmlDoc).text();
            $("#infraredMode").val(InfraredMode);
        }

        XmlHttpClient.BindPageByXml(CameraModule.mapping, xmlDoc);
    },
	getData: function() {
		window.top.showLoading();
		try {
			XmlHttpClient.SendHttpRequest({
				url: serverBase + "/GetImageConfig/1",
				type: "POST",
				async: true,
				data: "",
				beforeSend: XmlHttpClient.CommBeforeSend,
				callback: function(result) {
					xmlDoc = result;
                    xmlDocReset = result;
					CameraModule.bindCtrlData();
                    CameraModule.setModuleValue(xmlDoc);
					window.top.hideLoading();
				}
			});
		}
		catch (ex) {
			alert(ex);
		}
	},
	bindCtrlData: function() {
		function getWhitebalanceMode(value) {
			switch (value) {
				case "auto":
					return LangCtrl._L_("auto");
				default:
					return LangCtrl._L_(value);
			}
		}

		function getFrequencyMode(value) {
			switch (value) {
				default:
					return value;
			}
		}

		function getDayNightMode(value) {
			switch (value) {
				case "auto":
					return LangCtrl._L_("auto");
				case "day":
					return LangCtrl._L_("daytime");
				case "night":
					return LangCtrl._L_("night");
				case "time":
					return LangCtrl._L_("schedule");
                default :
                    return LangCtrl._L_(value);
			}
		}

		function setRange(slider, xmlPath) {
			var node = $(xmlPath, xmlDoc);
			if (node.size() == 0) {
				return;
			}
			var min = node.attr("min");
			var max = node.attr("max");
			var type = node.attr("type");
			var minValue = min * 1;
			var maxValue = max * 1;
			if (!min) {
				if (type == "uint8") {
					minValue = 0;
				}
			}
			if (!max) {
				if (type == "uint8") {
					maxValue = 255;
				}
			}
			slider.slider("setProperty", "minValue", minValue);
			slider.slider("setProperty", "maxValue", maxValue);
		}
        function setTextRange(slider, xmlPath) {
            var node = $(xmlPath, xmlDoc);
            if (node.size() == 0) {
                return;
            }
            var min = node.attr("min");
            var max = node.attr("max");
            var type = node.attr("type");
            var minValue = min * 1;
            var maxValue = max * 1;
            if (!min) {
                if (type == "uint8") {
                    minValue = 0;
                }
            }
            if (!max) {
                if (type == "uint8") {
                    maxValue = 255;
                }
            }
            initNumberInput(slider, { minValue: min, maxValue: max });
        }

		CameraModule.isSupportBright = $("config>image>bright", xmlDoc).size() > 0;
		CameraModule.isSupportContrast = $("config>image>contrast", xmlDoc).size() > 0;
		CameraModule.isSupportHue = $("config>image>hue", xmlDoc).size() > 0;
		CameraModule.isSupportSaturation = $("config>image>saturation", xmlDoc).size() > 0;
		CameraModule.isSupportWideDynamic = $("config>image>WDR>switch", xmlDoc).size() > 0
			&& $("config>image>WDR>value", xmlDoc).size() > 0;
		CameraModule.isSupportSharpen = $("config>image>sharpen>switch", xmlDoc).size() > 0
			&& $("config>image>sharpen>value", xmlDoc).size() > 0;
		CameraModule.isSupportDenoise = $("config>image>denoise>switch", xmlDoc).size() > 0
			&& $("config>image>denoise>value", xmlDoc).size() > 0;
		CameraModule.isSupportIrisSwitch = $("config>image>irisSwitch", xmlDoc).size() > 0;
		CameraModule.isSupportWhiteBalance = $("config>image>whiteBalance", xmlDoc).size() > 0;
		CameraModule.isSupportFrequency = $("config>image>frequency", xmlDoc).size() > 0;
		CameraModule.isSupportIRCutMode = $("config>image>IRCutMode", xmlDoc).size() > 0;
		CameraModule.isSupportMirror = $("config>image>mirrorSwitch", xmlDoc).size() > 0;
		CameraModule.isSupportFlip = $("config>image>flipSwitch", xmlDoc).size() > 0;
        CameraModule.isSupportInfrared = $("config>image>InfraredMode", xmlDoc).size() > 0;
        CameraModule.isSupportIRCutConsenv = $("config>image>IRCutConvSen", xmlDoc).size() > 0;
        CameraModule.isSupportAutoExposureMode = $("config>image>autoExposureMode", xmlDoc).size() > 0;
        CameraModule.isLightInhibit = $("config>image>HLC>switch", xmlDoc).size() > 0
            && $("config>image>HLC>value", xmlDoc).size() > 0;
        CameraModule.isSupportSmartir = $("config>image>SMARTIR", xmlDoc).size() > 0;

        $("#trLightInhibit")[CameraModule.isLightInhibit ? "show" : "remove"]();
		$("#trBrightness")[CameraModule.isSupportBright ? "show" : "remove"]();
		$("#trContrast")[CameraModule.isSupportContrast ? "show" : "remove"]();
		$("#trChroma")[CameraModule.isSupportHue ? "show" : "remove"]();
		$("#trSaturation")[CameraModule.isSupportSaturation ? "show" : "remove"]();
		$("#trWideDynamic")[CameraModule.isSupportWideDynamic ? "show" : "remove"]();
		$("#trSharpen")[CameraModule.isSupportSharpen ? "show" : "remove"]();
		$("#trDenoise")[CameraModule.isSupportDenoise ? "show" : "remove"]();
		$("#trIrisSwitch")[CameraModule.isSupportIrisSwitch ? "show" : "remove"]();
		$("#trWhiteBalance")[CameraModule.isSupportWhiteBalance ? "show" : "remove"]();
		if (!CameraModule.isSupportWhiteBalance) {
			$("#trBalanceRed, #trBalanceBlue").remove();
		}
		$("#trFrequency")[CameraModule.isSupportFrequency ? "show" : "remove"]();
		$("#trDayNight")[CameraModule.isSupportIRCutMode ? "show" : "remove"]();
        $("#trSensitivity")[CameraModule.isSupportIRCutConsenv ? "show" : "remove"]();
        $("#trAutoExposureMode")[CameraModule.isSupportAutoExposureMode ? "show" : "remove"]();

		if (!CameraModule.isSupportIRCutMode) {
			$("#trDayToNight, #trNightToDay").remove();
		}
		$("#trMirror")[CameraModule.isSupportMirror ? "show" : "remove"]();
		$("#trOverTurn")[CameraModule.isSupportFlip ? "show" : "remove"]();
        $("#trInfraredMode")[CameraModule.isSupportInfrared ? "show" : "remove"]();
        $("#trSmartir")[CameraModule.isSupportSmartir ? "show" : "remove"]();

		$(".rightContent").find("tr:odd").addClass("oddRow");

		setRange($("#sliderBrightness"), "config>image>bright");
        setTextRange($("#valueBrightness"), "config>image>bright");
		setRange($("#sliderContrast"), "config>image>contrast");
        setTextRange($("#valueContrast"), "config>image>contrast");
		setRange($("#sliderChroma"), "config>image>hue");
        setTextRange($("#valueChroma"), "config>image>hue");
		setRange($("#sliderSaturation"), "config>image>saturation");
        setTextRange($("#valueSaturation"), "config>image>saturation");
		if (CameraModule.isSupportWideDynamic) {
			setRange($("#sliderWideDynamic"), "config>image>WDR>value");
            setTextRange($("#valueWideDynamic"), "config>image>WDR>value");
		}
		setRange($("#sliderSharpen"), "config>image>sharpen>value");
        setTextRange($("#valueSharpen"), "config>image>sharpen>value");
		setRange($("#sliderDenoise"), "config>image>denoise>value");
        setTextRange($("#valueDenoise"), "config>image>denoise>value");
		setRange($("#sliderWhiteBalanceRed"), "config>image>whiteBalance>red");
        setTextRange($("#valueWhiteBalanceRed"), "config>image>whiteBalance>red");
		setRange($("#sliderWhiteBalanceBlue"), "config>image>whiteBalance>blue");
        setTextRange($("#valueWhiteBalanceRed"), "config>image>whiteBalance>blue");
        setRange($("#AutoExposureModeValue"), "config>image>autoExposureMode>value");
        setTextRange($("#valueExposureMode"), "config>image>autoExposureMode>value");
        setRange($("#sliderLightInhibit"), "config>image>sliderLightInhibit>value");
        setTextRange($("#valueLightInhibit"), "config>image>sliderLightInhibit>value");

		var cboWhiteBalance = $("#cboWhiteBalance");
		cboWhiteBalance.empty();
		$("config>types>whitebalanceMode>enum", xmlDoc).each(function(i, ele) {
			$("<option value=" + $(ele).text() + ">" + getWhitebalanceMode($(ele).text()) + "</option>").appendTo(cboWhiteBalance);
		});

		var cboFrequency = $("#cboFrequency");
		cboFrequency.empty();
		$("config>types>frequency>enum", xmlDoc).each(function(i, ele) {
			$("<option value=" + $(ele).text() + ">" + getFrequencyMode($(ele).text()) + "</option>").appendTo(cboFrequency);
		});

		if (CameraModule.isSupportIRCutMode) {
			var cboDayNight = $("#cboDayNight");
			cboDayNight.empty();
			$("config>types>IRCutMode>enum", xmlDoc).each(function(i, ele) {
				$("<option value=" + $(ele).text() + ">" + getDayNightMode($(ele).text()) + "</option>").appendTo(cboDayNight);
			});
		}

        if (CameraModule.isSupportInfrared) {
            var cboIfraredMode = $("#infraredMode");
            cboIfraredMode.empty();
            $("config>types>InfraredMode>enum", xmlDoc).each(function(i, ele) {
                $("<option value=" + $(ele).text() + ">" + LangCtrl._L_($(ele).text()) + "</option>").appendTo(cboIfraredMode);
            });
        }

        if(CameraModule.isSupportAutoExposureMode){
            var autoExposureMode = $("#autoExposureMode");
            autoExposureMode.empty();
            $("config>types>autoExposureMode>enum", xmlDoc).each(function(i, ele) {
                $("<option value=" + $(ele).text() + ">" + LangCtrl._L_($(ele).text()) + "</option>").appendTo(autoExposureMode);
            });
        }

        if (CameraModule.isLightInhibit) {
            CameraModule.toggleLightInhibit($(CameraModule.mapping.chkLightInhibit, xmlDoc).text() === "true");
            var lightInhibitNode = $("config>image>HLC>value",xmlDoc);
            $("#sliderLightInhibit").slider("setValue", lightInhibitNode.text() ? lightInhibitNode.text() : lightInhibitNode.attr("default"));
        }

	},
	getSaveData: function(mapping,param) {
        var xmlDoc;
        if(param === "default"){
            xmlDoc = XMLStr2XMLDoc(xmlHeader + "<config isDefault=\"true\"><image></image></config>");
        }else{
            xmlDoc = XMLStr2XMLDoc(xmlHeader + "<config><image></image></config>");
        }
//		var xmlDoc = XMLStr2XMLDoc(xmlHeader + "<config isDefault=\"true\"><image></image></config>");
		var root = $("config>image", xmlDoc);
		var configs = [ "frequency", "bright", "contrast", "hue", "saturation", "mirrorSwitch", "flipSwitch", "WDR","HLC","SMARTIR",
			, "whiteBalance", "denoise", "irisSwitch", "sharpen", "IRCutMode", "IRCutDayTime", "IRCutNightTime","IRCutConvSen","InfraredMode","autoExposureMode" ];
		$.each(configs, function(index, element) {
			var key = element;
			if (mapping[key] !== undefined) {
				if (key == "WDR" || key == "denoise" || key == "sharpen" || key == "HLC") {
					root.append(
						$(xmlDoc.createElement(key)).append(
							$(xmlDoc.createElement("switch")).append(
								$(xmlDoc.createTextNode(mapping[key]["switch"]))
							)
						).append(
							$(xmlDoc.createElement("value")).append(
								$(xmlDoc.createTextNode(mapping[key]["value"]))
							)
						)
					);
				} else if (key == "whiteBalance") {
					root.append(
						$(xmlDoc.createElement(key)).append(
							$(xmlDoc.createElement("mode")).append(
								$(xmlDoc.createTextNode(mapping[key]["mode"]))
							)
						).append(
							$(xmlDoc.createElement("red")).append(
								$(xmlDoc.createTextNode(mapping[key]["red"]))
							)
						).append(
							$(xmlDoc.createElement("blue")).append(
								$(xmlDoc.createTextNode(mapping[key]["blue"]))
							)
						)
					);
				}else if (key == "autoExposureMode") {
                    root.append(
                        $(xmlDoc.createElement(key)).append(
                            $(xmlDoc.createElement("mode")).append(
                                $(xmlDoc.createTextNode(mapping[key]["mode"]))
                            )
                        ).append(
                            $(xmlDoc.createElement("value")).append(
                                $(xmlDoc.createTextNode(mapping[key]["value"]))
                            )
                        )
                    );
                }else {
					root.append($(xmlDoc.createElement(key)).append($(xmlDoc.createTextNode(mapping[key]))));
				}
			}
		});
		
		return XMLDoc2XMLStr(xmlDoc);
	},
	setData: function(mapping,param) {
		try {
			XmlHttpClient.SendHttpRequest({
				url: serverBase + "/SetImageConfig/1",
				type: "POST",
				async: true,
				data: CameraModule.getSaveData(mapping,param),
				beforeSend: XmlHttpClient.CommBeforeSend,
				callback: function(result) {
                    if($("config",result).attr("status") == "success"){
                        ShowFloatError($("#tip"), LangCtrl._L_("setSuccess"), { top: 10,left:90 },"success");
                    }else{
                        ShowFloatError($("#tip"), LangCtrl._L_("setFailed"), { top: 10,left:90 },"failed");
                    }
				}
			});
		}
		catch (ex) {
			alert(ex);
		}
	},
	toDefault: function() {
		var defaultObj = {};

		if (CameraModule.isSupportBright) {
			defaultObj.bright = $("config>image>bright", xmlDoc).attr("default");
			$("#sliderBrightness").slider("setValue", defaultObj.bright);
		}

		if (CameraModule.isSupportContrast) {
			defaultObj.contrast = $("config>image>contrast", xmlDoc).attr("default");
			$("#sliderContrast").slider("setValue", defaultObj.contrast);
		}

		if (CameraModule.isSupportHue) {
			defaultObj.hue = $("config>image>hue", xmlDoc).attr("default");
			$("#sliderChroma").slider("setValue", defaultObj.hue);
		}

		if (CameraModule.isSupportSaturation) {
			defaultObj.saturation = $("config>image>saturation", xmlDoc).attr("default");
			$("#sliderSaturation").slider("setValue", defaultObj.saturation);
		}

		if (CameraModule.isSupportWideDynamic) {
			defaultObj.WDR = {};
			defaultObj.WDR["switch"] = $(CameraModule.mapping.chkWideDynamic, xmlDoc).attr("default");
			defaultObj.WDR.value = $("config>image>WDR>value", xmlDoc).attr("default");
			$("#sliderWideDynamic").slider("setValue", defaultObj.WDR.value);
			$("#chkWideDynamic").attr("checked", defaultObj.WDR["switch"] === "true");
			CameraModule.toggleWideDynamic(defaultObj.WDR["switch"] === "true");
		}

		if (CameraModule.isSupportSharpen) {
			defaultObj.sharpen = {};
			defaultObj.sharpen["switch"] = $(CameraModule.mapping.chkSharpen, xmlDoc).attr("default");
			defaultObj.sharpen.value = $("config>image>sharpen>value", xmlDoc).attr("default");
			$("#sliderSharpen").slider("setValue", defaultObj.sharpen.value);
			$("#chkSharpen").attr("checked", defaultObj.sharpen["switch"] === "true");
			CameraModule.toggleSharpen(defaultObj.sharpen["switch"] === "true");
		}

		if (CameraModule.isSupportDenoise) {
			defaultObj.denoise = {};
			defaultObj.denoise["switch"] = $(CameraModule.mapping.chkDenoise, xmlDoc).attr("default");
			defaultObj.denoise.value = $("config>image>denoise>value", xmlDoc).attr("default");
			$("#sliderDenoise").slider("setValue", defaultObj.denoise.value);
			$("#chkDenoise").attr("checked", defaultObj.denoise["switch"] === "true");
			CameraModule.toggleDenoise(defaultObj.denoise["switch"] === "true");
		}

		if (CameraModule.isSupportIrisSwitch) {
			defaultObj.irisSwitch = $(CameraModule.mapping.chkAutoIris, xmlDoc).attr("default");
			$("#chkAutoIris").attr("checked", defaultObj.irisSwitch === "true");
		}

		if (CameraModule.isSupportWhiteBalance) {
			defaultObj.whiteBalance = {};
			defaultObj.whiteBalance.mode = $(CameraModule.mapping.cboWhiteBalance, xmlDoc).attr("default");
			defaultObj.whiteBalance.red = $("config>image>whiteBalance>red", xmlDoc).attr("default");
			defaultObj.whiteBalance.blue = $("config>image>whiteBalance>blue", xmlDoc).attr("default");
			$("#sliderWhiteBalanceRed").slider("setValue", defaultObj.whiteBalance.red); 
			$("#sliderWhiteBalanceBlue").slider("setValue", defaultObj.whiteBalance.blue);
			$("#cboWhiteBalance").val(defaultObj.whiteBalance.mode);
			CameraModule.toggleWhiteBalance(defaultObj.whiteBalance.mode === "manual");
		}

        if (CameraModule.isSupportAutoExposureMode) {
            defaultObj.autoExposureMode = {};
            defaultObj.autoExposureMode.mode = $(CameraModule.mapping.autoExposureMode, xmlDoc).attr("default");
            defaultObj.autoExposureMode.value = $("config>image>autoExposureMode>value", xmlDoc).attr("default");
            $("#AutoExposureModeValue").slider("setValue", defaultObj.autoExposureMode.value);
            $("#autoExposureMode").val(defaultObj.autoExposureMode.mode);
            CameraModule.toggleAutoExposure(defaultObj.autoExposureMode.mode === "manual");
        }

//		if (CameraModule.isSupportFrequency) {
//			defaultObj.frequency = $(CameraModule.mapping.cboFrequency, xmlDoc).attr("default");
//			$("#cboFrequency").val(defaultObj.frequency);
//		}

		if (CameraModule.isSupportIRCutMode) {
			defaultObj.IRCutMode = $(CameraModule.mapping.cboDayNight, xmlDoc).attr("default");
            defaultObj.IRCutConvSen  = $("config>image>IRCutConvSen", xmlDoc).attr("default");
			$("#cboDayNight").val(defaultObj.IRCutMode);
			CameraModule.toggleDayNight(defaultObj.IRCutMode === "time");
            if(CameraModule.isSupportIRCutConsenv){
                CameraModule.toggleSensitivity(defaultObj.IRCutMode == "auto");
                $("#sensitivity").val( defaultObj.IRCutConvSen);
            }
		}

		if (CameraModule.isSupportMirror) {
			defaultObj.mirrorSwitch = $("config>image>mirrorSwitch", xmlDoc).attr("default");
			$(":radio[name=\"rdoImgMirror\"]").each(function(index, element) {
				if (defaultObj.mirrorSwitch == $(this).val()) {
					$(this).attr("checked", true);
					return false;
				}
			});
		}

        if (CameraModule.isSupportInfrared) {
            defaultObj.InfraredMode = $("config>image>InfraredMode", xmlDoc).attr("default");
            $("#infraredMode").val( defaultObj.InfraredMode);
        }

		if (CameraModule.isSupportFlip) {
			defaultObj.flipSwitch = $("config>image>flipSwitch", xmlDoc).attr("default");
			$(":radio[name=\"rdoOverTurn\"]").each(function(index, element) {
				if (defaultObj.flipSwitch == $(this).val()) {
					$(this).attr("checked", true);
					return false;
				}
			});
		}

        if (CameraModule.isSupportSmartir) {
            defaultObj.SMARTIR = $("config>image>SMARTIR", xmlDoc).attr("default");
            $(":radio[name=\"Smartir\"]").each(function(index, element) {
                if (defaultObj.SMARTIR == $(this).val()) {
                    $(this).attr("checked", true);
                    return false;
                }
            });
        }

        if (CameraModule.isLightInhibit) {
            defaultObj.HLC = {};
            defaultObj.HLC["switch"] = $(CameraModule.mapping.chkLightInhibit, xmlDoc).attr("default");
            defaultObj.HLC.value = $("config>image>lightInhibit>value", xmlDoc).attr("default");
            $("#sliderLightInhibit").slider("setValue", defaultObj.HLC.value);
            $("#chkLightInhibit").attr("checked", defaultObj.HLC["switch"] === "true");
            CameraModule.toggleLightInhibit(defaultObj.HLC["switch"] === "true");
        }

		CameraModule.setData(defaultObj,"default");
	},
	repairBadPixel: function() {
		window.top.showLoading();
		try {
			XmlHttpClient.SendHttpRequest({
				url: serverBase + "/BadPixelRepair",
				type: "POST",
				async: true,
				beforeSend: XmlHttpClient.CommBeforeSend,
				callback: function(result) {
					window.top.hideLoading();
					if ($("config", result).attr("status") == "success") {
						window.top.MsgBoxHelper.Show("success", LangCtrl._L_("successTip"), LangCtrl._L_("repairSuccess"), null);
					} else {
						window.top.MsgBoxHelper.Show("error", LangCtrl._L_("errorTip"), LangCtrl._L_("repairFailed"), null);
					}
				}
			});
		}
		catch (ex) {
			alert(ex);
		}
	},
    reset: function(){
        window.top.showLoading();
        try{
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/SetImageConfig/1",
                type: "POST",
                async: true,
                data: xmlDocReset,
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    CameraModule.setModuleValue(xmlDocReset);
                    window.top.hideLoading();
                    if($("config",result).attr("status") == "success"){
                        ShowFloatError($("#tip"), LangCtrl._L_("setSuccess"), { top: 10,left:90 },"success");
                    }else{
                        ShowFloatError($("#tip"), LangCtrl._L_("setFailed"), { top: 10,left:90 },"failed");
                    }
                }
            });
        }catch (e){
            alert(e);
        }
    },
	setOCX: function() {
//		window.top.showLoading();
		try {
			XmlHttpClient.SendHttpRequest({
				url: serverBase + "/GetPortConfig",
				type: "POST",
				async: true,
				data: "",
				beforeSend: XmlHttpClient.CommBeforeSend,
				callback: function(result) {
//					window.top.hideLoading();
                    netPort = $("config>port>netPort", result).text() * 1;
                    $("#divOCXCamera").empty();
					NetLiveMonitor = LoadPlugin("divOCXCamera","NetLiveMonitor");
					if(NetLiveMonitor){
						// 设置模式
						var sendXML = OCX_XML_SetPreViewModel("ReadOnly");
						NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
					}

				}
			});
		}
		catch (ex) {
			alert(ex);
		}
	}
};

//OCX调用js方法
function NotifyResultToJs(strXMLFormat, lStrLen) {
	var $xmlDoc = $(XMLStr2XMLDoc(strXMLFormat));

	// OCX已创建好窗口，通知可以登录了
	if ($("statenotify[type=\"Login\"]", $xmlDoc).length > 0) {
		var userInfo = Decryption($.cookie("auInfo"));
		var userInfoArr = userInfo.split(":");

		// 设置登录信息
		var username = userInfoArr[0];
		var password = userInfoArr[1];
		var id = "";
		var sendXML = OCX_XML_SetLoginInfo(username, password, serverIp, netPort, id);
		NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);

		// 设置预览码流索引
		var sendXML = OCX_XML_SetStreamType(2);
		NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
	}

	if ($("statenotify[type=\"GetOriginalWH\"]", $xmlDoc).length > 0) {
        $("#divOCXCamera").css({width:"400px",height:"300px"});
        CameraModule.getData();
	}
    var connectstate = $("statenotify[type='connectstate']",$xmlDoc);
    if(connectstate.length > 0){
        if($(">status", connectstate).text() === "success"){
            window.top.hideLoading();
        }else{
            window.top.showLoading(window.top.LangCtrl._L_("connectError"));
        }
    }

    var Connect  = $("statenotify[type='Connect']",$xmlDoc);
    if(Connect.length > 0){
        $("#divOCXCamera").css({width:"400px",height:"300px"});
        window.top.hideLoading();
        if($(">status", Connect).text() === "limit"){
            window.top.MsgBoxHelper.Show("info", LangCtrl._L_("infoTip"), LangCtrl._L_("limit"),  CameraModule.getData);
        }
    }
}

//检测重启
function reconnect() {
    XmlHttpClient.SendHttpRequest({
        url: serverBase + "/GetRebootStatus",
        type: "POST",
        async: true,
        data: "",
        timeout: 60000,
        beforeSend: XmlHttpClient.CommBeforeSend,
        callback: function(result) {
            if ($("rebootStatus", result).text() == "true") {
                $(".loadingIndicator_tip",window.top.document).css({background:"transparent"});
                $(".msg_border>.msg",window.top.document).css({color:"333"});
                window.top.hideLoading();
                $("#mainFrame", window.top.document).attr("src", MenuCtrl["menuList"]["live"]["url"]);
            }
            else {
                setTimeout("reconnect()", 5000);
            }

        },
        error: function() {
            setTimeout("reconnect()", 5000);
        }
    });
}