var xmlDoc;
var capsXmlDoc;

$(function() {
    initControl();
    $("#divParent").tab({
        map: [{ "tab": "liVideo", "content": "divVideo", init: initVideo },
            { "tab": "liAudio", "content": "divAudio", init: initAudio}]
    });
    $("#divParent").tab("selectLastTab");
    $("#Content",window.top.document).css({"min-width":"1080px"});
});

function initVideo() {
    VideoModule.getCapsData();
}

function initAudio() {
    AudioModule.getData();

}

var resolutionArr;
var VideoModule = {
    initCtrl: function() {
        $("#divVideoGrid").wbGrid({
            data: {
                colNames: ['id',LangCtrl._L_("streamName"), LangCtrl._L_("resolution"), LangCtrl._L_("rate")
                    , LangCtrl._L_("bitrateType"),LangCtrl._L_("bitrateMax"),LangCtrl._L_("videoQt")
                    ,LangCtrl._L_("GOP"),LangCtrl._L_("encodeType"),LangCtrl._L_("encodeLevel")
                ],
                colModel: [
                    { name: '@id', index: '@id',width: 80, align: "center", key:true, sortable: false , hidden: true},
                    { name: 'streamName', index: 'streamName',width: 80, align: "center", sortable: false },
                    { name: 'resolution', index: 'resolution',width: 110, align: "center", sortable: false,  formatter: "select",formatterParam: {
                        mode: "always",
                        getItems: function(streamArr) {
                            return $.map(streamArr["rateType"], function(element) {
                                var value = element["innerText"];
                                return { value: value, text: value };
                            });
                        },
                        events: [
                            {
                                name: "change",
                                handler: function (event) {
                                    var $this = $(this);
                                    var rowData = $("#divVideoGrid").wbGrid("getRowDataByCellInput", this)["data"];

                                    var arrType = rowData["rateType"];
                                    for(var n= 0,len = arrType.length;n<len;n++){
                                        if(arrType[n].innerText === rowData["resolution"]){
                                            var component =  $("#divVideoGrid").wbGrid("getStandardCellCtrl", rowData["@id"],"rate")[0];
                                            rowData["maxRate"] = arrType[n]["@maxFrameRate"];
                                            $(component).val( rowData["maxRate"]).focus();
                                            initNumberInput($(component), { minValue: 1, maxValue: rowData["maxRate"]  });
                                            break;
                                        }
                                    }

                                    if(rowData["@id"] ==  VideoModule.$alarmSnapBindStreamId){
                                        $("#photoSize").html((rowData["resolution"]));
                                    }
                                }
                            }
                        ]
                    }},
                    { name: 'rate', index: 'rate',width: 80, align: "center", sortable: false , formatter: "textbox",formatterParam: {
                        mode: 'always',
                        events: [
                            {
                                name: "focus",
                                handler: function (event) {
                                    var $this = $(this);
                                    var rowData = $("#divVideoGrid").wbGrid("getRowDataByCellInput", this)["data"];
                                    var maxValue = rowData["maxRate"];
                                    $this.data("originalValue", rowData["rate"]);
                                    initNumberInput($this, { minValue: 1, maxValue: maxValue });
                                }
                            },
                            {
                                name: "blur",
                                handler: function (event) {
                                    var $this = $(this);
                                    var rowData = $("#divVideoGrid").wbGrid("getRowDataByCellInput", this)["data"];
                                    if ($this.val() == "") {
                                        $("#divVideoGrid").wbGrid("setCellsValueByIds", [ rowData["@id"] ], [ "rate" ], [ $this.data("originalValue") ]);
                                    }else if($this.val() < 1){
                                        $("#divVideoGrid").wbGrid("setCellsValueByIds", [ rowData["@id"] ], [ "rate" ], ["1"] );
                                    }
//                                    else{
//                                        rowData["rate"] = $this.data("originalValue");
//                                    }
                                }
                            }
                      ]
                    }},
                    { name: 'bitrateValue', index: 'bitrateValue',width: 80, align: "center", sortable: false , formatter: "select",formatterParam: {
                        mode: 'always',
                        getItems: function(streamArr) {
                            return $.map(streamArr["bitrateTypeArr"], function(element) {
                                var value = null;
                                var key =null;
                                for(var v in element){
                                    key = v;
                                    value = getBitrateTypeName(key);
                                }
                                return { value: key, text: value };
                            });
                        },
                        events: [
                            {
                                name: "change",
                                handler: function (event) {
                                    var $this = $(this);
                                    var rowData = $("#divVideoGrid").wbGrid("getRowDataByCellInput", this)["data"];
                                    var id = rowData["@id"];
                                    var component =  $("#divVideoGrid").wbGrid("getStandardCellCtrl", id,"videoQt");
                                    var componentBit =  $("#bitrate_"+id).find("input");
                                    if($this.val() === "CBR"){
                                        $(component).attr("disabled","disabled");
                                        $(componentBit).removeAttr("disabled");
                                    }else{
                                        $(componentBit).attr("disabled","disabled");
                                        $(component).removeAttr("disabled");
                                        //当选择VBR，图像质量跟着码率值变化
                                        var rateValue = rowData["bitrateMax"];
                                        var maxValue = rowData["maxBitrate"] * 1;
                                        var minValue = rowData["minBitrate"] * 1;
                                        var bitArr = CalBitRateLevel(minValue,maxValue);

                                        var qtArr = ["lowest","lower","medium","higher","highest"];
                                        var handleFlag = true;
                                        for(var m= 0,len=bitArr.length;m<len;m++){
                                            if(bitArr[m] == rateValue){
                                                component.val(qtArr[m]);
                                                $("#divVideoGrid").wbGrid("setCellsValueByIds", [ rowData["@id"] ], [ "videoQt" ], [ qtArr[m] ]);
                                                handleFlag = false;
                                                break;
                                            }
                                        }
                                        if(handleFlag){
                                            for(var m= 0,len=bitArr.length;m<len;m++){
                                                if(rateValue > bitArr[m] && rateValue < bitArr[m+1] && ((rateValue -  bitArr[m]) - (bitArr[m+1] - rateValue)) < 0 ){
                                                    component.val(qtArr[m]);
                                                    $("#divVideoGrid").wbGrid("setCellsValueByIds", [ rowData["@id"] ], [ "videoQt" ], [ qtArr[m] ]);
                                                    handleFlag = true;
                                                    break;
                                                }else{
                                                    component.val(qtArr[m+1]);
                                                    $("#divVideoGrid").wbGrid("setCellsValueByIds", [ rowData["@id"] ], [ "videoQt" ], [ qtArr[m+1] ]);
                                                    handleFlag = true;
                                                    break;
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        ]
                    }},
                    { name: "bitrateMax", index: "bitrateMax", width: 100, align: "center", sortable: false, formatter: "custom",
                        formatterParam: {
                            init: function ($cell, rowData) {

//                                var arr = [64, 128, 256, 384, 512, 640, 768, 896, 1024, 2048, 4096, 6144, 8192];
                                var list = [];
                                var maxValue = rowData["maxBitrate"] * 1;
                                var minValue = rowData["minBitrate"] * 1;
                                var bitArr = CalBitRateLevel(minValue,maxValue);

                                list.push({text:minValue,value: minValue});
                                list.push({text:bitArr[1],value: bitArr[1]});
                                list.push({text:bitArr[2],value: bitArr[2]});
                                list.push({text:bitArr[3],value: bitArr[3]});
                                list.push({text:maxValue,value: maxValue});
//                                for(var i= 0,len=arr.length;i<len;i++){
//                                    if(arr[i]>=minValue && arr[i]<=maxValue){
//                                        list.push({text:arr[i],value: arr[i]});
//                                    }
//                                }
                                var id = rowData["@id"];
                                var totalDiv = $("<div style='text-align: center;'></div>");
                                var bitInput = $("<div id=\"bitrate_" + id + "\" style='vertical-align:middle;display:inline-block; width: 100px;'></div>");
                                bitInput.appendTo(totalDiv);
//                                var rangeBit = $("<div id=\"rangeBit_" + id + "\" style='vertical-align:middle; display:inline-block;width: 140px;'>"+"("+minValue+"~"+maxValue+")"+" Kbps</div>");
//                                var rangeBit = $("<div id=\"rangeBit_" + id + "\" style='vertical-align:middle; display:inline-block;width: 40px;'>"+" Kbps</div>");
//                                rangeBit.appendTo(totalDiv);
                                totalDiv.appendTo($cell);
                                bitInput.selectInput({
                                    list: list,
                                    mapping: function(text) {
                                        var validReg = /^[1-9]\d*$/;
                                        var execResults = validReg.exec(text);
                                        if (execResults) {
                                            var value = text * 1;
                                            if (value >= minValue && value <= maxValue) {
                                                return { text: text, value: text };
                                            }
                                        }
                                        return false;
                                    },
                                    onchange: function($widget, value) {
                                        $("#divVideoGrid").wbGrid("syncCellDataById", id, "bitrateMax", value);
                                    }
                                });
                                bitInput.selectInput("setData", { text: rowData["bitrateMax"], value: rowData["bitrateMax"] });
                                return $cell;
                            },
                            setWidgetValue: function ($widget, val) {
                                $widget.val(val);
                            }
                        }
                    },
                    { name: 'videoQt', index: 'videoQt',width: 80, align: "center", sortable: false , formatter: "select",formatterParam: {
                        mode: "always",
                            getItems: function(streamArr) {
                                return $.map(streamArr["videoQtArr"], function(element) {

                                    var value = null;
                                    var key =null;
                                    for(var v in element){
                                        key = v;
                                        value = getStreamVideoQualityName(key);
                                    }
                                    return { value: key, text: value };
                                });
                        },
                        events: [
                            {
                                name: "change",
                                handler: function (event) {
                                    var $this = $(this);
                                    var rowData = $("#divVideoGrid").wbGrid("getRowDataByCellInput", this)["data"];
                                    var id = rowData["@id"];
                                    var componentBit =  $("#bitrate_"+id);
                                    if($this.val() == "lowest"){
                                        componentBit.selectInput("setSelectedIndex",0);
                                        $("#divVideoGrid").wbGrid("setCellsValueByIds", [ rowData["@id"] ], [ "bitrateMax" ], [ componentBit.data("SelectInput")["settings"].list[0].value ]);
                                    }else if($this.val() == "lower"){
                                        componentBit.selectInput("setSelectedIndex",1);
                                        $("#divVideoGrid").wbGrid("setCellsValueByIds", [ rowData["@id"] ], [ "bitrateMax" ], [ componentBit.data("SelectInput")["settings"].list[1].value ]);
                                    }else if($this.val() == "medium"){
                                        componentBit.selectInput("setSelectedIndex",2);
                                        $("#divVideoGrid").wbGrid("setCellsValueByIds", [ rowData["@id"] ], [ "bitrateMax" ], [ componentBit.data("SelectInput")["settings"].list[2].value ]);
                                    }else if($this.val() == "higher"){
                                        componentBit.selectInput("setSelectedIndex",3);
                                        $("#divVideoGrid").wbGrid("setCellsValueByIds", [ rowData["@id"] ], [ "bitrateMax" ], [ componentBit.data("SelectInput")["settings"].list[3].value ]);
                                    }else if($this.val() == "highest"){
                                        componentBit.selectInput("setSelectedIndex",4);
                                        $("#divVideoGrid").wbGrid("setCellsValueByIds", [ rowData["@id"] ], [ "bitrateMax" ], [ componentBit.data("SelectInput")["settings"].list[4].value ]);
                                    }
                                }
                            }
                        ]
                    }}
                    ,
                    { name: 'GOP', index: 'GOP',width: 80, align: "center",sortable: false ,formatter: "textbox",formatterParam: {
                        mode: 'always',
                        events: [
                            {
                                name: "focus",
                                handler: function (event) {
                                    var $this = $(this);
                                    var rowData = $("#divVideoGrid").wbGrid("getRowDataByCellInput", this)["data"];
                                    var maxValue = rowData["GOP@max"];
                                    var minValue = rowData["GOP@min"];
                                    $this.data("originalValue", rowData["GOP"]);
                                    initNumberInput($this, { minValue: minValue, maxValue: maxValue });
                                }
                            },
                            {
                                name: "blur",
                                handler: function (event) {
                                    var $this = $(this);
                                    var rowData = $("#divVideoGrid").wbGrid("getRowDataByCellInput", this)["data"];
                                    if ($this.val() == "") {
                                        $("#divVideoGrid").wbGrid("setCellsValueByIds", [ rowData["@id"] ], [ "GOP" ], [ $this.data("originalValue")  ]);
                                    }else if($this.val()*1 < rowData["GOP@min"] *1){
                                        $("#divVideoGrid").wbGrid("setCellsValueByIds", [ rowData["@id"] ], [ "GOP" ], [$this.data("originalValue")  ]);
                                    }
                                }
                            }
                        ]
                    }},
                    { name: 'encodeType', index: 'encodeType',width: 80, align: "center", sortable: false ,formatter: "select",formatterParam: {
                        mode: "always",
                        getItems: function(streamArr) {
                            return $.map(streamArr["encodeTypeArr"], function(element) {
//                                var value = element;
//                                var key = element;
                                var value = null;
                                var key =null;
                                for(var v in element){
                                    key = v;
                                    value = element[v];
                                }
                                return { value: key, text: value };
                            });
                        },
                        events: [
                            {
                                name: "change",
                                handler: function (event) {
                                    var $this = $(this);
                                    var id = $("#divVideoGrid").wbGrid("getRowDataByCellInput", this)["data"]["@id"];
                                    var component =  $("#divVideoGrid").wbGrid("getStandardCellCtrl", id,"encodeLevel");
                                    if($this.val() === "mjpeg"){
                                        $(component).attr("disabled","disabled");
                                    }else if($this.val() === "h265"){
                                        $("#divVideoGrid").wbGrid("setCellsValueByIds", [ id ], [ "encodeLevel" ], [ "mainProfile" ]);
                                        $(component).attr("disabled","disabled");
                                    }else{
                                        $(component).removeAttr("disabled");
                                    }
                                }
                            }
                        ]
                    }},
                    { name: 'encodeLevel', index: 'encodeLevel',width: 120, align: "center", sortable: false ,formatter: "select",formatterParam: {
                        mode: "always",
                        getItems: function(streamArr) {
                            return $.map(streamArr["encodeLevelArr"], function(element) {
                                var value = null;
                                var key =null;
                                for(var v in element){
                                    key = v;
                                    value = element[v];
                                }
                                return { value: key, text: value };
                            });
                        },
                        events: [
                            {
                                name: "change",
                                handler: function (event) {
                                    var $this = $(this);
                                    var rowData = $("#divVideoGrid").wbGrid("getRowDataByCellInput", this)["data"];
                                }
                            }
                        ]
                    }}
                ],
                rowList: []
            },
            view: {
                selectRow : true,
                rownumbers: true,
                lang: LangCtrl.getLang()
            }
        });
        $("#alarmPhoto").change(function(){
            VideoModule.$alarmSnapBindStreamId = $(this).val();
            var rowData = $("#divVideoGrid").wbGrid("getRowById",VideoModule.$alarmSnapBindStreamId);
            $("#photoSize").html(rowData.data["resolution"]);
        });
    },
    getCapsData: function(callback) {
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/GetStreamCaps",
                type: "POST",
                async: true,
                data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    capsXmlDoc = result;
                    var tempResolution = xml2json(capsXmlDoc, "config>streamList>item")["item"];
                    resolutionArr = is_array(tempResolution) ? tempResolution : [tempResolution];
                    if (typeof callback == "function") {
                        callback();
                    }
                    VideoModule.getData();
                }
            });
        }
        catch (ex) {
            window.top.hideLoading();
            alert(ex);
        }

    },
    getData: function() {
        $("#divVideoGrid").show();
        $("#divAlarm").show();
        $(".cfgfooter").css("width","90%");
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/GetVideoStreamConfig",
                type: "POST",
                async: true,
                data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    xmlDoc = result;

                    //码流类型
                    var $streamTypeMode = $("config>types>bitRateType", xmlDoc);
                    var bitrateType = [];
                    $(">enum", $streamTypeMode).each(function(i, item) {
                        var typeModeKey = $(item).text();
                        var typeModeValue = getBitrateTypeName(typeModeKey);
                        var object ={};
                        switch (typeModeKey){
                            case 'VBR':
                                object = {VBR:typeModeValue};
                                break;
                            case 'CBR':
                                object = {CBR:typeModeValue};
                                break;
                        }
                        bitrateType.push(object);
                    });

                    //图像质量
                    var $qualityMode = $("config>types>quality", xmlDoc);
                    var qualityMode = [];
                    $(">enum", $qualityMode).each(function(i, item) {
                        var typeModeKey = $(item).text();
                        var typeModeValue = getStreamVideoQualityName(typeModeKey);
                        var object ={};
                        switch (typeModeKey){
                            case 'lowest':
                                object = {lowest:typeModeValue};
                                break;
                            case 'lower':
                                object = {lower:typeModeValue};
                                break;
                            case 'medium':
                                object = {medium:typeModeValue};
                                break;
                            case 'higher':
                                object = {higher:typeModeValue};
                                break;
                            case 'highest':
                                object = {highest:typeModeValue};
                                break;
                        }
                        qualityMode.push(object);
                });

//                    var encodeType = [];
//                    $("config>types>encodeType>enum", xmlDoc).each(function(i,ele){
//                        var encodeTypeText = $(ele).text();
//                        var oneEncodeType = getEncodeType(encodeTypeText);
//                        encodeType.push(oneEncodeType);
//                    });

                    var encodeLevel = [];
                    $("config>types>encodeLevel>enum", xmlDoc).each(function(i,ele){
                        var encodeLevelText = $(ele).text();
                        var oneEncodeLevel = getEncodeLevel(encodeLevelText);
                        encodeLevel.push(oneEncodeLevel);
                    });

                    $("#alarmPhoto").empty();

                    VideoModule.$alarmSnapBindStreamId = $("config>alarmSnapBindStreamId", xmlDoc).text();

                    var tempStream = xml2json(xmlDoc, "config>streams>item")["item"];
                    var streamArr = (is_array(xml2json(xmlDoc, "config>streams>item")["item"]) ? tempStream : [tempStream]);

                    $.each(streamArr, function(i,ele){
                        ele["streamName"] =  ele["name"].innerText == "profile1" ? LangCtrl._L_("mainStream") : ele["name"].innerText == "profile2" ? LangCtrl._L_("subStream") : LangCtrl._L_("thirdStream");
//                        ele["streamName"] =  ele["name"].innerText;
                        ele["rate"] =  ele["frameRate"].innerText;

                        var resolutionMax;
                        var rateType;
                        if($(resolutionArr[i]["resolutionCaps"].item).size() === 1){
                            resolutionMax = resolutionArr[i]["resolutionCaps"].item["@maxFrameRate"];
                            rateType =  [resolutionArr[i]["resolutionCaps"].item];
                        }else{
                            rateType =  resolutionArr[i]["resolutionCaps"].item;
                            var resolution =  ele["resolution"];
                            for(var n= 0,len = rateType.length;n<len;n++){
                                if(rateType[n].innerText === resolution){
                                    resolutionMax  = rateType[n]["@maxFrameRate"];
                                    break;
                                }
                            }
                        }

                        ele["rateType"] =rateType;
                        ele["maxRate"] = resolutionMax;
                        ele["bitrateValue"] =  ele["bitRateType"].innerText;
                        ele["bitrateTypeArr"] =  bitrateType;
                        ele["bitrateMax"] =  ele["maxBitRate"].innerText;
                        ele["maxBitrate"] = ele["maxBitRate"]["@max"];
                        ele["minBitrate"] = ele["maxBitRate"]["@min"];
                        ele["videoQt"] = ele["quality"].innerText;
                        ele["videoQtArr"] = qualityMode;

                        var GOP = ele["GOP"];
                        ele["GOP"] = ele["GOP"].innerText;
                        ele["GOP@min"] = GOP["@min"];
                        ele["GOP@max"] = GOP["@max"];
                        ele["encodeType"] = ele["encodeType"];

                        var encodeType = [];
                        if(typeof ele["encodeTypeCaps"].item === "string"){
                            var oneEncodeType = getEncodeType(ele["encodeTypeCaps"].item);
                            encodeType.push(oneEncodeType);
                        }else{
                            for(var m= 0,len=ele["encodeTypeCaps"].item.length;m<len;m++){
                                var oneEncodeType = getEncodeType(ele["encodeTypeCaps"].item[m]);
                                encodeType.push(oneEncodeType);
                            }
                        }
                        ele["encodeTypeArr"] = encodeType;
                        ele["encodeLevel"] = ele["encodeLevel"];
                        ele["encodeLevelArr"] = encodeLevel;

                        $("<option value=" + (i+1) + ">" + (i+1) + "</option>").appendTo($("#alarmPhoto" ));

                        if((i+1) == VideoModule.$alarmSnapBindStreamId){
                            $("#photoSize").html(ele["resolution"]);
                        }

                    });
                    $("#divVideoGrid").wbGrid("load", streamArr);

                    for(var n = 0,len = streamArr.length;n < len;n++){
                        var trEncodeType =  $("#divVideoGrid").wbGrid("getRowByIndex", n)["data"]["encodeType"];
                        var trBitrateType =  $("#divVideoGrid").wbGrid("getRowByIndex", n)["data"]["bitRateType"].innerText;
                        var id = n+1;
                        var component =  $("#divVideoGrid").wbGrid("getStandardCellCtrl", id,"encodeLevel");
                        var imgColumn =  $("#divVideoGrid").wbGrid("getStandardCellCtrl", id,"videoQt");
                        var componentBit =  $("#bitrate_"+id).find("input");
                        if(trEncodeType === "mjpeg" || trEncodeType === "h265"){
                            $(component).attr("disabled","disabled");
                        }else{
                            $(component).removeAttr("disabled");
                        }
                        if(trBitrateType === "CBR"){
                            $(imgColumn).attr("disabled","disabled");
                        }else{
                            $(componentBit).attr("disabled","disabled");
                            $(imgColumn).removeAttr("disabled");
                        }
                    }

                    //报警图片大小及分片编码设置
                    $("#alarmPhoto").val(VideoModule.$alarmSnapBindStreamId);
                    var $sliceSwitch = $("config>sliceSwitch", xmlDoc);
                    $("#encodeSlice" ).attr("checked", $("config>sliceSwitch", xmlDoc).text().toLowerCase() === "true");



                    window.top.hideLoading();
                }
            });
        }
        catch (ex) {
            window.top.hideLoading();
            alert(ex);
        }
    },
    verification: function() {
        try {
            ClearFloatError();
            //图像质量
            $("tr.streamItem", $("#tbStream")).each(function(j, tr) {
                $tr = $(tr);
                $txt = $("input.maxBitRate", $tr);
                //流
                var $maxBitRate = $("config>streams>item[id='" + $tr.data('index') + "']>maxBitRate", xmlDoc);

                var min = $maxBitRate.attr("min");
                var max = $maxBitRate.attr("max");

                if (!CheckNum($txt.val())) {
                    ShowFloatError($txt, LangCtrl._L_("bitrateMaxLimit").format(min, max));
                    throw j;
                }

                var val = $txt.val() * 1;
                if (val < min || val > max) {
                    ShowFloatError($txt, LangCtrl._L_("bitrateMaxLimit").format(min, max));
                    throw j;
                }
            });
        }
        catch (ex) {
            return false;
        }
        return true;
    },
    getSaveData: function() {

        var editRowDatas = $("#divVideoGrid").wbGrid("getEditedRows");
        $.each(editRowDatas, function(index, element) {
            //流
            var $stream = $("config>streams>item[id='" + element["@id"] + "']", xmlDoc);
            //分辨率
            $(">resolution", $stream).text(element["resolution"]);
            //帧率
            $(">frameRate", $stream).text(element["rate"]);

            //码流类型
            $(">bitRateType", $stream).text(element["bitrateValue"]);
            //图像质量
            $(">quality", $stream).text(element["videoQt"]);
            //码率上限
            $(">maxBitRate", $stream).text(element["bitrateMax"]);



            //I帧间隔
            $(">GOP", $stream).text(element["GOP"]);
            //视频编码
            $(">encodeType", $stream).text(element["encodeType"]);
            //编码方式
            $(">encodeLevel", $stream).text(element["encodeLevel"]);
        });

        $("config>sliceSwitch ", xmlDoc).text($("#encodeSlice").is(":checked") ? "true" : "false");
        $("config>alarmSnapBindStreamId ", xmlDoc).text($("#alarmPhoto").val());

        return XMLDoc2XMLStr(xmlDoc);
    },
    setData: function() {
        window.top.showLoading();
        if (!VideoModule.verification()) {
            window.top.hideLoading();
            return false;
        }
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/SetVideoStreamConfig",
                type: "POST",
                async: true,
                data: VideoModule.getSaveData(),
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    window.top.hideLoading();
                    commSaveResponseHadler(result);
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    }
};

var AudioModule = {
    mapping: {
        cboAudioEncoding: "config>audioEncode",
        cboAudioInput: "config>audioInput"
    },
    initCtrl: function() {

    },
    getData: function() {
        window.top.showLoading();
        $("#divVideoGrid").hide();
        $("#divAlarm").hide();
        $(".cfgfooter").width(450);
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/GetAudioStreamConfig",
                type: "POST",
                async: true,
                data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    xmlDoc = result;
                    AudioModule.bindCtrlData();
                    XmlHttpClient.BindPageByXml(AudioModule.mapping, xmlDoc);
                    window.top.hideLoading();
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    bindCtrlData: function() {
        function getAudioEncoding(value) {
            switch (value) {
                default:
                    return value;
            }
        }
        $("#cboAudioEncoding").empty();
        $("config>types>audioEncode>enum", xmlDoc).each(function(i, ele) {
            $("<option value=" + $(ele).text() + ">" + getAudioEncoding($(ele).text()) + "</option>").appendTo($("#cboAudioEncoding"));
        });
        $("#cboAudioInput").empty();
        $("config>types>audioInput>enum", xmlDoc).each(function(i, ele) {
            $("<option value=" + $(ele).text() + ">" + getAudioEncoding($(ele).text()) + "</option>").appendTo($("#cboAudioInput"));
        });
    },
    setData: function() {
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/SetAudioStreamConfig",
                type: "POST",
                async: true,
                data: XmlHttpClient.GetXmlByPage(AudioModule.mapping, xmlDoc),
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    window.top.hideLoading();
                    commSaveResponseHadler(result);
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    }
};

function createTrImgQualityTmp($table,num) {

    var $tr = "";
    if(!(num%2)){
        $tr = $("<tr class=\"streamItem\"></tr>");
    }else{
        $tr = $("<tr style=\"background-color: #eeeeee\" class=\"streamItem\"></tr>")
    }
//    var $tr = $("<tr class=\"streamItem\"></tr>");
    var $td = $("<td class=\"streamName\" align=\"center\"></td>");
    $td.appendTo($tr);
    $td = $("<td></td>");
    var $resolution = $("<select></select>");
    $resolution.addClass("resolution");
    $resolution.appendTo($td);
    $td.appendTo($tr);
    $td = $("<td></td>");
    var $frameRate = $("<select></select>");
    $frameRate.addClass("frameRate");
    $frameRate.appendTo($td);
    $td.appendTo($tr);
    $td = $("<td></td>");
    var $bitRateType = $("<select></select>");
    $bitRateType.addClass("bitRateType");
    $bitRateType.appendTo($td);
    $td.appendTo($tr);
    $td = $("<td></td>");
    var $maxBitRate = $("<input class=\"maxBitRate\" type=\"text\" />");
    $maxBitRate.appendTo($td);
    ToNumOnlyTxt_NoReplace($maxBitRate);
    $td.appendTo($tr);
    $td = $("<td></td>");
    var $videoQuality = $("<select></select>");
    $videoQuality.addClass("videoQuality");
    $videoQuality.appendTo($td);
    $td.appendTo($tr);
    $tr.appendTo($("tbody", $table));
    return $tr;
}

function getBitrateTypeName(value) {
    switch (value) {
        case "VBR":
            return LangCtrl._L_("vbr");
        case "CBR":
            return LangCtrl._L_("cbr");
    }
}

function getStreamVideoQualityName(value) {
    switch (value) {
        case "lowest":
            return LangCtrl._L_("lowest");
        case "lower":
            return LangCtrl._L_("lower");
        case "medium":
            return LangCtrl._L_("medium");
        case "higher":
            return LangCtrl._L_("higher");
        case "highest":
            return LangCtrl._L_("highest");
    }
}

function getEncodeType(value) {
    switch (value) {
        case "h264":
            return {h264:"H264"};
        case "mpeg4":
            return {mpeg4:"MPEG4"};
        case "mjpeg":
            return {mjpeg:"MJPEG"};
        case "h265":
            return {h265:"H265"};
    }
}

function getEncodeLevel(value) {
    switch (value) {
        case "baseLine":
            return {baseLine:"Base Line"};
        case "mainProfile":
            return {mainProfile:"Main Profile"};
        case "highProfile":
            return {highProfile:"High Profile"};
    }
}

//分辨率改变事件
function drpResolution_changed() {
    var $tr = $(this).parent().parent();
    var index = $tr.data('index');
    //流
    var $stream = $("config>streams>item[id='" + index + "']", xmlDoc);
    //分辨率
    var $resolution = $("config>streamList>item[id='" + index + "']>resolutionCaps", capsXmlDoc);
    var resolution_sel = $(this).val();
    bindDrpRate(resolution_sel, $resolution, $stream, $tr, true);
}

//绑定帧率
function bindDrpRate(resolution_sel, $resolution, $stream, $tr, isEvent) {
    var $drpRate = $("select.frameRate", $tr);
    $drpRate.empty();
    //帧率
    var selectResolution = getTextMatchNodes($(">item", $resolution), resolution_sel);
    var maxRate = $(selectResolution[0]).attr("maxFrameRate") * 1;
    for (var i = 1; i <= maxRate; i++) {
        $("<option value=" + i + ">" + i + "</option>").appendTo($drpRate);
    }
    if (!isEvent) {
        $drpRate.val($(">frameRate", $stream).text());
    } else {
        $drpRate.children("option:last").attr("selected", true);
    }
}

//码率类型改变事件
function drpBitrateType_changed() {
    var $tr = $(this).parent().parent();
    var $drpVideoQuality = $("select.videoQuality", $tr);
    setVideoQualityStatus($(this).val(), $drpVideoQuality);
}

function setVideoQualityStatus(bitRateType, $drpVideoQuality) {
    if (bitRateType == "VBR") {
        $drpVideoQuality.removeAttr("disabled");
    }
    else {
        $drpVideoQuality.attr("disabled", "disabled");
    }
}

function initControl() {
    VideoModule.initCtrl();
    AudioModule.initCtrl();
    $("#btnSave").click(function() {
        ClearFloatError();
        var curTab = $.cookie("tab");
        if (!curTab) {
            curTab = "liVideo";
        }
        switch (curTab) {
            case "liVideo":
                VideoModule.setData();
                break;
            case "liAudio":
                AudioModule.setData();
                break;
        }
    });
}

//划分码流的 函数
function CalBitRateLevel( iMin,  iMax)
{
    if (iMin > iMax)
    {
        return;
    }

    var iLevel = 5 - 1;
    if (0 == iLevel)
    {
        return;
    }

    var distance = 0;
    distance = (iMax - iMin) / iLevel;
    var  multiple = 0;
    var divider = 1024;

    var bitRate = [];
    bitRate[0] = iMin;
    bitRate[iLevel] = iMax;

    var i = 0;

    while (1)
    {
        for (i=1; i<iLevel; i++)
        {
            multiple = (distance * i + bitRate[0]) / divider;

            if (multiple - parseInt(multiple) > 0.5)
            {
                multiple = parseInt(multiple + 1);
            }
            else
            {
                multiple = parseInt(multiple);
            }
            bitRate[i] = multiple * divider;

            if (bitRate[i] <= bitRate[i - 1])
            {
                break;
            }
        }

        if (i < iLevel)
        {
            divider /= 2;
            if (0 == divider)
            {
                divider = 1;
                //break;
            }
        }
        else
        {
            break;
        }
    }

    return bitRate;
}