﻿var xmlDoc;
var netPort; // RTSP端口
var NetLiveMonitor; // 视频控件
var list,maxCount;
var selectId = { presetSelectId : 1 };

$(function(){
    $("#Content", window.top.document).css("min-width", "1550px");
    VideoMaskModule.initCtrl();
    closeStream();
});

var VideoMaskModule ={
    action:"EDIT_ON",   //EDIT_ON,EDIT_OFF,NONE
    setAction:function(action){
        $("#btnDraw").removeAttr("class").addClass("cfgBtn");
        this.action = action;
        switch (action) {
            case "disable":
                $("#btnDraw").addClass("disable").attr("value", LangCtrl._L_("drawArea"));
                break;
            case "on":
                var sendXML = OCX_XML_SetMaskAreaAction("EDIT_ON");
                NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
                $("#btnDraw").removeClass("off").addClass("on").attr("value", LangCtrl._L_("stopDraw"));
                break;
            case "off":
                var sendXML = OCX_XML_SetMaskAreaAction("EDIT_OFF");
                NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
                $("#btnDraw").removeClass("on").addClass("off").attr("value", LangCtrl._L_("drawArea"));
                break;
            case "clear":
                var sendXML = OCX_XML_SetMaskAreaAction("NONE");
                NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
                break;
        }
    },
    initCtrl: function() {
        VideoMaskModule.setOCX();
        VideoMaskModule.ptzGetCaps();
        VideoMaskModule.getPresetList();
        bindPtzEvent();
    },
    adjustHeight: function(){
        window.parent.setConfigMiniHeight($(document.body).height() + 70);
    },
    bindFun:function(){
        $("#btnDraw").unbind().click(function() {
            if (VideoMaskModule.action == "disable"){
                return;
            }
            VideoMaskModule.setAction(VideoMaskModule.action == "on" ? "off" : "on");
        });
        $("#btnClear").unbind().click(function(){
            VideoMaskModule.setAction("clear");
        });
        $("#add").unbind().click(function(){
            if($("#tbContent tbody tr").length >= maxCount){
                window.top.MsgBoxHelper.Show("error", LangCtrl._L_("errorTip"), LangCtrl._L_("maxCount"), null);
                return false;
            }
            VideoMaskModule.getArea();
        });
        $("#delete").unbind().click(function(){
            if($("#tbContent tbody tr.selected").length == 0){
                window.top.MsgBoxHelper.Show("error", LangCtrl._L_("errorTip"), LangCtrl._L_("selectArea"), null);
                return false;
            }
            VideoMaskModule.deleteArea($("#tbContent tbody tr.selected td:eq(0)").html());
        });
        $("#maskCheck").unbind().click(function(){
            VideoMaskModule.modifyArea();
        });
    },
    getData: function() {
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/GetPrivacyMaskConfig",
                type: "POST",
                async: true,
                data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    xmlDoc = result;
                    maxCount = $("config>privacyMask", result).attr("count");

                    var flag = false;
                    $("config>privacyMask>item", result).each(function(index,ele){
                        if($(">switch",ele).text() == "true"){
                            flag = true;
                            return;
                        }
                    });

                    $("#maskCheck").attr("checked", flag);
                    var rowData = xml2json(xmlDoc, "config>privacyMask>item")["item"];
                    if (!rowData)
                        rowData = [];
                    if (!(rowData instanceof Array)) {
                        rowData = [rowData];
                    }

                    list = [];
                    $("#tbContent tbody").empty();
                    $.each( rowData, function(i, n){
                        var mask = {};
                        mask.id = n["@id"];
                        mask.rectangle = {};
                        mask.rectangle.X1 = n["rectangle"].X;
                        mask.rectangle.Y1 = n["rectangle"].Y;
                        mask.rectangle.X2 = (n["rectangle"].width) * 1  + (n["rectangle"].X) * 1 ;
                        mask.rectangle.Y2 = (n["rectangle"].height) * 1 + (n["rectangle"].Y) * 1;
                        list.push(mask);
                        VideoMaskModule.createRow(n["@id"], n["switch"] == "true");
                    });

                    var sendXML = OCX_XML_SetMaskArea([]);
                    NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
                    VideoMaskModule.adjustHeight();
                    window.top.hideLoading();
                }
            });
        } catch (ex) {
            alert(ex);
            window.top.hideLoading();
        }
    },
    createRow:function(id,flag){
        $("<tr index=\"" + id + "\">" +
        "<td>" + id + "</td>" +
        "<td>Mask Area " + id + "</td>" +
        "<td>" + (flag ? LangCtrl._L_("yes") : LangCtrl._L_("no2")) + "</td>" +
        "</tr>").unbind().click(function(){
            $(this).addClass("selected").siblings().removeClass("selected");
            VideoMaskModule.invokeArea($(this).attr("index"));
            VideoMaskModule.showArea($(this).attr("index"));
        }).appendTo($("#tbContent tbody"));
    },
    getArea:function(){
        var sendXML = OCX_XML_GetMaskArea();
        var result = NetLiveMonitor.QueryInfo(sendXML, sendXML.length);
        var $xmlDoc = $(XMLStr2XMLDoc(result));

        $("config>privacyMask>item", xmlDoc).remove();
        $("response>item", $xmlDoc).each(function(index,element){
            if($(element).attr("X1") == "0" && $(element).attr("Y1") == "0" && $(element).attr("X2") == "0" && $(element).attr("Y2") == "0")
                return true;

            $("config>privacyMask", xmlDoc).append(
                $(xmlDoc.createElement("item")).append(
                    $(xmlDoc.createElement("switch")).append(
                        $(xmlDoc.createTextNode($("#maskCheck").attr("checked") === "checked" ? "true" : "false"))
                    )
                ).append(
                    $(xmlDoc.createElement("rectangle")).append(
                        $(xmlDoc.createElement("X")).append(
                            $(xmlDoc.createTextNode($(element).attr("X1")))
                        )
                    ).append(
                        $(xmlDoc.createElement("Y")).append(
                            $(xmlDoc.createTextNode($(element).attr("Y1")))
                        )
                    ).append(
                        $(xmlDoc.createElement("width")).append(
                            $(xmlDoc.createTextNode($(element).attr("X2")*1 - $(element).attr("X1")*1))
                        )
                    ).append(
                        $(xmlDoc.createElement("height")).append(
                            $(xmlDoc.createTextNode($(element).attr("Y2")*1 - $(element).attr("Y1")*1))
                        )
                    )
                ).append(
                    $(xmlDoc.createElement("color")).append(
                        $(xmlDoc.createTextNode("black"))
                    )
                )
            );
        });
        VideoMaskModule.addArea();
    },
    addArea:function(){
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/AddPrivacyMaskConfig",
                type: "POST",
                async: true,
                data: XMLDoc2XMLStr(xmlDoc),
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    if ($("config", result).attr("status") == "success") {
                        $("#btnClear").click();
                        VideoMaskModule.getData();
                    } else {
                        window.top.MsgBoxHelper.Show("error", LangCtrl._L_("errorTip"), LangCtrl._L_("saveFailed"), null);
                    }
                }
            });
        } catch (ex) {
            alert(ex);
        }
    },
    deleteArea:function(id){
        var sendData = xmlHeader + "<config><id>" + id + "</id></config>";

        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/DeletePrivacyMaskConfig",
                type: "POST",
                async: true,
                data: sendData,
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    if ($("config", result).attr("status") == "success") {
                        $("#tbContent tbody tr.selected").remove();
                        $("#btnClear").click();
                        for(var i=0; i<list.length; i++){
                            if(id == list[i].id){
                                list.splice(i,1);
                                break;
                            }
                        }
                    } else {
                        window.top.MsgBoxHelper.Show("error", LangCtrl._L_("errorTip"), LangCtrl._L_("saveFailed"), null);
                    }
                }
            });
        } catch (ex) {
            alert(ex);
        }
    },
    updateData:function(){
        $("config>privacyMask>item",xmlDoc).each(function(i,e){
            $(">switch", e).text($("#maskCheck").attr("checked") == "checked" ? "true" : "false");
        });
        return XMLDoc2XMLStr(xmlDoc);
    },
    modifyArea:function(){
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/ModifyPrivacyMaskConfig",
                type: "POST",
                async: true,
                data: VideoMaskModule.updateData(),
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    if ($("config",result).attr("status") === "success"){
                        ShowFloatError($("#showFloat"), LangCtrl._L_("saveSuccess"),{ },"success");
                    }else{
                        ShowFloatError($("#showFloat"), LangCtrl._L_("saveFailed"),{ },"failed");
                    }
                }
            });
        } catch (ex) {
            alert(ex);
        }
    },
    showArea:function(id){
        try{
            var mask = [];
            for(var i=0; i<list.length; i++){
                if(id == list[i].id){
                    mask.push(list[i]);
                    break;
                }
            }
            var sendXML = OCX_XML_SetMaskArea(mask);
            NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
        }catch (e){}
    },
    invokeArea:function(id){
        var sendData = xmlHeader + "<config><id>" + id + "</id></config>";
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/InvokePrivacyMaskConfig",
                type: "POST",
                async: true,
                data: sendData,
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                }
            });
        } catch (ex) {
            alert(ex);
        }
    },
    ptzGetCaps: function(){
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/PtzGetCaps",
                type: "POST",
                async: true,
                data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    $("#sliderSpeed").empty();
                    $("#sliderSpeed").slider({
                        minValue: 1,
                        maxValue: $("config>caps>controlMaxSpeed", result).text() * 1,
                        maxWidth: 155,
                        value: 4,
                        buildTip: function(value) {
                            return LangCtrl._L_("ptzSpeed") + value;
                        }
                    });
                    $("#btnSlow").unbind().click(function(event) {
                        var curSpeed = $("#sliderSpeed").slider("getValue");
                        if (curSpeed <= 1) {
                            return;
                        }
                        curSpeed = curSpeed - 1;
                        $("#sliderSpeed").slider("setValue", curSpeed);
                    });

                    $("#btnQuick").unbind().click(function(event) {
                        var curSpeed = $("#sliderSpeed").slider("getValue");
                        if (curSpeed >= 8) {
                            return;
                        }
                        curSpeed = curSpeed + 1;
                        $("#sliderSpeed").slider("setValue", curSpeed);
                    });
                    window.top.hideLoading();
                }
            });
        }
        catch (ex) {
            alert(ex);
            window.top.hideLoading();
        }
    },
    getPresetList:function(){
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/PtzGetPresets",
                type: "POST",
                async: true,
                data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    var presetArr = [];
                    var presetMap = {};

                    var presetPre = LangCtrl._L_("preset");
                    $("config>presetInfo>item", result).each(function(i, elem) {
                        presetMap["p_" + $(elem).attr("id")] = { value: presetPre + $(elem).attr("id"), title: $(elem).text() };
                    });

                    var maxId = $("config>presetInfo", result).attr("maxCount") * 1;
                    for (var i = 1; i <= maxId; i++) {
                        if ("p_" + i in presetMap)
                            presetArr.push({ id: i, value: presetMap["p_" + i].value, title:presetMap["p_" + i].title,savedPosition:true, normalStyle: false });
                        else if( i >= 90 && i<= 109)
                            presetArr.push({ id: i, value: presetPre + i,savedPosition:true, normalStyle: false });
                        else
                            presetArr.push({ id: i, value: presetPre + i,savedPosition:false, normalStyle: true });
                    }

                    $("#presetList").listbox({
                        data: presetArr,
                        itemCustomMapping:{savedPosition:"savedPosition", normalStyle: "normalStyle"},
                        selectItem: function(){
                            var itemData = $(this).data("itemData");
                            var aObj = $(".btnDiv", this);
                            selectId.presetSelectId = itemData.id;
                            VideoMaskModule.presetBtnOperate(itemData,aObj);
                        },
                        unSelectItem: function(){
                            var itemData = $(this).data("itemData");
                            $("#preset_call_" + itemData.id).unbind().remove();
                        },
                        mouse_enter: function(event){
                            var itemData = $(this).data("itemData");
                            var aObj = $(".btnDiv", this);
                            VideoMaskModule.presetBtnOperate(itemData,aObj);
                        },
                        mouse_leave:function(){
                            var itemData = $(this).data("itemData");
                            var divPresetItems = $("#presetList").listbox("getSeletedItems");
                            if(divPresetItems.length != 0){
                                selectId.presetSelectId = divPresetItems.data("itemData").id;
                                if(selectId.presetSelectId != itemData.id){
                                    $("#preset_call_" + itemData.id).unbind().remove();
                                }
                            }

                        }
                    });

                    if (presetArr.length > 0) {
                        var presetList = $("#presetList");
                        presetList.listbox("getItemByID", selectId.presetSelectId).click();
                    }
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    presetBtnOperate:function(itemData,aObj){
        if (itemData.savedPosition) {
            if(!(aObj.children("#preset_call_"+itemData.id).size() > 0)){
                var editStr = "<div class='button preset_call' id='preset_call_" + itemData.id + "' title='" + LangCtrl._L_("call") + "' onfocus='this.blur();'></div>";
                aObj.append(editStr);
                var btnCall = $("#preset_call_" + itemData.id);
                if (btnCall) {
                    btnCall.unbind().bind("click", function() {
                        aObj.parent().parent().find("span").removeClass("callPosition");
                        aObj.parent().find("span").removeClass().addClass("callPosition");
                        callPreset(itemData.id,$("#showFloat"));
                        return false;
                    });
                }
            }
        }else{
            if(!(aObj.children("#preset_call_"+itemData.id).size() > 0)){
                var editStr = "<div class='button preset_call_not' id='preset_call_" + itemData.id + "' title='" + LangCtrl._L_("call") + "' onfocus='this.blur();'></div>";
                aObj.append(editStr);
            }
        }
    },
    setOCX: function() {
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/GetPortConfig",
                type: "POST",
                async: true,
                data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    window.top.hideLoading();
                    netPort = $("config>port>netPort", result).text() * 1;
                    NetLiveMonitor = LoadPlugin("divOCX","NetLiveMonitor");

                    if(NetLiveMonitor){
                        // 设置模式
                        var sendXML = OCX_XML_SetPreViewModel("ReadOnly");
                        NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
                    }

                    VideoMaskModule.bindFun();
                }
            });
        }
        catch (ex) {
            alert(ex);
            window.top.hideLoading();
        }
    }
};

//OCX调用js方法
function NotifyResultToJs(strXMLFormat, lStrLen) {
    var $xmlDoc = $(XMLStr2XMLDoc(strXMLFormat));
    // OCX已创建好窗口，通知可以登录了
    if ($("statenotify[type=\"Login\"]", $xmlDoc).length > 0) {
        var userInfo = Decryption($.cookie("auInfo"));
        var userInfoArr = userInfo.split(":");
        // 设置登录信息
        var username = userInfoArr[0];
        var password = userInfoArr[1];
        var id = "";
        var sendXML = OCX_XML_SetLoginInfo(username, password, serverIp, netPort, id);
        NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
        // 设置预览码流索引
        var sendXML = OCX_XML_SetStreamType(2);
        NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
    }
    if ($("statenotify[type=\"GetOriginalWH\"]", $xmlDoc).length > 0) {
        VideoMaskModule.getData();
    }
    var connectstate = $("statenotify[type='connectstate']",$xmlDoc);
    if(connectstate.length > 0){
        if($(">status", connectstate).text() === "success"){
            window.top.hideLoading();
        }else{
            window.top.showLoading(window.top.LangCtrl._L_("connectError"));
        }
    }
    var Connect  = $("statenotify[type='Connect']",$xmlDoc);
    if(Connect.length > 0){
        if($(">status", Connect).text() === "limit"){
            window.top.MsgBoxHelper.Show("info", LangCtrl._L_("infoTip"), LangCtrl._L_("limit"), VideoMaskModule.getData);
        }
    }
}

