﻿/*
基础类，控制页面执行流程，每个页面都必须引用:
1.登录验证
2.记录最后访问页面，刷新恢复
3.多语言翻译
Cookie：
1.userInfo:admin;base64(123456);admin//登录用户验证信息
2.menu_1:m_LiveMonitor//一级菜单
3.menu_2:basicInfo//子级菜单（菜单树节点ID）
3.tab:
*/

//测试
//var webBase = "/ipcweb/";
//var serverIp = "192.168.13.89";
//var serverHost = "192.168.13.89";

//正式发布
var webBase = "/";
var serverIp = window.top.location.hostname;
var serverHost = window.top.location.host;

var serverBase = "http://" + serverHost;
var cfgMinHeight = 889; //配置页面最小高度
var heightFix = 52; //config_content的上下留空高度

var xmlHeader = "<?xml version=\"1.0\" encoding=\"utf-8\" ?>";
var defaultNS = "http://www.ipc.com/ver10";
var apiVersion = "1.0";
var langArr = {"zh-cn":"简体中文","zh-tw":"繁體中文","en-us":"English","tr-tr":"Türk","it-it":"Italiana"};

//菜单类  当前只有配置管理有二级菜单，如果有多个一级菜单含有二级菜单，应加上parent属性
function Menu(level, /*parent,*/url, lk, nav) {
    this.level = level;//目录级别
    //    this.parent = parent;
    this.url = url;
    this.lk = lk;//翻译key
    this.nav = nav;//导航路径
}

var MenuCtrl = {
    menuList: {
        "login": new Menu(0, "login.htm", "", []),
        "main": new Menu(0, "main.htm", "", []),
        "live": new Menu(1, "live.htm", "", []),
        "search": new Menu(1, "search.htm", "", []),
        "configMgr": new Menu(1, "configMgr.htm", "", []),

        "cfgHome": new Menu(1, "ConfigMgr/cfgHome.htm", "cfgHome", []),
        "system": new Menu(2, "ConfigMgr/system.htm", "systemCfg", ["system"]),
        "basicInfo": new Menu(2, "ConfigMgr/System/basicInfo.htm", "basicInfo", ["system", "basicInfo"]),
        "timeSet": new Menu(2, "ConfigMgr/System/timeSet.htm", "timeCfg", ["system", "timeSet"]),
        "localCfg": new Menu(2, "ConfigMgr/System/localCfg.htm", "localCfg", ["system", "localCfg"]),
        "sdCfg": new Menu(2, "ConfigMgr/System/sdCfg.htm", "sdCfg", ["system", "sdCfg"]),
        "video": new Menu(2, "ConfigMgr/video.htm", "video", ["video"]),
        "camera": new Menu(2, "ConfigMgr/Video/camera.htm", "camera", ["video", "camera"]),
        "stream": new Menu(2, "ConfigMgr/Video/stream.htm", "videoStream", ["video", "stream"]),
        "timeStamp": new Menu(2, "ConfigMgr/Video/timeStamp.htm", "timeStamp", ["video", "timeStamp"]),
        "videoMask": new Menu(2, "ConfigMgr/Video/videoMask.htm", "videoMask", ["video", "videoMask"]),
        "ROIConfig": new Menu(2, "ConfigMgr/Video/ROIConfig.htm", "ROIConfig", ["video", "ROIConfig"]),
        "AZConfig": new Menu(2, "ConfigMgr/Video/AZConfig.htm", "AZConfig", ["video", "AZConfig"]),
        "ptzCameraSettings": new Menu(2, "ConfigMgr/Video/ptzCameraSettings.htm", "ptzCameraSettings", ["video","ptzCameraSettings"]),
        "ptz": new Menu(2, "ConfigMgr/ptz.htm", "ptz", ["ptz"]),
        "ptzProtocol": new Menu(2, "ConfigMgr/PTZ/ptzProtocol.htm", "ptzProtocol", ["ptz", "ptzProtocol"]),
        "preset": new Menu(2, "ConfigMgr/PTZ/preset.htm", "preset", ["ptz", "preset"]),
        "cruise": new Menu(2, "ConfigMgr/PTZ/cruise.htm", "cruise", ["ptz", "cruise"]),
        "ptzMenu": new Menu(2, "ConfigMgr/PTZ/ptzMenu.htm", "ptzMenu", ["ptz","ptzMenu"]),
        "ptzSettings": new Menu(2, "ConfigMgr/PTZ/ptzSettings.htm", "ptzSettings", ["ptz","ptzSettings"]),
        "ptzRestoreSetting": new Menu(2, "ConfigMgr/PTZ/ptzRestoreSetting.htm", "ptzRestoreSetting", ["ptz","ptzRestoreSetting"]),
        "ptzInfoShow": new Menu(2, "ConfigMgr/PTZ/ptzInfoShow.htm", "ptzInfoShow", ["ptz","ptzInfoShow"]),
        "ptzAutomaticFeatures": new Menu(2, "ConfigMgr/PTZ/ptzAutomaticFeatures.htm", "ptzAutomaticFeatures", ["ptz","ptzAutomaticFeatures"]),
        "alarm": new Menu(2, "ConfigMgr/alarm.htm", "alarmCfg", ["alarm"]),
        "motion": new Menu(2, "ConfigMgr/Alarm/motion.htm", "motion", ["alarm", "motion"]),
        "alarmIn": new Menu(2, "ConfigMgr/Alarm/alarmIn.htm", "alarmIn", ["alarm", "alarmIn"]),
        "alarmOut": new Menu(2, "ConfigMgr/Alarm/alarmOut.htm", "alarmOut", ["alarm", "alarmOut"]),
        "alarmServer": new Menu(2, "ConfigMgr/Alarm/alarmServer.htm", "alarmServer", ["alarm", "alarmServer"]),
        "event": new Menu(2, "ConfigMgr/event.htm", "event", ["event"]),
        "itemsCare": new Menu(2, "ConfigMgr/Event/itemsCare.htm", "itemsCare", ["event", "itemsCare"]),
        "regionIntrusion": new Menu(2, "ConfigMgr/Event/regionIntrusion.htm", "regionIntrusion", ["event", "regionIntrusion"]),
        "crossBorder": new Menu(2, "ConfigMgr/Event/crossBorder.htm", "crossBorder", ["event", "crossBorder"]),
        "anomaly": new Menu(2, "ConfigMgr/Event/anomaly.htm", "anomaly", ["event", "anomaly"]),
        "faceRecognition": new Menu(2, "ConfigMgr/Event/faceRecognition.htm", "faceRecognition", ["event", "faceRecognition"]),
        "net": new Menu(2, "ConfigMgr/net.htm", "netCfg", ["net"]),
        "netBase": new Menu(2, "ConfigMgr/Net/netBase.htm", "netBase", ["net", "netBase"]),
        "netAdvance": new Menu(2, "ConfigMgr/Net/netAdvance.htm", "netAdvance", ["net", "netAdvance"]),
        "secure": new Menu(2, "ConfigMgr/secure.htm", "secure", ["secure"]),
        "user": new Menu(2, "ConfigMgr/Secure/user.htm", "user", ["secure", "user"]),
        "onlineUser": new Menu(2, "ConfigMgr/Secure/onlineUser.htm", "onlineUser", ["secure", "onlineUser"]),
        "addUser": new Menu(2, "ConfigMgr/Secure/testeMAILS.htm", "addUser", ["secure", "user", "addUser"]),
        "editUser": new Menu(2, "ConfigMgr/Secure/editUser.htm", "editUser", ["secure", "user", "editUser"]),
        "filterRules": new Menu(2, "ConfigMgr/Secure/filterRules.htm", "filterRules", ["secure", "filterRules"]),
        "sysMaintenance": new Menu(2, "ConfigMgr/sysMaintenance.htm", "SysMaintenance", ["sysMaintenance"]),
        "backupRestore": new Menu(2, "ConfigMgr/SysMaintenance/backupRestore.htm", "cfgBackupRestore", ["sysMaintenance", "backupRestore"]),
        "reboot": new Menu(2, "ConfigMgr/SysMaintenance/reboot.htm", "reboot", ["sysMaintenance", "reboot"]),
        "upgrade": new Menu(2, "ConfigMgr/SysMaintenance/upgrade.htm", "upgrade", ["sysMaintenance", "upgrade"]),
        "upgradeCheck": new Menu(2, "ConfigMgr/SysMaintenance/upgradeCheck.htm", "upgrade", ["sysMaintenance", "upgrade"]),
        "operationLog": new Menu(2, "ConfigMgr/SysMaintenance/operationLog.htm", "operationLog", ["sysMaintenance", "operationLog"]),
        "runLog": new Menu(2, "ConfigMgr/SysMaintenance/runLog.htm", "runLog", ["sysMaintenance", "runLog"])
    },
    setMenuCookie: function() {
        var menuId = PageCtrl.getPageName();
        var menu = MenuCtrl.menuList[menuId];
        if (!menu) return;
        autoSize();
        switch (menu.level) {
            case 1:
                $.cookie('menu_1', menuId);
                //                $("#Menu>ul>li>a", window.parent.document).removeClass("Selected");
                //                $("#mu_" + menuId, window.parent.document).addClass("Selected");

                parent.setMainMenu(menuId);
                break;
            case 2:
                $.cookie('menu_2', menuId);
                if ("selectModel" in window.parent) {
                    window.parent.selectModel(menuId);
                }
                var navList = MenuCtrl["menuList"][menuId]["nav"];
                if (navList.length > 0) {
                    setCfgNavBar(navList);
                }
                break;
        }
    }
};

function setCfgNavBar(navList) {
    var navBarHtml = "<img src=\"../Css/Pictures/cfp_pl.png\" alt=\"home\" /><a href=\"ConfigMgr/cfgHome.htm\" target=\"mainFrame\">" + window.parent.LangCtrl._L_('cfgHome') + "</a>";

    for (var i in navList) {
        navBarHtml += "<img src=\"../Css/Pictures/nav.png\" alt=\"nav\" /><a href=\"" + MenuCtrl["menuList"][navList[i]]["url"] + "\" target=\"configRightFrame\">" + window.parent.LangCtrl._L_(MenuCtrl["menuList"][navList[i]]["lk"]) + "</a>";
    }
    $("#navBar", window.parent.document).html(navBarHtml);
}

var PageCtrl = {
    getPageName: function() {
        var id = window.location.href.match(/.*\/(.+)\.htm/);
        if (id)
            return id[1];
    },
    getPagePath: function() {
        var reg = new RegExp(".*://[^/]*" + webBase + "Pages(/.+\\.htm)");
        //        var re = /.*:\/\/[^\/]*\/ipcweb\/Pages(\/.+\.htm)/;
        var path = window.location.href.match(reg);
        if (path)
            return path[1];
    }
};
/**
* 多语言
*/
var LangCtrl = {
    //语言包XML文档JQuery对象，第一次使用时加载，全局保存
    languageXMLDoc: null,
    //是否需要重新加载语言包，当重新选择了语言类型后，需要重新加载语言包
    isNeedLoadLang: true,
    //改变语言后执行的方法堆栈
    _callBack: {},
    _version: '20160314.00',
    //根据标签id获取对应语言的标签值
    _L_: function(tagID) {
        LangCtrl.loadLanguageXMLDoc();
        var tagText = tagID;
        var tag = $("languageInfo>items>item[id='" + tagID + "']", LangCtrl.languageXMLDoc);
        if (tag.length > 0)
            tagText = $(tag[0]).text();
        return tagText !== "" ? tagText : tagID;
    },
    //加载语言XML文档
    loadLanguageXMLDoc: function() {
        if (!LangCtrl.languageXMLDoc || LangCtrl.isNeedLoadLang) {
            var urlArr = [];
            var url = webBase + "LanguageInfo/";
            var langType = $.cookie('lang_type');
            langType = langType ? langType : getSystemLanguage();
            urlArr.push(url + langType + "/common.xml?v=" + LangCtrl._version);
            var menuId = PageCtrl.getPageName();
            var menu = MenuCtrl.menuList[menuId];
            if (menu) {
                urlArr.push(url + langType + "/" + menu["url"] + ".xml?v=" + LangCtrl._version);
            }
            LangCtrl.languageXMLDoc = $(XMLStr2XMLDoc("<?xml version=\"1.0\" encoding=\"utf-8\"?><languageInfo><items></items></languageInfo>"));
            for (var i in urlArr) {
                $.ajax({
                    async: false,
                    cache: true,
                    type: "GET",
                    url: urlArr[i],
                    data: "",
                    success: function(data) {
                            $("languageInfo>items>item", data).appendTo($("languageInfo>items", LangCtrl.languageXMLDoc));

//                                                var items = $("languageInfo>items>item", data);
//                                                for (var j in items) {
//                                                    $("languageInfo>items", LangCtrl.languageXMLDoc).append(items[j]);
//                                                }
                    }
                });
            }
            LangCtrl.isNeedLoadLang = false;
        }
    },
    //改变语言
    changLang: function(lang) {
        $.cookie('use_lang', lang, {expires:45});
        LangCtrl.isNeedLoadLang = true;
        window.top.location.reload();
        // 开始遍历
        //        for (var p in LangCtrl._callBack) { // 方法
        //            if (typeof (LangCtrl._callBack[p]) == "function") {
        //                LangCtrl._callBack[p]();
        //            }
        //        }
    },
    setLang: function(drp,langObj) {
        var type = $.cookie('use_lang');
        $.cookie('lang_type', type);
        var language = langObj[getSystemLanguage()];
        for(var key in langObj ){
            if(type === key){
                language = langObj[key];
                break;
            }
        }

        if (language) drp.html(language);
    },
    getLang: function() {
        var langType = $.cookie('lang_type');
        langType = langType ? langType : getSystemLanguage();
        return langType;
    },
    //添加改变语言后执行的方法
    addCallBack: function(key, fun) {
        if (key in LangCtrl._callBack) {
        }
        else {
            LangCtrl._callBack[key] = fun;
        }
    },
    //翻译页面
    translate: function(context) {
        if ($.xmlns) {
            $.xmlns[""] = "*";
        }    
        var tranObj = context ? $("[lc]", context) : $("[lc]");
        tranObj.each(function(index, domEle) {
            var $domEle = $(domEle);
            var lcArr = $domEle.attr("lc").split(',');
            for (var i in lcArr) {
                switch (lcArr[i]) {
                    case "html":
                        $domEle.html(LangCtrl._L_($domEle.attr("lk")));
                        break;
                    case "value":
                        $domEle.val(LangCtrl._L_($domEle.attr("lk")));
                        break;
                    case "title":
                        $domEle.attr("title", LangCtrl._L_($domEle.attr("lk")));
                        break;
                }
            }
        });
    }
};

function checkLogout() {
    var userInfo = $.cookie('auInfo');
    if (userInfo == null) {
        window.top.location.href = webBase + "Pages/login.htm";
    }
}

$(function() {
    $("#Main", window.top.document).removeAttr("style");
    if ($.xmlns) {
        $.xmlns[""] = "http://www.ipc.com/ver10";
    }
    MenuCtrl.setMenuCookie();
    if(PageCtrl.getPageName() === "login")
        return;
    LangCtrl.translate();
});

function commSaveResponseHadler($response) {
    if ($("config", $response).attr("status") == "success") {
        window.top.MsgBoxHelper.Show("success", LangCtrl._L_("successTip"), LangCtrl._L_("saveSuccess"), null);
    }
    else {
        window.top.MsgBoxHelper.Show("error", LangCtrl._L_("errorTip"), LangCtrl._L_("saveFailed"), null);
    }
}

function logout() {
    //是否退出登录标志位，如果为true，进入登录页面后删除auInfo，为了解决在有定时请求的页面，注销时，有可能在跳转到登录页面前弹出浏览器验证框
    $.cookie('logout', true);
//    $.cookie('auInfo', null);
    $.cookie('menu_1', null);
    $.cookie('menu_2', null);
    window.top.location.href = webBase + "Pages/login.htm";
}

function getDeviceInfo(callback) {
	try {
        XmlHttpClient.SendHttpRequest({
            url: serverBase + "/GetDeviceInfo",
            type: "POST",
            async: false,
            data: "",
            beforeSend:XmlHttpClient.CommBeforeSend,
            callback: callback
        });
    }
    catch (ex) {
        alert(ex);
    }
}

function autoSize() {
    $("#Content", window.top.document).height(window.top.document.body.clientHeight - 90);
}

function abc()
{
    var sendData = xmlHeader + "<macInfo><address type=\"string\"><![CDATA[" + $.cookie("userMac") + "]]></address></macInfo>";
    try {
        XmlHttpClient.SendHttpRequest({
            url: serverBase + "/DoLogin",
            type: "POST",
            timeout:5000,
            async: true,
            data: sendData,
            beforeSend: function (xhr) {
                xhr.setRequestHeader("Authorization", "Basic " + $.cookie("auInfo"));
                return true;
            },
            callback: function (result) {
                if ($("config", result).attr("status") === "failed") {
                    logout();
                }
            }
        });
    }
    catch (ex) {
        alert(ex);
    }
}

//检测重启
function reconnect() {
    XmlHttpClient.SendHttpRequest({
        url: serverBase + "/GetRebootStatus",
        type: "POST",
        async: true,
        data: "",
        timeout: 60000,
        beforeSend: XmlHttpClient.CommBeforeSend,
        callback: function(result) {
            if ($("rebootStatus", result).text() == "true") {
                $(".loadingIndicator_tip",window.top.document).css({background:"transparent"});
                $(".msg_border>.msg",window.top.document).css({color:"333"});
//                window.top.hideLoading();
//                $("#mainFrame", window.top.document).attr("src", MenuCtrl["menuList"]["live"]["url"]);
                window.top.location.reload();
            }
            else {
                setTimeout("reconnect()", 5000);
            }

        },
        error: function() {
            setTimeout("reconnect()", 5000);
        }
    });
}

function getSystemLanguage(){
    var language = (navigator.language || navigator.browserLanguage).toLowerCase();
    return langArr[language] ? language : "en-us";
}
